#include "soapH.h"

#ifdef WIN32
#pragma warning(push)
// do not warn on switch w/o cases
#pragma warning(disable:4065)
#endif
SOAP_FMAC3 int SOAP_FMAC4 soap_fbase(int t, int b)
{
	do
	{	switch (t)
		{
		default: return 0;
		}
	}
	while (t != b);
	return 1;
}
#ifdef WIN32
#pragma warning(pop)
#endif

#ifndef WITH_NOIDREF
#ifdef WIN32
#pragma warning(push)
// do not warn on switch w/o cases
#pragma warning(disable:4065)
#endif
SOAP_FMAC3 void SOAP_FMAC4 soap_finsert(struct soap *soap, int t, int tt, void *p, size_t index, const void *q, void **x)
{
	(void)soap; (void)t; (void)p; (void)index; (void)q; (void)x; /* appease -Wall -Werror */
	switch (tt)
	{
	case SOAP_TYPE_std__vectorTemplateOfunsignedShort:
		if (t == SOAP_TYPE_unsignedShort)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<unsigned short>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<unsigned short> *)p)[index] = *(unsigned short *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfshort:
		if (t == SOAP_TYPE_short)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<short>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<short> *)p)[index] = *(short *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__VBoxEventType:
		if (t == SOAP_TYPE_vbox__VBoxEventType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__VBoxEventType>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__VBoxEventType> *)p)[index] = *(enum vbox__VBoxEventType *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__FramebufferCapabilities:
		if (t == SOAP_TYPE_vbox__FramebufferCapabilities)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__FramebufferCapabilities>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__FramebufferCapabilities> *)p)[index] = *(enum vbox__FramebufferCapabilities *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__KeyboardLED:
		if (t == SOAP_TYPE_vbox__KeyboardLED)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__KeyboardLED>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__KeyboardLED> *)p)[index] = *(enum vbox__KeyboardLED *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DataType:
		if (t == SOAP_TYPE_vbox__DataType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DataType>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DataType> *)p)[index] = *(enum vbox__DataType *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__MediumFormatCapabilities:
		if (t == SOAP_TYPE_vbox__MediumFormatCapabilities)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__MediumFormatCapabilities>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__MediumFormatCapabilities> *)p)[index] = *(enum vbox__MediumFormatCapabilities *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__MediumType:
		if (t == SOAP_TYPE_vbox__MediumType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__MediumType>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__MediumType> *)p)[index] = *(enum vbox__MediumType *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__MediumVariant:
		if (t == SOAP_TYPE_vbox__MediumVariant)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__MediumVariant>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__MediumVariant> *)p)[index] = *(enum vbox__MediumVariant *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__AdditionsUpdateFlag:
		if (t == SOAP_TYPE_vbox__AdditionsUpdateFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__AdditionsUpdateFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__AdditionsUpdateFlag> *)p)[index] = *(enum vbox__AdditionsUpdateFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IAdditionsFacility:
		if (t == SOAP_TYPE_vbox__IAdditionsFacility)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<vbox__IAdditionsFacility *>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<vbox__IAdditionsFacility *> *)p)[index] = *(vbox__IAdditionsFacility **)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__ProcessInputFlag:
		if (t == SOAP_TYPE_vbox__ProcessInputFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__ProcessInputFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__ProcessInputFlag> *)p)[index] = *(enum vbox__ProcessInputFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__ProcessWaitForFlag:
		if (t == SOAP_TYPE_vbox__ProcessWaitForFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__ProcessWaitForFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__ProcessWaitForFlag> *)p)[index] = *(enum vbox__ProcessWaitForFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__GuestSessionWaitForFlag:
		if (t == SOAP_TYPE_vbox__GuestSessionWaitForFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__GuestSessionWaitForFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__GuestSessionWaitForFlag> *)p)[index] = *(enum vbox__GuestSessionWaitForFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__SymlinkReadFlag:
		if (t == SOAP_TYPE_vbox__SymlinkReadFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__SymlinkReadFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__SymlinkReadFlag> *)p)[index] = *(enum vbox__SymlinkReadFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfint:
		if (t == SOAP_TYPE_int)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<int>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<int> *)p)[index] = *(int *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__ProcessCreateFlag:
		if (t == SOAP_TYPE_vbox__ProcessCreateFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__ProcessCreateFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__ProcessCreateFlag> *)p)[index] = *(enum vbox__ProcessCreateFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__FsObjMoveFlags:
		if (t == SOAP_TYPE_vbox__FsObjMoveFlags)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__FsObjMoveFlags>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__FsObjMoveFlags> *)p)[index] = *(enum vbox__FsObjMoveFlags *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__FsObjRenameFlag:
		if (t == SOAP_TYPE_vbox__FsObjRenameFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__FsObjRenameFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__FsObjRenameFlag> *)p)[index] = *(enum vbox__FsObjRenameFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__FileOpenExFlags:
		if (t == SOAP_TYPE_vbox__FileOpenExFlags)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__FileOpenExFlags>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__FileOpenExFlags> *)p)[index] = *(enum vbox__FileOpenExFlags *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__FileCopyFlag:
		if (t == SOAP_TYPE_vbox__FileCopyFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__FileCopyFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__FileCopyFlag> *)p)[index] = *(enum vbox__FileCopyFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DirectoryRemoveRecFlag:
		if (t == SOAP_TYPE_vbox__DirectoryRemoveRecFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DirectoryRemoveRecFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DirectoryRemoveRecFlag> *)p)[index] = *(enum vbox__DirectoryRemoveRecFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DirectoryOpenFlag:
		if (t == SOAP_TYPE_vbox__DirectoryOpenFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DirectoryOpenFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DirectoryOpenFlag> *)p)[index] = *(enum vbox__DirectoryOpenFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DirectoryCreateFlag:
		if (t == SOAP_TYPE_vbox__DirectoryCreateFlag)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DirectoryCreateFlag>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DirectoryCreateFlag> *)p)[index] = *(enum vbox__DirectoryCreateFlag *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DirectoryCopyFlags:
		if (t == SOAP_TYPE_vbox__DirectoryCopyFlags)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DirectoryCopyFlags>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DirectoryCopyFlags> *)p)[index] = *(enum vbox__DirectoryCopyFlags *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DnDAction:
		if (t == SOAP_TYPE_vbox__DnDAction)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DnDAction>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DnDAction> *)p)[index] = *(enum vbox__DnDAction *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DeviceActivity:
		if (t == SOAP_TYPE_vbox__DeviceActivity)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DeviceActivity>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DeviceActivity> *)p)[index] = *(enum vbox__DeviceActivity *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__DeviceType:
		if (t == SOAP_TYPE_vbox__DeviceType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__DeviceType>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__DeviceType> *)p)[index] = *(enum vbox__DeviceType *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__CloneOptions:
		if (t == SOAP_TYPE_vbox__CloneOptions)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__CloneOptions>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__CloneOptions> *)p)[index] = *(enum vbox__CloneOptions *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__BitmapFormat:
		if (t == SOAP_TYPE_vbox__BitmapFormat)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__BitmapFormat>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__BitmapFormat> *)p)[index] = *(enum vbox__BitmapFormat *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IPCIDeviceAttachment:
		if (t == SOAP_TYPE_vbox__IPCIDeviceAttachment)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<vbox__IPCIDeviceAttachment *>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<vbox__IPCIDeviceAttachment *> *)p)[index] = *(vbox__IPCIDeviceAttachment **)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IMediumAttachment:
		if (t == SOAP_TYPE_vbox__IMediumAttachment)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<vbox__IMediumAttachment *>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<vbox__IMediumAttachment *> *)p)[index] = *(vbox__IMediumAttachment **)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfbool:
		if (t == SOAP_TYPE_bool)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<bool>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<bool> *)p)[index] = *(bool *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__VirtualSystemDescriptionType:
		if (t == SOAP_TYPE_vbox__VirtualSystemDescriptionType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__VirtualSystemDescriptionType>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__VirtualSystemDescriptionType> *)p)[index] = *(enum vbox__VirtualSystemDescriptionType *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__ExportOptions:
		if (t == SOAP_TYPE_vbox__ExportOptions)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__ExportOptions>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__ExportOptions> *)p)[index] = *(enum vbox__ExportOptions *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__ImportOptions:
		if (t == SOAP_TYPE_vbox__ImportOptions)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__ImportOptions>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__ImportOptions> *)p)[index] = *(enum vbox__ImportOptions *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfLONG64:
		if (t == SOAP_TYPE_LONG64)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<LONG64>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<LONG64> *)p)[index] = *(LONG64 *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfunsignedInt:
		if (t == SOAP_TYPE_unsignedInt)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<unsigned int>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<unsigned int> *)p)[index] = *(unsigned int *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfvbox__MachineState:
		if (t == SOAP_TYPE_vbox__MachineState)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<enum vbox__MachineState>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<enum vbox__MachineState> *)p)[index] = *(enum vbox__MachineState *)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__ISharedFolder:
		if (t == SOAP_TYPE_vbox__ISharedFolder)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<vbox__ISharedFolder *>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<vbox__ISharedFolder *> *)p)[index] = *(vbox__ISharedFolder **)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfPointerTovbox__IGuestOSType:
		if (t == SOAP_TYPE_vbox__IGuestOSType)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<vbox__IGuestOSType *>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<vbox__IGuestOSType *> *)p)[index] = *(vbox__IGuestOSType **)q;
		}
		break;
	case SOAP_TYPE_std__vectorTemplateOfstd__string:
		if (t == SOAP_TYPE_std__string)
		{	DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Container std::vector<std::string>  insert type=%d in %d location=%p object=%p at index=%lu\n", t, tt, p, q, (unsigned long)index));
			(*(std::vector<std::string> *)p)[index] = *(std::string *)q;
		}
		break;
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Detail:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct SOAP_ENV__Detail type=%d location=%p object=%p\n", t, p, q));
		*(struct SOAP_ENV__Detail*)p = *(struct SOAP_ENV__Detail*)q;
		break;
#endif
	case SOAP_TYPE_std__string:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy std::string type=%d location=%p object=%p\n", t, p, q));
		*(std::string*)p = *(std::string*)q;
		break;
	case SOAP_TYPE_vbox__IPCIDeviceAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__IPCIDeviceAttachment type=%d location=%p object=%p\n", t, p, q));
		*(vbox__IPCIDeviceAttachment*)p = *(vbox__IPCIDeviceAttachment*)q;
		break;
	case SOAP_TYPE_vbox__IVRDEServerInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__IVRDEServerInfo type=%d location=%p object=%p\n", t, p, q));
		*(vbox__IVRDEServerInfo*)p = *(vbox__IVRDEServerInfo*)q;
		break;
	case SOAP_TYPE_vbox__IGuestOSType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__IGuestOSType type=%d location=%p object=%p\n", t, p, q));
		*(vbox__IGuestOSType*)p = *(vbox__IGuestOSType*)q;
		break;
	case SOAP_TYPE_vbox__IAdditionsFacility:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__IAdditionsFacility type=%d location=%p object=%p\n", t, p, q));
		*(vbox__IAdditionsFacility*)p = *(vbox__IAdditionsFacility*)q;
		break;
	case SOAP_TYPE_vbox__IMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__IMediumAttachment type=%d location=%p object=%p\n", t, p, q));
		*(vbox__IMediumAttachment*)p = *(vbox__IMediumAttachment*)q;
		break;
	case SOAP_TYPE_vbox__ISharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy vbox__ISharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(vbox__ISharedFolder*)p = *(vbox__ISharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetResultCode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetResultCodeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetResultDetailResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetResultDetailResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetResultDetailResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetResultDetailResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetComponent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetComponentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetText:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetText type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetText*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetText*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetTextResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetNext type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetNext*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse*)p = *(_vbox__IVirtualBoxErrorInfo_USCOREgetNextResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNetworkName*)p = *(_vbox__INATNetwork_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNetworkNameResponse*)p = *(_vbox__INATNetwork_USCOREgetNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNetworkName*)p = *(_vbox__INATNetwork_USCOREsetNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNetworkNameResponse*)p = *(_vbox__INATNetwork_USCOREsetNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetEnabled*)p = *(_vbox__INATNetwork_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetEnabledResponse*)p = *(_vbox__INATNetwork_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetEnabled*)p = *(_vbox__INATNetwork_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetEnabledResponse*)p = *(_vbox__INATNetwork_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNetwork*)p = *(_vbox__INATNetwork_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNetworkResponse*)p = *(_vbox__INATNetwork_USCOREgetNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNetwork*)p = *(_vbox__INATNetwork_USCOREsetNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNetworkResponse*)p = *(_vbox__INATNetwork_USCOREsetNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetGateway:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetGateway type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetGateway*)p = *(_vbox__INATNetwork_USCOREgetGateway*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetGatewayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetGatewayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetGatewayResponse*)p = *(_vbox__INATNetwork_USCOREgetGatewayResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetIPv6Enabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetIPv6Enabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetIPv6Enabled*)p = *(_vbox__INATNetwork_USCOREgetIPv6Enabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetIPv6EnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetIPv6EnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetIPv6EnabledResponse*)p = *(_vbox__INATNetwork_USCOREgetIPv6EnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetIPv6Enabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetIPv6Enabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetIPv6Enabled*)p = *(_vbox__INATNetwork_USCOREsetIPv6Enabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetIPv6EnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetIPv6EnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetIPv6EnabledResponse*)p = *(_vbox__INATNetwork_USCOREsetIPv6EnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetIPv6Prefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetIPv6Prefix type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetIPv6Prefix*)p = *(_vbox__INATNetwork_USCOREgetIPv6Prefix*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetIPv6PrefixResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetIPv6PrefixResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetIPv6PrefixResponse*)p = *(_vbox__INATNetwork_USCOREgetIPv6PrefixResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetIPv6Prefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetIPv6Prefix type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetIPv6Prefix*)p = *(_vbox__INATNetwork_USCOREsetIPv6Prefix*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetIPv6PrefixResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetIPv6PrefixResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetIPv6PrefixResponse*)p = *(_vbox__INATNetwork_USCOREsetIPv6PrefixResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)p = *(_vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse*)p = *(_vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled*)p = *(_vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabledResponse*)p = *(_vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNeedDhcpServer*)p = *(_vbox__INATNetwork_USCOREgetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetNeedDhcpServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetNeedDhcpServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetNeedDhcpServerResponse*)p = *(_vbox__INATNetwork_USCOREgetNeedDhcpServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNeedDhcpServer*)p = *(_vbox__INATNetwork_USCOREsetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetNeedDhcpServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetNeedDhcpServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetNeedDhcpServerResponse*)p = *(_vbox__INATNetwork_USCOREsetNeedDhcpServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetEventSource*)p = *(_vbox__INATNetwork_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetEventSourceResponse*)p = *(_vbox__INATNetwork_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetPortForwardRules4:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetPortForwardRules4 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetPortForwardRules4*)p = *(_vbox__INATNetwork_USCOREgetPortForwardRules4*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetPortForwardRules4Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetPortForwardRules4Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetPortForwardRules4Response*)p = *(_vbox__INATNetwork_USCOREgetPortForwardRules4Response*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetLocalMappings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetLocalMappings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetLocalMappings*)p = *(_vbox__INATNetwork_USCOREgetLocalMappings*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetLocalMappingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetLocalMappingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetLocalMappingsResponse*)p = *(_vbox__INATNetwork_USCOREgetLocalMappingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetLoopbackIp6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetLoopbackIp6 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetLoopbackIp6*)p = *(_vbox__INATNetwork_USCOREgetLoopbackIp6*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetLoopbackIp6Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetLoopbackIp6Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetLoopbackIp6Response*)p = *(_vbox__INATNetwork_USCOREgetLoopbackIp6Response*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetLoopbackIp6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetLoopbackIp6 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetLoopbackIp6*)p = *(_vbox__INATNetwork_USCOREsetLoopbackIp6*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREsetLoopbackIp6Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREsetLoopbackIp6Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREsetLoopbackIp6Response*)p = *(_vbox__INATNetwork_USCOREsetLoopbackIp6Response*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetPortForwardRules6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetPortForwardRules6 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetPortForwardRules6*)p = *(_vbox__INATNetwork_USCOREgetPortForwardRules6*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREgetPortForwardRules6Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREgetPortForwardRules6Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREgetPortForwardRules6Response*)p = *(_vbox__INATNetwork_USCOREgetPortForwardRules6Response*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREaddLocalMapping:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREaddLocalMapping type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREaddLocalMapping*)p = *(_vbox__INATNetwork_USCOREaddLocalMapping*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREaddLocalMappingResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREaddLocalMappingResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREaddLocalMappingResponse*)p = *(_vbox__INATNetwork_USCOREaddLocalMappingResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREaddPortForwardRule:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREaddPortForwardRule type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREaddPortForwardRule*)p = *(_vbox__INATNetwork_USCOREaddPortForwardRule*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREaddPortForwardRuleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREaddPortForwardRuleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREaddPortForwardRuleResponse*)p = *(_vbox__INATNetwork_USCOREaddPortForwardRuleResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREremovePortForwardRule:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREremovePortForwardRule type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREremovePortForwardRule*)p = *(_vbox__INATNetwork_USCOREremovePortForwardRule*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREremovePortForwardRuleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREremovePortForwardRuleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREremovePortForwardRuleResponse*)p = *(_vbox__INATNetwork_USCOREremovePortForwardRuleResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREstart:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREstart type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREstart*)p = *(_vbox__INATNetwork_USCOREstart*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREstartResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREstartResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREstartResponse*)p = *(_vbox__INATNetwork_USCOREstartResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREstop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREstop type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREstop*)p = *(_vbox__INATNetwork_USCOREstop*)q;
		break;
	case SOAP_TYPE__vbox__INATNetwork_USCOREstopResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetwork_USCOREstopResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetwork_USCOREstopResponse*)p = *(_vbox__INATNetwork_USCOREstopResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetEventSource*)p = *(_vbox__IDHCPServer_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetEventSourceResponse*)p = *(_vbox__IDHCPServer_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetEnabled*)p = *(_vbox__IDHCPServer_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetEnabledResponse*)p = *(_vbox__IDHCPServer_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREsetEnabled*)p = *(_vbox__IDHCPServer_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREsetEnabledResponse*)p = *(_vbox__IDHCPServer_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetIPAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetIPAddress*)p = *(_vbox__IDHCPServer_USCOREgetIPAddress*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetIPAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetIPAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetIPAddressResponse*)p = *(_vbox__IDHCPServer_USCOREgetIPAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMask:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetNetworkMask type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetNetworkMask*)p = *(_vbox__IDHCPServer_USCOREgetNetworkMask*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkMaskResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetNetworkMaskResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetNetworkMaskResponse*)p = *(_vbox__IDHCPServer_USCOREgetNetworkMaskResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetNetworkName*)p = *(_vbox__IDHCPServer_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetNetworkNameResponse*)p = *(_vbox__IDHCPServer_USCOREgetNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetLowerIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetLowerIP*)p = *(_vbox__IDHCPServer_USCOREgetLowerIP*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetLowerIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetLowerIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetLowerIPResponse*)p = *(_vbox__IDHCPServer_USCOREgetLowerIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetUpperIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetUpperIP*)p = *(_vbox__IDHCPServer_USCOREgetUpperIP*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetUpperIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetUpperIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetUpperIPResponse*)p = *(_vbox__IDHCPServer_USCOREgetUpperIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetGlobalOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetGlobalOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetGlobalOptions*)p = *(_vbox__IDHCPServer_USCOREgetGlobalOptions*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetGlobalOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetGlobalOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetGlobalOptionsResponse*)p = *(_vbox__IDHCPServer_USCOREgetGlobalOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetVmConfigs:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetVmConfigs type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetVmConfigs*)p = *(_vbox__IDHCPServer_USCOREgetVmConfigs*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetVmConfigsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetVmConfigsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetVmConfigsResponse*)p = *(_vbox__IDHCPServer_USCOREgetVmConfigsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREaddGlobalOption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREaddGlobalOption type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREaddGlobalOption*)p = *(_vbox__IDHCPServer_USCOREaddGlobalOption*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREaddGlobalOptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREaddGlobalOptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREaddGlobalOptionResponse*)p = *(_vbox__IDHCPServer_USCOREaddGlobalOptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREaddVmSlotOption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREaddVmSlotOption type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREaddVmSlotOption*)p = *(_vbox__IDHCPServer_USCOREaddVmSlotOption*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREaddVmSlotOptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREaddVmSlotOptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREaddVmSlotOptionResponse*)p = *(_vbox__IDHCPServer_USCOREaddVmSlotOptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREremoveVmSlotOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREremoveVmSlotOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREremoveVmSlotOptions*)p = *(_vbox__IDHCPServer_USCOREremoveVmSlotOptions*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREremoveVmSlotOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREremoveVmSlotOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREremoveVmSlotOptionsResponse*)p = *(_vbox__IDHCPServer_USCOREremoveVmSlotOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetVmSlotOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetVmSlotOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetVmSlotOptions*)p = *(_vbox__IDHCPServer_USCOREgetVmSlotOptions*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetVmSlotOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetVmSlotOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetVmSlotOptionsResponse*)p = *(_vbox__IDHCPServer_USCOREgetVmSlotOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetMacOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetMacOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetMacOptions*)p = *(_vbox__IDHCPServer_USCOREgetMacOptions*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREgetMacOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREgetMacOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREgetMacOptionsResponse*)p = *(_vbox__IDHCPServer_USCOREgetMacOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfiguration:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREsetConfiguration type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREsetConfiguration*)p = *(_vbox__IDHCPServer_USCOREsetConfiguration*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREsetConfigurationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREsetConfigurationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREsetConfigurationResponse*)p = *(_vbox__IDHCPServer_USCOREsetConfigurationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstart:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREstart type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREstart*)p = *(_vbox__IDHCPServer_USCOREstart*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstartResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREstartResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREstartResponse*)p = *(_vbox__IDHCPServer_USCOREstartResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREstop type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREstop*)p = *(_vbox__IDHCPServer_USCOREstop*)q;
		break;
	case SOAP_TYPE__vbox__IDHCPServer_USCOREstopResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDHCPServer_USCOREstopResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDHCPServer_USCOREstopResponse*)p = *(_vbox__IDHCPServer_USCOREstopResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetVersion*)p = *(_vbox__IVirtualBox_USCOREgetVersion*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetVersionResponse*)p = *(_vbox__IVirtualBox_USCOREgetVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersionNormalized:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetVersionNormalized type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetVersionNormalized*)p = *(_vbox__IVirtualBox_USCOREgetVersionNormalized*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetVersionNormalizedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetVersionNormalizedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetVersionNormalizedResponse*)p = *(_vbox__IVirtualBox_USCOREgetVersionNormalizedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetRevision*)p = *(_vbox__IVirtualBox_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetRevisionResponse*)p = *(_vbox__IVirtualBox_USCOREgetRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetPackageType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetPackageType*)p = *(_vbox__IVirtualBox_USCOREgetPackageType*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPackageTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetPackageTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetPackageTypeResponse*)p = *(_vbox__IVirtualBox_USCOREgetPackageTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetAPIVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetAPIVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetAPIVersion*)p = *(_vbox__IVirtualBox_USCOREgetAPIVersion*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetAPIVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetAPIVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetAPIVersionResponse*)p = *(_vbox__IVirtualBox_USCOREgetAPIVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetAPIRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetAPIRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetAPIRevision*)p = *(_vbox__IVirtualBox_USCOREgetAPIRevision*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetAPIRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetAPIRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetAPIRevisionResponse*)p = *(_vbox__IVirtualBox_USCOREgetAPIRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHomeFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHomeFolder*)p = *(_vbox__IVirtualBox_USCOREgetHomeFolder*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHomeFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHomeFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHomeFolderResponse*)p = *(_vbox__IVirtualBox_USCOREgetHomeFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSettingsFilePath*)p = *(_vbox__IVirtualBox_USCOREgetSettingsFilePath*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSettingsFilePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSettingsFilePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSettingsFilePathResponse*)p = *(_vbox__IVirtualBox_USCOREgetSettingsFilePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHost:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHost type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHost*)p = *(_vbox__IVirtualBox_USCOREgetHost*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHostResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHostResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHostResponse*)p = *(_vbox__IVirtualBox_USCOREgetHostResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSystemProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSystemProperties*)p = *(_vbox__IVirtualBox_USCOREgetSystemProperties*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSystemPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSystemPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSystemPropertiesResponse*)p = *(_vbox__IVirtualBox_USCOREgetSystemPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachines type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachines*)p = *(_vbox__IVirtualBox_USCOREgetMachines*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachinesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachinesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachinesResponse*)p = *(_vbox__IVirtualBox_USCOREgetMachinesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachineGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachineGroups*)p = *(_vbox__IVirtualBox_USCOREgetMachineGroups*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachineGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachineGroupsResponse*)p = *(_vbox__IVirtualBox_USCOREgetMachineGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHardDisks type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHardDisks*)p = *(_vbox__IVirtualBox_USCOREgetHardDisks*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetHardDisksResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetHardDisksResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetHardDisksResponse*)p = *(_vbox__IVirtualBox_USCOREgetHardDisksResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImages:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetDVDImages type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetDVDImages*)p = *(_vbox__IVirtualBox_USCOREgetDVDImages*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDVDImagesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetDVDImagesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetDVDImagesResponse*)p = *(_vbox__IVirtualBox_USCOREgetDVDImagesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImages:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetFloppyImages type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetFloppyImages*)p = *(_vbox__IVirtualBox_USCOREgetFloppyImages*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetFloppyImagesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetFloppyImagesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetFloppyImagesResponse*)p = *(_vbox__IVirtualBox_USCOREgetFloppyImagesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetProgressOperations type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetProgressOperations*)p = *(_vbox__IVirtualBox_USCOREgetProgressOperations*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetProgressOperationsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetProgressOperationsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetProgressOperationsResponse*)p = *(_vbox__IVirtualBox_USCOREgetProgressOperationsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGuestOSTypes type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGuestOSTypes*)p = *(_vbox__IVirtualBox_USCOREgetGuestOSTypes*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGuestOSTypesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGuestOSTypesResponse*)p = *(_vbox__IVirtualBox_USCOREgetGuestOSTypesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSharedFolders*)p = *(_vbox__IVirtualBox_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetSharedFoldersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetSharedFoldersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetSharedFoldersResponse*)p = *(_vbox__IVirtualBox_USCOREgetSharedFoldersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollector:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetPerformanceCollector type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetPerformanceCollector*)p = *(_vbox__IVirtualBox_USCOREgetPerformanceCollector*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse*)p = *(_vbox__IVirtualBox_USCOREgetPerformanceCollectorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetDHCPServers type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetDHCPServers*)p = *(_vbox__IVirtualBox_USCOREgetDHCPServers*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetDHCPServersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetDHCPServersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetDHCPServersResponse*)p = *(_vbox__IVirtualBox_USCOREgetDHCPServersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetNATNetworks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetNATNetworks type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetNATNetworks*)p = *(_vbox__IVirtualBox_USCOREgetNATNetworks*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetNATNetworksResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetNATNetworksResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetNATNetworksResponse*)p = *(_vbox__IVirtualBox_USCOREgetNATNetworksResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetEventSource*)p = *(_vbox__IVirtualBox_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetEventSourceResponse*)p = *(_vbox__IVirtualBox_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetInternalNetworks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetInternalNetworks type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetInternalNetworks*)p = *(_vbox__IVirtualBox_USCOREgetInternalNetworks*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetInternalNetworksResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetInternalNetworksResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetInternalNetworksResponse*)p = *(_vbox__IVirtualBox_USCOREgetInternalNetworksResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGenericNetworkDrivers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGenericNetworkDrivers type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGenericNetworkDrivers*)p = *(_vbox__IVirtualBox_USCOREgetGenericNetworkDrivers*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGenericNetworkDriversResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGenericNetworkDriversResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGenericNetworkDriversResponse*)p = *(_vbox__IVirtualBox_USCOREgetGenericNetworkDriversResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcomposeMachineFilename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcomposeMachineFilename type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcomposeMachineFilename*)p = *(_vbox__IVirtualBox_USCOREcomposeMachineFilename*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcomposeMachineFilenameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcomposeMachineFilenameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcomposeMachineFilenameResponse*)p = *(_vbox__IVirtualBox_USCOREcomposeMachineFilenameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateMachine*)p = *(_vbox__IVirtualBox_USCOREcreateMachine*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateMachineResponse*)p = *(_vbox__IVirtualBox_USCOREcreateMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREopenMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREopenMachine*)p = *(_vbox__IVirtualBox_USCOREopenMachine*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREopenMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREopenMachineResponse*)p = *(_vbox__IVirtualBox_USCOREopenMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREregisterMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREregisterMachine*)p = *(_vbox__IVirtualBox_USCOREregisterMachine*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREregisterMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREregisterMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREregisterMachineResponse*)p = *(_vbox__IVirtualBox_USCOREregisterMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindMachine*)p = *(_vbox__IVirtualBox_USCOREfindMachine*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindMachineResponse*)p = *(_vbox__IVirtualBox_USCOREfindMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachinesByGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachinesByGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachinesByGroups*)p = *(_vbox__IVirtualBox_USCOREgetMachinesByGroups*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachinesByGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachinesByGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachinesByGroupsResponse*)p = *(_vbox__IVirtualBox_USCOREgetMachinesByGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineStates:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachineStates type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachineStates*)p = *(_vbox__IVirtualBox_USCOREgetMachineStates*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetMachineStatesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetMachineStatesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetMachineStatesResponse*)p = *(_vbox__IVirtualBox_USCOREgetMachineStatesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateAppliance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateAppliance type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateAppliance*)p = *(_vbox__IVirtualBox_USCOREcreateAppliance*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateApplianceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateApplianceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateApplianceResponse*)p = *(_vbox__IVirtualBox_USCOREcreateApplianceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateMedium*)p = *(_vbox__IVirtualBox_USCOREcreateMedium*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateMediumResponse*)p = *(_vbox__IVirtualBox_USCOREcreateMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREopenMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREopenMedium*)p = *(_vbox__IVirtualBox_USCOREopenMedium*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREopenMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREopenMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREopenMediumResponse*)p = *(_vbox__IVirtualBox_USCOREopenMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGuestOSType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGuestOSType*)p = *(_vbox__IVirtualBox_USCOREgetGuestOSType*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetGuestOSTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetGuestOSTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetGuestOSTypeResponse*)p = *(_vbox__IVirtualBox_USCOREgetGuestOSTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateSharedFolder*)p = *(_vbox__IVirtualBox_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateSharedFolderResponse*)p = *(_vbox__IVirtualBox_USCOREcreateSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveSharedFolder*)p = *(_vbox__IVirtualBox_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveSharedFolderResponse*)p = *(_vbox__IVirtualBox_USCOREremoveSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetExtraDataKeys type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetExtraDataKeys*)p = *(_vbox__IVirtualBox_USCOREgetExtraDataKeys*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataKeysResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetExtraDataKeysResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetExtraDataKeysResponse*)p = *(_vbox__IVirtualBox_USCOREgetExtraDataKeysResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetExtraData*)p = *(_vbox__IVirtualBox_USCOREgetExtraData*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREgetExtraDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREgetExtraDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREgetExtraDataResponse*)p = *(_vbox__IVirtualBox_USCOREgetExtraDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREsetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREsetExtraData*)p = *(_vbox__IVirtualBox_USCOREsetExtraData*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetExtraDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREsetExtraDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREsetExtraDataResponse*)p = *(_vbox__IVirtualBox_USCOREsetExtraDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetSettingsSecret:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREsetSettingsSecret type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREsetSettingsSecret*)p = *(_vbox__IVirtualBox_USCOREsetSettingsSecret*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREsetSettingsSecretResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREsetSettingsSecretResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREsetSettingsSecretResponse*)p = *(_vbox__IVirtualBox_USCOREsetSettingsSecretResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateDHCPServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateDHCPServer*)p = *(_vbox__IVirtualBox_USCOREcreateDHCPServer*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateDHCPServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateDHCPServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateDHCPServerResponse*)p = *(_vbox__IVirtualBox_USCOREcreateDHCPServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p = *(_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse*)p = *(_vbox__IVirtualBox_USCOREfindDHCPServerByNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveDHCPServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveDHCPServer*)p = *(_vbox__IVirtualBox_USCOREremoveDHCPServer*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveDHCPServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveDHCPServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveDHCPServerResponse*)p = *(_vbox__IVirtualBox_USCOREremoveDHCPServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateNATNetwork*)p = *(_vbox__IVirtualBox_USCOREcreateNATNetwork*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcreateNATNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcreateNATNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcreateNATNetworkResponse*)p = *(_vbox__IVirtualBox_USCOREcreateNATNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindNATNetworkByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindNATNetworkByName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindNATNetworkByName*)p = *(_vbox__IVirtualBox_USCOREfindNATNetworkByName*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREfindNATNetworkByNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREfindNATNetworkByNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREfindNATNetworkByNameResponse*)p = *(_vbox__IVirtualBox_USCOREfindNATNetworkByNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveNATNetwork*)p = *(_vbox__IVirtualBox_USCOREremoveNATNetwork*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREremoveNATNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREremoveNATNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREremoveNATNetworkResponse*)p = *(_vbox__IVirtualBox_USCOREremoveNATNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcheckFirmwarePresent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p = *(_vbox__IVirtualBox_USCOREcheckFirmwarePresent*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse*)p = *(_vbox__IVirtualBox_USCOREcheckFirmwarePresentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREgetPath*)p = *(_vbox__IVFSExplorer_USCOREgetPath*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREgetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREgetPathResponse*)p = *(_vbox__IVFSExplorer_USCOREgetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREgetType*)p = *(_vbox__IVFSExplorer_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREgetTypeResponse*)p = *(_vbox__IVFSExplorer_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREupdate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREupdate*)p = *(_vbox__IVFSExplorer_USCOREupdate*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREupdateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREupdateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREupdateResponse*)p = *(_vbox__IVFSExplorer_USCOREupdateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREcd type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREcd*)p = *(_vbox__IVFSExplorer_USCOREcd*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREcdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREcdResponse*)p = *(_vbox__IVFSExplorer_USCOREcdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREcdUp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREcdUp*)p = *(_vbox__IVFSExplorer_USCOREcdUp*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREcdUpResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREcdUpResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREcdUpResponse*)p = *(_vbox__IVFSExplorer_USCOREcdUpResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryList:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREentryList type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREentryList*)p = *(_vbox__IVFSExplorer_USCOREentryList*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREentryListResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREentryListResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREentryListResponse*)p = *(_vbox__IVFSExplorer_USCOREentryListResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREexists type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREexists*)p = *(_vbox__IVFSExplorer_USCOREexists*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREexistsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREexistsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREexistsResponse*)p = *(_vbox__IVFSExplorer_USCOREexistsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREremove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREremove*)p = *(_vbox__IVFSExplorer_USCOREremove*)q;
		break;
	case SOAP_TYPE__vbox__IVFSExplorer_USCOREremoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVFSExplorer_USCOREremoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVFSExplorer_USCOREremoveResponse*)p = *(_vbox__IVFSExplorer_USCOREremoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetVersionNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetVersionNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetVersionNumber*)p = *(_vbox__ICertificate_USCOREgetVersionNumber*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetVersionNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetVersionNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetVersionNumberResponse*)p = *(_vbox__ICertificate_USCOREgetVersionNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSerialNumber*)p = *(_vbox__ICertificate_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSerialNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSerialNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSerialNumberResponse*)p = *(_vbox__ICertificate_USCOREgetSerialNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSignatureAlgorithmOID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSignatureAlgorithmOID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSignatureAlgorithmOID*)p = *(_vbox__ICertificate_USCOREgetSignatureAlgorithmOID*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSignatureAlgorithmOIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSignatureAlgorithmOIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSignatureAlgorithmOIDResponse*)p = *(_vbox__ICertificate_USCOREgetSignatureAlgorithmOIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSignatureAlgorithmName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSignatureAlgorithmName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSignatureAlgorithmName*)p = *(_vbox__ICertificate_USCOREgetSignatureAlgorithmName*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSignatureAlgorithmNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSignatureAlgorithmNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSignatureAlgorithmNameResponse*)p = *(_vbox__ICertificate_USCOREgetSignatureAlgorithmNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetIssuerName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetIssuerName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetIssuerName*)p = *(_vbox__ICertificate_USCOREgetIssuerName*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetIssuerNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetIssuerNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetIssuerNameResponse*)p = *(_vbox__ICertificate_USCOREgetIssuerNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectName*)p = *(_vbox__ICertificate_USCOREgetSubjectName*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectNameResponse*)p = *(_vbox__ICertificate_USCOREgetSubjectNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetFriendlyName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetFriendlyName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetFriendlyName*)p = *(_vbox__ICertificate_USCOREgetFriendlyName*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetFriendlyNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetFriendlyNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetFriendlyNameResponse*)p = *(_vbox__ICertificate_USCOREgetFriendlyNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetValidityPeriodNotBefore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetValidityPeriodNotBefore type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetValidityPeriodNotBefore*)p = *(_vbox__ICertificate_USCOREgetValidityPeriodNotBefore*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetValidityPeriodNotBeforeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetValidityPeriodNotBeforeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetValidityPeriodNotBeforeResponse*)p = *(_vbox__ICertificate_USCOREgetValidityPeriodNotBeforeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetValidityPeriodNotAfter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetValidityPeriodNotAfter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetValidityPeriodNotAfter*)p = *(_vbox__ICertificate_USCOREgetValidityPeriodNotAfter*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetValidityPeriodNotAfterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetValidityPeriodNotAfterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetValidityPeriodNotAfterResponse*)p = *(_vbox__ICertificate_USCOREgetValidityPeriodNotAfterResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID*)p = *(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetPublicKeyAlgorithmOIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetPublicKeyAlgorithmOIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmOIDResponse*)p = *(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmOIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetPublicKeyAlgorithm:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetPublicKeyAlgorithm type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetPublicKeyAlgorithm*)p = *(_vbox__ICertificate_USCOREgetPublicKeyAlgorithm*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetPublicKeyAlgorithmResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetPublicKeyAlgorithmResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmResponse*)p = *(_vbox__ICertificate_USCOREgetPublicKeyAlgorithmResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectPublicKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectPublicKey type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectPublicKey*)p = *(_vbox__ICertificate_USCOREgetSubjectPublicKey*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectPublicKeyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectPublicKeyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectPublicKeyResponse*)p = *(_vbox__ICertificate_USCOREgetSubjectPublicKeyResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetIssuerUniqueIdentifier:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetIssuerUniqueIdentifier type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetIssuerUniqueIdentifier*)p = *(_vbox__ICertificate_USCOREgetIssuerUniqueIdentifier*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetIssuerUniqueIdentifierResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetIssuerUniqueIdentifierResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetIssuerUniqueIdentifierResponse*)p = *(_vbox__ICertificate_USCOREgetIssuerUniqueIdentifierResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectUniqueIdentifier:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectUniqueIdentifier type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectUniqueIdentifier*)p = *(_vbox__ICertificate_USCOREgetSubjectUniqueIdentifier*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSubjectUniqueIdentifierResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSubjectUniqueIdentifierResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSubjectUniqueIdentifierResponse*)p = *(_vbox__ICertificate_USCOREgetSubjectUniqueIdentifierResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetCertificateAuthority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetCertificateAuthority type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetCertificateAuthority*)p = *(_vbox__ICertificate_USCOREgetCertificateAuthority*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetCertificateAuthorityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetCertificateAuthorityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetCertificateAuthorityResponse*)p = *(_vbox__ICertificate_USCOREgetCertificateAuthorityResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetKeyUsage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetKeyUsage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetKeyUsage*)p = *(_vbox__ICertificate_USCOREgetKeyUsage*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetKeyUsageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetKeyUsageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetKeyUsageResponse*)p = *(_vbox__ICertificate_USCOREgetKeyUsageResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetExtendedKeyUsage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetExtendedKeyUsage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetExtendedKeyUsage*)p = *(_vbox__ICertificate_USCOREgetExtendedKeyUsage*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetExtendedKeyUsageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetExtendedKeyUsageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetExtendedKeyUsageResponse*)p = *(_vbox__ICertificate_USCOREgetExtendedKeyUsageResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetRawCertData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetRawCertData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetRawCertData*)p = *(_vbox__ICertificate_USCOREgetRawCertData*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetRawCertDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetRawCertDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetRawCertDataResponse*)p = *(_vbox__ICertificate_USCOREgetRawCertDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSelfSigned:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSelfSigned type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSelfSigned*)p = *(_vbox__ICertificate_USCOREgetSelfSigned*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetSelfSignedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetSelfSignedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetSelfSignedResponse*)p = *(_vbox__ICertificate_USCOREgetSelfSignedResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetTrusted:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetTrusted type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetTrusted*)p = *(_vbox__ICertificate_USCOREgetTrusted*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetTrustedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetTrustedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetTrustedResponse*)p = *(_vbox__ICertificate_USCOREgetTrustedResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetExpired:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetExpired type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetExpired*)p = *(_vbox__ICertificate_USCOREgetExpired*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREgetExpiredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREgetExpiredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREgetExpiredResponse*)p = *(_vbox__ICertificate_USCOREgetExpiredResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREisCurrentlyExpired:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREisCurrentlyExpired type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREisCurrentlyExpired*)p = *(_vbox__ICertificate_USCOREisCurrentlyExpired*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREisCurrentlyExpiredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREisCurrentlyExpiredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREisCurrentlyExpiredResponse*)p = *(_vbox__ICertificate_USCOREisCurrentlyExpiredResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREqueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREqueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREqueryInfo*)p = *(_vbox__ICertificate_USCOREqueryInfo*)q;
		break;
	case SOAP_TYPE__vbox__ICertificate_USCOREqueryInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICertificate_USCOREqueryInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICertificate_USCOREqueryInfoResponse*)p = *(_vbox__ICertificate_USCOREqueryInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetPath*)p = *(_vbox__IAppliance_USCOREgetPath*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetPathResponse*)p = *(_vbox__IAppliance_USCOREgetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetDisks type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetDisks*)p = *(_vbox__IAppliance_USCOREgetDisks*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetDisksResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetDisksResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetDisksResponse*)p = *(_vbox__IAppliance_USCOREgetDisksResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetVirtualSystemDescriptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p = *(_vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse*)p = *(_vbox__IAppliance_USCOREgetVirtualSystemDescriptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetMachines type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetMachines*)p = *(_vbox__IAppliance_USCOREgetMachines*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetMachinesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetMachinesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetMachinesResponse*)p = *(_vbox__IAppliance_USCOREgetMachinesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetCertificate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetCertificate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetCertificate*)p = *(_vbox__IAppliance_USCOREgetCertificate*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetCertificateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetCertificateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetCertificateResponse*)p = *(_vbox__IAppliance_USCOREgetCertificateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREread*)p = *(_vbox__IAppliance_USCOREread*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREreadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREreadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREreadResponse*)p = *(_vbox__IAppliance_USCOREreadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpret:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREinterpret type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREinterpret*)p = *(_vbox__IAppliance_USCOREinterpret*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREinterpretResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREinterpretResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREinterpretResponse*)p = *(_vbox__IAppliance_USCOREinterpretResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREimportMachines type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREimportMachines*)p = *(_vbox__IAppliance_USCOREimportMachines*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREimportMachinesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREimportMachinesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREimportMachinesResponse*)p = *(_vbox__IAppliance_USCOREimportMachinesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREcreateVFSExplorer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREcreateVFSExplorer*)p = *(_vbox__IAppliance_USCOREcreateVFSExplorer*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREcreateVFSExplorerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREcreateVFSExplorerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREcreateVFSExplorerResponse*)p = *(_vbox__IAppliance_USCOREcreateVFSExplorerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREwrite*)p = *(_vbox__IAppliance_USCOREwrite*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREwriteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREwriteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREwriteResponse*)p = *(_vbox__IAppliance_USCOREwriteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarnings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetWarnings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetWarnings*)p = *(_vbox__IAppliance_USCOREgetWarnings*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetWarningsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetWarningsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetWarningsResponse*)p = *(_vbox__IAppliance_USCOREgetWarningsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPasswordIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetPasswordIds type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetPasswordIds*)p = *(_vbox__IAppliance_USCOREgetPasswordIds*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetPasswordIdsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetPasswordIdsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetPasswordIdsResponse*)p = *(_vbox__IAppliance_USCOREgetPasswordIdsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetMediumIdsForPasswordId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetMediumIdsForPasswordId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetMediumIdsForPasswordId*)p = *(_vbox__IAppliance_USCOREgetMediumIdsForPasswordId*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREgetMediumIdsForPasswordIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREgetMediumIdsForPasswordIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREgetMediumIdsForPasswordIdResponse*)p = *(_vbox__IAppliance_USCOREgetMediumIdsForPasswordIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREaddPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREaddPasswords type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREaddPasswords*)p = *(_vbox__IAppliance_USCOREaddPasswords*)q;
		break;
	case SOAP_TYPE__vbox__IAppliance_USCOREaddPasswordsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAppliance_USCOREaddPasswordsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAppliance_USCOREaddPasswordsResponse*)p = *(_vbox__IAppliance_USCOREaddPasswordsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetCount*)p = *(_vbox__IVirtualSystemDescription_USCOREgetCount*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetCountResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREgetCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetDescription*)p = *(_vbox__IVirtualSystemDescription_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetDescriptionByType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p = *(_vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREgetDescriptionByTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetValuesByType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p = *(_vbox__IVirtualSystemDescription_USCOREgetValuesByType*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREgetValuesByTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREsetFinalValues type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p = *(_vbox__IVirtualSystemDescription_USCOREsetFinalValues*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREsetFinalValuesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREaddDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREaddDescription*)p = *(_vbox__IVirtualSystemDescription_USCOREaddDescription*)q;
		break;
	case SOAP_TYPE__vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse*)p = *(_vbox__IVirtualSystemDescription_USCOREaddDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoFadeIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p = *(_vbox__IBIOSSettings_USCOREgetLogoFadeIn*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoFadeInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoFadeInResponse*)p = *(_vbox__IBIOSSettings_USCOREgetLogoFadeInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoFadeIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p = *(_vbox__IBIOSSettings_USCOREsetLogoFadeIn*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoFadeInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoFadeInResponse*)p = *(_vbox__IBIOSSettings_USCOREsetLogoFadeInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoFadeOut type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p = *(_vbox__IBIOSSettings_USCOREgetLogoFadeOut*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse*)p = *(_vbox__IBIOSSettings_USCOREgetLogoFadeOutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoFadeOut type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p = *(_vbox__IBIOSSettings_USCOREsetLogoFadeOut*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse*)p = *(_vbox__IBIOSSettings_USCOREsetLogoFadeOutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoDisplayTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p = *(_vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse*)p = *(_vbox__IBIOSSettings_USCOREgetLogoDisplayTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoDisplayTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p = *(_vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse*)p = *(_vbox__IBIOSSettings_USCOREsetLogoDisplayTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoImagePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoImagePath*)p = *(_vbox__IBIOSSettings_USCOREgetLogoImagePath*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetLogoImagePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetLogoImagePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetLogoImagePathResponse*)p = *(_vbox__IBIOSSettings_USCOREgetLogoImagePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoImagePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoImagePath*)p = *(_vbox__IBIOSSettings_USCOREsetLogoImagePath*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetLogoImagePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetLogoImagePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetLogoImagePathResponse*)p = *(_vbox__IBIOSSettings_USCOREsetLogoImagePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetBootMenuMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetBootMenuMode*)p = *(_vbox__IBIOSSettings_USCOREgetBootMenuMode*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetBootMenuModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetBootMenuModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetBootMenuModeResponse*)p = *(_vbox__IBIOSSettings_USCOREgetBootMenuModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetBootMenuMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetBootMenuMode*)p = *(_vbox__IBIOSSettings_USCOREsetBootMenuMode*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetBootMenuModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetBootMenuModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetBootMenuModeResponse*)p = *(_vbox__IBIOSSettings_USCOREsetBootMenuModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetACPIEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetACPIEnabled*)p = *(_vbox__IBIOSSettings_USCOREgetACPIEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetACPIEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetACPIEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetACPIEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREgetACPIEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetACPIEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetACPIEnabled*)p = *(_vbox__IBIOSSettings_USCOREsetACPIEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetACPIEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetACPIEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetACPIEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREsetACPIEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetIOAPICEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p = *(_vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREgetIOAPICEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetIOAPICEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p = *(_vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREsetIOAPICEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetAPICMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetAPICMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetAPICMode*)p = *(_vbox__IBIOSSettings_USCOREgetAPICMode*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetAPICModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetAPICModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetAPICModeResponse*)p = *(_vbox__IBIOSSettings_USCOREgetAPICModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetAPICMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetAPICMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetAPICMode*)p = *(_vbox__IBIOSSettings_USCOREsetAPICMode*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetAPICModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetAPICModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetAPICModeResponse*)p = *(_vbox__IBIOSSettings_USCOREsetAPICModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetTimeOffset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetTimeOffset*)p = *(_vbox__IBIOSSettings_USCOREgetTimeOffset*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetTimeOffsetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetTimeOffsetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetTimeOffsetResponse*)p = *(_vbox__IBIOSSettings_USCOREgetTimeOffsetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetTimeOffset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetTimeOffset*)p = *(_vbox__IBIOSSettings_USCOREsetTimeOffset*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetTimeOffsetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetTimeOffsetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetTimeOffsetResponse*)p = *(_vbox__IBIOSSettings_USCOREsetTimeOffsetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetPXEDebugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p = *(_vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREgetPXEDebugEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetPXEDebugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p = *(_vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse*)p = *(_vbox__IBIOSSettings_USCOREsetPXEDebugEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile*)p = *(_vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile*)q;
		break;
	case SOAP_TYPE__vbox__IBIOSSettings_USCOREgetNonVolatileStorageFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBIOSSettings_USCOREgetNonVolatileStorageFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBIOSSettings_USCOREgetNonVolatileStorageFileResponse*)p = *(_vbox__IBIOSSettings_USCOREgetNonVolatileStorageFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetBus*)p = *(_vbox__IPCIAddress_USCOREgetBus*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetBusResponse*)p = *(_vbox__IPCIAddress_USCOREgetBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetBus*)p = *(_vbox__IPCIAddress_USCOREsetBus*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetBusResponse*)p = *(_vbox__IPCIAddress_USCOREsetBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetDevice*)p = *(_vbox__IPCIAddress_USCOREgetDevice*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetDeviceResponse*)p = *(_vbox__IPCIAddress_USCOREgetDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetDevice*)p = *(_vbox__IPCIAddress_USCOREsetDevice*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetDeviceResponse*)p = *(_vbox__IPCIAddress_USCOREsetDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetDevFunction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetDevFunction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetDevFunction*)p = *(_vbox__IPCIAddress_USCOREgetDevFunction*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREgetDevFunctionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREgetDevFunctionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREgetDevFunctionResponse*)p = *(_vbox__IPCIAddress_USCOREgetDevFunctionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetDevFunction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetDevFunction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetDevFunction*)p = *(_vbox__IPCIAddress_USCOREsetDevFunction*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREsetDevFunctionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREsetDevFunctionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREsetDevFunctionResponse*)p = *(_vbox__IPCIAddress_USCOREsetDevFunctionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREasLong:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREasLong type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREasLong*)p = *(_vbox__IPCIAddress_USCOREasLong*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREasLongResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREasLongResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREasLongResponse*)p = *(_vbox__IPCIAddress_USCOREasLongResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREfromLong:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREfromLong type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREfromLong*)p = *(_vbox__IPCIAddress_USCOREfromLong*)q;
		break;
	case SOAP_TYPE__vbox__IPCIAddress_USCOREfromLongResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPCIAddress_USCOREfromLongResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPCIAddress_USCOREfromLongResponse*)p = *(_vbox__IPCIAddress_USCOREfromLongResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParent*)p = *(_vbox__IMachine_USCOREgetParent*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParentResponse*)p = *(_vbox__IMachine_USCOREgetParentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIcon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIcon type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIcon*)p = *(_vbox__IMachine_USCOREgetIcon*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIconResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIconResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIconResponse*)p = *(_vbox__IMachine_USCOREgetIconResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIcon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIcon type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIcon*)p = *(_vbox__IMachine_USCOREsetIcon*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIconResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIconResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIconResponse*)p = *(_vbox__IMachine_USCOREsetIconResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccessible type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccessible*)p = *(_vbox__IMachine_USCOREgetAccessible*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessibleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccessibleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccessibleResponse*)p = *(_vbox__IMachine_USCOREgetAccessibleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccessError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccessError*)p = *(_vbox__IMachine_USCOREgetAccessError*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccessErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccessErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccessErrorResponse*)p = *(_vbox__IMachine_USCOREgetAccessErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetName*)p = *(_vbox__IMachine_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetNameResponse*)p = *(_vbox__IMachine_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetName*)p = *(_vbox__IMachine_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetNameResponse*)p = *(_vbox__IMachine_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDescription*)p = *(_vbox__IMachine_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDescriptionResponse*)p = *(_vbox__IMachine_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDescription*)p = *(_vbox__IMachine_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDescriptionResponse*)p = *(_vbox__IMachine_USCOREsetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetId*)p = *(_vbox__IMachine_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIdResponse*)p = *(_vbox__IMachine_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGroups*)p = *(_vbox__IMachine_USCOREgetGroups*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGroupsResponse*)p = *(_vbox__IMachine_USCOREgetGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGroups*)p = *(_vbox__IMachine_USCOREsetGroups*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGroupsResponse*)p = *(_vbox__IMachine_USCOREsetGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetOSTypeId*)p = *(_vbox__IMachine_USCOREgetOSTypeId*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetOSTypeIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetOSTypeIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetOSTypeIdResponse*)p = *(_vbox__IMachine_USCOREgetOSTypeIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetOSTypeId*)p = *(_vbox__IMachine_USCOREsetOSTypeId*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetOSTypeIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetOSTypeIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetOSTypeIdResponse*)p = *(_vbox__IMachine_USCOREsetOSTypeIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHardwareVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHardwareVersion*)p = *(_vbox__IMachine_USCOREgetHardwareVersion*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHardwareVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHardwareVersionResponse*)p = *(_vbox__IMachine_USCOREgetHardwareVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHardwareVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHardwareVersion*)p = *(_vbox__IMachine_USCOREsetHardwareVersion*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHardwareVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHardwareVersionResponse*)p = *(_vbox__IMachine_USCOREsetHardwareVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHardwareUUID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHardwareUUID*)p = *(_vbox__IMachine_USCOREgetHardwareUUID*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHardwareUUIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHardwareUUIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHardwareUUIDResponse*)p = *(_vbox__IMachine_USCOREgetHardwareUUIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHardwareUUID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHardwareUUID*)p = *(_vbox__IMachine_USCOREsetHardwareUUID*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHardwareUUIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHardwareUUIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHardwareUUIDResponse*)p = *(_vbox__IMachine_USCOREsetHardwareUUIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUCount*)p = *(_vbox__IMachine_USCOREgetCPUCount*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUCountResponse*)p = *(_vbox__IMachine_USCOREgetCPUCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUCount*)p = *(_vbox__IMachine_USCOREsetCPUCount*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUCountResponse*)p = *(_vbox__IMachine_USCOREsetCPUCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUHotPlugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUHotPlugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUHotPlugEnabled*)p = *(_vbox__IMachine_USCOREgetCPUHotPlugEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUHotPlugEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUHotPlugEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUHotPlugEnabledResponse*)p = *(_vbox__IMachine_USCOREgetCPUHotPlugEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUHotPlugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUHotPlugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUHotPlugEnabled*)p = *(_vbox__IMachine_USCOREsetCPUHotPlugEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUHotPlugEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUHotPlugEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUHotPlugEnabledResponse*)p = *(_vbox__IMachine_USCOREsetCPUHotPlugEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUExecutionCap*)p = *(_vbox__IMachine_USCOREgetCPUExecutionCap*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUExecutionCapResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUExecutionCapResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUExecutionCapResponse*)p = *(_vbox__IMachine_USCOREgetCPUExecutionCapResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUExecutionCap*)p = *(_vbox__IMachine_USCOREsetCPUExecutionCap*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUExecutionCapResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUExecutionCapResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUExecutionCapResponse*)p = *(_vbox__IMachine_USCOREsetCPUExecutionCapResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUIDPortabilityLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUIDPortabilityLevel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUIDPortabilityLevel*)p = *(_vbox__IMachine_USCOREgetCPUIDPortabilityLevel*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUIDPortabilityLevelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUIDPortabilityLevelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUIDPortabilityLevelResponse*)p = *(_vbox__IMachine_USCOREgetCPUIDPortabilityLevelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUIDPortabilityLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUIDPortabilityLevel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUIDPortabilityLevel*)p = *(_vbox__IMachine_USCOREsetCPUIDPortabilityLevel*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUIDPortabilityLevelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUIDPortabilityLevelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUIDPortabilityLevelResponse*)p = *(_vbox__IMachine_USCOREsetCPUIDPortabilityLevelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMemorySize*)p = *(_vbox__IMachine_USCOREgetMemorySize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemorySizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMemorySizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMemorySizeResponse*)p = *(_vbox__IMachine_USCOREgetMemorySizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMemorySize*)p = *(_vbox__IMachine_USCOREsetMemorySize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemorySizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMemorySizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMemorySizeResponse*)p = *(_vbox__IMachine_USCOREsetMemorySizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMemoryBalloonSize*)p = *(_vbox__IMachine_USCOREgetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMemoryBalloonSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMemoryBalloonSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMemoryBalloonSizeResponse*)p = *(_vbox__IMachine_USCOREgetMemoryBalloonSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMemoryBalloonSize*)p = *(_vbox__IMachine_USCOREsetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMemoryBalloonSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMemoryBalloonSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMemoryBalloonSizeResponse*)p = *(_vbox__IMachine_USCOREsetMemoryBalloonSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPageFusionEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPageFusionEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPageFusionEnabled*)p = *(_vbox__IMachine_USCOREgetPageFusionEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPageFusionEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPageFusionEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPageFusionEnabledResponse*)p = *(_vbox__IMachine_USCOREgetPageFusionEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetPageFusionEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetPageFusionEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetPageFusionEnabled*)p = *(_vbox__IMachine_USCOREsetPageFusionEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetPageFusionEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetPageFusionEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetPageFusionEnabledResponse*)p = *(_vbox__IMachine_USCOREsetPageFusionEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGraphicsControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGraphicsControllerType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGraphicsControllerType*)p = *(_vbox__IMachine_USCOREgetGraphicsControllerType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGraphicsControllerTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGraphicsControllerTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGraphicsControllerTypeResponse*)p = *(_vbox__IMachine_USCOREgetGraphicsControllerTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGraphicsControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGraphicsControllerType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGraphicsControllerType*)p = *(_vbox__IMachine_USCOREsetGraphicsControllerType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGraphicsControllerTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGraphicsControllerTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGraphicsControllerTypeResponse*)p = *(_vbox__IMachine_USCOREsetGraphicsControllerTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVRAMSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVRAMSize*)p = *(_vbox__IMachine_USCOREgetVRAMSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRAMSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVRAMSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVRAMSizeResponse*)p = *(_vbox__IMachine_USCOREgetVRAMSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVRAMSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVRAMSize*)p = *(_vbox__IMachine_USCOREsetVRAMSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVRAMSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVRAMSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVRAMSizeResponse*)p = *(_vbox__IMachine_USCOREsetVRAMSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccelerate3DEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccelerate3DEnabled*)p = *(_vbox__IMachine_USCOREgetAccelerate3DEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate3DEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccelerate3DEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccelerate3DEnabledResponse*)p = *(_vbox__IMachine_USCOREgetAccelerate3DEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAccelerate3DEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAccelerate3DEnabled*)p = *(_vbox__IMachine_USCOREsetAccelerate3DEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate3DEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAccelerate3DEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAccelerate3DEnabledResponse*)p = *(_vbox__IMachine_USCOREsetAccelerate3DEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccelerate2DVideoEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p = *(_vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse*)p = *(_vbox__IMachine_USCOREgetAccelerate2DVideoEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAccelerate2DVideoEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p = *(_vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse*)p = *(_vbox__IMachine_USCOREsetAccelerate2DVideoEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMonitorCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMonitorCount*)p = *(_vbox__IMachine_USCOREgetMonitorCount*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMonitorCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMonitorCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMonitorCountResponse*)p = *(_vbox__IMachine_USCOREgetMonitorCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMonitorCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMonitorCount*)p = *(_vbox__IMachine_USCOREsetMonitorCount*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetMonitorCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetMonitorCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetMonitorCountResponse*)p = *(_vbox__IMachine_USCOREsetMonitorCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureEnabled*)p = *(_vbox__IMachine_USCOREgetVideoCaptureEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureEnabledResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureEnabled*)p = *(_vbox__IMachine_USCOREsetVideoCaptureEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureEnabledResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureScreens:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureScreens type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureScreens*)p = *(_vbox__IMachine_USCOREgetVideoCaptureScreens*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureScreensResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureScreensResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureScreensResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureScreensResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureScreens:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureScreens type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureScreens*)p = *(_vbox__IMachine_USCOREsetVideoCaptureScreens*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureScreensResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureScreensResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureScreensResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureScreensResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureFile*)p = *(_vbox__IMachine_USCOREgetVideoCaptureFile*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureFileResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureFile*)p = *(_vbox__IMachine_USCOREsetVideoCaptureFile*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureFileResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureWidth*)p = *(_vbox__IMachine_USCOREgetVideoCaptureWidth*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureWidthResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureWidth*)p = *(_vbox__IMachine_USCOREsetVideoCaptureWidth*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureWidthResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureHeight*)p = *(_vbox__IMachine_USCOREgetVideoCaptureHeight*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureHeightResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureHeight*)p = *(_vbox__IMachine_USCOREsetVideoCaptureHeight*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureHeightResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureRate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureRate*)p = *(_vbox__IMachine_USCOREgetVideoCaptureRate*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureRateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureRateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureRateResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureRateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureRate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureRate*)p = *(_vbox__IMachine_USCOREsetVideoCaptureRate*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureRateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureRateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureRateResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureRateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureFPS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureFPS type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureFPS*)p = *(_vbox__IMachine_USCOREgetVideoCaptureFPS*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureFPSResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureFPSResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureFPSResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureFPSResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureFPS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureFPS type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureFPS*)p = *(_vbox__IMachine_USCOREsetVideoCaptureFPS*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureFPSResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureFPSResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureFPSResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureFPSResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureMaxTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureMaxTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureMaxTime*)p = *(_vbox__IMachine_USCOREgetVideoCaptureMaxTime*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureMaxTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureMaxTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureMaxTimeResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureMaxTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureMaxTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureMaxTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureMaxTime*)p = *(_vbox__IMachine_USCOREsetVideoCaptureMaxTime*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureMaxTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureMaxTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureMaxTimeResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureMaxTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureMaxFileSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureMaxFileSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureMaxFileSize*)p = *(_vbox__IMachine_USCOREgetVideoCaptureMaxFileSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureMaxFileSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureMaxFileSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureMaxFileSizeResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureMaxFileSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureMaxFileSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureMaxFileSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureMaxFileSize*)p = *(_vbox__IMachine_USCOREsetVideoCaptureMaxFileSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureMaxFileSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureMaxFileSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureMaxFileSizeResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureMaxFileSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureOptions*)p = *(_vbox__IMachine_USCOREgetVideoCaptureOptions*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVideoCaptureOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVideoCaptureOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVideoCaptureOptionsResponse*)p = *(_vbox__IMachine_USCOREgetVideoCaptureOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureOptions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureOptions*)p = *(_vbox__IMachine_USCOREsetVideoCaptureOptions*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVideoCaptureOptionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVideoCaptureOptionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVideoCaptureOptionsResponse*)p = *(_vbox__IMachine_USCOREsetVideoCaptureOptionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBIOSSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBIOSSettings*)p = *(_vbox__IMachine_USCOREgetBIOSSettings*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBIOSSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBIOSSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBIOSSettingsResponse*)p = *(_vbox__IMachine_USCOREgetBIOSSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFirmwareType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFirmwareType*)p = *(_vbox__IMachine_USCOREgetFirmwareType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFirmwareTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFirmwareTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFirmwareTypeResponse*)p = *(_vbox__IMachine_USCOREgetFirmwareTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFirmwareType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFirmwareType*)p = *(_vbox__IMachine_USCOREsetFirmwareType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFirmwareTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFirmwareTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFirmwareTypeResponse*)p = *(_vbox__IMachine_USCOREsetFirmwareTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPointingHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPointingHIDType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPointingHIDType*)p = *(_vbox__IMachine_USCOREgetPointingHIDType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPointingHIDTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPointingHIDTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPointingHIDTypeResponse*)p = *(_vbox__IMachine_USCOREgetPointingHIDTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetPointingHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetPointingHIDType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetPointingHIDType*)p = *(_vbox__IMachine_USCOREsetPointingHIDType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetPointingHIDTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetPointingHIDTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetPointingHIDTypeResponse*)p = *(_vbox__IMachine_USCOREsetPointingHIDTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetKeyboardHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetKeyboardHIDType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetKeyboardHIDType*)p = *(_vbox__IMachine_USCOREgetKeyboardHIDType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetKeyboardHIDTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetKeyboardHIDTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetKeyboardHIDTypeResponse*)p = *(_vbox__IMachine_USCOREgetKeyboardHIDTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetKeyboardHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetKeyboardHIDType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetKeyboardHIDType*)p = *(_vbox__IMachine_USCOREsetKeyboardHIDType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetKeyboardHIDTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetKeyboardHIDTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetKeyboardHIDTypeResponse*)p = *(_vbox__IMachine_USCOREsetKeyboardHIDTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHPETEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHPETEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHPETEnabled*)p = *(_vbox__IMachine_USCOREgetHPETEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHPETEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHPETEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHPETEnabledResponse*)p = *(_vbox__IMachine_USCOREgetHPETEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHPETEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHPETEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHPETEnabled*)p = *(_vbox__IMachine_USCOREsetHPETEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHPETEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHPETEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHPETEnabledResponse*)p = *(_vbox__IMachine_USCOREsetHPETEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetChipsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetChipsetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetChipsetType*)p = *(_vbox__IMachine_USCOREgetChipsetType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetChipsetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetChipsetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetChipsetTypeResponse*)p = *(_vbox__IMachine_USCOREgetChipsetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetChipsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetChipsetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetChipsetType*)p = *(_vbox__IMachine_USCOREsetChipsetType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetChipsetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetChipsetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetChipsetTypeResponse*)p = *(_vbox__IMachine_USCOREsetChipsetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSnapshotFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSnapshotFolder*)p = *(_vbox__IMachine_USCOREgetSnapshotFolder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSnapshotFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSnapshotFolderResponse*)p = *(_vbox__IMachine_USCOREgetSnapshotFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetSnapshotFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetSnapshotFolder*)p = *(_vbox__IMachine_USCOREsetSnapshotFolder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSnapshotFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetSnapshotFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetSnapshotFolderResponse*)p = *(_vbox__IMachine_USCOREsetSnapshotFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDEServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVRDEServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVRDEServer*)p = *(_vbox__IMachine_USCOREgetVRDEServer*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVRDEServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVRDEServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVRDEServerResponse*)p = *(_vbox__IMachine_USCOREgetVRDEServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled*)p = *(_vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabledResponse*)p = *(_vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled*)p = *(_vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabledResponse*)p = *(_vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachments type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachments*)p = *(_vbox__IMachine_USCOREgetMediumAttachments*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachmentsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachmentsResponse*)p = *(_vbox__IMachine_USCOREgetMediumAttachmentsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllers type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllers*)p = *(_vbox__IMachine_USCOREgetUSBControllers*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllersResponse*)p = *(_vbox__IMachine_USCOREgetUSBControllersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBDeviceFilters*)p = *(_vbox__IMachine_USCOREgetUSBDeviceFilters*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBDeviceFiltersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBDeviceFiltersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBDeviceFiltersResponse*)p = *(_vbox__IMachine_USCOREgetUSBDeviceFiltersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAudioAdapter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAudioAdapter*)p = *(_vbox__IMachine_USCOREgetAudioAdapter*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAudioAdapterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAudioAdapterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAudioAdapterResponse*)p = *(_vbox__IMachine_USCOREgetAudioAdapterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllers type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllers*)p = *(_vbox__IMachine_USCOREgetStorageControllers*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllersResponse*)p = *(_vbox__IMachine_USCOREgetStorageControllersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsFilePath*)p = *(_vbox__IMachine_USCOREgetSettingsFilePath*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsFilePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsFilePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsFilePathResponse*)p = *(_vbox__IMachine_USCOREgetSettingsFilePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsAuxFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsAuxFilePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsAuxFilePath*)p = *(_vbox__IMachine_USCOREgetSettingsAuxFilePath*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsAuxFilePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsAuxFilePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsAuxFilePathResponse*)p = *(_vbox__IMachine_USCOREgetSettingsAuxFilePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModified:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsModified type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsModified*)p = *(_vbox__IMachine_USCOREgetSettingsModified*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSettingsModifiedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSettingsModifiedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSettingsModifiedResponse*)p = *(_vbox__IMachine_USCOREgetSettingsModifiedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionState*)p = *(_vbox__IMachine_USCOREgetSessionState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionStateResponse*)p = *(_vbox__IMachine_USCOREgetSessionStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionName*)p = *(_vbox__IMachine_USCOREgetSessionName*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionNameResponse*)p = *(_vbox__IMachine_USCOREgetSessionNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionPID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionPID*)p = *(_vbox__IMachine_USCOREgetSessionPID*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSessionPIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSessionPIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSessionPIDResponse*)p = *(_vbox__IMachine_USCOREgetSessionPIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetState*)p = *(_vbox__IMachine_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStateResponse*)p = *(_vbox__IMachine_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetLastStateChange type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetLastStateChange*)p = *(_vbox__IMachine_USCOREgetLastStateChange*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLastStateChangeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetLastStateChangeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetLastStateChangeResponse*)p = *(_vbox__IMachine_USCOREgetLastStateChangeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStateFilePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStateFilePath*)p = *(_vbox__IMachine_USCOREgetStateFilePath*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStateFilePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStateFilePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStateFilePathResponse*)p = *(_vbox__IMachine_USCOREgetStateFilePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetLogFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetLogFolder*)p = *(_vbox__IMachine_USCOREgetLogFolder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetLogFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetLogFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetLogFolderResponse*)p = *(_vbox__IMachine_USCOREgetLogFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCurrentSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCurrentSnapshot*)p = *(_vbox__IMachine_USCOREgetCurrentSnapshot*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentSnapshotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCurrentSnapshotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCurrentSnapshotResponse*)p = *(_vbox__IMachine_USCOREgetCurrentSnapshotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSnapshotCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSnapshotCount*)p = *(_vbox__IMachine_USCOREgetSnapshotCount*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSnapshotCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSnapshotCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSnapshotCountResponse*)p = *(_vbox__IMachine_USCOREgetSnapshotCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModified:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCurrentStateModified type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCurrentStateModified*)p = *(_vbox__IMachine_USCOREgetCurrentStateModified*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCurrentStateModifiedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCurrentStateModifiedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCurrentStateModifiedResponse*)p = *(_vbox__IMachine_USCOREgetCurrentStateModifiedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSharedFolders*)p = *(_vbox__IMachine_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSharedFoldersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSharedFoldersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSharedFoldersResponse*)p = *(_vbox__IMachine_USCOREgetSharedFoldersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetClipboardMode*)p = *(_vbox__IMachine_USCOREgetClipboardMode*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetClipboardModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetClipboardModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetClipboardModeResponse*)p = *(_vbox__IMachine_USCOREgetClipboardModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetClipboardMode*)p = *(_vbox__IMachine_USCOREsetClipboardMode*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetClipboardModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetClipboardModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetClipboardModeResponse*)p = *(_vbox__IMachine_USCOREsetClipboardModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDnDMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDnDMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDnDMode*)p = *(_vbox__IMachine_USCOREgetDnDMode*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDnDModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDnDModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDnDModeResponse*)p = *(_vbox__IMachine_USCOREgetDnDModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDnDMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDnDMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDnDMode*)p = *(_vbox__IMachine_USCOREsetDnDMode*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDnDModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDnDModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDnDModeResponse*)p = *(_vbox__IMachine_USCOREsetDnDModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterEnabled*)p = *(_vbox__IMachine_USCOREgetTeleporterEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterEnabledResponse*)p = *(_vbox__IMachine_USCOREgetTeleporterEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterEnabled*)p = *(_vbox__IMachine_USCOREsetTeleporterEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterEnabledResponse*)p = *(_vbox__IMachine_USCOREsetTeleporterEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterPort*)p = *(_vbox__IMachine_USCOREgetTeleporterPort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterPortResponse*)p = *(_vbox__IMachine_USCOREgetTeleporterPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterPort*)p = *(_vbox__IMachine_USCOREsetTeleporterPort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterPortResponse*)p = *(_vbox__IMachine_USCOREsetTeleporterPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterAddress*)p = *(_vbox__IMachine_USCOREgetTeleporterAddress*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterAddressResponse*)p = *(_vbox__IMachine_USCOREgetTeleporterAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterAddress*)p = *(_vbox__IMachine_USCOREsetTeleporterAddress*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterAddressResponse*)p = *(_vbox__IMachine_USCOREsetTeleporterAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterPassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterPassword*)p = *(_vbox__IMachine_USCOREgetTeleporterPassword*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTeleporterPasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTeleporterPasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTeleporterPasswordResponse*)p = *(_vbox__IMachine_USCOREgetTeleporterPasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterPassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterPassword*)p = *(_vbox__IMachine_USCOREsetTeleporterPassword*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTeleporterPasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTeleporterPasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTeleporterPasswordResponse*)p = *(_vbox__IMachine_USCOREsetTeleporterPasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParavirtProvider*)p = *(_vbox__IMachine_USCOREgetParavirtProvider*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParavirtProviderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParavirtProviderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParavirtProviderResponse*)p = *(_vbox__IMachine_USCOREgetParavirtProviderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetParavirtProvider*)p = *(_vbox__IMachine_USCOREsetParavirtProvider*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetParavirtProviderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetParavirtProviderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetParavirtProviderResponse*)p = *(_vbox__IMachine_USCOREsetParavirtProviderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceState*)p = *(_vbox__IMachine_USCOREgetFaultToleranceState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceStateResponse*)p = *(_vbox__IMachine_USCOREgetFaultToleranceStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceState*)p = *(_vbox__IMachine_USCOREsetFaultToleranceState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceStateResponse*)p = *(_vbox__IMachine_USCOREsetFaultToleranceStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultTolerancePort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultTolerancePort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultTolerancePort*)p = *(_vbox__IMachine_USCOREgetFaultTolerancePort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultTolerancePortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultTolerancePortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultTolerancePortResponse*)p = *(_vbox__IMachine_USCOREgetFaultTolerancePortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultTolerancePort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultTolerancePort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultTolerancePort*)p = *(_vbox__IMachine_USCOREsetFaultTolerancePort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultTolerancePortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultTolerancePortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultTolerancePortResponse*)p = *(_vbox__IMachine_USCOREsetFaultTolerancePortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceAddress*)p = *(_vbox__IMachine_USCOREgetFaultToleranceAddress*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceAddressResponse*)p = *(_vbox__IMachine_USCOREgetFaultToleranceAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceAddress*)p = *(_vbox__IMachine_USCOREsetFaultToleranceAddress*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceAddressResponse*)p = *(_vbox__IMachine_USCOREsetFaultToleranceAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultTolerancePassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultTolerancePassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultTolerancePassword*)p = *(_vbox__IMachine_USCOREgetFaultTolerancePassword*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultTolerancePasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultTolerancePasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultTolerancePasswordResponse*)p = *(_vbox__IMachine_USCOREgetFaultTolerancePasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultTolerancePassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultTolerancePassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultTolerancePassword*)p = *(_vbox__IMachine_USCOREsetFaultTolerancePassword*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultTolerancePasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultTolerancePasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultTolerancePasswordResponse*)p = *(_vbox__IMachine_USCOREsetFaultTolerancePasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceSyncInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceSyncInterval type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceSyncInterval*)p = *(_vbox__IMachine_USCOREgetFaultToleranceSyncInterval*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetFaultToleranceSyncIntervalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetFaultToleranceSyncIntervalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetFaultToleranceSyncIntervalResponse*)p = *(_vbox__IMachine_USCOREgetFaultToleranceSyncIntervalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceSyncInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceSyncInterval type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceSyncInterval*)p = *(_vbox__IMachine_USCOREsetFaultToleranceSyncInterval*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetFaultToleranceSyncIntervalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetFaultToleranceSyncIntervalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetFaultToleranceSyncIntervalResponse*)p = *(_vbox__IMachine_USCOREsetFaultToleranceSyncIntervalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetRTCUseUTC:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetRTCUseUTC type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetRTCUseUTC*)p = *(_vbox__IMachine_USCOREgetRTCUseUTC*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetRTCUseUTCResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetRTCUseUTCResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetRTCUseUTCResponse*)p = *(_vbox__IMachine_USCOREgetRTCUseUTCResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetRTCUseUTC:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetRTCUseUTC type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetRTCUseUTC*)p = *(_vbox__IMachine_USCOREsetRTCUseUTC*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetRTCUseUTCResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetRTCUseUTCResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetRTCUseUTCResponse*)p = *(_vbox__IMachine_USCOREsetRTCUseUTCResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIOCacheEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIOCacheEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIOCacheEnabled*)p = *(_vbox__IMachine_USCOREgetIOCacheEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIOCacheEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIOCacheEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIOCacheEnabledResponse*)p = *(_vbox__IMachine_USCOREgetIOCacheEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIOCacheEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIOCacheEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIOCacheEnabled*)p = *(_vbox__IMachine_USCOREsetIOCacheEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIOCacheEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIOCacheEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIOCacheEnabledResponse*)p = *(_vbox__IMachine_USCOREsetIOCacheEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIOCacheSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIOCacheSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIOCacheSize*)p = *(_vbox__IMachine_USCOREgetIOCacheSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetIOCacheSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetIOCacheSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetIOCacheSizeResponse*)p = *(_vbox__IMachine_USCOREgetIOCacheSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIOCacheSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIOCacheSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIOCacheSize*)p = *(_vbox__IMachine_USCOREsetIOCacheSize*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetIOCacheSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetIOCacheSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetIOCacheSizeResponse*)p = *(_vbox__IMachine_USCOREsetIOCacheSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPCIDeviceAssignments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPCIDeviceAssignments type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPCIDeviceAssignments*)p = *(_vbox__IMachine_USCOREgetPCIDeviceAssignments*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetPCIDeviceAssignmentsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetPCIDeviceAssignmentsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetPCIDeviceAssignmentsResponse*)p = *(_vbox__IMachine_USCOREgetPCIDeviceAssignmentsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBandwidthControl:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBandwidthControl type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBandwidthControl*)p = *(_vbox__IMachine_USCOREgetBandwidthControl*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBandwidthControlResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBandwidthControlResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBandwidthControlResponse*)p = *(_vbox__IMachine_USCOREgetBandwidthControlResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTracingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTracingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTracingEnabled*)p = *(_vbox__IMachine_USCOREgetTracingEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTracingEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTracingEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTracingEnabledResponse*)p = *(_vbox__IMachine_USCOREgetTracingEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTracingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTracingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTracingEnabled*)p = *(_vbox__IMachine_USCOREsetTracingEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTracingEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTracingEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTracingEnabledResponse*)p = *(_vbox__IMachine_USCOREsetTracingEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTracingConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTracingConfig type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTracingConfig*)p = *(_vbox__IMachine_USCOREgetTracingConfig*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetTracingConfigResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetTracingConfigResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetTracingConfigResponse*)p = *(_vbox__IMachine_USCOREgetTracingConfigResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTracingConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTracingConfig type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTracingConfig*)p = *(_vbox__IMachine_USCOREsetTracingConfig*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetTracingConfigResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetTracingConfigResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetTracingConfigResponse*)p = *(_vbox__IMachine_USCOREsetTracingConfigResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAllowTracingToAccessVM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAllowTracingToAccessVM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAllowTracingToAccessVM*)p = *(_vbox__IMachine_USCOREgetAllowTracingToAccessVM*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAllowTracingToAccessVMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAllowTracingToAccessVMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAllowTracingToAccessVMResponse*)p = *(_vbox__IMachine_USCOREgetAllowTracingToAccessVMResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAllowTracingToAccessVM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAllowTracingToAccessVM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAllowTracingToAccessVM*)p = *(_vbox__IMachine_USCOREsetAllowTracingToAccessVM*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAllowTracingToAccessVMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAllowTracingToAccessVMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAllowTracingToAccessVMResponse*)p = *(_vbox__IMachine_USCOREsetAllowTracingToAccessVMResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostartEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostartEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostartEnabled*)p = *(_vbox__IMachine_USCOREgetAutostartEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostartEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostartEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostartEnabledResponse*)p = *(_vbox__IMachine_USCOREgetAutostartEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostartEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostartEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostartEnabled*)p = *(_vbox__IMachine_USCOREsetAutostartEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostartEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostartEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostartEnabledResponse*)p = *(_vbox__IMachine_USCOREsetAutostartEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostartDelay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostartDelay type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostartDelay*)p = *(_vbox__IMachine_USCOREgetAutostartDelay*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostartDelayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostartDelayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostartDelayResponse*)p = *(_vbox__IMachine_USCOREgetAutostartDelayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostartDelay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostartDelay type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostartDelay*)p = *(_vbox__IMachine_USCOREsetAutostartDelay*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostartDelayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostartDelayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostartDelayResponse*)p = *(_vbox__IMachine_USCOREsetAutostartDelayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostopType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostopType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostopType*)p = *(_vbox__IMachine_USCOREgetAutostopType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetAutostopTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetAutostopTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetAutostopTypeResponse*)p = *(_vbox__IMachine_USCOREgetAutostopTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostopType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostopType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostopType*)p = *(_vbox__IMachine_USCOREsetAutostopType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutostopTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutostopTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutostopTypeResponse*)p = *(_vbox__IMachine_USCOREsetAutostopTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDefaultFrontend*)p = *(_vbox__IMachine_USCOREgetDefaultFrontend*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetDefaultFrontendResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetDefaultFrontendResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetDefaultFrontendResponse*)p = *(_vbox__IMachine_USCOREgetDefaultFrontendResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDefaultFrontend*)p = *(_vbox__IMachine_USCOREsetDefaultFrontend*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetDefaultFrontendResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetDefaultFrontendResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetDefaultFrontendResponse*)p = *(_vbox__IMachine_USCOREsetDefaultFrontendResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBProxyAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBProxyAvailable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBProxyAvailable*)p = *(_vbox__IMachine_USCOREgetUSBProxyAvailable*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBProxyAvailableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBProxyAvailableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBProxyAvailableResponse*)p = *(_vbox__IMachine_USCOREgetUSBProxyAvailableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVMProcessPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVMProcessPriority type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVMProcessPriority*)p = *(_vbox__IMachine_USCOREgetVMProcessPriority*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetVMProcessPriorityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetVMProcessPriorityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetVMProcessPriorityResponse*)p = *(_vbox__IMachine_USCOREgetVMProcessPriorityResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVMProcessPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVMProcessPriority type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVMProcessPriority*)p = *(_vbox__IMachine_USCOREsetVMProcessPriority*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetVMProcessPriorityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetVMProcessPriorityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetVMProcessPriorityResponse*)p = *(_vbox__IMachine_USCOREsetVMProcessPriorityResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParavirtDebug:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParavirtDebug type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParavirtDebug*)p = *(_vbox__IMachine_USCOREgetParavirtDebug*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParavirtDebugResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParavirtDebugResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParavirtDebugResponse*)p = *(_vbox__IMachine_USCOREgetParavirtDebugResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetParavirtDebug:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetParavirtDebug type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetParavirtDebug*)p = *(_vbox__IMachine_USCOREsetParavirtDebug*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetParavirtDebugResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetParavirtDebugResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetParavirtDebugResponse*)p = *(_vbox__IMachine_USCOREsetParavirtDebugResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUProfile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUProfile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUProfile*)p = *(_vbox__IMachine_USCOREgetCPUProfile*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUProfileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUProfileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUProfileResponse*)p = *(_vbox__IMachine_USCOREgetCPUProfileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUProfile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUProfile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUProfile*)p = *(_vbox__IMachine_USCOREsetCPUProfile*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUProfileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUProfileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUProfileResponse*)p = *(_vbox__IMachine_USCOREsetCPUProfileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORElockMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORElockMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORElockMachine*)p = *(_vbox__IMachine_USCORElockMachine*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORElockMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORElockMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORElockMachineResponse*)p = *(_vbox__IMachine_USCORElockMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORElaunchVMProcess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORElaunchVMProcess type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORElaunchVMProcess*)p = *(_vbox__IMachine_USCORElaunchVMProcess*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORElaunchVMProcessResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORElaunchVMProcessResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORElaunchVMProcessResponse*)p = *(_vbox__IMachine_USCORElaunchVMProcessResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetBootOrder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetBootOrder*)p = *(_vbox__IMachine_USCOREsetBootOrder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBootOrderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetBootOrderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetBootOrderResponse*)p = *(_vbox__IMachine_USCOREsetBootOrderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBootOrder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBootOrder*)p = *(_vbox__IMachine_USCOREgetBootOrder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetBootOrderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetBootOrderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetBootOrderResponse*)p = *(_vbox__IMachine_USCOREgetBootOrderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachDevice*)p = *(_vbox__IMachine_USCOREattachDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachDeviceResponse*)p = *(_vbox__IMachine_USCOREattachDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDeviceWithoutMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachDeviceWithoutMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachDeviceWithoutMedium*)p = *(_vbox__IMachine_USCOREattachDeviceWithoutMedium*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachDeviceWithoutMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachDeviceWithoutMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachDeviceWithoutMediumResponse*)p = *(_vbox__IMachine_USCOREattachDeviceWithoutMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdetachDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdetachDevice*)p = *(_vbox__IMachine_USCOREdetachDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdetachDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdetachDeviceResponse*)p = *(_vbox__IMachine_USCOREdetachDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREpassthroughDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREpassthroughDevice*)p = *(_vbox__IMachine_USCOREpassthroughDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREpassthroughDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREpassthroughDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREpassthroughDeviceResponse*)p = *(_vbox__IMachine_USCOREpassthroughDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREtemporaryEjectDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREtemporaryEjectDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREtemporaryEjectDevice*)p = *(_vbox__IMachine_USCOREtemporaryEjectDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREtemporaryEjectDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREtemporaryEjectDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREtemporaryEjectDeviceResponse*)p = *(_vbox__IMachine_USCOREtemporaryEjectDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREnonRotationalDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREnonRotationalDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREnonRotationalDevice*)p = *(_vbox__IMachine_USCOREnonRotationalDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREnonRotationalDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREnonRotationalDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREnonRotationalDeviceResponse*)p = *(_vbox__IMachine_USCOREnonRotationalDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutoDiscardForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutoDiscardForDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutoDiscardForDevice*)p = *(_vbox__IMachine_USCOREsetAutoDiscardForDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetAutoDiscardForDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetAutoDiscardForDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetAutoDiscardForDeviceResponse*)p = *(_vbox__IMachine_USCOREsetAutoDiscardForDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHotPluggableForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHotPluggableForDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHotPluggableForDevice*)p = *(_vbox__IMachine_USCOREsetHotPluggableForDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHotPluggableForDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHotPluggableForDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHotPluggableForDeviceResponse*)p = *(_vbox__IMachine_USCOREsetHotPluggableForDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBandwidthGroupForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetBandwidthGroupForDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetBandwidthGroupForDevice*)p = *(_vbox__IMachine_USCOREsetBandwidthGroupForDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetBandwidthGroupForDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetBandwidthGroupForDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetBandwidthGroupForDeviceResponse*)p = *(_vbox__IMachine_USCOREsetBandwidthGroupForDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetNoBandwidthGroupForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetNoBandwidthGroupForDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetNoBandwidthGroupForDevice*)p = *(_vbox__IMachine_USCOREsetNoBandwidthGroupForDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetNoBandwidthGroupForDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetNoBandwidthGroupForDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetNoBandwidthGroupForDeviceResponse*)p = *(_vbox__IMachine_USCOREsetNoBandwidthGroupForDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREunmountMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREunmountMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREunmountMedium*)p = *(_vbox__IMachine_USCOREunmountMedium*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREunmountMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREunmountMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREunmountMediumResponse*)p = *(_vbox__IMachine_USCOREunmountMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREmountMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREmountMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREmountMedium*)p = *(_vbox__IMachine_USCOREmountMedium*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREmountMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREmountMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREmountMediumResponse*)p = *(_vbox__IMachine_USCOREmountMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMedium*)p = *(_vbox__IMachine_USCOREgetMedium*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumResponse*)p = *(_vbox__IMachine_USCOREgetMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachmentsOfController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p = *(_vbox__IMachine_USCOREgetMediumAttachmentsOfController*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse*)p = *(_vbox__IMachine_USCOREgetMediumAttachmentsOfControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachment type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachment*)p = *(_vbox__IMachine_USCOREgetMediumAttachment*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetMediumAttachmentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetMediumAttachmentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetMediumAttachmentResponse*)p = *(_vbox__IMachine_USCOREgetMediumAttachmentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachHostPCIDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachHostPCIDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachHostPCIDevice*)p = *(_vbox__IMachine_USCOREattachHostPCIDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREattachHostPCIDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREattachHostPCIDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREattachHostPCIDeviceResponse*)p = *(_vbox__IMachine_USCOREattachHostPCIDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachHostPCIDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdetachHostPCIDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdetachHostPCIDevice*)p = *(_vbox__IMachine_USCOREdetachHostPCIDevice*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdetachHostPCIDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdetachHostPCIDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdetachHostPCIDeviceResponse*)p = *(_vbox__IMachine_USCOREdetachHostPCIDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetNetworkAdapter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetNetworkAdapter*)p = *(_vbox__IMachine_USCOREgetNetworkAdapter*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetNetworkAdapterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetNetworkAdapterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetNetworkAdapterResponse*)p = *(_vbox__IMachine_USCOREgetNetworkAdapterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREaddStorageController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREaddStorageController*)p = *(_vbox__IMachine_USCOREaddStorageController*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddStorageControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREaddStorageControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREaddStorageControllerResponse*)p = *(_vbox__IMachine_USCOREaddStorageControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllerByName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllerByName*)p = *(_vbox__IMachine_USCOREgetStorageControllerByName*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllerByNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllerByNameResponse*)p = *(_vbox__IMachine_USCOREgetStorageControllerByNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllerByInstance type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllerByInstance*)p = *(_vbox__IMachine_USCOREgetStorageControllerByInstance*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetStorageControllerByInstanceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetStorageControllerByInstanceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetStorageControllerByInstanceResponse*)p = *(_vbox__IMachine_USCOREgetStorageControllerByInstanceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveStorageController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveStorageController*)p = *(_vbox__IMachine_USCOREremoveStorageController*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveStorageControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveStorageControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveStorageControllerResponse*)p = *(_vbox__IMachine_USCOREremoveStorageControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetStorageControllerBootable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetStorageControllerBootable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetStorageControllerBootable*)p = *(_vbox__IMachine_USCOREsetStorageControllerBootable*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetStorageControllerBootableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetStorageControllerBootableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetStorageControllerBootableResponse*)p = *(_vbox__IMachine_USCOREsetStorageControllerBootableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddUSBController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREaddUSBController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREaddUSBController*)p = *(_vbox__IMachine_USCOREaddUSBController*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREaddUSBControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREaddUSBControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREaddUSBControllerResponse*)p = *(_vbox__IMachine_USCOREaddUSBControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveUSBController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveUSBController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveUSBController*)p = *(_vbox__IMachine_USCOREremoveUSBController*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveUSBControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveUSBControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveUSBControllerResponse*)p = *(_vbox__IMachine_USCOREremoveUSBControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllerByName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllerByName*)p = *(_vbox__IMachine_USCOREgetUSBControllerByName*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerByNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllerByNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllerByNameResponse*)p = *(_vbox__IMachine_USCOREgetUSBControllerByNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerCountByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllerCountByType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllerCountByType*)p = *(_vbox__IMachine_USCOREgetUSBControllerCountByType*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetUSBControllerCountByTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetUSBControllerCountByTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetUSBControllerCountByTypeResponse*)p = *(_vbox__IMachine_USCOREgetUSBControllerCountByTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSerialPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSerialPort*)p = *(_vbox__IMachine_USCOREgetSerialPort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetSerialPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetSerialPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetSerialPortResponse*)p = *(_vbox__IMachine_USCOREgetSerialPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParallelPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParallelPort*)p = *(_vbox__IMachine_USCOREgetParallelPort*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetParallelPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetParallelPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetParallelPortResponse*)p = *(_vbox__IMachine_USCOREgetParallelPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetExtraDataKeys type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetExtraDataKeys*)p = *(_vbox__IMachine_USCOREgetExtraDataKeys*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataKeysResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetExtraDataKeysResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetExtraDataKeysResponse*)p = *(_vbox__IMachine_USCOREgetExtraDataKeysResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetExtraData*)p = *(_vbox__IMachine_USCOREgetExtraData*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetExtraDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetExtraDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetExtraDataResponse*)p = *(_vbox__IMachine_USCOREgetExtraDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetExtraData*)p = *(_vbox__IMachine_USCOREsetExtraData*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetExtraDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetExtraDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetExtraDataResponse*)p = *(_vbox__IMachine_USCOREsetExtraDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUProperty*)p = *(_vbox__IMachine_USCOREgetCPUProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUPropertyResponse*)p = *(_vbox__IMachine_USCOREgetCPUPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUProperty*)p = *(_vbox__IMachine_USCOREsetCPUProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUPropertyResponse*)p = *(_vbox__IMachine_USCOREsetCPUPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUIDLeaf*)p = *(_vbox__IMachine_USCOREgetCPUIDLeaf*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUIDLeafResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUIDLeafResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUIDLeafResponse*)p = *(_vbox__IMachine_USCOREgetCPUIDLeafResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUIDLeaf*)p = *(_vbox__IMachine_USCOREsetCPUIDLeaf*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetCPUIDLeafResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetCPUIDLeafResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetCPUIDLeafResponse*)p = *(_vbox__IMachine_USCOREsetCPUIDLeafResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveCPUIDLeaf*)p = *(_vbox__IMachine_USCOREremoveCPUIDLeaf*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveCPUIDLeafResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveCPUIDLeafResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveCPUIDLeafResponse*)p = *(_vbox__IMachine_USCOREremoveCPUIDLeafResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCPUIDLeaves:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveAllCPUIDLeaves type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveAllCPUIDLeaves*)p = *(_vbox__IMachine_USCOREremoveAllCPUIDLeaves*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveAllCPUIDLeavesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveAllCPUIDLeavesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveAllCPUIDLeavesResponse*)p = *(_vbox__IMachine_USCOREremoveAllCPUIDLeavesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHWVirtExProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHWVirtExProperty*)p = *(_vbox__IMachine_USCOREgetHWVirtExProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetHWVirtExPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetHWVirtExPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetHWVirtExPropertyResponse*)p = *(_vbox__IMachine_USCOREgetHWVirtExPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHWVirtExProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHWVirtExProperty*)p = *(_vbox__IMachine_USCOREsetHWVirtExProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetHWVirtExPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetHWVirtExPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetHWVirtExPropertyResponse*)p = *(_vbox__IMachine_USCOREsetHWVirtExPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetSettingsFilePath*)p = *(_vbox__IMachine_USCOREsetSettingsFilePath*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetSettingsFilePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetSettingsFilePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetSettingsFilePathResponse*)p = *(_vbox__IMachine_USCOREsetSettingsFilePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsaveSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsaveSettings*)p = *(_vbox__IMachine_USCOREsaveSettings*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsaveSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsaveSettingsResponse*)p = *(_vbox__IMachine_USCOREsaveSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdiscardSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdiscardSettings*)p = *(_vbox__IMachine_USCOREdiscardSettings*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdiscardSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdiscardSettingsResponse*)p = *(_vbox__IMachine_USCOREdiscardSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREunregister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREunregister type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREunregister*)p = *(_vbox__IMachine_USCOREunregister*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREunregisterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREunregisterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREunregisterResponse*)p = *(_vbox__IMachine_USCOREunregisterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteConfig type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteConfig*)p = *(_vbox__IMachine_USCOREdeleteConfig*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteConfigResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteConfigResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteConfigResponse*)p = *(_vbox__IMachine_USCOREdeleteConfigResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREexportTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREexportTo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREexportTo*)p = *(_vbox__IMachine_USCOREexportTo*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREexportToResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREexportToResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREexportToResponse*)p = *(_vbox__IMachine_USCOREexportToResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREfindSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREfindSnapshot*)p = *(_vbox__IMachine_USCOREfindSnapshot*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREfindSnapshotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREfindSnapshotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREfindSnapshotResponse*)p = *(_vbox__IMachine_USCOREfindSnapshotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcreateSharedFolder*)p = *(_vbox__IMachine_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcreateSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcreateSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcreateSharedFolderResponse*)p = *(_vbox__IMachine_USCOREcreateSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveSharedFolder*)p = *(_vbox__IMachine_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREremoveSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREremoveSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREremoveSharedFolderResponse*)p = *(_vbox__IMachine_USCOREremoveSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindow:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcanShowConsoleWindow type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcanShowConsoleWindow*)p = *(_vbox__IMachine_USCOREcanShowConsoleWindow*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcanShowConsoleWindowResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcanShowConsoleWindowResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcanShowConsoleWindowResponse*)p = *(_vbox__IMachine_USCOREcanShowConsoleWindowResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindow:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREshowConsoleWindow type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREshowConsoleWindow*)p = *(_vbox__IMachine_USCOREshowConsoleWindow*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREshowConsoleWindowResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREshowConsoleWindowResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREshowConsoleWindowResponse*)p = *(_vbox__IMachine_USCOREshowConsoleWindowResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestProperty*)p = *(_vbox__IMachine_USCOREgetGuestProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestPropertyResponse*)p = *(_vbox__IMachine_USCOREgetGuestPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestPropertyValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestPropertyValue*)p = *(_vbox__IMachine_USCOREgetGuestPropertyValue*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestPropertyValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestPropertyValueResponse*)p = *(_vbox__IMachine_USCOREgetGuestPropertyValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestPropertyTimestamp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p = *(_vbox__IMachine_USCOREgetGuestPropertyTimestamp*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetGuestPropertyTimestampResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetGuestPropertyTimestampResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetGuestPropertyTimestampResponse*)p = *(_vbox__IMachine_USCOREgetGuestPropertyTimestampResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGuestProperty*)p = *(_vbox__IMachine_USCOREsetGuestProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGuestPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGuestPropertyResponse*)p = *(_vbox__IMachine_USCOREsetGuestPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGuestPropertyValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGuestPropertyValue*)p = *(_vbox__IMachine_USCOREsetGuestPropertyValue*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsetGuestPropertyValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsetGuestPropertyValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsetGuestPropertyValueResponse*)p = *(_vbox__IMachine_USCOREsetGuestPropertyValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteGuestProperty*)p = *(_vbox__IMachine_USCOREdeleteGuestProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteGuestPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteGuestPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteGuestPropertyResponse*)p = *(_vbox__IMachine_USCOREdeleteGuestPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREenumerateGuestProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREenumerateGuestProperties*)p = *(_vbox__IMachine_USCOREenumerateGuestProperties*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREenumerateGuestPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREenumerateGuestPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREenumerateGuestPropertiesResponse*)p = *(_vbox__IMachine_USCOREenumerateGuestPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedGuestScreenInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREquerySavedGuestScreenInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREquerySavedGuestScreenInfo*)p = *(_vbox__IMachine_USCOREquerySavedGuestScreenInfo*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedGuestScreenInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREquerySavedGuestScreenInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREquerySavedGuestScreenInfoResponse*)p = *(_vbox__IMachine_USCOREquerySavedGuestScreenInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadSavedThumbnailToArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadSavedThumbnailToArray*)p = *(_vbox__IMachine_USCOREreadSavedThumbnailToArray*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse*)p = *(_vbox__IMachine_USCOREreadSavedThumbnailToArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREquerySavedScreenshotInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREquerySavedScreenshotInfo*)p = *(_vbox__IMachine_USCOREquerySavedScreenshotInfo*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREquerySavedScreenshotInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREquerySavedScreenshotInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREquerySavedScreenshotInfoResponse*)p = *(_vbox__IMachine_USCOREquerySavedScreenshotInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadSavedScreenshotToArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadSavedScreenshotToArray*)p = *(_vbox__IMachine_USCOREreadSavedScreenshotToArray*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadSavedScreenshotToArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadSavedScreenshotToArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadSavedScreenshotToArrayResponse*)p = *(_vbox__IMachine_USCOREreadSavedScreenshotToArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREhotPlugCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREhotPlugCPU type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREhotPlugCPU*)p = *(_vbox__IMachine_USCOREhotPlugCPU*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREhotPlugCPUResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREhotPlugCPUResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREhotPlugCPUResponse*)p = *(_vbox__IMachine_USCOREhotPlugCPUResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREhotUnplugCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREhotUnplugCPU type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREhotUnplugCPU*)p = *(_vbox__IMachine_USCOREhotUnplugCPU*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREhotUnplugCPUResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREhotUnplugCPUResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREhotUnplugCPUResponse*)p = *(_vbox__IMachine_USCOREhotUnplugCPUResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUStatus*)p = *(_vbox__IMachine_USCOREgetCPUStatus*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetCPUStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetCPUStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetCPUStatusResponse*)p = *(_vbox__IMachine_USCOREgetCPUStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetEffectiveParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetEffectiveParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetEffectiveParavirtProvider*)p = *(_vbox__IMachine_USCOREgetEffectiveParavirtProvider*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREgetEffectiveParavirtProviderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREgetEffectiveParavirtProviderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREgetEffectiveParavirtProviderResponse*)p = *(_vbox__IMachine_USCOREgetEffectiveParavirtProviderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREqueryLogFilename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREqueryLogFilename type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREqueryLogFilename*)p = *(_vbox__IMachine_USCOREqueryLogFilename*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREqueryLogFilenameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREqueryLogFilenameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREqueryLogFilenameResponse*)p = *(_vbox__IMachine_USCOREqueryLogFilenameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadLog:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadLog type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadLog*)p = *(_vbox__IMachine_USCOREreadLog*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREreadLogResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREreadLogResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREreadLogResponse*)p = *(_vbox__IMachine_USCOREreadLogResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcloneTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcloneTo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcloneTo*)p = *(_vbox__IMachine_USCOREcloneTo*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREcloneToResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREcloneToResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREcloneToResponse*)p = *(_vbox__IMachine_USCOREcloneToResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsaveState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsaveState*)p = *(_vbox__IMachine_USCOREsaveState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREsaveStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREsaveStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREsaveStateResponse*)p = *(_vbox__IMachine_USCOREsaveStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREadoptSavedState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREadoptSavedState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREadoptSavedState*)p = *(_vbox__IMachine_USCOREadoptSavedState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREadoptSavedStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREadoptSavedStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREadoptSavedStateResponse*)p = *(_vbox__IMachine_USCOREadoptSavedStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSavedState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdiscardSavedState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdiscardSavedState*)p = *(_vbox__IMachine_USCOREdiscardSavedState*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdiscardSavedStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdiscardSavedStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdiscardSavedStateResponse*)p = *(_vbox__IMachine_USCOREdiscardSavedStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREtakeSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREtakeSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREtakeSnapshot*)p = *(_vbox__IMachine_USCOREtakeSnapshot*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREtakeSnapshotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREtakeSnapshotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREtakeSnapshotResponse*)p = *(_vbox__IMachine_USCOREtakeSnapshotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshot*)p = *(_vbox__IMachine_USCOREdeleteSnapshot*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshotResponse*)p = *(_vbox__IMachine_USCOREdeleteSnapshotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshotAndAllChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshotAndAllChildren type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshotAndAllChildren*)p = *(_vbox__IMachine_USCOREdeleteSnapshotAndAllChildren*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshotAndAllChildrenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshotAndAllChildrenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshotAndAllChildrenResponse*)p = *(_vbox__IMachine_USCOREdeleteSnapshotAndAllChildrenResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshotRange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshotRange type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshotRange*)p = *(_vbox__IMachine_USCOREdeleteSnapshotRange*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREdeleteSnapshotRangeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREdeleteSnapshotRangeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREdeleteSnapshotRangeResponse*)p = *(_vbox__IMachine_USCOREdeleteSnapshotRangeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORErestoreSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORErestoreSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORErestoreSnapshot*)p = *(_vbox__IMachine_USCORErestoreSnapshot*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCORErestoreSnapshotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCORErestoreSnapshotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCORErestoreSnapshotResponse*)p = *(_vbox__IMachine_USCORErestoreSnapshotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREapplyDefaults:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREapplyDefaults type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREapplyDefaults*)p = *(_vbox__IMachine_USCOREapplyDefaults*)q;
		break;
	case SOAP_TYPE__vbox__IMachine_USCOREapplyDefaultsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachine_USCOREapplyDefaultsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachine_USCOREapplyDefaultsResponse*)p = *(_vbox__IMachine_USCOREapplyDefaultsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREgetWebcams:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREgetWebcams type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREgetWebcams*)p = *(_vbox__IEmulatedUSB_USCOREgetWebcams*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREgetWebcamsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREgetWebcamsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREgetWebcamsResponse*)p = *(_vbox__IEmulatedUSB_USCOREgetWebcamsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREwebcamAttach:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREwebcamAttach type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREwebcamAttach*)p = *(_vbox__IEmulatedUSB_USCOREwebcamAttach*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREwebcamAttachResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREwebcamAttachResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREwebcamAttachResponse*)p = *(_vbox__IEmulatedUSB_USCOREwebcamAttachResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREwebcamDetach:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREwebcamDetach type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREwebcamDetach*)p = *(_vbox__IEmulatedUSB_USCOREwebcamDetach*)q;
		break;
	case SOAP_TYPE__vbox__IEmulatedUSB_USCOREwebcamDetachResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEmulatedUSB_USCOREwebcamDetachResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEmulatedUSB_USCOREwebcamDetachResponse*)p = *(_vbox__IEmulatedUSB_USCOREwebcamDetachResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetMachine*)p = *(_vbox__IConsole_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetMachineResponse*)p = *(_vbox__IConsole_USCOREgetMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetState*)p = *(_vbox__IConsole_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetStateResponse*)p = *(_vbox__IConsole_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetGuest type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetGuest*)p = *(_vbox__IConsole_USCOREgetGuest*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetGuestResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetGuestResponse*)p = *(_vbox__IConsole_USCOREgetGuestResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetKeyboard type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetKeyboard*)p = *(_vbox__IConsole_USCOREgetKeyboard*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetKeyboardResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetKeyboardResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetKeyboardResponse*)p = *(_vbox__IConsole_USCOREgetKeyboardResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetMouse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetMouse*)p = *(_vbox__IConsole_USCOREgetMouse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetMouseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetMouseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetMouseResponse*)p = *(_vbox__IConsole_USCOREgetMouseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDisplay type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDisplay*)p = *(_vbox__IConsole_USCOREgetDisplay*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDisplayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDisplayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDisplayResponse*)p = *(_vbox__IConsole_USCOREgetDisplayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDebugger:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDebugger type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDebugger*)p = *(_vbox__IConsole_USCOREgetDebugger*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDebuggerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDebuggerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDebuggerResponse*)p = *(_vbox__IConsole_USCOREgetDebuggerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetUSBDevices*)p = *(_vbox__IConsole_USCOREgetUSBDevices*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUSBDevicesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetUSBDevicesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetUSBDevicesResponse*)p = *(_vbox__IConsole_USCOREgetUSBDevicesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetRemoteUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetRemoteUSBDevices*)p = *(_vbox__IConsole_USCOREgetRemoteUSBDevices*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetRemoteUSBDevicesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetRemoteUSBDevicesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetRemoteUSBDevicesResponse*)p = *(_vbox__IConsole_USCOREgetRemoteUSBDevicesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetSharedFolders*)p = *(_vbox__IConsole_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetSharedFoldersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetSharedFoldersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetSharedFoldersResponse*)p = *(_vbox__IConsole_USCOREgetSharedFoldersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetVRDEServerInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetVRDEServerInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetVRDEServerInfo*)p = *(_vbox__IConsole_USCOREgetVRDEServerInfo*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetVRDEServerInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetVRDEServerInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetVRDEServerInfoResponse*)p = *(_vbox__IConsole_USCOREgetVRDEServerInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetEventSource*)p = *(_vbox__IConsole_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetEventSourceResponse*)p = *(_vbox__IConsole_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetAttachedPCIDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetAttachedPCIDevices type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetAttachedPCIDevices*)p = *(_vbox__IConsole_USCOREgetAttachedPCIDevices*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetAttachedPCIDevicesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetAttachedPCIDevicesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetAttachedPCIDevicesResponse*)p = *(_vbox__IConsole_USCOREgetAttachedPCIDevicesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUseHostClipboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetUseHostClipboard type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetUseHostClipboard*)p = *(_vbox__IConsole_USCOREgetUseHostClipboard*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetUseHostClipboardResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetUseHostClipboardResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetUseHostClipboardResponse*)p = *(_vbox__IConsole_USCOREgetUseHostClipboardResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsetUseHostClipboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREsetUseHostClipboard type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREsetUseHostClipboard*)p = *(_vbox__IConsole_USCOREsetUseHostClipboard*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsetUseHostClipboardResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREsetUseHostClipboardResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREsetUseHostClipboardResponse*)p = *(_vbox__IConsole_USCOREsetUseHostClipboardResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetEmulatedUSB:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetEmulatedUSB type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetEmulatedUSB*)p = *(_vbox__IConsole_USCOREgetEmulatedUSB*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetEmulatedUSBResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetEmulatedUSBResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetEmulatedUSBResponse*)p = *(_vbox__IConsole_USCOREgetEmulatedUSBResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerUp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerUp*)p = *(_vbox__IConsole_USCOREpowerUp*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerUpResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerUpResponse*)p = *(_vbox__IConsole_USCOREpowerUpResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPaused:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerUpPaused type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerUpPaused*)p = *(_vbox__IConsole_USCOREpowerUpPaused*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerUpPausedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerUpPausedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerUpPausedResponse*)p = *(_vbox__IConsole_USCOREpowerUpPausedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDown:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerDown type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerDown*)p = *(_vbox__IConsole_USCOREpowerDown*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerDownResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerDownResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerDownResponse*)p = *(_vbox__IConsole_USCOREpowerDownResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREreset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREreset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREreset*)p = *(_vbox__IConsole_USCOREreset*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREresetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREresetResponse*)p = *(_vbox__IConsole_USCOREresetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpause:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpause type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpause*)p = *(_vbox__IConsole_USCOREpause*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpauseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpauseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpauseResponse*)p = *(_vbox__IConsole_USCOREpauseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresume:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREresume type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREresume*)p = *(_vbox__IConsole_USCOREresume*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREresumeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREresumeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREresumeResponse*)p = *(_vbox__IConsole_USCOREresumeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButton:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerButton type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerButton*)p = *(_vbox__IConsole_USCOREpowerButton*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREpowerButtonResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREpowerButtonResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREpowerButtonResponse*)p = *(_vbox__IConsole_USCOREpowerButtonResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButton:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREsleepButton type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREsleepButton*)p = *(_vbox__IConsole_USCOREsleepButton*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREsleepButtonResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREsleepButtonResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREsleepButtonResponse*)p = *(_vbox__IConsole_USCOREsleepButtonResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetPowerButtonHandled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetPowerButtonHandled*)p = *(_vbox__IConsole_USCOREgetPowerButtonHandled*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetPowerButtonHandledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetPowerButtonHandledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetPowerButtonHandledResponse*)p = *(_vbox__IConsole_USCOREgetPowerButtonHandledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetGuestEnteredACPIMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p = *(_vbox__IConsole_USCOREgetGuestEnteredACPIMode*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse*)p = *(_vbox__IConsole_USCOREgetGuestEnteredACPIModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivity:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDeviceActivity type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDeviceActivity*)p = *(_vbox__IConsole_USCOREgetDeviceActivity*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREgetDeviceActivityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREgetDeviceActivityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREgetDeviceActivityResponse*)p = *(_vbox__IConsole_USCOREgetDeviceActivityResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREattachUSBDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREattachUSBDevice*)p = *(_vbox__IConsole_USCOREattachUSBDevice*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREattachUSBDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREattachUSBDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREattachUSBDeviceResponse*)p = *(_vbox__IConsole_USCOREattachUSBDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREdetachUSBDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREdetachUSBDevice*)p = *(_vbox__IConsole_USCOREdetachUSBDevice*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREdetachUSBDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREdetachUSBDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREdetachUSBDeviceResponse*)p = *(_vbox__IConsole_USCOREdetachUSBDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREfindUSBDeviceByAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREfindUSBDeviceByAddress*)p = *(_vbox__IConsole_USCOREfindUSBDeviceByAddress*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREfindUSBDeviceByAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREfindUSBDeviceByAddressResponse*)p = *(_vbox__IConsole_USCOREfindUSBDeviceByAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREfindUSBDeviceById type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREfindUSBDeviceById*)p = *(_vbox__IConsole_USCOREfindUSBDeviceById*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREfindUSBDeviceByIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREfindUSBDeviceByIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREfindUSBDeviceByIdResponse*)p = *(_vbox__IConsole_USCOREfindUSBDeviceByIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREcreateSharedFolder*)p = *(_vbox__IConsole_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREcreateSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREcreateSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREcreateSharedFolderResponse*)p = *(_vbox__IConsole_USCOREcreateSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREremoveSharedFolder*)p = *(_vbox__IConsole_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveSharedFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREremoveSharedFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREremoveSharedFolderResponse*)p = *(_vbox__IConsole_USCOREremoveSharedFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREteleport:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREteleport type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREteleport*)p = *(_vbox__IConsole_USCOREteleport*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREteleportResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREteleportResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREteleportResponse*)p = *(_vbox__IConsole_USCOREteleportResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREaddDiskEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREaddDiskEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREaddDiskEncryptionPassword*)p = *(_vbox__IConsole_USCOREaddDiskEncryptionPassword*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREaddDiskEncryptionPasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREaddDiskEncryptionPasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREaddDiskEncryptionPasswordResponse*)p = *(_vbox__IConsole_USCOREaddDiskEncryptionPasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREaddDiskEncryptionPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREaddDiskEncryptionPasswords type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREaddDiskEncryptionPasswords*)p = *(_vbox__IConsole_USCOREaddDiskEncryptionPasswords*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREaddDiskEncryptionPasswordsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREaddDiskEncryptionPasswordsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREaddDiskEncryptionPasswordsResponse*)p = *(_vbox__IConsole_USCOREaddDiskEncryptionPasswordsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveDiskEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREremoveDiskEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREremoveDiskEncryptionPassword*)p = *(_vbox__IConsole_USCOREremoveDiskEncryptionPassword*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREremoveDiskEncryptionPasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREremoveDiskEncryptionPasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREremoveDiskEncryptionPasswordResponse*)p = *(_vbox__IConsole_USCOREremoveDiskEncryptionPasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREclearAllDiskEncryptionPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREclearAllDiskEncryptionPasswords type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREclearAllDiskEncryptionPasswords*)p = *(_vbox__IConsole_USCOREclearAllDiskEncryptionPasswords*)q;
		break;
	case SOAP_TYPE__vbox__IConsole_USCOREclearAllDiskEncryptionPasswordsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IConsole_USCOREclearAllDiskEncryptionPasswordsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IConsole_USCOREclearAllDiskEncryptionPasswordsResponse*)p = *(_vbox__IConsole_USCOREclearAllDiskEncryptionPasswordsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetName*)p = *(_vbox__IHostNetworkInterface_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetNameResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetShortName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetShortName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetShortName*)p = *(_vbox__IHostNetworkInterface_USCOREgetShortName*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetShortNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetShortNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetShortNameResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetShortNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetId*)p = *(_vbox__IHostNetworkInterface_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIdResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetNetworkName*)p = *(_vbox__IHostNetworkInterface_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDHCPEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetDHCPEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetDHCPEnabled*)p = *(_vbox__IHostNetworkInterface_USCOREgetDHCPEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetDHCPEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetDHCPEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetDHCPEnabledResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetDHCPEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPAddress*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPAddress*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPAddressResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetNetworkMask type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p = *(_vbox__IHostNetworkInterface_USCOREgetNetworkMask*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetNetworkMaskResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6Supported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6SupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6Address type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6Address*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6AddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLengthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetHardwareAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p = *(_vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetHardwareAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetMediumType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetMediumType*)p = *(_vbox__IHostNetworkInterface_USCOREgetMediumType*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetMediumTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetStatus*)p = *(_vbox__IHostNetworkInterface_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetStatusResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetInterfaceType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p = *(_vbox__IHostNetworkInterface_USCOREgetInterfaceType*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse*)p = *(_vbox__IHostNetworkInterface_USCOREgetInterfaceTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIPConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableStaticIPConfig type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfig*)p = *(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfig*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIPConfigResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableStaticIPConfigResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigResponse*)p = *(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6*)p = *(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6Response*)p = *(_vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6Response*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig*)p = *(_vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREenableDynamicIPConfigResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREenableDynamicIPConfigResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREenableDynamicIPConfigResponse*)p = *(_vbox__IHostNetworkInterface_USCOREenableDynamicIPConfigResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREDHCPRediscover:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREDHCPRediscover type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREDHCPRediscover*)p = *(_vbox__IHostNetworkInterface_USCOREDHCPRediscover*)q;
		break;
	case SOAP_TYPE__vbox__IHostNetworkInterface_USCOREDHCPRediscoverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNetworkInterface_USCOREDHCPRediscoverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNetworkInterface_USCOREDHCPRediscoverResponse*)p = *(_vbox__IHostNetworkInterface_USCOREDHCPRediscoverResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetName*)p = *(_vbox__IHostVideoInputDevice_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetNameResponse*)p = *(_vbox__IHostVideoInputDevice_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetPath*)p = *(_vbox__IHostVideoInputDevice_USCOREgetPath*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetPathResponse*)p = *(_vbox__IHostVideoInputDevice_USCOREgetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetAlias:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetAlias type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetAlias*)p = *(_vbox__IHostVideoInputDevice_USCOREgetAlias*)q;
		break;
	case SOAP_TYPE__vbox__IHostVideoInputDevice_USCOREgetAliasResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostVideoInputDevice_USCOREgetAliasResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostVideoInputDevice_USCOREgetAliasResponse*)p = *(_vbox__IHostVideoInputDevice_USCOREgetAliasResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrives:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetDVDDrives type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetDVDDrives*)p = *(_vbox__IHost_USCOREgetDVDDrives*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDVDDrivesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetDVDDrivesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetDVDDrivesResponse*)p = *(_vbox__IHost_USCOREgetDVDDrivesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrives:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetFloppyDrives type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetFloppyDrives*)p = *(_vbox__IHost_USCOREgetFloppyDrives*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetFloppyDrivesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetFloppyDrivesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetFloppyDrivesResponse*)p = *(_vbox__IHost_USCOREgetFloppyDrivesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUSBDevices*)p = *(_vbox__IHost_USCOREgetUSBDevices*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDevicesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUSBDevicesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUSBDevicesResponse*)p = *(_vbox__IHost_USCOREgetUSBDevicesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUSBDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUSBDeviceFilters*)p = *(_vbox__IHost_USCOREgetUSBDeviceFilters*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUSBDeviceFiltersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUSBDeviceFiltersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUSBDeviceFiltersResponse*)p = *(_vbox__IHost_USCOREgetUSBDeviceFiltersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetNetworkInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetNetworkInterfaces*)p = *(_vbox__IHost_USCOREgetNetworkInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNetworkInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetNetworkInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetNetworkInterfacesResponse*)p = *(_vbox__IHost_USCOREgetNetworkInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNameServers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetNameServers type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetNameServers*)p = *(_vbox__IHost_USCOREgetNameServers*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetNameServersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetNameServersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetNameServersResponse*)p = *(_vbox__IHost_USCOREgetNameServersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDomainName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetDomainName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetDomainName*)p = *(_vbox__IHost_USCOREgetDomainName*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetDomainNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetDomainNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetDomainNameResponse*)p = *(_vbox__IHost_USCOREgetDomainNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetSearchStrings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetSearchStrings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetSearchStrings*)p = *(_vbox__IHost_USCOREgetSearchStrings*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetSearchStringsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetSearchStringsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetSearchStringsResponse*)p = *(_vbox__IHost_USCOREgetSearchStringsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCount*)p = *(_vbox__IHost_USCOREgetProcessorCount*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCountResponse*)p = *(_vbox__IHost_USCOREgetProcessorCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorOnlineCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorOnlineCount*)p = *(_vbox__IHost_USCOREgetProcessorOnlineCount*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorOnlineCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorOnlineCountResponse*)p = *(_vbox__IHost_USCOREgetProcessorOnlineCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCoreCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCoreCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCoreCount*)p = *(_vbox__IHost_USCOREgetProcessorCoreCount*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCoreCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCoreCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCoreCountResponse*)p = *(_vbox__IHost_USCOREgetProcessorCoreCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCoreCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorOnlineCoreCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorOnlineCoreCount*)p = *(_vbox__IHost_USCOREgetProcessorOnlineCoreCount*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorOnlineCoreCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorOnlineCoreCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorOnlineCoreCountResponse*)p = *(_vbox__IHost_USCOREgetProcessorOnlineCoreCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetMemorySize*)p = *(_vbox__IHost_USCOREgetMemorySize*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemorySizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetMemorySizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetMemorySizeResponse*)p = *(_vbox__IHost_USCOREgetMemorySizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetMemoryAvailable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetMemoryAvailable*)p = *(_vbox__IHost_USCOREgetMemoryAvailable*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetMemoryAvailableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetMemoryAvailableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetMemoryAvailableResponse*)p = *(_vbox__IHost_USCOREgetMemoryAvailableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystem:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetOperatingSystem type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetOperatingSystem*)p = *(_vbox__IHost_USCOREgetOperatingSystem*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOperatingSystemResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetOperatingSystemResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetOperatingSystemResponse*)p = *(_vbox__IHost_USCOREgetOperatingSystemResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetOSVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetOSVersion*)p = *(_vbox__IHost_USCOREgetOSVersion*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetOSVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetOSVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetOSVersionResponse*)p = *(_vbox__IHost_USCOREgetOSVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUTCTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUTCTime*)p = *(_vbox__IHost_USCOREgetUTCTime*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetUTCTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetUTCTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetUTCTimeResponse*)p = *(_vbox__IHost_USCOREgetUTCTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetAcceleration3DAvailable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetAcceleration3DAvailable*)p = *(_vbox__IHost_USCOREgetAcceleration3DAvailable*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetAcceleration3DAvailableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetAcceleration3DAvailableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetAcceleration3DAvailableResponse*)p = *(_vbox__IHost_USCOREgetAcceleration3DAvailableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetVideoInputDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetVideoInputDevices type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetVideoInputDevices*)p = *(_vbox__IHost_USCOREgetVideoInputDevices*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetVideoInputDevicesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetVideoInputDevicesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetVideoInputDevicesResponse*)p = *(_vbox__IHost_USCOREgetVideoInputDevicesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorSpeed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorSpeed*)p = *(_vbox__IHost_USCOREgetProcessorSpeed*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorSpeedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorSpeedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorSpeedResponse*)p = *(_vbox__IHost_USCOREgetProcessorSpeedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeature:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorFeature type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorFeature*)p = *(_vbox__IHost_USCOREgetProcessorFeature*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorFeatureResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorFeatureResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorFeatureResponse*)p = *(_vbox__IHost_USCOREgetProcessorFeatureResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorDescription*)p = *(_vbox__IHost_USCOREgetProcessorDescription*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorDescriptionResponse*)p = *(_vbox__IHost_USCOREgetProcessorDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCPUIDLeaf*)p = *(_vbox__IHost_USCOREgetProcessorCPUIDLeaf*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgetProcessorCPUIDLeafResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgetProcessorCPUIDLeafResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgetProcessorCPUIDLeafResponse*)p = *(_vbox__IHost_USCOREgetProcessorCPUIDLeafResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREcreateHostOnlyNetworkInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p = *(_vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse*)p = *(_vbox__IHost_USCOREcreateHostOnlyNetworkInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveHostOnlyNetworkInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p = *(_vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse*)p = *(_vbox__IHost_USCOREremoveHostOnlyNetworkInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREcreateUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREcreateUSBDeviceFilter*)p = *(_vbox__IHost_USCOREcreateUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREcreateUSBDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREcreateUSBDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREcreateUSBDeviceFilterResponse*)p = *(_vbox__IHost_USCOREcreateUSBDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREinsertUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREinsertUSBDeviceFilter*)p = *(_vbox__IHost_USCOREinsertUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREinsertUSBDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREinsertUSBDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREinsertUSBDeviceFilterResponse*)p = *(_vbox__IHost_USCOREinsertUSBDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveUSBDeviceFilter*)p = *(_vbox__IHost_USCOREremoveUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveUSBDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveUSBDeviceFilterResponse*)p = *(_vbox__IHost_USCOREremoveUSBDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostDVDDrive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostDVDDrive*)p = *(_vbox__IHost_USCOREfindHostDVDDrive*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostDVDDriveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostDVDDriveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostDVDDriveResponse*)p = *(_vbox__IHost_USCOREfindHostDVDDriveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostFloppyDrive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostFloppyDrive*)p = *(_vbox__IHost_USCOREfindHostFloppyDrive*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostFloppyDriveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostFloppyDriveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostFloppyDriveResponse*)p = *(_vbox__IHost_USCOREfindHostFloppyDriveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfaceByName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfaceByName*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfaceByNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfaceById type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfaceById*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfaceById*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfaceByIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfacesOfType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse*)p = *(_vbox__IHost_USCOREfindHostNetworkInterfacesOfTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindUSBDeviceById type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindUSBDeviceById*)p = *(_vbox__IHost_USCOREfindUSBDeviceById*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindUSBDeviceByIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindUSBDeviceByIdResponse*)p = *(_vbox__IHost_USCOREfindUSBDeviceByIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindUSBDeviceByAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindUSBDeviceByAddress*)p = *(_vbox__IHost_USCOREfindUSBDeviceByAddress*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREfindUSBDeviceByAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREfindUSBDeviceByAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREfindUSBDeviceByAddressResponse*)p = *(_vbox__IHost_USCOREfindUSBDeviceByAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgenerateMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgenerateMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgenerateMACAddress*)p = *(_vbox__IHost_USCOREgenerateMACAddress*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREgenerateMACAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREgenerateMACAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREgenerateMACAddressResponse*)p = *(_vbox__IHost_USCOREgenerateMACAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREaddUSBDeviceSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREaddUSBDeviceSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREaddUSBDeviceSource*)p = *(_vbox__IHost_USCOREaddUSBDeviceSource*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREaddUSBDeviceSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREaddUSBDeviceSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREaddUSBDeviceSourceResponse*)p = *(_vbox__IHost_USCOREaddUSBDeviceSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveUSBDeviceSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveUSBDeviceSource*)p = *(_vbox__IHost_USCOREremoveUSBDeviceSource*)q;
		break;
	case SOAP_TYPE__vbox__IHost_USCOREremoveUSBDeviceSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHost_USCOREremoveUSBDeviceSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHost_USCOREremoveUSBDeviceSourceResponse*)p = *(_vbox__IHost_USCOREremoveUSBDeviceSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestRAM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestRAM*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestRAM*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestRAMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestRAMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestRAMResponse*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestRAMResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestRAM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestRAM*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestRAMResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestVRAM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestVRAM*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestVRAMResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestVRAM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestVRAMResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse*)p = *(_vbox__ISystemProperties_USCOREgetMinGuestCPUCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestCPUCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestMonitors:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestMonitors type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestMonitors*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestMonitors*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxGuestMonitorsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxGuestMonitorsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxGuestMonitorsResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxGuestMonitorsResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetInfoVDSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetInfoVDSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetInfoVDSize*)p = *(_vbox__ISystemProperties_USCOREgetInfoVDSize*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetInfoVDSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetInfoVDSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetInfoVDSizeResponse*)p = *(_vbox__ISystemProperties_USCOREgetInfoVDSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetSerialPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetSerialPortCount*)p = *(_vbox__ISystemProperties_USCOREgetSerialPortCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetSerialPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetSerialPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetSerialPortCountResponse*)p = *(_vbox__ISystemProperties_USCOREgetSerialPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetParallelPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetParallelPortCount*)p = *(_vbox__ISystemProperties_USCOREgetParallelPortCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetParallelPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetParallelPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetParallelPortCountResponse*)p = *(_vbox__ISystemProperties_USCOREgetParallelPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPosition:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxBootPosition type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxBootPosition*)p = *(_vbox__ISystemProperties_USCOREgetMaxBootPosition*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxBootPositionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxBootPositionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxBootPositionResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxBootPositionResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRawModeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetRawModeSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetRawModeSupported*)p = *(_vbox__ISystemProperties_USCOREgetRawModeSupported*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetRawModeSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetRawModeSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetRawModeSupportedResponse*)p = *(_vbox__ISystemProperties_USCOREgetRawModeSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetExclusiveHwVirt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetExclusiveHwVirt type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetExclusiveHwVirt*)p = *(_vbox__ISystemProperties_USCOREgetExclusiveHwVirt*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetExclusiveHwVirtResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetExclusiveHwVirtResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetExclusiveHwVirtResponse*)p = *(_vbox__ISystemProperties_USCOREgetExclusiveHwVirtResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetExclusiveHwVirt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetExclusiveHwVirt type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetExclusiveHwVirt*)p = *(_vbox__ISystemProperties_USCOREsetExclusiveHwVirt*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetExclusiveHwVirtResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetExclusiveHwVirtResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetExclusiveHwVirtResponse*)p = *(_vbox__ISystemProperties_USCOREsetExclusiveHwVirtResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultMachineFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p = *(_vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultMachineFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultMachineFolder type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p = *(_vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse*)p = *(_vbox__ISystemProperties_USCOREsetDefaultMachineFolderResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLoggingLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetLoggingLevel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetLoggingLevel*)p = *(_vbox__ISystemProperties_USCOREgetLoggingLevel*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLoggingLevelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetLoggingLevelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetLoggingLevelResponse*)p = *(_vbox__ISystemProperties_USCOREgetLoggingLevelResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLoggingLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetLoggingLevel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetLoggingLevel*)p = *(_vbox__ISystemProperties_USCOREsetLoggingLevel*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLoggingLevelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetLoggingLevelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetLoggingLevelResponse*)p = *(_vbox__ISystemProperties_USCOREsetLoggingLevelResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMediumFormats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMediumFormats*)p = *(_vbox__ISystemProperties_USCOREgetMediumFormats*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMediumFormatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMediumFormatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMediumFormatsResponse*)p = *(_vbox__ISystemProperties_USCOREgetMediumFormatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p = *(_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultHardDiskFormatResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p = *(_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse*)p = *(_vbox__ISystemProperties_USCOREsetDefaultHardDiskFormatResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarningResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarningResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarningResponse*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarningResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarningResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarningResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarningResponse*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarningResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarningResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarningResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarningResponse*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarningResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarningResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarningResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarningResponse*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarningResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpaceError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpaceError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceError*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceError*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpaceErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpaceErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceErrorResponse*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpaceErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpaceError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpaceError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceError*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceError*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpaceErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpaceErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceErrorResponse*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpaceErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentErrorResponse*)p = *(_vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentErrorResponse*)p = *(_vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetVRDEAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetVRDEAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetVRDEAuthLibrary*)p = *(_vbox__ISystemProperties_USCOREgetVRDEAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetVRDEAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetVRDEAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetVRDEAuthLibraryResponse*)p = *(_vbox__ISystemProperties_USCOREgetVRDEAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetVRDEAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetVRDEAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetVRDEAuthLibrary*)p = *(_vbox__ISystemProperties_USCOREsetVRDEAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetVRDEAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetVRDEAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetVRDEAuthLibraryResponse*)p = *(_vbox__ISystemProperties_USCOREsetVRDEAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p = *(_vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse*)p = *(_vbox__ISystemProperties_USCOREgetWebServiceAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p = *(_vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse*)p = *(_vbox__ISystemProperties_USCOREsetWebServiceAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack*)p = *(_vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultVRDEExtPackResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultVRDEExtPackResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultVRDEExtPackResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultVRDEExtPackResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack*)p = *(_vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultVRDEExtPackResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultVRDEExtPackResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultVRDEExtPackResponse*)p = *(_vbox__ISystemProperties_USCOREsetDefaultVRDEExtPackResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetLogHistoryCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetLogHistoryCount*)p = *(_vbox__ISystemProperties_USCOREgetLogHistoryCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetLogHistoryCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetLogHistoryCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetLogHistoryCountResponse*)p = *(_vbox__ISystemProperties_USCOREgetLogHistoryCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetLogHistoryCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetLogHistoryCount*)p = *(_vbox__ISystemProperties_USCOREsetLogHistoryCount*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetLogHistoryCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetLogHistoryCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetLogHistoryCountResponse*)p = *(_vbox__ISystemProperties_USCOREsetLogHistoryCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p = *(_vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultAudioDriverResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetAutostartDatabasePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetAutostartDatabasePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetAutostartDatabasePath*)p = *(_vbox__ISystemProperties_USCOREgetAutostartDatabasePath*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetAutostartDatabasePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetAutostartDatabasePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetAutostartDatabasePathResponse*)p = *(_vbox__ISystemProperties_USCOREgetAutostartDatabasePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetAutostartDatabasePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetAutostartDatabasePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetAutostartDatabasePath*)p = *(_vbox__ISystemProperties_USCOREsetAutostartDatabasePath*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetAutostartDatabasePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetAutostartDatabasePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetAutostartDatabasePathResponse*)p = *(_vbox__ISystemProperties_USCOREsetAutostartDatabasePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAdditionsISO:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultAdditionsISO type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultAdditionsISO*)p = *(_vbox__ISystemProperties_USCOREgetDefaultAdditionsISO*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultAdditionsISOResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultAdditionsISOResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultAdditionsISOResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultAdditionsISOResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultAdditionsISO:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultAdditionsISO type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultAdditionsISO*)p = *(_vbox__ISystemProperties_USCOREsetDefaultAdditionsISO*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultAdditionsISOResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultAdditionsISOResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultAdditionsISOResponse*)p = *(_vbox__ISystemProperties_USCOREsetDefaultAdditionsISOResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultFrontend*)p = *(_vbox__ISystemProperties_USCOREgetDefaultFrontend*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultFrontendResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultFrontendResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultFrontendResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultFrontendResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultFrontend*)p = *(_vbox__ISystemProperties_USCOREsetDefaultFrontend*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREsetDefaultFrontendResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREsetDefaultFrontendResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREsetDefaultFrontendResponse*)p = *(_vbox__ISystemProperties_USCOREsetDefaultFrontendResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetScreenShotFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetScreenShotFormats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetScreenShotFormats*)p = *(_vbox__ISystemProperties_USCOREgetScreenShotFormats*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetScreenShotFormatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetScreenShotFormatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetScreenShotFormatsResponse*)p = *(_vbox__ISystemProperties_USCOREgetScreenShotFormatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxNetworkAdapters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxNetworkAdapters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxNetworkAdapters*)p = *(_vbox__ISystemProperties_USCOREgetMaxNetworkAdapters*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType*)p = *(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfTypeResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p = *(_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p = *(_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse*)p = *(_vbox__ISystemProperties_USCOREgetMinPortCountForStorageBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p = *(_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p = *(_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p = *(_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse*)p = *(_vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController*)p = *(_vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageControllerResponse*)p = *(_vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable*)p = *(_vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapableResponse*)p = *(_vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapableResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType*)p = *(_vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType*)q;
		break;
	case SOAP_TYPE__vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerTypeResponse*)p = *(_vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREgetFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREgetFormats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREgetFormats*)p = *(_vbox__IDnDBase_USCOREgetFormats*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREgetFormatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREgetFormatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREgetFormatsResponse*)p = *(_vbox__IDnDBase_USCOREgetFormatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREgetProtocolVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREgetProtocolVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREgetProtocolVersion*)p = *(_vbox__IDnDBase_USCOREgetProtocolVersion*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREgetProtocolVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREgetProtocolVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREgetProtocolVersionResponse*)p = *(_vbox__IDnDBase_USCOREgetProtocolVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREisFormatSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREisFormatSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREisFormatSupported*)p = *(_vbox__IDnDBase_USCOREisFormatSupported*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREisFormatSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREisFormatSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREisFormatSupportedResponse*)p = *(_vbox__IDnDBase_USCOREisFormatSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREaddFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREaddFormats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREaddFormats*)p = *(_vbox__IDnDBase_USCOREaddFormats*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREaddFormatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREaddFormatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREaddFormatsResponse*)p = *(_vbox__IDnDBase_USCOREaddFormatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREremoveFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREremoveFormats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREremoveFormats*)p = *(_vbox__IDnDBase_USCOREremoveFormats*)q;
		break;
	case SOAP_TYPE__vbox__IDnDBase_USCOREremoveFormatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDBase_USCOREremoveFormatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDBase_USCOREremoveFormatsResponse*)p = *(_vbox__IDnDBase_USCOREremoveFormatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREdragIsPending:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREdragIsPending type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREdragIsPending*)p = *(_vbox__IDnDSource_USCOREdragIsPending*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREdragIsPendingResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREdragIsPendingResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREdragIsPendingResponse*)p = *(_vbox__IDnDSource_USCOREdragIsPendingResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREdrop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREdrop type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREdrop*)p = *(_vbox__IDnDSource_USCOREdrop*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREdropResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREdropResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREdropResponse*)p = *(_vbox__IDnDSource_USCOREdropResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREreceiveData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREreceiveData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREreceiveData*)p = *(_vbox__IDnDSource_USCOREreceiveData*)q;
		break;
	case SOAP_TYPE__vbox__IDnDSource_USCOREreceiveDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDSource_USCOREreceiveDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDSource_USCOREreceiveDataResponse*)p = *(_vbox__IDnDSource_USCOREreceiveDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREenter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREenter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREenter*)p = *(_vbox__IDnDTarget_USCOREenter*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREenterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREenterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREenterResponse*)p = *(_vbox__IDnDTarget_USCOREenterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREmove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREmove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREmove*)p = *(_vbox__IDnDTarget_USCOREmove*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREmoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREmoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREmoveResponse*)p = *(_vbox__IDnDTarget_USCOREmoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREleave:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREleave type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREleave*)p = *(_vbox__IDnDTarget_USCOREleave*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREleaveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREleaveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREleaveResponse*)p = *(_vbox__IDnDTarget_USCOREleaveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREdrop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREdrop type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREdrop*)p = *(_vbox__IDnDTarget_USCOREdrop*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREdropResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREdropResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREdropResponse*)p = *(_vbox__IDnDTarget_USCOREdropResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREsendData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREsendData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREsendData*)p = *(_vbox__IDnDTarget_USCOREsendData*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREsendDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREsendDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREsendDataResponse*)p = *(_vbox__IDnDTarget_USCOREsendDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREcancel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREcancel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREcancel*)p = *(_vbox__IDnDTarget_USCOREcancel*)q;
		break;
	case SOAP_TYPE__vbox__IDnDTarget_USCOREcancelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDTarget_USCOREcancelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDTarget_USCOREcancelResponse*)p = *(_vbox__IDnDTarget_USCOREcancelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetUser type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetUser*)p = *(_vbox__IGuestSession_USCOREgetUser*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetUserResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetUserResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetUserResponse*)p = *(_vbox__IGuestSession_USCOREgetUserResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetDomain type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetDomain*)p = *(_vbox__IGuestSession_USCOREgetDomain*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetDomainResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetDomainResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetDomainResponse*)p = *(_vbox__IGuestSession_USCOREgetDomainResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetName*)p = *(_vbox__IGuestSession_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetNameResponse*)p = *(_vbox__IGuestSession_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetId*)p = *(_vbox__IGuestSession_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetIdResponse*)p = *(_vbox__IGuestSession_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetTimeout*)p = *(_vbox__IGuestSession_USCOREgetTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetTimeoutResponse*)p = *(_vbox__IGuestSession_USCOREgetTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetTimeout*)p = *(_vbox__IGuestSession_USCOREsetTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetTimeoutResponse*)p = *(_vbox__IGuestSession_USCOREsetTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetProtocolVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetProtocolVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetProtocolVersion*)p = *(_vbox__IGuestSession_USCOREgetProtocolVersion*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetProtocolVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetProtocolVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetProtocolVersionResponse*)p = *(_vbox__IGuestSession_USCOREgetProtocolVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetStatus*)p = *(_vbox__IGuestSession_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetStatusResponse*)p = *(_vbox__IGuestSession_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEnvironmentChanges:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEnvironmentChanges type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEnvironmentChanges*)p = *(_vbox__IGuestSession_USCOREgetEnvironmentChanges*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEnvironmentChangesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEnvironmentChangesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEnvironmentChangesResponse*)p = *(_vbox__IGuestSession_USCOREgetEnvironmentChangesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetEnvironmentChanges:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetEnvironmentChanges type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetEnvironmentChanges*)p = *(_vbox__IGuestSession_USCOREsetEnvironmentChanges*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetEnvironmentChangesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetEnvironmentChangesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetEnvironmentChangesResponse*)p = *(_vbox__IGuestSession_USCOREsetEnvironmentChangesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEnvironmentBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEnvironmentBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEnvironmentBase*)p = *(_vbox__IGuestSession_USCOREgetEnvironmentBase*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEnvironmentBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEnvironmentBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEnvironmentBaseResponse*)p = *(_vbox__IGuestSession_USCOREgetEnvironmentBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetProcesses:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetProcesses type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetProcesses*)p = *(_vbox__IGuestSession_USCOREgetProcesses*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetProcessesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetProcessesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetProcessesResponse*)p = *(_vbox__IGuestSession_USCOREgetProcessesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetPathStyle:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetPathStyle type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetPathStyle*)p = *(_vbox__IGuestSession_USCOREgetPathStyle*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetPathStyleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetPathStyleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetPathStyleResponse*)p = *(_vbox__IGuestSession_USCOREgetPathStyleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetCurrentDirectory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetCurrentDirectory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetCurrentDirectory*)p = *(_vbox__IGuestSession_USCOREgetCurrentDirectory*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetCurrentDirectoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetCurrentDirectoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetCurrentDirectoryResponse*)p = *(_vbox__IGuestSession_USCOREgetCurrentDirectoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetCurrentDirectory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetCurrentDirectory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetCurrentDirectory*)p = *(_vbox__IGuestSession_USCOREsetCurrentDirectory*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsetCurrentDirectoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsetCurrentDirectoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsetCurrentDirectoryResponse*)p = *(_vbox__IGuestSession_USCOREsetCurrentDirectoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetDirectories:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetDirectories type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetDirectories*)p = *(_vbox__IGuestSession_USCOREgetDirectories*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetDirectoriesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetDirectoriesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetDirectoriesResponse*)p = *(_vbox__IGuestSession_USCOREgetDirectoriesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetFiles:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetFiles type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetFiles*)p = *(_vbox__IGuestSession_USCOREgetFiles*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetFilesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetFilesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetFilesResponse*)p = *(_vbox__IGuestSession_USCOREgetFilesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEventSource*)p = *(_vbox__IGuestSession_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREgetEventSourceResponse*)p = *(_vbox__IGuestSession_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREclose*)p = *(_vbox__IGuestSession_USCOREclose*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREcloseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREcloseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREcloseResponse*)p = *(_vbox__IGuestSession_USCOREcloseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopy*)p = *(_vbox__IGuestSession_USCOREdirectoryCopy*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopyResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryCopyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopyFromGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopyFromGuest type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopyFromGuest*)p = *(_vbox__IGuestSession_USCOREdirectoryCopyFromGuest*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopyFromGuestResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopyFromGuestResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopyFromGuestResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryCopyFromGuestResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopyToGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopyToGuest type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopyToGuest*)p = *(_vbox__IGuestSession_USCOREdirectoryCopyToGuest*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCopyToGuestResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCopyToGuestResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCopyToGuestResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryCopyToGuestResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCreate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCreate*)p = *(_vbox__IGuestSession_USCOREdirectoryCreate*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCreateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCreateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCreateResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryCreateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCreateTemp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCreateTemp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCreateTemp*)p = *(_vbox__IGuestSession_USCOREdirectoryCreateTemp*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryCreateTempResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryCreateTempResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryCreateTempResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryCreateTempResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryExists type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryExists*)p = *(_vbox__IGuestSession_USCOREdirectoryExists*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryExistsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryExistsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryExistsResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryExistsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryOpen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryOpen type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryOpen*)p = *(_vbox__IGuestSession_USCOREdirectoryOpen*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryOpenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryOpenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryOpenResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryOpenResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryRemove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryRemove*)p = *(_vbox__IGuestSession_USCOREdirectoryRemove*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryRemoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryRemoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryRemoveResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryRemoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryRemoveRecursive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryRemoveRecursive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryRemoveRecursive*)p = *(_vbox__IGuestSession_USCOREdirectoryRemoveRecursive*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREdirectoryRemoveRecursiveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREdirectoryRemoveRecursiveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREdirectoryRemoveRecursiveResponse*)p = *(_vbox__IGuestSession_USCOREdirectoryRemoveRecursiveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentScheduleSet:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentScheduleSet type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentScheduleSet*)p = *(_vbox__IGuestSession_USCOREenvironmentScheduleSet*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentScheduleSetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentScheduleSetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentScheduleSetResponse*)p = *(_vbox__IGuestSession_USCOREenvironmentScheduleSetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentScheduleUnset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentScheduleUnset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentScheduleUnset*)p = *(_vbox__IGuestSession_USCOREenvironmentScheduleUnset*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentScheduleUnsetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentScheduleUnsetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentScheduleUnsetResponse*)p = *(_vbox__IGuestSession_USCOREenvironmentScheduleUnsetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentGetBaseVariable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentGetBaseVariable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentGetBaseVariable*)p = *(_vbox__IGuestSession_USCOREenvironmentGetBaseVariable*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentGetBaseVariableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentGetBaseVariableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentGetBaseVariableResponse*)p = *(_vbox__IGuestSession_USCOREenvironmentGetBaseVariableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist*)p = *(_vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExistResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExistResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExistResponse*)p = *(_vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExistResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopy*)p = *(_vbox__IGuestSession_USCOREfileCopy*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopyResponse*)p = *(_vbox__IGuestSession_USCOREfileCopyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopyFromGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopyFromGuest type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopyFromGuest*)p = *(_vbox__IGuestSession_USCOREfileCopyFromGuest*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopyFromGuestResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopyFromGuestResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopyFromGuestResponse*)p = *(_vbox__IGuestSession_USCOREfileCopyFromGuestResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopyToGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopyToGuest type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopyToGuest*)p = *(_vbox__IGuestSession_USCOREfileCopyToGuest*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCopyToGuestResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCopyToGuestResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCopyToGuestResponse*)p = *(_vbox__IGuestSession_USCOREfileCopyToGuestResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCreateTemp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCreateTemp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCreateTemp*)p = *(_vbox__IGuestSession_USCOREfileCreateTemp*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileCreateTempResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileCreateTempResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileCreateTempResponse*)p = *(_vbox__IGuestSession_USCOREfileCreateTempResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileExists type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileExists*)p = *(_vbox__IGuestSession_USCOREfileExists*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileExistsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileExistsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileExistsResponse*)p = *(_vbox__IGuestSession_USCOREfileExistsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileOpen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileOpen type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileOpen*)p = *(_vbox__IGuestSession_USCOREfileOpen*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileOpenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileOpenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileOpenResponse*)p = *(_vbox__IGuestSession_USCOREfileOpenResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileOpenEx:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileOpenEx type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileOpenEx*)p = *(_vbox__IGuestSession_USCOREfileOpenEx*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileOpenExResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileOpenExResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileOpenExResponse*)p = *(_vbox__IGuestSession_USCOREfileOpenExResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileQuerySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileQuerySize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileQuerySize*)p = *(_vbox__IGuestSession_USCOREfileQuerySize*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfileQuerySizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfileQuerySizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfileQuerySizeResponse*)p = *(_vbox__IGuestSession_USCOREfileQuerySizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjExists type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjExists*)p = *(_vbox__IGuestSession_USCOREfsObjExists*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjExistsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjExistsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjExistsResponse*)p = *(_vbox__IGuestSession_USCOREfsObjExistsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjQueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjQueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjQueryInfo*)p = *(_vbox__IGuestSession_USCOREfsObjQueryInfo*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjQueryInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjQueryInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjQueryInfoResponse*)p = *(_vbox__IGuestSession_USCOREfsObjQueryInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjRemove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjRemove*)p = *(_vbox__IGuestSession_USCOREfsObjRemove*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjRemoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjRemoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjRemoveResponse*)p = *(_vbox__IGuestSession_USCOREfsObjRemoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjRename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjRename type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjRename*)p = *(_vbox__IGuestSession_USCOREfsObjRename*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjRenameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjRenameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjRenameResponse*)p = *(_vbox__IGuestSession_USCOREfsObjRenameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjMove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjMove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjMove*)p = *(_vbox__IGuestSession_USCOREfsObjMove*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjMoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjMoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjMoveResponse*)p = *(_vbox__IGuestSession_USCOREfsObjMoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjSetACL:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjSetACL type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjSetACL*)p = *(_vbox__IGuestSession_USCOREfsObjSetACL*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREfsObjSetACLResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREfsObjSetACLResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREfsObjSetACLResponse*)p = *(_vbox__IGuestSession_USCOREfsObjSetACLResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessCreate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessCreate*)p = *(_vbox__IGuestSession_USCOREprocessCreate*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessCreateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessCreateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessCreateResponse*)p = *(_vbox__IGuestSession_USCOREprocessCreateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessCreateEx:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessCreateEx type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessCreateEx*)p = *(_vbox__IGuestSession_USCOREprocessCreateEx*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessCreateExResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessCreateExResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessCreateExResponse*)p = *(_vbox__IGuestSession_USCOREprocessCreateExResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessGet:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessGet type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessGet*)p = *(_vbox__IGuestSession_USCOREprocessGet*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREprocessGetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREprocessGetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREprocessGetResponse*)p = *(_vbox__IGuestSession_USCOREprocessGetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkCreate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkCreate*)p = *(_vbox__IGuestSession_USCOREsymlinkCreate*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkCreateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkCreateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkCreateResponse*)p = *(_vbox__IGuestSession_USCOREsymlinkCreateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkExists type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkExists*)p = *(_vbox__IGuestSession_USCOREsymlinkExists*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkExistsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkExistsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkExistsResponse*)p = *(_vbox__IGuestSession_USCOREsymlinkExistsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkRead:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkRead type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkRead*)p = *(_vbox__IGuestSession_USCOREsymlinkRead*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREsymlinkReadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREsymlinkReadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREsymlinkReadResponse*)p = *(_vbox__IGuestSession_USCOREsymlinkReadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREwaitFor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREwaitFor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREwaitFor*)p = *(_vbox__IGuestSession_USCOREwaitFor*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREwaitForResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREwaitForResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREwaitForResponse*)p = *(_vbox__IGuestSession_USCOREwaitForResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREwaitForArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREwaitForArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREwaitForArray*)p = *(_vbox__IGuestSession_USCOREwaitForArray*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSession_USCOREwaitForArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSession_USCOREwaitForArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSession_USCOREwaitForArrayResponse*)p = *(_vbox__IGuestSession_USCOREwaitForArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetArguments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetArguments type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetArguments*)p = *(_vbox__IProcess_USCOREgetArguments*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetArgumentsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetArgumentsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetArgumentsResponse*)p = *(_vbox__IProcess_USCOREgetArgumentsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetEnvironment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetEnvironment type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetEnvironment*)p = *(_vbox__IProcess_USCOREgetEnvironment*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetEnvironmentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetEnvironmentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetEnvironmentResponse*)p = *(_vbox__IProcess_USCOREgetEnvironmentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetEventSource*)p = *(_vbox__IProcess_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetEventSourceResponse*)p = *(_vbox__IProcess_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetExecutablePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetExecutablePath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetExecutablePath*)p = *(_vbox__IProcess_USCOREgetExecutablePath*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetExecutablePathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetExecutablePathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetExecutablePathResponse*)p = *(_vbox__IProcess_USCOREgetExecutablePathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetExitCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetExitCode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetExitCode*)p = *(_vbox__IProcess_USCOREgetExitCode*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetExitCodeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetExitCodeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetExitCodeResponse*)p = *(_vbox__IProcess_USCOREgetExitCodeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetName*)p = *(_vbox__IProcess_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetNameResponse*)p = *(_vbox__IProcess_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetPID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetPID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetPID*)p = *(_vbox__IProcess_USCOREgetPID*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetPIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetPIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetPIDResponse*)p = *(_vbox__IProcess_USCOREgetPIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetStatus*)p = *(_vbox__IProcess_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREgetStatusResponse*)p = *(_vbox__IProcess_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwaitFor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwaitFor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwaitFor*)p = *(_vbox__IProcess_USCOREwaitFor*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwaitForResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwaitForResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwaitForResponse*)p = *(_vbox__IProcess_USCOREwaitForResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwaitForArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwaitForArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwaitForArray*)p = *(_vbox__IProcess_USCOREwaitForArray*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwaitForArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwaitForArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwaitForArrayResponse*)p = *(_vbox__IProcess_USCOREwaitForArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREread*)p = *(_vbox__IProcess_USCOREread*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREreadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREreadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREreadResponse*)p = *(_vbox__IProcess_USCOREreadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwrite*)p = *(_vbox__IProcess_USCOREwrite*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwriteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwriteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwriteResponse*)p = *(_vbox__IProcess_USCOREwriteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwriteArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwriteArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwriteArray*)p = *(_vbox__IProcess_USCOREwriteArray*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREwriteArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREwriteArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREwriteArrayResponse*)p = *(_vbox__IProcess_USCOREwriteArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREterminate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREterminate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREterminate*)p = *(_vbox__IProcess_USCOREterminate*)q;
		break;
	case SOAP_TYPE__vbox__IProcess_USCOREterminateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProcess_USCOREterminateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProcess_USCOREterminateResponse*)p = *(_vbox__IProcess_USCOREterminateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREgetDirectoryName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREgetDirectoryName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREgetDirectoryName*)p = *(_vbox__IDirectory_USCOREgetDirectoryName*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREgetDirectoryNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREgetDirectoryNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREgetDirectoryNameResponse*)p = *(_vbox__IDirectory_USCOREgetDirectoryNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREgetFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREgetFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREgetFilter*)p = *(_vbox__IDirectory_USCOREgetFilter*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREgetFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREgetFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREgetFilterResponse*)p = *(_vbox__IDirectory_USCOREgetFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREclose*)p = *(_vbox__IDirectory_USCOREclose*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREcloseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREcloseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREcloseResponse*)p = *(_vbox__IDirectory_USCOREcloseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREread*)p = *(_vbox__IDirectory_USCOREread*)q;
		break;
	case SOAP_TYPE__vbox__IDirectory_USCOREreadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDirectory_USCOREreadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDirectory_USCOREreadResponse*)p = *(_vbox__IDirectory_USCOREreadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetEventSource*)p = *(_vbox__IFile_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetEventSourceResponse*)p = *(_vbox__IFile_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetId*)p = *(_vbox__IFile_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetIdResponse*)p = *(_vbox__IFile_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetInitialSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetInitialSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetInitialSize*)p = *(_vbox__IFile_USCOREgetInitialSize*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetInitialSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetInitialSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetInitialSizeResponse*)p = *(_vbox__IFile_USCOREgetInitialSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetOffset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetOffset*)p = *(_vbox__IFile_USCOREgetOffset*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetOffsetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetOffsetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetOffsetResponse*)p = *(_vbox__IFile_USCOREgetOffsetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetStatus*)p = *(_vbox__IFile_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetStatusResponse*)p = *(_vbox__IFile_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetFileName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetFileName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetFileName*)p = *(_vbox__IFile_USCOREgetFileName*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetFileNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetFileNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetFileNameResponse*)p = *(_vbox__IFile_USCOREgetFileNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetCreationMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetCreationMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetCreationMode*)p = *(_vbox__IFile_USCOREgetCreationMode*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetCreationModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetCreationModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetCreationModeResponse*)p = *(_vbox__IFile_USCOREgetCreationModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetOpenAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetOpenAction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetOpenAction*)p = *(_vbox__IFile_USCOREgetOpenAction*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetOpenActionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetOpenActionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetOpenActionResponse*)p = *(_vbox__IFile_USCOREgetOpenActionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetAccessMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetAccessMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetAccessMode*)p = *(_vbox__IFile_USCOREgetAccessMode*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREgetAccessModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREgetAccessModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREgetAccessModeResponse*)p = *(_vbox__IFile_USCOREgetAccessModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREclose*)p = *(_vbox__IFile_USCOREclose*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREcloseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREcloseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREcloseResponse*)p = *(_vbox__IFile_USCOREcloseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREqueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREqueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREqueryInfo*)p = *(_vbox__IFile_USCOREqueryInfo*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREqueryInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREqueryInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREqueryInfoResponse*)p = *(_vbox__IFile_USCOREqueryInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREquerySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREquerySize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREquerySize*)p = *(_vbox__IFile_USCOREquerySize*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREquerySizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREquerySizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREquerySizeResponse*)p = *(_vbox__IFile_USCOREquerySizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREread*)p = *(_vbox__IFile_USCOREread*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREreadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREreadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREreadResponse*)p = *(_vbox__IFile_USCOREreadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREreadAt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREreadAt type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREreadAt*)p = *(_vbox__IFile_USCOREreadAt*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREreadAtResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREreadAtResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREreadAtResponse*)p = *(_vbox__IFile_USCOREreadAtResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREseek:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREseek type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREseek*)p = *(_vbox__IFile_USCOREseek*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREseekResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREseekResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREseekResponse*)p = *(_vbox__IFile_USCOREseekResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREsetACL:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREsetACL type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREsetACL*)p = *(_vbox__IFile_USCOREsetACL*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREsetACLResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREsetACLResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREsetACLResponse*)p = *(_vbox__IFile_USCOREsetACLResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREsetSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREsetSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREsetSize*)p = *(_vbox__IFile_USCOREsetSize*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREsetSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREsetSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREsetSizeResponse*)p = *(_vbox__IFile_USCOREsetSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREwrite*)p = *(_vbox__IFile_USCOREwrite*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREwriteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREwriteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREwriteResponse*)p = *(_vbox__IFile_USCOREwriteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREwriteAt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREwriteAt type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREwriteAt*)p = *(_vbox__IFile_USCOREwriteAt*)q;
		break;
	case SOAP_TYPE__vbox__IFile_USCOREwriteAtResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFile_USCOREwriteAtResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFile_USCOREwriteAtResponse*)p = *(_vbox__IFile_USCOREwriteAtResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetAccessTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetAccessTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetAccessTime*)p = *(_vbox__IFsObjInfo_USCOREgetAccessTime*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetAccessTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetAccessTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetAccessTimeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetAccessTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetAllocatedSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetAllocatedSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetAllocatedSize*)p = *(_vbox__IFsObjInfo_USCOREgetAllocatedSize*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetAllocatedSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetAllocatedSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetAllocatedSizeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetAllocatedSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetBirthTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetBirthTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetBirthTime*)p = *(_vbox__IFsObjInfo_USCOREgetBirthTime*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetBirthTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetBirthTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetBirthTimeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetBirthTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetChangeTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetChangeTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetChangeTime*)p = *(_vbox__IFsObjInfo_USCOREgetChangeTime*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetChangeTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetChangeTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetChangeTimeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetChangeTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetDeviceNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetDeviceNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetDeviceNumber*)p = *(_vbox__IFsObjInfo_USCOREgetDeviceNumber*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetDeviceNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetDeviceNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetDeviceNumberResponse*)p = *(_vbox__IFsObjInfo_USCOREgetDeviceNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetFileAttributes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetFileAttributes type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetFileAttributes*)p = *(_vbox__IFsObjInfo_USCOREgetFileAttributes*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetFileAttributesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetFileAttributesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetFileAttributesResponse*)p = *(_vbox__IFsObjInfo_USCOREgetFileAttributesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGenerationId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGenerationId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGenerationId*)p = *(_vbox__IFsObjInfo_USCOREgetGenerationId*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGenerationIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGenerationIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGenerationIdResponse*)p = *(_vbox__IFsObjInfo_USCOREgetGenerationIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGID*)p = *(_vbox__IFsObjInfo_USCOREgetGID*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGIDResponse*)p = *(_vbox__IFsObjInfo_USCOREgetGIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGroupName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGroupName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGroupName*)p = *(_vbox__IFsObjInfo_USCOREgetGroupName*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetGroupNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetGroupNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetGroupNameResponse*)p = *(_vbox__IFsObjInfo_USCOREgetGroupNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetHardLinks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetHardLinks type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetHardLinks*)p = *(_vbox__IFsObjInfo_USCOREgetHardLinks*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetHardLinksResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetHardLinksResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetHardLinksResponse*)p = *(_vbox__IFsObjInfo_USCOREgetHardLinksResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetModificationTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetModificationTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetModificationTime*)p = *(_vbox__IFsObjInfo_USCOREgetModificationTime*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetModificationTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetModificationTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetModificationTimeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetModificationTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetName*)p = *(_vbox__IFsObjInfo_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetNameResponse*)p = *(_vbox__IFsObjInfo_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetNodeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetNodeId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetNodeId*)p = *(_vbox__IFsObjInfo_USCOREgetNodeId*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetNodeIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetNodeIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetNodeIdResponse*)p = *(_vbox__IFsObjInfo_USCOREgetNodeIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetNodeIdDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetNodeIdDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetNodeIdDevice*)p = *(_vbox__IFsObjInfo_USCOREgetNodeIdDevice*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetNodeIdDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetNodeIdDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetNodeIdDeviceResponse*)p = *(_vbox__IFsObjInfo_USCOREgetNodeIdDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetObjectSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetObjectSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetObjectSize*)p = *(_vbox__IFsObjInfo_USCOREgetObjectSize*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetObjectSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetObjectSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetObjectSizeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetObjectSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetType*)p = *(_vbox__IFsObjInfo_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetTypeResponse*)p = *(_vbox__IFsObjInfo_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUID type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUID*)p = *(_vbox__IFsObjInfo_USCOREgetUID*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUIDResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUIDResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUIDResponse*)p = *(_vbox__IFsObjInfo_USCOREgetUIDResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUserFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUserFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUserFlags*)p = *(_vbox__IFsObjInfo_USCOREgetUserFlags*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUserFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUserFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUserFlagsResponse*)p = *(_vbox__IFsObjInfo_USCOREgetUserFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUserName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUserName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUserName*)p = *(_vbox__IFsObjInfo_USCOREgetUserName*)q;
		break;
	case SOAP_TYPE__vbox__IFsObjInfo_USCOREgetUserNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFsObjInfo_USCOREgetUserNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFsObjInfo_USCOREgetUserNameResponse*)p = *(_vbox__IFsObjInfo_USCOREgetUserNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetOSTypeId*)p = *(_vbox__IGuest_USCOREgetOSTypeId*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetOSTypeIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetOSTypeIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetOSTypeIdResponse*)p = *(_vbox__IGuest_USCOREgetOSTypeIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsRunLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsRunLevel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsRunLevel*)p = *(_vbox__IGuest_USCOREgetAdditionsRunLevel*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsRunLevelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsRunLevelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsRunLevelResponse*)p = *(_vbox__IGuest_USCOREgetAdditionsRunLevelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsVersion*)p = *(_vbox__IGuest_USCOREgetAdditionsVersion*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsVersionResponse*)p = *(_vbox__IGuest_USCOREgetAdditionsVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsRevision*)p = *(_vbox__IGuest_USCOREgetAdditionsRevision*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsRevisionResponse*)p = *(_vbox__IGuest_USCOREgetAdditionsRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetDnDSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetDnDSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetDnDSource*)p = *(_vbox__IGuest_USCOREgetDnDSource*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetDnDSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetDnDSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetDnDSourceResponse*)p = *(_vbox__IGuest_USCOREgetDnDSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetDnDTarget:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetDnDTarget type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetDnDTarget*)p = *(_vbox__IGuest_USCOREgetDnDTarget*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetDnDTargetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetDnDTargetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetDnDTargetResponse*)p = *(_vbox__IGuest_USCOREgetDnDTargetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetEventSource*)p = *(_vbox__IGuest_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetEventSourceResponse*)p = *(_vbox__IGuest_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetFacilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetFacilities type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetFacilities*)p = *(_vbox__IGuest_USCOREgetFacilities*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetFacilitiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetFacilitiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetFacilitiesResponse*)p = *(_vbox__IGuest_USCOREgetFacilitiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSessions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetSessions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetSessions*)p = *(_vbox__IGuest_USCOREgetSessions*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetSessionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetSessionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetSessionsResponse*)p = *(_vbox__IGuest_USCOREgetSessionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetMemoryBalloonSize*)p = *(_vbox__IGuest_USCOREgetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetMemoryBalloonSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetMemoryBalloonSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetMemoryBalloonSizeResponse*)p = *(_vbox__IGuest_USCOREgetMemoryBalloonSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetMemoryBalloonSize*)p = *(_vbox__IGuest_USCOREsetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetMemoryBalloonSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetMemoryBalloonSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetMemoryBalloonSizeResponse*)p = *(_vbox__IGuest_USCOREsetMemoryBalloonSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetStatisticsUpdateInterval type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p = *(_vbox__IGuest_USCOREgetStatisticsUpdateInterval*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse*)p = *(_vbox__IGuest_USCOREgetStatisticsUpdateIntervalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetStatisticsUpdateInterval type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p = *(_vbox__IGuest_USCOREsetStatisticsUpdateInterval*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse*)p = *(_vbox__IGuest_USCOREsetStatisticsUpdateIntervalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREinternalGetStatistics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREinternalGetStatistics type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREinternalGetStatistics*)p = *(_vbox__IGuest_USCOREinternalGetStatistics*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREinternalGetStatisticsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREinternalGetStatisticsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREinternalGetStatisticsResponse*)p = *(_vbox__IGuest_USCOREinternalGetStatisticsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetFacilityStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetFacilityStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetFacilityStatus*)p = *(_vbox__IGuest_USCOREgetFacilityStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetFacilityStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetFacilityStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetFacilityStatusResponse*)p = *(_vbox__IGuest_USCOREgetFacilityStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsStatus*)p = *(_vbox__IGuest_USCOREgetAdditionsStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREgetAdditionsStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREgetAdditionsStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREgetAdditionsStatusResponse*)p = *(_vbox__IGuest_USCOREgetAdditionsStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentials:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetCredentials type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetCredentials*)p = *(_vbox__IGuest_USCOREsetCredentials*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREsetCredentialsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREsetCredentialsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREsetCredentialsResponse*)p = *(_vbox__IGuest_USCOREsetCredentialsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREcreateSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREcreateSession type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREcreateSession*)p = *(_vbox__IGuest_USCOREcreateSession*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREcreateSessionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREcreateSessionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREcreateSessionResponse*)p = *(_vbox__IGuest_USCOREcreateSessionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREfindSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREfindSession type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREfindSession*)p = *(_vbox__IGuest_USCOREfindSession*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREfindSessionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREfindSessionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREfindSessionResponse*)p = *(_vbox__IGuest_USCOREfindSessionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREupdateGuestAdditions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREupdateGuestAdditions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREupdateGuestAdditions*)p = *(_vbox__IGuest_USCOREupdateGuestAdditions*)q;
		break;
	case SOAP_TYPE__vbox__IGuest_USCOREupdateGuestAdditionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuest_USCOREupdateGuestAdditionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuest_USCOREupdateGuestAdditionsResponse*)p = *(_vbox__IGuest_USCOREupdateGuestAdditionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetId*)p = *(_vbox__IProgress_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetIdResponse*)p = *(_vbox__IProgress_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetDescription*)p = *(_vbox__IProgress_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetDescriptionResponse*)p = *(_vbox__IProgress_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiator:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetInitiator type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetInitiator*)p = *(_vbox__IProgress_USCOREgetInitiator*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetInitiatorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetInitiatorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetInitiatorResponse*)p = *(_vbox__IProgress_USCOREgetInitiatorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCancelable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCancelable*)p = *(_vbox__IProgress_USCOREgetCancelable*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCancelableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCancelableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCancelableResponse*)p = *(_vbox__IProgress_USCOREgetCancelableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetPercent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetPercent*)p = *(_vbox__IProgress_USCOREgetPercent*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetPercentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetPercentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetPercentResponse*)p = *(_vbox__IProgress_USCOREgetPercentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemaining:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetTimeRemaining type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetTimeRemaining*)p = *(_vbox__IProgress_USCOREgetTimeRemaining*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeRemainingResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetTimeRemainingResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetTimeRemainingResponse*)p = *(_vbox__IProgress_USCOREgetTimeRemainingResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompleted:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCompleted type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCompleted*)p = *(_vbox__IProgress_USCOREgetCompleted*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCompletedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCompletedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCompletedResponse*)p = *(_vbox__IProgress_USCOREgetCompletedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCanceled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCanceled*)p = *(_vbox__IProgress_USCOREgetCanceled*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetCanceledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetCanceledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetCanceledResponse*)p = *(_vbox__IProgress_USCOREgetCanceledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetResultCode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetResultCode*)p = *(_vbox__IProgress_USCOREgetResultCode*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetResultCodeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetResultCodeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetResultCodeResponse*)p = *(_vbox__IProgress_USCOREgetResultCodeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetErrorInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetErrorInfo*)p = *(_vbox__IProgress_USCOREgetErrorInfo*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetErrorInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetErrorInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetErrorInfoResponse*)p = *(_vbox__IProgress_USCOREgetErrorInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationCount*)p = *(_vbox__IProgress_USCOREgetOperationCount*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationCountResponse*)p = *(_vbox__IProgress_USCOREgetOperationCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperation type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperation*)p = *(_vbox__IProgress_USCOREgetOperation*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationResponse*)p = *(_vbox__IProgress_USCOREgetOperationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationDescription*)p = *(_vbox__IProgress_USCOREgetOperationDescription*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationDescriptionResponse*)p = *(_vbox__IProgress_USCOREgetOperationDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationPercent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationPercent*)p = *(_vbox__IProgress_USCOREgetOperationPercent*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationPercentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationPercentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationPercentResponse*)p = *(_vbox__IProgress_USCOREgetOperationPercentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationWeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationWeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationWeight*)p = *(_vbox__IProgress_USCOREgetOperationWeight*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetOperationWeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetOperationWeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetOperationWeightResponse*)p = *(_vbox__IProgress_USCOREgetOperationWeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetTimeout*)p = *(_vbox__IProgress_USCOREgetTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREgetTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREgetTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREgetTimeoutResponse*)p = *(_vbox__IProgress_USCOREgetTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetTimeout*)p = *(_vbox__IProgress_USCOREsetTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetTimeoutResponse*)p = *(_vbox__IProgress_USCOREsetTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetCurrentOperationProgress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetCurrentOperationProgress*)p = *(_vbox__IProgress_USCOREsetCurrentOperationProgress*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetCurrentOperationProgressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetCurrentOperationProgressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetCurrentOperationProgressResponse*)p = *(_vbox__IProgress_USCOREsetCurrentOperationProgressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetNextOperation type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetNextOperation*)p = *(_vbox__IProgress_USCOREsetNextOperation*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREsetNextOperationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREsetNextOperationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREsetNextOperationResponse*)p = *(_vbox__IProgress_USCOREsetNextOperationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForCompletion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForCompletion*)p = *(_vbox__IProgress_USCOREwaitForCompletion*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForCompletionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForCompletionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForCompletionResponse*)p = *(_vbox__IProgress_USCOREwaitForCompletionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForOperationCompletion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForOperationCompletion*)p = *(_vbox__IProgress_USCOREwaitForOperationCompletion*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForOperationCompletionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForOperationCompletionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForOperationCompletionResponse*)p = *(_vbox__IProgress_USCOREwaitForOperationCompletionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForAsyncProgressCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForAsyncProgressCompletion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForAsyncProgressCompletion*)p = *(_vbox__IProgress_USCOREwaitForAsyncProgressCompletion*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREwaitForAsyncProgressCompletionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREwaitForAsyncProgressCompletionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREwaitForAsyncProgressCompletionResponse*)p = *(_vbox__IProgress_USCOREwaitForAsyncProgressCompletionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREcancel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREcancel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREcancel*)p = *(_vbox__IProgress_USCOREcancel*)q;
		break;
	case SOAP_TYPE__vbox__IProgress_USCOREcancelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IProgress_USCOREcancelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IProgress_USCOREcancelResponse*)p = *(_vbox__IProgress_USCOREcancelResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetId*)p = *(_vbox__ISnapshot_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetIdResponse*)p = *(_vbox__ISnapshot_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetName*)p = *(_vbox__ISnapshot_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetNameResponse*)p = *(_vbox__ISnapshot_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREsetName*)p = *(_vbox__ISnapshot_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREsetNameResponse*)p = *(_vbox__ISnapshot_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetDescription*)p = *(_vbox__ISnapshot_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetDescriptionResponse*)p = *(_vbox__ISnapshot_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREsetDescription*)p = *(_vbox__ISnapshot_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREsetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREsetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREsetDescriptionResponse*)p = *(_vbox__ISnapshot_USCOREsetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStamp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetTimeStamp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetTimeStamp*)p = *(_vbox__ISnapshot_USCOREgetTimeStamp*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetTimeStampResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetTimeStampResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetTimeStampResponse*)p = *(_vbox__ISnapshot_USCOREgetTimeStampResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnline:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetOnline type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetOnline*)p = *(_vbox__ISnapshot_USCOREgetOnline*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetOnlineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetOnlineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetOnlineResponse*)p = *(_vbox__ISnapshot_USCOREgetOnlineResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetMachine*)p = *(_vbox__ISnapshot_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetMachineResponse*)p = *(_vbox__ISnapshot_USCOREgetMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetParent*)p = *(_vbox__ISnapshot_USCOREgetParent*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetParentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetParentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetParentResponse*)p = *(_vbox__ISnapshot_USCOREgetParentResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetChildren type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetChildren*)p = *(_vbox__ISnapshot_USCOREgetChildren*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildrenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetChildrenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetChildrenResponse*)p = *(_vbox__ISnapshot_USCOREgetChildrenResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildrenCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetChildrenCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetChildrenCount*)p = *(_vbox__ISnapshot_USCOREgetChildrenCount*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshot_USCOREgetChildrenCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshot_USCOREgetChildrenCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshot_USCOREgetChildrenCountResponse*)p = *(_vbox__ISnapshot_USCOREgetChildrenCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetId*)p = *(_vbox__IMedium_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetIdResponse*)p = *(_vbox__IMedium_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetDescription*)p = *(_vbox__IMedium_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetDescriptionResponse*)p = *(_vbox__IMedium_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetDescription*)p = *(_vbox__IMedium_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetDescriptionResponse*)p = *(_vbox__IMedium_USCOREsetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetState*)p = *(_vbox__IMedium_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetStateResponse*)p = *(_vbox__IMedium_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetVariant:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetVariant type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetVariant*)p = *(_vbox__IMedium_USCOREgetVariant*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetVariantResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetVariantResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetVariantResponse*)p = *(_vbox__IMedium_USCOREgetVariantResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLocation type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLocation*)p = *(_vbox__IMedium_USCOREgetLocation*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLocationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLocationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLocationResponse*)p = *(_vbox__IMedium_USCOREgetLocationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetName*)p = *(_vbox__IMedium_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetNameResponse*)p = *(_vbox__IMedium_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetDeviceType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetDeviceType*)p = *(_vbox__IMedium_USCOREgetDeviceType*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetDeviceTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetDeviceTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetDeviceTypeResponse*)p = *(_vbox__IMedium_USCOREgetDeviceTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetHostDrive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetHostDrive*)p = *(_vbox__IMedium_USCOREgetHostDrive*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetHostDriveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetHostDriveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetHostDriveResponse*)p = *(_vbox__IMedium_USCOREgetHostDriveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetSize*)p = *(_vbox__IMedium_USCOREgetSize*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetSizeResponse*)p = *(_vbox__IMedium_USCOREgetSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetFormat type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetFormat*)p = *(_vbox__IMedium_USCOREgetFormat*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetFormatResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetFormatResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetFormatResponse*)p = *(_vbox__IMedium_USCOREgetFormatResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMediumFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetMediumFormat type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetMediumFormat*)p = *(_vbox__IMedium_USCOREgetMediumFormat*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMediumFormatResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetMediumFormatResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetMediumFormatResponse*)p = *(_vbox__IMedium_USCOREgetMediumFormatResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetType*)p = *(_vbox__IMedium_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetTypeResponse*)p = *(_vbox__IMedium_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetType*)p = *(_vbox__IMedium_USCOREsetType*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetTypeResponse*)p = *(_vbox__IMedium_USCOREsetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAllowedTypes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetAllowedTypes type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetAllowedTypes*)p = *(_vbox__IMedium_USCOREgetAllowedTypes*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAllowedTypesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetAllowedTypesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetAllowedTypesResponse*)p = *(_vbox__IMedium_USCOREgetAllowedTypesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetParent*)p = *(_vbox__IMedium_USCOREgetParent*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetParentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetParentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetParentResponse*)p = *(_vbox__IMedium_USCOREgetParentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetChildren type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetChildren*)p = *(_vbox__IMedium_USCOREgetChildren*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetChildrenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetChildrenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetChildrenResponse*)p = *(_vbox__IMedium_USCOREgetChildrenResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetBase*)p = *(_vbox__IMedium_USCOREgetBase*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetBaseResponse*)p = *(_vbox__IMedium_USCOREgetBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnly:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetReadOnly type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetReadOnly*)p = *(_vbox__IMedium_USCOREgetReadOnly*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetReadOnlyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetReadOnlyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetReadOnlyResponse*)p = *(_vbox__IMedium_USCOREgetReadOnlyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLogicalSize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLogicalSize*)p = *(_vbox__IMedium_USCOREgetLogicalSize*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLogicalSizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLogicalSizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLogicalSizeResponse*)p = *(_vbox__IMedium_USCOREgetLogicalSizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoReset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetAutoReset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetAutoReset*)p = *(_vbox__IMedium_USCOREgetAutoReset*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetAutoResetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetAutoResetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetAutoResetResponse*)p = *(_vbox__IMedium_USCOREgetAutoResetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoReset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetAutoReset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetAutoReset*)p = *(_vbox__IMedium_USCOREsetAutoReset*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetAutoResetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetAutoResetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetAutoResetResponse*)p = *(_vbox__IMedium_USCOREsetAutoResetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLastAccessError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLastAccessError*)p = *(_vbox__IMedium_USCOREgetLastAccessError*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetLastAccessErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetLastAccessErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetLastAccessErrorResponse*)p = *(_vbox__IMedium_USCOREgetLastAccessErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetMachineIds type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetMachineIds*)p = *(_vbox__IMedium_USCOREgetMachineIds*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetMachineIdsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetMachineIdsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetMachineIdsResponse*)p = *(_vbox__IMedium_USCOREgetMachineIdsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetIds type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetIds*)p = *(_vbox__IMedium_USCOREsetIds*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetIdsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetIdsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetIdsResponse*)p = *(_vbox__IMedium_USCOREsetIdsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORErefreshState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORErefreshState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORErefreshState*)p = *(_vbox__IMedium_USCORErefreshState*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORErefreshStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORErefreshStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORErefreshStateResponse*)p = *(_vbox__IMedium_USCORErefreshStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetSnapshotIds type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetSnapshotIds*)p = *(_vbox__IMedium_USCOREgetSnapshotIds*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetSnapshotIdsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetSnapshotIdsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetSnapshotIdsResponse*)p = *(_vbox__IMedium_USCOREgetSnapshotIdsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockRead:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORElockRead type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORElockRead*)p = *(_vbox__IMedium_USCORElockRead*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockReadResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORElockReadResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORElockReadResponse*)p = *(_vbox__IMedium_USCORElockReadResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockWrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORElockWrite type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORElockWrite*)p = *(_vbox__IMedium_USCORElockWrite*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCORElockWriteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCORElockWriteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCORElockWriteResponse*)p = *(_vbox__IMedium_USCORElockWriteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREclose*)p = *(_vbox__IMedium_USCOREclose*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcloseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcloseResponse*)p = *(_vbox__IMedium_USCOREcloseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetProperty*)p = *(_vbox__IMedium_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetPropertyResponse*)p = *(_vbox__IMedium_USCOREgetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetProperty*)p = *(_vbox__IMedium_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetPropertyResponse*)p = *(_vbox__IMedium_USCOREsetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetProperties*)p = *(_vbox__IMedium_USCOREgetProperties*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetPropertiesResponse*)p = *(_vbox__IMedium_USCOREgetPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetProperties*)p = *(_vbox__IMedium_USCOREsetProperties*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetPropertiesResponse*)p = *(_vbox__IMedium_USCOREsetPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcreateBaseStorage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcreateBaseStorage*)p = *(_vbox__IMedium_USCOREcreateBaseStorage*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateBaseStorageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcreateBaseStorageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcreateBaseStorageResponse*)p = *(_vbox__IMedium_USCOREcreateBaseStorageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREdeleteStorage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREdeleteStorage*)p = *(_vbox__IMedium_USCOREdeleteStorage*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREdeleteStorageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREdeleteStorageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREdeleteStorageResponse*)p = *(_vbox__IMedium_USCOREdeleteStorageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcreateDiffStorage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcreateDiffStorage*)p = *(_vbox__IMedium_USCOREcreateDiffStorage*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcreateDiffStorageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcreateDiffStorageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcreateDiffStorageResponse*)p = *(_vbox__IMedium_USCOREcreateDiffStorageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREmergeTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREmergeTo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREmergeTo*)p = *(_vbox__IMedium_USCOREmergeTo*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREmergeToResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREmergeToResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREmergeToResponse*)p = *(_vbox__IMedium_USCOREmergeToResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcloneTo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcloneTo*)p = *(_vbox__IMedium_USCOREcloneTo*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneToResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcloneToResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcloneToResponse*)p = *(_vbox__IMedium_USCOREcloneToResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneToBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcloneToBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcloneToBase*)p = *(_vbox__IMedium_USCOREcloneToBase*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcloneToBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcloneToBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcloneToBaseResponse*)p = *(_vbox__IMedium_USCOREcloneToBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetLocation type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetLocation*)p = *(_vbox__IMedium_USCOREsetLocation*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREsetLocationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREsetLocationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREsetLocationResponse*)p = *(_vbox__IMedium_USCOREsetLocationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcompact:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcompact type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcompact*)p = *(_vbox__IMedium_USCOREcompact*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcompactResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcompactResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcompactResponse*)p = *(_vbox__IMedium_USCOREcompactResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREresize type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREresize*)p = *(_vbox__IMedium_USCOREresize*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresizeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREresizeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREresizeResponse*)p = *(_vbox__IMedium_USCOREresizeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREreset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREreset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREreset*)p = *(_vbox__IMedium_USCOREreset*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREresetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREresetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREresetResponse*)p = *(_vbox__IMedium_USCOREresetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREchangeEncryption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREchangeEncryption type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREchangeEncryption*)p = *(_vbox__IMedium_USCOREchangeEncryption*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREchangeEncryptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREchangeEncryptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREchangeEncryptionResponse*)p = *(_vbox__IMedium_USCOREchangeEncryptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetEncryptionSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetEncryptionSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetEncryptionSettings*)p = *(_vbox__IMedium_USCOREgetEncryptionSettings*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREgetEncryptionSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREgetEncryptionSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREgetEncryptionSettingsResponse*)p = *(_vbox__IMedium_USCOREgetEncryptionSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcheckEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcheckEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcheckEncryptionPassword*)p = *(_vbox__IMedium_USCOREcheckEncryptionPassword*)q;
		break;
	case SOAP_TYPE__vbox__IMedium_USCOREcheckEncryptionPasswordResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMedium_USCOREcheckEncryptionPasswordResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMedium_USCOREcheckEncryptionPasswordResponse*)p = *(_vbox__IMedium_USCOREcheckEncryptionPasswordResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetId*)p = *(_vbox__IMediumFormat_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetIdResponse*)p = *(_vbox__IMediumFormat_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetName*)p = *(_vbox__IMediumFormat_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetNameResponse*)p = *(_vbox__IMediumFormat_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetCapabilities type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetCapabilities*)p = *(_vbox__IMediumFormat_USCOREgetCapabilities*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREgetCapabilitiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREgetCapabilitiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREgetCapabilitiesResponse*)p = *(_vbox__IMediumFormat_USCOREgetCapabilitiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribeFileExtensions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREdescribeFileExtensions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREdescribeFileExtensions*)p = *(_vbox__IMediumFormat_USCOREdescribeFileExtensions*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribeFileExtensionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREdescribeFileExtensionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREdescribeFileExtensionsResponse*)p = *(_vbox__IMediumFormat_USCOREdescribeFileExtensionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribeProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREdescribeProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREdescribeProperties*)p = *(_vbox__IMediumFormat_USCOREdescribeProperties*)q;
		break;
	case SOAP_TYPE__vbox__IMediumFormat_USCOREdescribePropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumFormat_USCOREdescribePropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumFormat_USCOREdescribePropertiesResponse*)p = *(_vbox__IMediumFormat_USCOREdescribePropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IToken_USCOREabandon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IToken_USCOREabandon type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IToken_USCOREabandon*)p = *(_vbox__IToken_USCOREabandon*)q;
		break;
	case SOAP_TYPE__vbox__IToken_USCOREabandonResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IToken_USCOREabandonResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IToken_USCOREabandonResponse*)p = *(_vbox__IToken_USCOREabandonResponse*)q;
		break;
	case SOAP_TYPE__vbox__IToken_USCOREdummy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IToken_USCOREdummy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IToken_USCOREdummy*)p = *(_vbox__IToken_USCOREdummy*)q;
		break;
	case SOAP_TYPE__vbox__IToken_USCOREdummyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IToken_USCOREdummyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IToken_USCOREdummyResponse*)p = *(_vbox__IToken_USCOREdummyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREgetKeyboardLEDs:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREgetKeyboardLEDs type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREgetKeyboardLEDs*)p = *(_vbox__IKeyboard_USCOREgetKeyboardLEDs*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREgetKeyboardLEDsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREgetKeyboardLEDsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREgetKeyboardLEDsResponse*)p = *(_vbox__IKeyboard_USCOREgetKeyboardLEDsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREgetEventSource*)p = *(_vbox__IKeyboard_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREgetEventSourceResponse*)p = *(_vbox__IKeyboard_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputScancode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputScancode*)p = *(_vbox__IKeyboard_USCOREputScancode*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputScancodeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputScancodeResponse*)p = *(_vbox__IKeyboard_USCOREputScancodeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputScancodes type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputScancodes*)p = *(_vbox__IKeyboard_USCOREputScancodes*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputScancodesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputScancodesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputScancodesResponse*)p = *(_vbox__IKeyboard_USCOREputScancodesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCAD:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputCAD type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputCAD*)p = *(_vbox__IKeyboard_USCOREputCAD*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREputCADResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREputCADResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREputCADResponse*)p = *(_vbox__IKeyboard_USCOREputCADResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREreleaseKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREreleaseKeys type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREreleaseKeys*)p = *(_vbox__IKeyboard_USCOREreleaseKeys*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboard_USCOREreleaseKeysResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboard_USCOREreleaseKeysResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboard_USCOREreleaseKeysResponse*)p = *(_vbox__IKeyboard_USCOREreleaseKeysResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetVisible*)p = *(_vbox__IMousePointerShape_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetVisibleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetVisibleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetVisibleResponse*)p = *(_vbox__IMousePointerShape_USCOREgetVisibleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetAlpha*)p = *(_vbox__IMousePointerShape_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetAlphaResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetAlphaResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetAlphaResponse*)p = *(_vbox__IMousePointerShape_USCOREgetAlphaResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHotX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHotX type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHotX*)p = *(_vbox__IMousePointerShape_USCOREgetHotX*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHotXResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHotXResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHotXResponse*)p = *(_vbox__IMousePointerShape_USCOREgetHotXResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHotY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHotY type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHotY*)p = *(_vbox__IMousePointerShape_USCOREgetHotY*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHotYResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHotYResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHotYResponse*)p = *(_vbox__IMousePointerShape_USCOREgetHotYResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetWidth*)p = *(_vbox__IMousePointerShape_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetWidthResponse*)p = *(_vbox__IMousePointerShape_USCOREgetWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHeight*)p = *(_vbox__IMousePointerShape_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetHeightResponse*)p = *(_vbox__IMousePointerShape_USCOREgetHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetShape type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetShape*)p = *(_vbox__IMousePointerShape_USCOREgetShape*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShape_USCOREgetShapeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShape_USCOREgetShapeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShape_USCOREgetShapeResponse*)p = *(_vbox__IMousePointerShape_USCOREgetShapeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetAbsoluteSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetAbsoluteSupported*)p = *(_vbox__IMouse_USCOREgetAbsoluteSupported*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetAbsoluteSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetAbsoluteSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetAbsoluteSupportedResponse*)p = *(_vbox__IMouse_USCOREgetAbsoluteSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetRelativeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetRelativeSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetRelativeSupported*)p = *(_vbox__IMouse_USCOREgetRelativeSupported*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetRelativeSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetRelativeSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetRelativeSupportedResponse*)p = *(_vbox__IMouse_USCOREgetRelativeSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetMultiTouchSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetMultiTouchSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetMultiTouchSupported*)p = *(_vbox__IMouse_USCOREgetMultiTouchSupported*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetMultiTouchSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetMultiTouchSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetMultiTouchSupportedResponse*)p = *(_vbox__IMouse_USCOREgetMultiTouchSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetNeedsHostCursor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetNeedsHostCursor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetNeedsHostCursor*)p = *(_vbox__IMouse_USCOREgetNeedsHostCursor*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetNeedsHostCursorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetNeedsHostCursorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetNeedsHostCursorResponse*)p = *(_vbox__IMouse_USCOREgetNeedsHostCursorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetPointerShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetPointerShape type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetPointerShape*)p = *(_vbox__IMouse_USCOREgetPointerShape*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetPointerShapeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetPointerShapeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetPointerShapeResponse*)p = *(_vbox__IMouse_USCOREgetPointerShapeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetEventSource*)p = *(_vbox__IMouse_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREgetEventSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREgetEventSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREgetEventSourceResponse*)p = *(_vbox__IMouse_USCOREgetEventSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputMouseEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputMouseEvent*)p = *(_vbox__IMouse_USCOREputMouseEvent*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputMouseEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputMouseEventResponse*)p = *(_vbox__IMouse_USCOREputMouseEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsolute:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputMouseEventAbsolute type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputMouseEventAbsolute*)p = *(_vbox__IMouse_USCOREputMouseEventAbsolute*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputMouseEventAbsoluteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputMouseEventAbsoluteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputMouseEventAbsoluteResponse*)p = *(_vbox__IMouse_USCOREputMouseEventAbsoluteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputEventMultiTouch:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputEventMultiTouch type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputEventMultiTouch*)p = *(_vbox__IMouse_USCOREputEventMultiTouch*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputEventMultiTouchResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputEventMultiTouchResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputEventMultiTouchResponse*)p = *(_vbox__IMouse_USCOREputEventMultiTouchResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputEventMultiTouchString:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputEventMultiTouchString type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputEventMultiTouchString*)p = *(_vbox__IMouse_USCOREputEventMultiTouchString*)q;
		break;
	case SOAP_TYPE__vbox__IMouse_USCOREputEventMultiTouchStringResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouse_USCOREputEventMultiTouchStringResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouse_USCOREputEventMultiTouchStringResponse*)p = *(_vbox__IMouse_USCOREputEventMultiTouchStringResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetWidth*)p = *(_vbox__IFramebuffer_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetWidthResponse*)p = *(_vbox__IFramebuffer_USCOREgetWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetHeight*)p = *(_vbox__IFramebuffer_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetHeightResponse*)p = *(_vbox__IFramebuffer_USCOREgetHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetBitsPerPixel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetBitsPerPixel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetBitsPerPixel*)p = *(_vbox__IFramebuffer_USCOREgetBitsPerPixel*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetBitsPerPixelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetBitsPerPixelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetBitsPerPixelResponse*)p = *(_vbox__IFramebuffer_USCOREgetBitsPerPixelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetBytesPerLine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetBytesPerLine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetBytesPerLine*)p = *(_vbox__IFramebuffer_USCOREgetBytesPerLine*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetBytesPerLineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetBytesPerLineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetBytesPerLineResponse*)p = *(_vbox__IFramebuffer_USCOREgetBytesPerLineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetPixelFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetPixelFormat type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetPixelFormat*)p = *(_vbox__IFramebuffer_USCOREgetPixelFormat*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetPixelFormatResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetPixelFormatResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetPixelFormatResponse*)p = *(_vbox__IFramebuffer_USCOREgetPixelFormatResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetHeightReduction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetHeightReduction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetHeightReduction*)p = *(_vbox__IFramebuffer_USCOREgetHeightReduction*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetHeightReductionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetHeightReductionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetHeightReductionResponse*)p = *(_vbox__IFramebuffer_USCOREgetHeightReductionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetOverlay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetOverlay type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetOverlay*)p = *(_vbox__IFramebuffer_USCOREgetOverlay*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetOverlayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetOverlayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetOverlayResponse*)p = *(_vbox__IFramebuffer_USCOREgetOverlayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetCapabilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetCapabilities type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetCapabilities*)p = *(_vbox__IFramebuffer_USCOREgetCapabilities*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREgetCapabilitiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREgetCapabilitiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREgetCapabilitiesResponse*)p = *(_vbox__IFramebuffer_USCOREgetCapabilitiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyUpdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyUpdate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyUpdate*)p = *(_vbox__IFramebuffer_USCOREnotifyUpdate*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyUpdateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyUpdateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyUpdateResponse*)p = *(_vbox__IFramebuffer_USCOREnotifyUpdateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyUpdateImage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyUpdateImage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyUpdateImage*)p = *(_vbox__IFramebuffer_USCOREnotifyUpdateImage*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyUpdateImageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyUpdateImageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyUpdateImageResponse*)p = *(_vbox__IFramebuffer_USCOREnotifyUpdateImageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyChange type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyChange*)p = *(_vbox__IFramebuffer_USCOREnotifyChange*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotifyChangeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotifyChangeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotifyChangeResponse*)p = *(_vbox__IFramebuffer_USCOREnotifyChangeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREvideoModeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREvideoModeSupported type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREvideoModeSupported*)p = *(_vbox__IFramebuffer_USCOREvideoModeSupported*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREvideoModeSupportedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREvideoModeSupportedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREvideoModeSupportedResponse*)p = *(_vbox__IFramebuffer_USCOREvideoModeSupportedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotify3DEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotify3DEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotify3DEvent*)p = *(_vbox__IFramebuffer_USCOREnotify3DEvent*)q;
		break;
	case SOAP_TYPE__vbox__IFramebuffer_USCOREnotify3DEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebuffer_USCOREnotify3DEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebuffer_USCOREnotify3DEventResponse*)p = *(_vbox__IFramebuffer_USCOREnotify3DEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetX type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetX*)p = *(_vbox__IFramebufferOverlay_USCOREgetX*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetXResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetXResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetXResponse*)p = *(_vbox__IFramebufferOverlay_USCOREgetXResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetY type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetY*)p = *(_vbox__IFramebufferOverlay_USCOREgetY*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetYResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetYResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetYResponse*)p = *(_vbox__IFramebufferOverlay_USCOREgetYResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetVisible*)p = *(_vbox__IFramebufferOverlay_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetVisibleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetVisibleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetVisibleResponse*)p = *(_vbox__IFramebufferOverlay_USCOREgetVisibleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREsetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREsetVisible type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREsetVisible*)p = *(_vbox__IFramebufferOverlay_USCOREsetVisible*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREsetVisibleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREsetVisibleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREsetVisibleResponse*)p = *(_vbox__IFramebufferOverlay_USCOREsetVisibleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetAlpha*)p = *(_vbox__IFramebufferOverlay_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREgetAlphaResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREgetAlphaResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREgetAlphaResponse*)p = *(_vbox__IFramebufferOverlay_USCOREgetAlphaResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREsetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREsetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREsetAlpha*)p = *(_vbox__IFramebufferOverlay_USCOREsetAlpha*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREsetAlphaResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREsetAlphaResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREsetAlphaResponse*)p = *(_vbox__IFramebufferOverlay_USCOREsetAlphaResponse*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREmove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREmove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREmove*)p = *(_vbox__IFramebufferOverlay_USCOREmove*)q;
		break;
	case SOAP_TYPE__vbox__IFramebufferOverlay_USCOREmoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IFramebufferOverlay_USCOREmoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IFramebufferOverlay_USCOREmoveResponse*)p = *(_vbox__IFramebufferOverlay_USCOREmoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetScreenId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetScreenId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetScreenId*)p = *(_vbox__IGuestScreenInfo_USCOREgetScreenId*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetScreenIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetScreenIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetScreenIdResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetScreenIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus*)p = *(_vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatusResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetPrimary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetPrimary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetPrimary*)p = *(_vbox__IGuestScreenInfo_USCOREgetPrimary*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetPrimaryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetPrimaryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetPrimaryResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetPrimaryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOrigin:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOrigin type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOrigin*)p = *(_vbox__IGuestScreenInfo_USCOREgetOrigin*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOriginResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOriginResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOriginResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetOriginResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOriginX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOriginX type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOriginX*)p = *(_vbox__IGuestScreenInfo_USCOREgetOriginX*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOriginXResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOriginXResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOriginXResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetOriginXResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOriginY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOriginY type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOriginY*)p = *(_vbox__IGuestScreenInfo_USCOREgetOriginY*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetOriginYResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetOriginYResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetOriginYResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetOriginYResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetWidth*)p = *(_vbox__IGuestScreenInfo_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetWidthResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetHeight*)p = *(_vbox__IGuestScreenInfo_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetHeightResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetBitsPerPixel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetBitsPerPixel type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetBitsPerPixel*)p = *(_vbox__IGuestScreenInfo_USCOREgetBitsPerPixel*)q;
		break;
	case SOAP_TYPE__vbox__IGuestScreenInfo_USCOREgetBitsPerPixelResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestScreenInfo_USCOREgetBitsPerPixelResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestScreenInfo_USCOREgetBitsPerPixelResponse*)p = *(_vbox__IGuestScreenInfo_USCOREgetBitsPerPixelResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetGuestScreenLayout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREgetGuestScreenLayout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREgetGuestScreenLayout*)p = *(_vbox__IDisplay_USCOREgetGuestScreenLayout*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetGuestScreenLayoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREgetGuestScreenLayoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREgetGuestScreenLayoutResponse*)p = *(_vbox__IDisplay_USCOREgetGuestScreenLayoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetScreenResolution:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREgetScreenResolution type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREgetScreenResolution*)p = *(_vbox__IDisplay_USCOREgetScreenResolution*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREgetScreenResolutionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREgetScreenResolutionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREgetScreenResolutionResponse*)p = *(_vbox__IDisplay_USCOREgetScreenResolutionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREattachFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREattachFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREattachFramebuffer*)p = *(_vbox__IDisplay_USCOREattachFramebuffer*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREattachFramebufferResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREattachFramebufferResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREattachFramebufferResponse*)p = *(_vbox__IDisplay_USCOREattachFramebufferResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREdetachFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREdetachFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREdetachFramebuffer*)p = *(_vbox__IDisplay_USCOREdetachFramebuffer*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREdetachFramebufferResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREdetachFramebufferResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREdetachFramebufferResponse*)p = *(_vbox__IDisplay_USCOREdetachFramebufferResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREqueryFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREqueryFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREqueryFramebuffer*)p = *(_vbox__IDisplay_USCOREqueryFramebuffer*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREqueryFramebufferResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREqueryFramebufferResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREqueryFramebufferResponse*)p = *(_vbox__IDisplay_USCOREqueryFramebufferResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHint:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetVideoModeHint type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetVideoModeHint*)p = *(_vbox__IDisplay_USCOREsetVideoModeHint*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetVideoModeHintResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetVideoModeHintResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetVideoModeHintResponse*)p = *(_vbox__IDisplay_USCOREsetVideoModeHintResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetSeamlessMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetSeamlessMode*)p = *(_vbox__IDisplay_USCOREsetSeamlessMode*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetSeamlessModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetSeamlessModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetSeamlessModeResponse*)p = *(_vbox__IDisplay_USCOREsetSeamlessModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREtakeScreenShotToArray type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREtakeScreenShotToArray*)p = *(_vbox__IDisplay_USCOREtakeScreenShotToArray*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREtakeScreenShotToArrayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREtakeScreenShotToArrayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREtakeScreenShotToArrayResponse*)p = *(_vbox__IDisplay_USCOREtakeScreenShotToArrayResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREinvalidateAndUpdate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREinvalidateAndUpdate*)p = *(_vbox__IDisplay_USCOREinvalidateAndUpdate*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREinvalidateAndUpdateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREinvalidateAndUpdateResponse*)p = *(_vbox__IDisplay_USCOREinvalidateAndUpdateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdateScreen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREinvalidateAndUpdateScreen type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREinvalidateAndUpdateScreen*)p = *(_vbox__IDisplay_USCOREinvalidateAndUpdateScreen*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREinvalidateAndUpdateScreenResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREinvalidateAndUpdateScreenResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREinvalidateAndUpdateScreenResponse*)p = *(_vbox__IDisplay_USCOREinvalidateAndUpdateScreenResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREviewportChanged:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREviewportChanged type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREviewportChanged*)p = *(_vbox__IDisplay_USCOREviewportChanged*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREviewportChangedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREviewportChangedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREviewportChangedResponse*)p = *(_vbox__IDisplay_USCOREviewportChangedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREnotifyScaleFactorChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREnotifyScaleFactorChange type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREnotifyScaleFactorChange*)p = *(_vbox__IDisplay_USCOREnotifyScaleFactorChange*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREnotifyScaleFactorChangeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREnotifyScaleFactorChangeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREnotifyScaleFactorChangeResponse*)p = *(_vbox__IDisplay_USCOREnotifyScaleFactorChangeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange*)p = *(_vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChangeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChangeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChangeResponse*)p = *(_vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChangeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetScreenLayout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetScreenLayout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetScreenLayout*)p = *(_vbox__IDisplay_USCOREsetScreenLayout*)q;
		break;
	case SOAP_TYPE__vbox__IDisplay_USCOREsetScreenLayoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDisplay_USCOREsetScreenLayoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDisplay_USCOREsetScreenLayoutResponse*)p = *(_vbox__IDisplay_USCOREsetScreenLayoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetAdapterType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetAdapterType*)p = *(_vbox__INetworkAdapter_USCOREgetAdapterType*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAdapterTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetAdapterTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetAdapterTypeResponse*)p = *(_vbox__INetworkAdapter_USCOREgetAdapterTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetAdapterType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetAdapterType*)p = *(_vbox__INetworkAdapter_USCOREsetAdapterType*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAdapterTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetAdapterTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetAdapterTypeResponse*)p = *(_vbox__INetworkAdapter_USCOREsetAdapterTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetSlot*)p = *(_vbox__INetworkAdapter_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetSlotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetSlotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetSlotResponse*)p = *(_vbox__INetworkAdapter_USCOREgetSlotResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetEnabled*)p = *(_vbox__INetworkAdapter_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetEnabledResponse*)p = *(_vbox__INetworkAdapter_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetEnabled*)p = *(_vbox__INetworkAdapter_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetEnabledResponse*)p = *(_vbox__INetworkAdapter_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetMACAddress*)p = *(_vbox__INetworkAdapter_USCOREgetMACAddress*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetMACAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetMACAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetMACAddressResponse*)p = *(_vbox__INetworkAdapter_USCOREgetMACAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetMACAddress*)p = *(_vbox__INetworkAdapter_USCOREsetMACAddress*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetMACAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetMACAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetMACAddressResponse*)p = *(_vbox__INetworkAdapter_USCOREsetMACAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetAttachmentType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetAttachmentType*)p = *(_vbox__INetworkAdapter_USCOREgetAttachmentType*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse*)p = *(_vbox__INetworkAdapter_USCOREgetAttachmentTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAttachmentType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetAttachmentType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetAttachmentType*)p = *(_vbox__INetworkAdapter_USCOREsetAttachmentType*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetAttachmentTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetAttachmentTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetAttachmentTypeResponse*)p = *(_vbox__INetworkAdapter_USCOREsetAttachmentTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBridgedInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBridgedInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBridgedInterface*)p = *(_vbox__INetworkAdapter_USCOREgetBridgedInterface*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBridgedInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBridgedInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBridgedInterfaceResponse*)p = *(_vbox__INetworkAdapter_USCOREgetBridgedInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBridgedInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBridgedInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBridgedInterface*)p = *(_vbox__INetworkAdapter_USCOREsetBridgedInterface*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBridgedInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBridgedInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBridgedInterfaceResponse*)p = *(_vbox__INetworkAdapter_USCOREsetBridgedInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostOnlyInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetHostOnlyInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetHostOnlyInterface*)p = *(_vbox__INetworkAdapter_USCOREgetHostOnlyInterface*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetHostOnlyInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetHostOnlyInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetHostOnlyInterfaceResponse*)p = *(_vbox__INetworkAdapter_USCOREgetHostOnlyInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostOnlyInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetHostOnlyInterface type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetHostOnlyInterface*)p = *(_vbox__INetworkAdapter_USCOREsetHostOnlyInterface*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetHostOnlyInterfaceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetHostOnlyInterfaceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetHostOnlyInterfaceResponse*)p = *(_vbox__INetworkAdapter_USCOREsetHostOnlyInterfaceResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetInternalNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetInternalNetwork*)p = *(_vbox__INetworkAdapter_USCOREgetInternalNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetInternalNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetInternalNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetInternalNetworkResponse*)p = *(_vbox__INetworkAdapter_USCOREgetInternalNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetInternalNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetInternalNetwork*)p = *(_vbox__INetworkAdapter_USCOREsetInternalNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetInternalNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetInternalNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetInternalNetworkResponse*)p = *(_vbox__INetworkAdapter_USCOREsetInternalNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetNATNetwork*)p = *(_vbox__INetworkAdapter_USCOREgetNATNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetNATNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetNATNetworkResponse*)p = *(_vbox__INetworkAdapter_USCOREgetNATNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetNATNetwork*)p = *(_vbox__INetworkAdapter_USCOREsetNATNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetNATNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetNATNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetNATNetworkResponse*)p = *(_vbox__INetworkAdapter_USCOREsetNATNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetGenericDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetGenericDriver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetGenericDriver*)p = *(_vbox__INetworkAdapter_USCOREgetGenericDriver*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetGenericDriverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetGenericDriverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetGenericDriverResponse*)p = *(_vbox__INetworkAdapter_USCOREgetGenericDriverResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetGenericDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetGenericDriver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetGenericDriver*)p = *(_vbox__INetworkAdapter_USCOREsetGenericDriver*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetGenericDriverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetGenericDriverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetGenericDriverResponse*)p = *(_vbox__INetworkAdapter_USCOREsetGenericDriverResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnected:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetCableConnected type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetCableConnected*)p = *(_vbox__INetworkAdapter_USCOREgetCableConnected*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetCableConnectedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetCableConnectedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetCableConnectedResponse*)p = *(_vbox__INetworkAdapter_USCOREgetCableConnectedResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnected:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetCableConnected type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetCableConnected*)p = *(_vbox__INetworkAdapter_USCOREsetCableConnected*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetCableConnectedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetCableConnectedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetCableConnectedResponse*)p = *(_vbox__INetworkAdapter_USCOREsetCableConnectedResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetLineSpeed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetLineSpeed*)p = *(_vbox__INetworkAdapter_USCOREgetLineSpeed*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetLineSpeedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetLineSpeedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetLineSpeedResponse*)p = *(_vbox__INetworkAdapter_USCOREgetLineSpeedResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetLineSpeed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetLineSpeed*)p = *(_vbox__INetworkAdapter_USCOREsetLineSpeed*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetLineSpeedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetLineSpeedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetLineSpeedResponse*)p = *(_vbox__INetworkAdapter_USCOREsetLineSpeedResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetPromiscModePolicy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetPromiscModePolicy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetPromiscModePolicy*)p = *(_vbox__INetworkAdapter_USCOREgetPromiscModePolicy*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetPromiscModePolicyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetPromiscModePolicyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetPromiscModePolicyResponse*)p = *(_vbox__INetworkAdapter_USCOREgetPromiscModePolicyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetPromiscModePolicy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetPromiscModePolicy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetPromiscModePolicy*)p = *(_vbox__INetworkAdapter_USCOREsetPromiscModePolicy*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetPromiscModePolicyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetPromiscModePolicyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetPromiscModePolicyResponse*)p = *(_vbox__INetworkAdapter_USCOREsetPromiscModePolicyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetTraceEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetTraceEnabled*)p = *(_vbox__INetworkAdapter_USCOREgetTraceEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetTraceEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetTraceEnabledResponse*)p = *(_vbox__INetworkAdapter_USCOREgetTraceEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetTraceEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetTraceEnabled*)p = *(_vbox__INetworkAdapter_USCOREsetTraceEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetTraceEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetTraceEnabledResponse*)p = *(_vbox__INetworkAdapter_USCOREsetTraceEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetTraceFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetTraceFile*)p = *(_vbox__INetworkAdapter_USCOREgetTraceFile*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetTraceFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetTraceFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetTraceFileResponse*)p = *(_vbox__INetworkAdapter_USCOREgetTraceFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetTraceFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetTraceFile*)p = *(_vbox__INetworkAdapter_USCOREsetTraceFile*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetTraceFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetTraceFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetTraceFileResponse*)p = *(_vbox__INetworkAdapter_USCOREsetTraceFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATEngine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetNATEngine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetNATEngine*)p = *(_vbox__INetworkAdapter_USCOREgetNATEngine*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetNATEngineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetNATEngineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetNATEngineResponse*)p = *(_vbox__INetworkAdapter_USCOREgetNATEngineResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBootPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBootPriority type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBootPriority*)p = *(_vbox__INetworkAdapter_USCOREgetBootPriority*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBootPriorityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBootPriorityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBootPriorityResponse*)p = *(_vbox__INetworkAdapter_USCOREgetBootPriorityResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBootPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBootPriority type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBootPriority*)p = *(_vbox__INetworkAdapter_USCOREsetBootPriority*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBootPriorityResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBootPriorityResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBootPriorityResponse*)p = *(_vbox__INetworkAdapter_USCOREsetBootPriorityResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBandwidthGroup*)p = *(_vbox__INetworkAdapter_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetBandwidthGroupResponse*)p = *(_vbox__INetworkAdapter_USCOREgetBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBandwidthGroup*)p = *(_vbox__INetworkAdapter_USCOREsetBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetBandwidthGroupResponse*)p = *(_vbox__INetworkAdapter_USCOREsetBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetProperty*)p = *(_vbox__INetworkAdapter_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetPropertyResponse*)p = *(_vbox__INetworkAdapter_USCOREgetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetProperty*)p = *(_vbox__INetworkAdapter_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREsetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREsetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREsetPropertyResponse*)p = *(_vbox__INetworkAdapter_USCOREsetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetProperties*)p = *(_vbox__INetworkAdapter_USCOREgetProperties*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapter_USCOREgetPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapter_USCOREgetPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapter_USCOREgetPropertiesResponse*)p = *(_vbox__INetworkAdapter_USCOREgetPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetSlot*)p = *(_vbox__ISerialPort_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetSlotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetSlotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetSlotResponse*)p = *(_vbox__ISerialPort_USCOREgetSlotResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetEnabled*)p = *(_vbox__ISerialPort_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetEnabledResponse*)p = *(_vbox__ISerialPort_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetEnabled*)p = *(_vbox__ISerialPort_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetEnabledResponse*)p = *(_vbox__ISerialPort_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetIOBase*)p = *(_vbox__ISerialPort_USCOREgetIOBase*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIOBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetIOBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetIOBaseResponse*)p = *(_vbox__ISerialPort_USCOREgetIOBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetIOBase*)p = *(_vbox__ISerialPort_USCOREsetIOBase*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIOBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetIOBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetIOBaseResponse*)p = *(_vbox__ISerialPort_USCOREsetIOBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetIRQ*)p = *(_vbox__ISerialPort_USCOREgetIRQ*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetIRQResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetIRQResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetIRQResponse*)p = *(_vbox__ISerialPort_USCOREgetIRQResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetIRQ*)p = *(_vbox__ISerialPort_USCOREsetIRQ*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetIRQResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetIRQResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetIRQResponse*)p = *(_vbox__ISerialPort_USCOREsetIRQResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetHostMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetHostMode*)p = *(_vbox__ISerialPort_USCOREgetHostMode*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetHostModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetHostModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetHostModeResponse*)p = *(_vbox__ISerialPort_USCOREgetHostModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetHostMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetHostMode*)p = *(_vbox__ISerialPort_USCOREsetHostMode*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetHostModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetHostModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetHostModeResponse*)p = *(_vbox__ISerialPort_USCOREsetHostModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetServer*)p = *(_vbox__ISerialPort_USCOREgetServer*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetServerResponse*)p = *(_vbox__ISerialPort_USCOREgetServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetServer*)p = *(_vbox__ISerialPort_USCOREsetServer*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetServerResponse*)p = *(_vbox__ISerialPort_USCOREsetServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetPath*)p = *(_vbox__ISerialPort_USCOREgetPath*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREgetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREgetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREgetPathResponse*)p = *(_vbox__ISerialPort_USCOREgetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetPath*)p = *(_vbox__ISerialPort_USCOREsetPath*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPort_USCOREsetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPort_USCOREsetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPort_USCOREsetPathResponse*)p = *(_vbox__ISerialPort_USCOREsetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetSlot*)p = *(_vbox__IParallelPort_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetSlotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetSlotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetSlotResponse*)p = *(_vbox__IParallelPort_USCOREgetSlotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetEnabled*)p = *(_vbox__IParallelPort_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetEnabledResponse*)p = *(_vbox__IParallelPort_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetEnabled*)p = *(_vbox__IParallelPort_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetEnabledResponse*)p = *(_vbox__IParallelPort_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetIOBase*)p = *(_vbox__IParallelPort_USCOREgetIOBase*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIOBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetIOBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetIOBaseResponse*)p = *(_vbox__IParallelPort_USCOREgetIOBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetIOBase*)p = *(_vbox__IParallelPort_USCOREsetIOBase*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIOBaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetIOBaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetIOBaseResponse*)p = *(_vbox__IParallelPort_USCOREsetIOBaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetIRQ*)p = *(_vbox__IParallelPort_USCOREgetIRQ*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetIRQResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetIRQResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetIRQResponse*)p = *(_vbox__IParallelPort_USCOREgetIRQResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetIRQ*)p = *(_vbox__IParallelPort_USCOREsetIRQ*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetIRQResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetIRQResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetIRQResponse*)p = *(_vbox__IParallelPort_USCOREsetIRQResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetPath*)p = *(_vbox__IParallelPort_USCOREgetPath*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREgetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREgetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREgetPathResponse*)p = *(_vbox__IParallelPort_USCOREgetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetPath type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetPath*)p = *(_vbox__IParallelPort_USCOREsetPath*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPort_USCOREsetPathResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPort_USCOREsetPathResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPort_USCOREsetPathResponse*)p = *(_vbox__IParallelPort_USCOREsetPathResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetSingleStep:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetSingleStep type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetSingleStep*)p = *(_vbox__IMachineDebugger_USCOREgetSingleStep*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetSingleStepResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetSingleStepResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetSingleStepResponse*)p = *(_vbox__IMachineDebugger_USCOREgetSingleStepResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetSingleStep:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetSingleStep type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetSingleStep*)p = *(_vbox__IMachineDebugger_USCOREsetSingleStep*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetSingleStepResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetSingleStepResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetSingleStepResponse*)p = *(_vbox__IMachineDebugger_USCOREsetSingleStepResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRecompileUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRecompileUser type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRecompileUser*)p = *(_vbox__IMachineDebugger_USCOREgetRecompileUser*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRecompileUserResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRecompileUserResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRecompileUserResponse*)p = *(_vbox__IMachineDebugger_USCOREgetRecompileUserResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRecompileUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRecompileUser type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRecompileUser*)p = *(_vbox__IMachineDebugger_USCOREsetRecompileUser*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRecompileUserResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRecompileUserResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRecompileUserResponse*)p = *(_vbox__IMachineDebugger_USCOREsetRecompileUserResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRecompileSupervisor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRecompileSupervisor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRecompileSupervisor*)p = *(_vbox__IMachineDebugger_USCOREgetRecompileSupervisor*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRecompileSupervisorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRecompileSupervisorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRecompileSupervisorResponse*)p = *(_vbox__IMachineDebugger_USCOREgetRecompileSupervisorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRecompileSupervisor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRecompileSupervisor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRecompileSupervisor*)p = *(_vbox__IMachineDebugger_USCOREsetRecompileSupervisor*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRecompileSupervisorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRecompileSupervisorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRecompileSupervisorResponse*)p = *(_vbox__IMachineDebugger_USCOREsetRecompileSupervisorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetExecuteAllInIEM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetExecuteAllInIEM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetExecuteAllInIEM*)p = *(_vbox__IMachineDebugger_USCOREgetExecuteAllInIEM*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetExecuteAllInIEMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetExecuteAllInIEMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetExecuteAllInIEMResponse*)p = *(_vbox__IMachineDebugger_USCOREgetExecuteAllInIEMResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetExecuteAllInIEM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetExecuteAllInIEM type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetExecuteAllInIEM*)p = *(_vbox__IMachineDebugger_USCOREsetExecuteAllInIEM*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetExecuteAllInIEMResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetExecuteAllInIEMResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetExecuteAllInIEMResponse*)p = *(_vbox__IMachineDebugger_USCOREsetExecuteAllInIEMResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetPATMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetPATMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetPATMEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetPATMEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetPATMEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetPATMEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetPATMEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetPATMEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetPATMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetPATMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetPATMEnabled*)p = *(_vbox__IMachineDebugger_USCOREsetPATMEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetPATMEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetPATMEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetPATMEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREsetPATMEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetCSAMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetCSAMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetCSAMEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetCSAMEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetCSAMEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetCSAMEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetCSAMEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetCSAMEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetCSAMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetCSAMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetCSAMEnabled*)p = *(_vbox__IMachineDebugger_USCOREsetCSAMEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetCSAMEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetCSAMEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetCSAMEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREsetCSAMEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetLogEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetLogEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetLogEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetLogEnabled*)p = *(_vbox__IMachineDebugger_USCOREsetLogEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetLogEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetLogEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetLogEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREsetLogEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgFlags*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgFlags*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgFlagsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgGroups*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgGroups*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgGroupsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgDestinations type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgDestinations*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgDestinations*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogDbgDestinationsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogDbgDestinationsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogDbgDestinationsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogDbgDestinationsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelFlags*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelFlags*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelFlagsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelGroups*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelGroups*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelGroupsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelDestinations type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelDestinations*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelDestinations*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetLogRelDestinationsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetLogRelDestinationsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetLogRelDestinationsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetLogRelDestinationsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetOSName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetOSName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetOSName*)p = *(_vbox__IMachineDebugger_USCOREgetOSName*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetOSNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetOSNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetOSNameResponse*)p = *(_vbox__IMachineDebugger_USCOREgetOSNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetOSVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetOSVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetOSVersion*)p = *(_vbox__IMachineDebugger_USCOREgetOSVersion*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetOSVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetOSVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetOSVersionResponse*)p = *(_vbox__IMachineDebugger_USCOREgetOSVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetPAEEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetPAEEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetPAEEnabled*)p = *(_vbox__IMachineDebugger_USCOREgetPAEEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetPAEEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetPAEEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetPAEEnabledResponse*)p = *(_vbox__IMachineDebugger_USCOREgetPAEEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetVirtualTimeRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetVirtualTimeRate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetVirtualTimeRate*)p = *(_vbox__IMachineDebugger_USCOREgetVirtualTimeRate*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetVirtualTimeRateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetVirtualTimeRateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetVirtualTimeRateResponse*)p = *(_vbox__IMachineDebugger_USCOREgetVirtualTimeRateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetVirtualTimeRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetVirtualTimeRate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetVirtualTimeRate*)p = *(_vbox__IMachineDebugger_USCOREsetVirtualTimeRate*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetVirtualTimeRateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetVirtualTimeRateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetVirtualTimeRateResponse*)p = *(_vbox__IMachineDebugger_USCOREsetVirtualTimeRateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetUptime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetUptime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetUptime*)p = *(_vbox__IMachineDebugger_USCOREgetUptime*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetUptimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetUptimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetUptimeResponse*)p = *(_vbox__IMachineDebugger_USCOREgetUptimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpGuestCore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpGuestCore type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpGuestCore*)p = *(_vbox__IMachineDebugger_USCOREdumpGuestCore*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpGuestCoreResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpGuestCoreResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpGuestCoreResponse*)p = *(_vbox__IMachineDebugger_USCOREdumpGuestCoreResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpHostProcessCore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpHostProcessCore type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpHostProcessCore*)p = *(_vbox__IMachineDebugger_USCOREdumpHostProcessCore*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpHostProcessCoreResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpHostProcessCoreResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpHostProcessCoreResponse*)p = *(_vbox__IMachineDebugger_USCOREdumpHostProcessCoreResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREinfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREinfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREinfo*)p = *(_vbox__IMachineDebugger_USCOREinfo*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREinfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREinfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREinfoResponse*)p = *(_vbox__IMachineDebugger_USCOREinfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREinjectNMI:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREinjectNMI type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREinjectNMI*)p = *(_vbox__IMachineDebugger_USCOREinjectNMI*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREinjectNMIResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREinjectNMIResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREinjectNMIResponse*)p = *(_vbox__IMachineDebugger_USCOREinjectNMIResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogGroups*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogGroups*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogGroupsResponse*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogFlags*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogFlags*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogFlagsResponse*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogDestinations type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogDestinations*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogDestinations*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREmodifyLogDestinationsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREmodifyLogDestinationsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREmodifyLogDestinationsResponse*)p = *(_vbox__IMachineDebugger_USCOREmodifyLogDestinationsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREreadPhysicalMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREreadPhysicalMemory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREreadPhysicalMemory*)p = *(_vbox__IMachineDebugger_USCOREreadPhysicalMemory*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREreadPhysicalMemoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREreadPhysicalMemoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREreadPhysicalMemoryResponse*)p = *(_vbox__IMachineDebugger_USCOREreadPhysicalMemoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREwritePhysicalMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREwritePhysicalMemory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREwritePhysicalMemory*)p = *(_vbox__IMachineDebugger_USCOREwritePhysicalMemory*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREwritePhysicalMemoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREwritePhysicalMemoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREwritePhysicalMemoryResponse*)p = *(_vbox__IMachineDebugger_USCOREwritePhysicalMemoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREreadVirtualMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREreadVirtualMemory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREreadVirtualMemory*)p = *(_vbox__IMachineDebugger_USCOREreadVirtualMemory*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREreadVirtualMemoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREreadVirtualMemoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREreadVirtualMemoryResponse*)p = *(_vbox__IMachineDebugger_USCOREreadVirtualMemoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREwriteVirtualMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREwriteVirtualMemory type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREwriteVirtualMemory*)p = *(_vbox__IMachineDebugger_USCOREwriteVirtualMemory*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREwriteVirtualMemoryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREwriteVirtualMemoryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREwriteVirtualMemoryResponse*)p = *(_vbox__IMachineDebugger_USCOREwriteVirtualMemoryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREloadPlugIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREloadPlugIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREloadPlugIn*)p = *(_vbox__IMachineDebugger_USCOREloadPlugIn*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREloadPlugInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREloadPlugInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREloadPlugInResponse*)p = *(_vbox__IMachineDebugger_USCOREloadPlugInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREunloadPlugIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREunloadPlugIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREunloadPlugIn*)p = *(_vbox__IMachineDebugger_USCOREunloadPlugIn*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREunloadPlugInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREunloadPlugInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREunloadPlugInResponse*)p = *(_vbox__IMachineDebugger_USCOREunloadPlugInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdetectOS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdetectOS type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdetectOS*)p = *(_vbox__IMachineDebugger_USCOREdetectOS*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdetectOSResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdetectOSResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdetectOSResponse*)p = *(_vbox__IMachineDebugger_USCOREdetectOSResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREqueryOSKernelLog:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREqueryOSKernelLog type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREqueryOSKernelLog*)p = *(_vbox__IMachineDebugger_USCOREqueryOSKernelLog*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREqueryOSKernelLogResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREqueryOSKernelLogResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREqueryOSKernelLogResponse*)p = *(_vbox__IMachineDebugger_USCOREqueryOSKernelLogResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRegister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRegister type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRegister*)p = *(_vbox__IMachineDebugger_USCOREgetRegister*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRegisterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRegisterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRegisterResponse*)p = *(_vbox__IMachineDebugger_USCOREgetRegisterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRegisters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRegisters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRegisters*)p = *(_vbox__IMachineDebugger_USCOREgetRegisters*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetRegistersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetRegistersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetRegistersResponse*)p = *(_vbox__IMachineDebugger_USCOREgetRegistersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRegister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRegister type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRegister*)p = *(_vbox__IMachineDebugger_USCOREsetRegister*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRegisterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRegisterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRegisterResponse*)p = *(_vbox__IMachineDebugger_USCOREsetRegisterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRegisters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRegisters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRegisters*)p = *(_vbox__IMachineDebugger_USCOREsetRegisters*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREsetRegistersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREsetRegistersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREsetRegistersResponse*)p = *(_vbox__IMachineDebugger_USCOREsetRegistersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpGuestStack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpGuestStack type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpGuestStack*)p = *(_vbox__IMachineDebugger_USCOREdumpGuestStack*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpGuestStackResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpGuestStackResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpGuestStackResponse*)p = *(_vbox__IMachineDebugger_USCOREdumpGuestStackResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREresetStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREresetStats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREresetStats*)p = *(_vbox__IMachineDebugger_USCOREresetStats*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREresetStatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREresetStatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREresetStatsResponse*)p = *(_vbox__IMachineDebugger_USCOREresetStatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpStats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpStats*)p = *(_vbox__IMachineDebugger_USCOREdumpStats*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREdumpStatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREdumpStatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREdumpStatsResponse*)p = *(_vbox__IMachineDebugger_USCOREdumpStatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetStats type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetStats*)p = *(_vbox__IMachineDebugger_USCOREgetStats*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDebugger_USCOREgetStatsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDebugger_USCOREgetStatsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDebugger_USCOREgetStatsResponse*)p = *(_vbox__IMachineDebugger_USCOREgetStatsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREgetDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREgetDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREgetDeviceFilters*)p = *(_vbox__IUSBDeviceFilters_USCOREgetDeviceFilters*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREgetDeviceFiltersResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREgetDeviceFiltersResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREgetDeviceFiltersResponse*)p = *(_vbox__IUSBDeviceFilters_USCOREgetDeviceFiltersResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter*)p = *(_vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREcreateDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREcreateDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREcreateDeviceFilterResponse*)p = *(_vbox__IUSBDeviceFilters_USCOREcreateDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter*)p = *(_vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREinsertDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREinsertDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREinsertDeviceFilterResponse*)p = *(_vbox__IUSBDeviceFilters_USCOREinsertDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter*)p = *(_vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilters_USCOREremoveDeviceFilterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilters_USCOREremoveDeviceFilterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilters_USCOREremoveDeviceFilterResponse*)p = *(_vbox__IUSBDeviceFilters_USCOREremoveDeviceFilterResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetName*)p = *(_vbox__IUSBController_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetNameResponse*)p = *(_vbox__IUSBController_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREsetName*)p = *(_vbox__IUSBController_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREsetNameResponse*)p = *(_vbox__IUSBController_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetType*)p = *(_vbox__IUSBController_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetTypeResponse*)p = *(_vbox__IUSBController_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREsetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREsetType*)p = *(_vbox__IUSBController_USCOREsetType*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREsetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREsetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREsetTypeResponse*)p = *(_vbox__IUSBController_USCOREsetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetUSBStandard type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetUSBStandard*)p = *(_vbox__IUSBController_USCOREgetUSBStandard*)q;
		break;
	case SOAP_TYPE__vbox__IUSBController_USCOREgetUSBStandardResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBController_USCOREgetUSBStandardResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBController_USCOREgetUSBStandardResponse*)p = *(_vbox__IUSBController_USCOREgetUSBStandardResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetId*)p = *(_vbox__IUSBDevice_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetIdResponse*)p = *(_vbox__IUSBDevice_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetVendorId*)p = *(_vbox__IUSBDevice_USCOREgetVendorId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVendorIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetVendorIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetVendorIdResponse*)p = *(_vbox__IUSBDevice_USCOREgetVendorIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetProductId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetProductId*)p = *(_vbox__IUSBDevice_USCOREgetProductId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetProductIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetProductIdResponse*)p = *(_vbox__IUSBDevice_USCOREgetProductIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetRevision*)p = *(_vbox__IUSBDevice_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetRevisionResponse*)p = *(_vbox__IUSBDevice_USCOREgetRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetManufacturer*)p = *(_vbox__IUSBDevice_USCOREgetManufacturer*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetManufacturerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetManufacturerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetManufacturerResponse*)p = *(_vbox__IUSBDevice_USCOREgetManufacturerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetProduct type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetProduct*)p = *(_vbox__IUSBDevice_USCOREgetProduct*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetProductResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetProductResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetProductResponse*)p = *(_vbox__IUSBDevice_USCOREgetProductResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetSerialNumber*)p = *(_vbox__IUSBDevice_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSerialNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetSerialNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetSerialNumberResponse*)p = *(_vbox__IUSBDevice_USCOREgetSerialNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetAddress type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetAddress*)p = *(_vbox__IUSBDevice_USCOREgetAddress*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetAddressResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetAddressResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetAddressResponse*)p = *(_vbox__IUSBDevice_USCOREgetAddressResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetPort*)p = *(_vbox__IUSBDevice_USCOREgetPort*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetPortResponse*)p = *(_vbox__IUSBDevice_USCOREgetPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetVersion*)p = *(_vbox__IUSBDevice_USCOREgetVersion*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetVersionResponse*)p = *(_vbox__IUSBDevice_USCOREgetVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetPortVersion type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetPortVersion*)p = *(_vbox__IUSBDevice_USCOREgetPortVersion*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetPortVersionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetPortVersionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetPortVersionResponse*)p = *(_vbox__IUSBDevice_USCOREgetPortVersionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetSpeed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetSpeed*)p = *(_vbox__IUSBDevice_USCOREgetSpeed*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetSpeedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetSpeedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetSpeedResponse*)p = *(_vbox__IUSBDevice_USCOREgetSpeedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetRemote type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetRemote*)p = *(_vbox__IUSBDevice_USCOREgetRemote*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetRemoteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetRemoteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetRemoteResponse*)p = *(_vbox__IUSBDevice_USCOREgetRemoteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetDeviceInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetDeviceInfo type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetDeviceInfo*)p = *(_vbox__IUSBDevice_USCOREgetDeviceInfo*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetDeviceInfoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetDeviceInfoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetDeviceInfoResponse*)p = *(_vbox__IUSBDevice_USCOREgetDeviceInfoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetBackend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetBackend type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetBackend*)p = *(_vbox__IUSBDevice_USCOREgetBackend*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDevice_USCOREgetBackendResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDevice_USCOREgetBackendResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDevice_USCOREgetBackendResponse*)p = *(_vbox__IUSBDevice_USCOREgetBackendResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetName*)p = *(_vbox__IUSBDeviceFilter_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetNameResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetName*)p = *(_vbox__IUSBDeviceFilter_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetNameResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetActive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetActive*)p = *(_vbox__IUSBDeviceFilter_USCOREgetActive*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetActiveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetActiveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetActiveResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetActiveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetActive type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetActive*)p = *(_vbox__IUSBDeviceFilter_USCOREsetActive*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetActiveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetActiveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetActiveResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetActiveResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetVendorId*)p = *(_vbox__IUSBDeviceFilter_USCOREgetVendorId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetVendorIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetVendorId*)p = *(_vbox__IUSBDeviceFilter_USCOREsetVendorId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetVendorIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetProductId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetProductId*)p = *(_vbox__IUSBDeviceFilter_USCOREgetProductId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetProductIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetProductIdResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetProductIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetProductId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetProductId*)p = *(_vbox__IUSBDeviceFilter_USCOREsetProductId*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetProductIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetProductIdResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetProductIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetRevision*)p = *(_vbox__IUSBDeviceFilter_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetRevisionResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetRevision type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetRevision*)p = *(_vbox__IUSBDeviceFilter_USCOREsetRevision*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRevisionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetRevisionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetRevisionResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetRevisionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p = *(_vbox__IUSBDeviceFilter_USCOREgetManufacturer*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetManufacturerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p = *(_vbox__IUSBDeviceFilter_USCOREsetManufacturer*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetManufacturerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetProduct type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetProduct*)p = *(_vbox__IUSBDeviceFilter_USCOREgetProduct*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetProductResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetProductResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetProductResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetProductResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetProduct type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetProduct*)p = *(_vbox__IUSBDeviceFilter_USCOREsetProduct*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetProductResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetProductResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetProductResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetProductResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p = *(_vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetSerialNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p = *(_vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetSerialNumberResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetPort*)p = *(_vbox__IUSBDeviceFilter_USCOREgetPort*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetPortResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetPort*)p = *(_vbox__IUSBDeviceFilter_USCOREsetPort*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetPortResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetRemote type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetRemote*)p = *(_vbox__IUSBDeviceFilter_USCOREgetRemote*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetRemoteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetRemoteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetRemoteResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetRemoteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetRemote type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetRemote*)p = *(_vbox__IUSBDeviceFilter_USCOREsetRemote*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetRemoteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetRemoteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetRemoteResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetRemoteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p = *(_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREgetMaskedInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p = *(_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse*)p = *(_vbox__IUSBDeviceFilter_USCOREsetMaskedInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDevice_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDevice_USCOREgetState*)p = *(_vbox__IHostUSBDevice_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDevice_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDevice_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDevice_USCOREgetStateResponse*)p = *(_vbox__IHostUSBDevice_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDeviceFilter_USCOREgetAction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDeviceFilter_USCOREgetAction*)p = *(_vbox__IHostUSBDeviceFilter_USCOREgetAction*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREgetActionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDeviceFilter_USCOREgetActionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)p = *(_vbox__IHostUSBDeviceFilter_USCOREgetActionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDeviceFilter_USCOREsetAction type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDeviceFilter_USCOREsetAction*)p = *(_vbox__IHostUSBDeviceFilter_USCOREsetAction*)q;
		break;
	case SOAP_TYPE__vbox__IHostUSBDeviceFilter_USCOREsetActionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostUSBDeviceFilter_USCOREsetActionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)p = *(_vbox__IHostUSBDeviceFilter_USCOREsetActionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBProxyBackend_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBProxyBackend_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBProxyBackend_USCOREgetName*)p = *(_vbox__IUSBProxyBackend_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IUSBProxyBackend_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBProxyBackend_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBProxyBackend_USCOREgetNameResponse*)p = *(_vbox__IUSBProxyBackend_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBProxyBackend_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBProxyBackend_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBProxyBackend_USCOREgetType*)p = *(_vbox__IUSBProxyBackend_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IUSBProxyBackend_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBProxyBackend_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBProxyBackend_USCOREgetTypeResponse*)p = *(_vbox__IUSBProxyBackend_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabled*)p = *(_vbox__IAudioAdapter_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabledResponse*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabled*)p = *(_vbox__IAudioAdapter_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabledResponse*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabledIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabledIn*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledIn*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabledInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabledInResponse*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabledIn type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabledIn*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledIn*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledInResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabledInResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabledInResponse*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledInResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabledOut type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabledOut*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledOut*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetEnabledOutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetEnabledOutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetEnabledOutResponse*)p = *(_vbox__IAudioAdapter_USCOREgetEnabledOutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabledOut type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabledOut*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledOut*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetEnabledOutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetEnabledOutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetEnabledOutResponse*)p = *(_vbox__IAudioAdapter_USCOREsetEnabledOutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioController*)p = *(_vbox__IAudioAdapter_USCOREgetAudioController*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)p = *(_vbox__IAudioAdapter_USCOREgetAudioControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioController type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioController*)p = *(_vbox__IAudioAdapter_USCOREsetAudioController*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioControllerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioControllerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)p = *(_vbox__IAudioAdapter_USCOREsetAudioControllerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioCodec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioCodec type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioCodec*)p = *(_vbox__IAudioAdapter_USCOREgetAudioCodec*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioCodecResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioCodecResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioCodecResponse*)p = *(_vbox__IAudioAdapter_USCOREgetAudioCodecResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioCodec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioCodec type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioCodec*)p = *(_vbox__IAudioAdapter_USCOREsetAudioCodec*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioCodecResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioCodecResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioCodecResponse*)p = *(_vbox__IAudioAdapter_USCOREsetAudioCodecResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioDriver*)p = *(_vbox__IAudioAdapter_USCOREgetAudioDriver*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetAudioDriverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetAudioDriverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)p = *(_vbox__IAudioAdapter_USCOREgetAudioDriverResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioDriver*)p = *(_vbox__IAudioAdapter_USCOREsetAudioDriver*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetAudioDriverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetAudioDriverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)p = *(_vbox__IAudioAdapter_USCOREsetAudioDriverResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetPropertiesList:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetPropertiesList type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetPropertiesList*)p = *(_vbox__IAudioAdapter_USCOREgetPropertiesList*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetPropertiesListResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetPropertiesListResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetPropertiesListResponse*)p = *(_vbox__IAudioAdapter_USCOREgetPropertiesListResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetProperty*)p = *(_vbox__IAudioAdapter_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREsetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREsetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREsetPropertyResponse*)p = *(_vbox__IAudioAdapter_USCOREsetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetProperty*)p = *(_vbox__IAudioAdapter_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE__vbox__IAudioAdapter_USCOREgetPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAudioAdapter_USCOREgetPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAudioAdapter_USCOREgetPropertyResponse*)p = *(_vbox__IAudioAdapter_USCOREgetPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetEnabled*)p = *(_vbox__IVRDEServer_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetEnabledResponse*)p = *(_vbox__IVRDEServer_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetEnabled*)p = *(_vbox__IVRDEServer_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetEnabledResponse*)p = *(_vbox__IVRDEServer_USCOREsetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthType*)p = *(_vbox__IVRDEServer_USCOREgetAuthType*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthTypeResponse*)p = *(_vbox__IVRDEServer_USCOREgetAuthTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthType*)p = *(_vbox__IVRDEServer_USCOREsetAuthType*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthTypeResponse*)p = *(_vbox__IVRDEServer_USCOREsetAuthTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthTimeout*)p = *(_vbox__IVRDEServer_USCOREgetAuthTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthTimeoutResponse*)p = *(_vbox__IVRDEServer_USCOREgetAuthTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthTimeout type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthTimeout*)p = *(_vbox__IVRDEServer_USCOREsetAuthTimeout*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthTimeoutResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthTimeoutResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthTimeoutResponse*)p = *(_vbox__IVRDEServer_USCOREsetAuthTimeoutResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAllowMultiConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAllowMultiConnection type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAllowMultiConnection*)p = *(_vbox__IVRDEServer_USCOREgetAllowMultiConnection*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAllowMultiConnectionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAllowMultiConnectionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAllowMultiConnectionResponse*)p = *(_vbox__IVRDEServer_USCOREgetAllowMultiConnectionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAllowMultiConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAllowMultiConnection type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAllowMultiConnection*)p = *(_vbox__IVRDEServer_USCOREsetAllowMultiConnection*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAllowMultiConnectionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAllowMultiConnectionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAllowMultiConnectionResponse*)p = *(_vbox__IVRDEServer_USCOREsetAllowMultiConnectionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetReuseSingleConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetReuseSingleConnection type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetReuseSingleConnection*)p = *(_vbox__IVRDEServer_USCOREgetReuseSingleConnection*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetReuseSingleConnectionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetReuseSingleConnectionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetReuseSingleConnectionResponse*)p = *(_vbox__IVRDEServer_USCOREgetReuseSingleConnectionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetReuseSingleConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetReuseSingleConnection type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetReuseSingleConnection*)p = *(_vbox__IVRDEServer_USCOREsetReuseSingleConnection*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetReuseSingleConnectionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetReuseSingleConnectionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetReuseSingleConnectionResponse*)p = *(_vbox__IVRDEServer_USCOREsetReuseSingleConnectionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEExtPack*)p = *(_vbox__IVRDEServer_USCOREgetVRDEExtPack*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEExtPackResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEExtPackResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEExtPackResponse*)p = *(_vbox__IVRDEServer_USCOREgetVRDEExtPackResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetVRDEExtPack*)p = *(_vbox__IVRDEServer_USCOREsetVRDEExtPack*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetVRDEExtPackResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetVRDEExtPackResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetVRDEExtPackResponse*)p = *(_vbox__IVRDEServer_USCOREsetVRDEExtPackResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthLibrary*)p = *(_vbox__IVRDEServer_USCOREgetAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetAuthLibraryResponse*)p = *(_vbox__IVRDEServer_USCOREgetAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthLibrary*)p = *(_vbox__IVRDEServer_USCOREsetAuthLibrary*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetAuthLibraryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetAuthLibraryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetAuthLibraryResponse*)p = *(_vbox__IVRDEServer_USCOREsetAuthLibraryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEProperties type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEProperties*)p = *(_vbox__IVRDEServer_USCOREgetVRDEProperties*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEPropertiesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEPropertiesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEPropertiesResponse*)p = *(_vbox__IVRDEServer_USCOREgetVRDEPropertiesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetVRDEProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetVRDEProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetVRDEProperty*)p = *(_vbox__IVRDEServer_USCOREsetVRDEProperty*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREsetVRDEPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREsetVRDEPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREsetVRDEPropertyResponse*)p = *(_vbox__IVRDEServer_USCOREsetVRDEPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEProperty type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEProperty*)p = *(_vbox__IVRDEServer_USCOREgetVRDEProperty*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServer_USCOREgetVRDEPropertyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServer_USCOREgetVRDEPropertyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServer_USCOREgetVRDEPropertyResponse*)p = *(_vbox__IVRDEServer_USCOREgetVRDEPropertyResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetState*)p = *(_vbox__ISession_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetStateResponse*)p = *(_vbox__ISession_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetType*)p = *(_vbox__ISession_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetTypeResponse*)p = *(_vbox__ISession_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetName*)p = *(_vbox__ISession_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetNameResponse*)p = *(_vbox__ISession_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREsetName*)p = *(_vbox__ISession_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREsetNameResponse*)p = *(_vbox__ISession_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetMachine*)p = *(_vbox__ISession_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetMachineResponse*)p = *(_vbox__ISession_USCOREgetMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetConsole:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetConsole type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetConsole*)p = *(_vbox__ISession_USCOREgetConsole*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREgetConsoleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREgetConsoleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREgetConsoleResponse*)p = *(_vbox__ISession_USCOREgetConsoleResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREunlockMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREunlockMachine type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREunlockMachine*)p = *(_vbox__ISession_USCOREunlockMachine*)q;
		break;
	case SOAP_TYPE__vbox__ISession_USCOREunlockMachineResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISession_USCOREunlockMachineResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISession_USCOREunlockMachineResponse*)p = *(_vbox__ISession_USCOREunlockMachineResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetName*)p = *(_vbox__IStorageController_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetNameResponse*)p = *(_vbox__IStorageController_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetName*)p = *(_vbox__IStorageController_USCOREsetName*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetNameResponse*)p = *(_vbox__IStorageController_USCOREsetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMaxDevicesPerPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p = *(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMaxDevicesPerPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMinPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMinPortCount*)p = *(_vbox__IStorageController_USCOREgetMinPortCount*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMinPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMinPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMinPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMinPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMaxPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMaxPortCount*)p = *(_vbox__IStorageController_USCOREgetMaxPortCount*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetMaxPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetMaxPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetMaxPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetMaxPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetInstance type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetInstance*)p = *(_vbox__IStorageController_USCOREgetInstance*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetInstanceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetInstanceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetInstanceResponse*)p = *(_vbox__IStorageController_USCOREgetInstanceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetInstance type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetInstance*)p = *(_vbox__IStorageController_USCOREsetInstance*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetInstanceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetInstanceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetInstanceResponse*)p = *(_vbox__IStorageController_USCOREsetInstanceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetPortCount*)p = *(_vbox__IStorageController_USCOREgetPortCount*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetPortCountResponse*)p = *(_vbox__IStorageController_USCOREgetPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetPortCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetPortCount*)p = *(_vbox__IStorageController_USCOREsetPortCount*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetPortCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetPortCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetPortCountResponse*)p = *(_vbox__IStorageController_USCOREsetPortCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetBus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetBus*)p = *(_vbox__IStorageController_USCOREgetBus*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetBusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetBusResponse*)p = *(_vbox__IStorageController_USCOREgetBusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetControllerType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetControllerType*)p = *(_vbox__IStorageController_USCOREgetControllerType*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetControllerTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetControllerTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetControllerTypeResponse*)p = *(_vbox__IStorageController_USCOREgetControllerTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetControllerType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetControllerType*)p = *(_vbox__IStorageController_USCOREsetControllerType*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetControllerTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetControllerTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetControllerTypeResponse*)p = *(_vbox__IStorageController_USCOREsetControllerTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetUseHostIOCache:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetUseHostIOCache type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetUseHostIOCache*)p = *(_vbox__IStorageController_USCOREgetUseHostIOCache*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetUseHostIOCacheResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetUseHostIOCacheResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetUseHostIOCacheResponse*)p = *(_vbox__IStorageController_USCOREgetUseHostIOCacheResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetUseHostIOCache:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetUseHostIOCache type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetUseHostIOCache*)p = *(_vbox__IStorageController_USCOREsetUseHostIOCache*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREsetUseHostIOCacheResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREsetUseHostIOCacheResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREsetUseHostIOCacheResponse*)p = *(_vbox__IStorageController_USCOREsetUseHostIOCacheResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBootable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetBootable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetBootable*)p = *(_vbox__IStorageController_USCOREgetBootable*)q;
		break;
	case SOAP_TYPE__vbox__IStorageController_USCOREgetBootableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageController_USCOREgetBootableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageController_USCOREgetBootableResponse*)p = *(_vbox__IStorageController_USCOREgetBootableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IManagedObjectRef_USCOREgetInterfaceName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IManagedObjectRef_USCOREgetInterfaceName*)p = *(_vbox__IManagedObjectRef_USCOREgetInterfaceName*)q;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)p = *(_vbox__IManagedObjectRef_USCOREgetInterfaceNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCORErelease:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IManagedObjectRef_USCORErelease type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IManagedObjectRef_USCORErelease*)p = *(_vbox__IManagedObjectRef_USCORErelease*)q;
		break;
	case SOAP_TYPE__vbox__IManagedObjectRef_USCOREreleaseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IManagedObjectRef_USCOREreleaseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IManagedObjectRef_USCOREreleaseResponse*)p = *(_vbox__IManagedObjectRef_USCOREreleaseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCORElogon type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCORElogon*)p = *(_vbox__IWebsessionManager_USCORElogon*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogonResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCORElogonResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCORElogonResponse*)p = *(_vbox__IWebsessionManager_USCORElogonResponse*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObject:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCOREgetSessionObject type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCOREgetSessionObject*)p = *(_vbox__IWebsessionManager_USCOREgetSessionObject*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCOREgetSessionObjectResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCOREgetSessionObjectResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)p = *(_vbox__IWebsessionManager_USCOREgetSessionObjectResponse*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoff:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCORElogoff type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCORElogoff*)p = *(_vbox__IWebsessionManager_USCORElogoff*)q;
		break;
	case SOAP_TYPE__vbox__IWebsessionManager_USCORElogoffResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IWebsessionManager_USCORElogoffResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IWebsessionManager_USCORElogoffResponse*)p = *(_vbox__IWebsessionManager_USCORElogoffResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMetricName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMetricName*)p = *(_vbox__IPerformanceMetric_USCOREgetMetricName*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMetricNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMetricNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMetricNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObject:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetObject type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetObject*)p = *(_vbox__IPerformanceMetric_USCOREgetObject*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetObjectResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetObjectResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetObjectResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetObjectResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetDescription*)p = *(_vbox__IPerformanceMetric_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetDescriptionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetDescriptionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetDescriptionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriod:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetPeriod type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetPeriod*)p = *(_vbox__IPerformanceMetric_USCOREgetPeriod*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetPeriodResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetPeriodResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetPeriodResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetCount*)p = *(_vbox__IPerformanceMetric_USCOREgetCount*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetCountResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnit:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetUnit type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetUnit*)p = *(_vbox__IPerformanceMetric_USCOREgetUnit*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetUnitResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetUnitResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetUnitResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetUnitResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMinimumValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMinimumValue*)p = *(_vbox__IPerformanceMetric_USCOREgetMinimumValue*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMinimumValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMinimumValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMinimumValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMaximumValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMaximumValue*)p = *(_vbox__IPerformanceMetric_USCOREgetMaximumValue*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceMetric_USCOREgetMaximumValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceMetric_USCOREgetMaximumValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)p = *(_vbox__IPerformanceMetric_USCOREgetMaximumValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNames:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREgetMetricNames type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREgetMetricNames*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricNames*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricNamesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREgetMetricNamesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricNamesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREgetMetrics type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREgetMetrics*)p = *(_vbox__IPerformanceCollector_USCOREgetMetrics*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREgetMetricsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREgetMetricsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREgetMetricsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREsetupMetrics type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREsetupMetrics*)p = *(_vbox__IPerformanceCollector_USCOREsetupMetrics*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREsetupMetricsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREsetupMetricsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREsetupMetricsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREenableMetrics type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREenableMetrics*)p = *(_vbox__IPerformanceCollector_USCOREenableMetrics*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREenableMetricsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREenableMetricsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREenableMetricsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREdisableMetrics type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREdisableMetrics*)p = *(_vbox__IPerformanceCollector_USCOREdisableMetrics*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREdisableMetricsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREdisableMetricsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)p = *(_vbox__IPerformanceCollector_USCOREdisableMetricsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREqueryMetricsData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREqueryMetricsData*)p = *(_vbox__IPerformanceCollector_USCOREqueryMetricsData*)q;
		break;
	case SOAP_TYPE__vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)p = *(_vbox__IPerformanceCollector_USCOREqueryMetricsDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetNetwork*)p = *(_vbox__INATEngine_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetNetworkResponse*)p = *(_vbox__INATEngine_USCOREgetNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetNetwork*)p = *(_vbox__INATEngine_USCOREsetNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetNetworkResponse*)p = *(_vbox__INATEngine_USCOREsetNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetHostIP*)p = *(_vbox__INATEngine_USCOREgetHostIP*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetHostIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetHostIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetHostIPResponse*)p = *(_vbox__INATEngine_USCOREgetHostIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetHostIP*)p = *(_vbox__INATEngine_USCOREsetHostIP*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetHostIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetHostIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetHostIPResponse*)p = *(_vbox__INATEngine_USCOREsetHostIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPPrefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPPrefix type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPPrefix*)p = *(_vbox__INATEngine_USCOREgetTFTPPrefix*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPPrefixResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPPrefixResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPPrefixResponse*)p = *(_vbox__INATEngine_USCOREgetTFTPPrefixResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPPrefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPPrefix type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPPrefix*)p = *(_vbox__INATEngine_USCOREsetTFTPPrefix*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPPrefixResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPPrefixResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPPrefixResponse*)p = *(_vbox__INATEngine_USCOREsetTFTPPrefixResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPBootFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPBootFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPBootFile*)p = *(_vbox__INATEngine_USCOREgetTFTPBootFile*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPBootFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPBootFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPBootFileResponse*)p = *(_vbox__INATEngine_USCOREgetTFTPBootFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPBootFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPBootFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPBootFile*)p = *(_vbox__INATEngine_USCOREsetTFTPBootFile*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPBootFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPBootFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPBootFileResponse*)p = *(_vbox__INATEngine_USCOREsetTFTPBootFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPNextServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPNextServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPNextServer*)p = *(_vbox__INATEngine_USCOREgetTFTPNextServer*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetTFTPNextServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetTFTPNextServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetTFTPNextServerResponse*)p = *(_vbox__INATEngine_USCOREgetTFTPNextServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPNextServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPNextServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPNextServer*)p = *(_vbox__INATEngine_USCOREsetTFTPNextServer*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetTFTPNextServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetTFTPNextServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetTFTPNextServerResponse*)p = *(_vbox__INATEngine_USCOREsetTFTPNextServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetAliasMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetAliasMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetAliasMode*)p = *(_vbox__INATEngine_USCOREgetAliasMode*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetAliasModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetAliasModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetAliasModeResponse*)p = *(_vbox__INATEngine_USCOREgetAliasModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetAliasMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetAliasMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetAliasMode*)p = *(_vbox__INATEngine_USCOREsetAliasMode*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetAliasModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetAliasModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetAliasModeResponse*)p = *(_vbox__INATEngine_USCOREsetAliasModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSPassDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSPassDomain type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSPassDomain*)p = *(_vbox__INATEngine_USCOREgetDNSPassDomain*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSPassDomainResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSPassDomainResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSPassDomainResponse*)p = *(_vbox__INATEngine_USCOREgetDNSPassDomainResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSPassDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSPassDomain type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSPassDomain*)p = *(_vbox__INATEngine_USCOREsetDNSPassDomain*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSPassDomainResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSPassDomainResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSPassDomainResponse*)p = *(_vbox__INATEngine_USCOREsetDNSPassDomainResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSProxy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSProxy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSProxy*)p = *(_vbox__INATEngine_USCOREgetDNSProxy*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSProxyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSProxyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSProxyResponse*)p = *(_vbox__INATEngine_USCOREgetDNSProxyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSProxy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSProxy type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSProxy*)p = *(_vbox__INATEngine_USCOREsetDNSProxy*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSProxyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSProxyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSProxyResponse*)p = *(_vbox__INATEngine_USCOREsetDNSProxyResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSUseHostResolver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSUseHostResolver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSUseHostResolver*)p = *(_vbox__INATEngine_USCOREgetDNSUseHostResolver*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetDNSUseHostResolverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetDNSUseHostResolverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetDNSUseHostResolverResponse*)p = *(_vbox__INATEngine_USCOREgetDNSUseHostResolverResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSUseHostResolver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSUseHostResolver type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSUseHostResolver*)p = *(_vbox__INATEngine_USCOREsetDNSUseHostResolver*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetDNSUseHostResolverResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetDNSUseHostResolverResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetDNSUseHostResolverResponse*)p = *(_vbox__INATEngine_USCOREsetDNSUseHostResolverResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetRedirects:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetRedirects type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetRedirects*)p = *(_vbox__INATEngine_USCOREgetRedirects*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetRedirectsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetRedirectsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetRedirectsResponse*)p = *(_vbox__INATEngine_USCOREgetRedirectsResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetNetworkSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetNetworkSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetNetworkSettings*)p = *(_vbox__INATEngine_USCOREsetNetworkSettings*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREsetNetworkSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREsetNetworkSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREsetNetworkSettingsResponse*)p = *(_vbox__INATEngine_USCOREsetNetworkSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetNetworkSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetNetworkSettings type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetNetworkSettings*)p = *(_vbox__INATEngine_USCOREgetNetworkSettings*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREgetNetworkSettingsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREgetNetworkSettingsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREgetNetworkSettingsResponse*)p = *(_vbox__INATEngine_USCOREgetNetworkSettingsResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREaddRedirect:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREaddRedirect type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREaddRedirect*)p = *(_vbox__INATEngine_USCOREaddRedirect*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREaddRedirectResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREaddRedirectResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREaddRedirectResponse*)p = *(_vbox__INATEngine_USCOREaddRedirectResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREremoveRedirect:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREremoveRedirect type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREremoveRedirect*)p = *(_vbox__INATEngine_USCOREremoveRedirect*)q;
		break;
	case SOAP_TYPE__vbox__INATEngine_USCOREremoveRedirectResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATEngine_USCOREremoveRedirectResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATEngine_USCOREremoveRedirectResponse*)p = *(_vbox__INATEngine_USCOREremoveRedirectResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetName*)p = *(_vbox__IBandwidthGroup_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetNameResponse*)p = *(_vbox__IBandwidthGroup_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetType*)p = *(_vbox__IBandwidthGroup_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetTypeResponse*)p = *(_vbox__IBandwidthGroup_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetReference:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetReference type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetReference*)p = *(_vbox__IBandwidthGroup_USCOREgetReference*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetReferenceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetReferenceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetReferenceResponse*)p = *(_vbox__IBandwidthGroup_USCOREgetReferenceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec*)p = *(_vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREgetMaxBytesPerSecResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREgetMaxBytesPerSecResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREgetMaxBytesPerSecResponse*)p = *(_vbox__IBandwidthGroup_USCOREgetMaxBytesPerSecResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec*)p = *(_vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroup_USCOREsetMaxBytesPerSecResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroup_USCOREsetMaxBytesPerSecResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroup_USCOREsetMaxBytesPerSecResponse*)p = *(_vbox__IBandwidthGroup_USCOREsetMaxBytesPerSecResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetNumGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetNumGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetNumGroups*)p = *(_vbox__IBandwidthControl_USCOREgetNumGroups*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetNumGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetNumGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetNumGroupsResponse*)p = *(_vbox__IBandwidthControl_USCOREgetNumGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREcreateBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREcreateBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREcreateBandwidthGroup*)p = *(_vbox__IBandwidthControl_USCOREcreateBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREcreateBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREcreateBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREcreateBandwidthGroupResponse*)p = *(_vbox__IBandwidthControl_USCOREcreateBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREdeleteBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREdeleteBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREdeleteBandwidthGroup*)p = *(_vbox__IBandwidthControl_USCOREdeleteBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREdeleteBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREdeleteBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREdeleteBandwidthGroupResponse*)p = *(_vbox__IBandwidthControl_USCOREdeleteBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetBandwidthGroup*)p = *(_vbox__IBandwidthControl_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetBandwidthGroupResponse*)p = *(_vbox__IBandwidthControl_USCOREgetBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetAllBandwidthGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetAllBandwidthGroups type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetAllBandwidthGroups*)p = *(_vbox__IBandwidthControl_USCOREgetAllBandwidthGroups*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthControl_USCOREgetAllBandwidthGroupsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthControl_USCOREgetAllBandwidthGroupsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthControl_USCOREgetAllBandwidthGroupsResponse*)p = *(_vbox__IBandwidthControl_USCOREgetAllBandwidthGroupsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREcreateListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREcreateListener type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREcreateListener*)p = *(_vbox__IEventSource_USCOREcreateListener*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREcreateListenerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREcreateListenerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREcreateListenerResponse*)p = *(_vbox__IEventSource_USCOREcreateListenerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREcreateAggregator:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREcreateAggregator type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREcreateAggregator*)p = *(_vbox__IEventSource_USCOREcreateAggregator*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREcreateAggregatorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREcreateAggregatorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREcreateAggregatorResponse*)p = *(_vbox__IEventSource_USCOREcreateAggregatorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREregisterListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREregisterListener type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREregisterListener*)p = *(_vbox__IEventSource_USCOREregisterListener*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREregisterListenerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREregisterListenerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREregisterListenerResponse*)p = *(_vbox__IEventSource_USCOREregisterListenerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREunregisterListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREunregisterListener type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREunregisterListener*)p = *(_vbox__IEventSource_USCOREunregisterListener*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREunregisterListenerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREunregisterListenerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREunregisterListenerResponse*)p = *(_vbox__IEventSource_USCOREunregisterListenerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREfireEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREfireEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREfireEvent*)p = *(_vbox__IEventSource_USCOREfireEvent*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREfireEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREfireEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREfireEventResponse*)p = *(_vbox__IEventSource_USCOREfireEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREgetEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREgetEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREgetEvent*)p = *(_vbox__IEventSource_USCOREgetEvent*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREgetEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREgetEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREgetEventResponse*)p = *(_vbox__IEventSource_USCOREgetEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREeventProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREeventProcessed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREeventProcessed*)p = *(_vbox__IEventSource_USCOREeventProcessed*)q;
		break;
	case SOAP_TYPE__vbox__IEventSource_USCOREeventProcessedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSource_USCOREeventProcessedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSource_USCOREeventProcessedResponse*)p = *(_vbox__IEventSource_USCOREeventProcessedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventListener_USCOREhandleEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventListener_USCOREhandleEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventListener_USCOREhandleEvent*)p = *(_vbox__IEventListener_USCOREhandleEvent*)q;
		break;
	case SOAP_TYPE__vbox__IEventListener_USCOREhandleEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventListener_USCOREhandleEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventListener_USCOREhandleEventResponse*)p = *(_vbox__IEventListener_USCOREhandleEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetType*)p = *(_vbox__IEvent_USCOREgetType*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetTypeResponse*)p = *(_vbox__IEvent_USCOREgetTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetSource type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetSource*)p = *(_vbox__IEvent_USCOREgetSource*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetSourceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetSourceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetSourceResponse*)p = *(_vbox__IEvent_USCOREgetSourceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetWaitable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetWaitable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetWaitable*)p = *(_vbox__IEvent_USCOREgetWaitable*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREgetWaitableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREgetWaitableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREgetWaitableResponse*)p = *(_vbox__IEvent_USCOREgetWaitableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREsetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREsetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREsetProcessed*)p = *(_vbox__IEvent_USCOREsetProcessed*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREsetProcessedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREsetProcessedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREsetProcessedResponse*)p = *(_vbox__IEvent_USCOREsetProcessedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREwaitProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREwaitProcessed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREwaitProcessed*)p = *(_vbox__IEvent_USCOREwaitProcessed*)q;
		break;
	case SOAP_TYPE__vbox__IEvent_USCOREwaitProcessedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEvent_USCOREwaitProcessedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEvent_USCOREwaitProcessedResponse*)p = *(_vbox__IEvent_USCOREwaitProcessedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IReusableEvent_USCOREgetGeneration:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IReusableEvent_USCOREgetGeneration type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IReusableEvent_USCOREgetGeneration*)p = *(_vbox__IReusableEvent_USCOREgetGeneration*)q;
		break;
	case SOAP_TYPE__vbox__IReusableEvent_USCOREgetGenerationResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IReusableEvent_USCOREgetGenerationResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IReusableEvent_USCOREgetGenerationResponse*)p = *(_vbox__IReusableEvent_USCOREgetGenerationResponse*)q;
		break;
	case SOAP_TYPE__vbox__IReusableEvent_USCOREreuse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IReusableEvent_USCOREreuse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IReusableEvent_USCOREreuse*)p = *(_vbox__IReusableEvent_USCOREreuse*)q;
		break;
	case SOAP_TYPE__vbox__IReusableEvent_USCOREreuseResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IReusableEvent_USCOREreuseResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IReusableEvent_USCOREreuseResponse*)p = *(_vbox__IReusableEvent_USCOREreuseResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineEvent_USCOREgetMachineId*)p = *(_vbox__IMachineEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE__vbox__IMachineEvent_USCOREgetMachineIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineEvent_USCOREgetMachineIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineEvent_USCOREgetMachineIdResponse*)p = *(_vbox__IMachineEvent_USCOREgetMachineIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineStateChangedEvent_USCOREgetState*)p = *(_vbox__IMachineStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IMachineStateChangedEvent_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineStateChangedEvent_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineStateChangedEvent_USCOREgetStateResponse*)p = *(_vbox__IMachineStateChangedEvent_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDataChangedEvent_USCOREgetTemporary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDataChangedEvent_USCOREgetTemporary type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDataChangedEvent_USCOREgetTemporary*)p = *(_vbox__IMachineDataChangedEvent_USCOREgetTemporary*)q;
		break;
	case SOAP_TYPE__vbox__IMachineDataChangedEvent_USCOREgetTemporaryResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineDataChangedEvent_USCOREgetTemporaryResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineDataChangedEvent_USCOREgetTemporaryResponse*)p = *(_vbox__IMachineDataChangedEvent_USCOREgetTemporaryResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetMediumId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetMediumId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetMediumId*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetMediumId*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetMediumIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetMediumIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetMediumIdResponse*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetMediumIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetMediumType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetMediumType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetMediumType*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetMediumType*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetMediumTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetMediumTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetMediumTypeResponse*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetMediumTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetRegistered*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE__vbox__IMediumRegisteredEvent_USCOREgetRegisteredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumRegisteredEvent_USCOREgetRegisteredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumRegisteredEvent_USCOREgetRegisteredResponse*)p = *(_vbox__IMediumRegisteredEvent_USCOREgetRegisteredResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumConfigChangedEvent_USCOREgetMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumConfigChangedEvent_USCOREgetMedium type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumConfigChangedEvent_USCOREgetMedium*)p = *(_vbox__IMediumConfigChangedEvent_USCOREgetMedium*)q;
		break;
	case SOAP_TYPE__vbox__IMediumConfigChangedEvent_USCOREgetMediumResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumConfigChangedEvent_USCOREgetMediumResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumConfigChangedEvent_USCOREgetMediumResponse*)p = *(_vbox__IMediumConfigChangedEvent_USCOREgetMediumResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMachineRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineRegisteredEvent_USCOREgetRegistered*)p = *(_vbox__IMachineRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE__vbox__IMachineRegisteredEvent_USCOREgetRegisteredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMachineRegisteredEvent_USCOREgetRegisteredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMachineRegisteredEvent_USCOREgetRegisteredResponse*)p = *(_vbox__IMachineRegisteredEvent_USCOREgetRegisteredResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISessionStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISessionStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISessionStateChangedEvent_USCOREgetState*)p = *(_vbox__ISessionStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__ISessionStateChangedEvent_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISessionStateChangedEvent_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISessionStateChangedEvent_USCOREgetStateResponse*)p = *(_vbox__ISessionStateChangedEvent_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetName*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetNameResponse*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetValue*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetValueResponse*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetFlags*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetFlags*)q;
		break;
	case SOAP_TYPE__vbox__IGuestPropertyChangedEvent_USCOREgetFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestPropertyChangedEvent_USCOREgetFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestPropertyChangedEvent_USCOREgetFlagsResponse*)p = *(_vbox__IGuestPropertyChangedEvent_USCOREgetFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotEvent_USCOREgetSnapshotId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotEvent_USCOREgetSnapshotId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotEvent_USCOREgetSnapshotId*)p = *(_vbox__ISnapshotEvent_USCOREgetSnapshotId*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotEvent_USCOREgetSnapshotIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotEvent_USCOREgetSnapshotIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotEvent_USCOREgetSnapshotIdResponse*)p = *(_vbox__ISnapshotEvent_USCOREgetSnapshotIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetVisible*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetVisibleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetVisibleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetVisibleResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetVisibleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetAlphaResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetAlphaResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetAlphaResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetAlphaResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetXhot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetXhot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetXhot*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetXhot*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetXhotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetXhotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetXhotResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetXhotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetYhot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetYhot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetYhot*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetYhot*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetYhotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetYhotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetYhotResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetYhotResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetWidth*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetWidthResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetHeight*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetHeightResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetShape type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetShape*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetShape*)q;
		break;
	case SOAP_TYPE__vbox__IMousePointerShapeChangedEvent_USCOREgetShapeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMousePointerShapeChangedEvent_USCOREgetShapeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMousePointerShapeChangedEvent_USCOREgetShapeResponse*)p = *(_vbox__IMousePointerShapeChangedEvent_USCOREgetShapeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsoluteResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsoluteResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsoluteResponse*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsoluteResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelativeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelativeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelativeResponse*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelativeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouchResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouchResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouchResponse*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouchResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor*)q;
		break;
	case SOAP_TYPE__vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursorResponse*)p = *(_vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetNumLockResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetNumLockResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetNumLockResponse*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetNumLockResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLockResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLockResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLockResponse*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLockResponse*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock*)q;
		break;
	case SOAP_TYPE__vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLockResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLockResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLockResponse*)p = *(_vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLockResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStateChangedEvent_USCOREgetState*)p = *(_vbox__IStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IStateChangedEvent_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStateChangedEvent_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStateChangedEvent_USCOREgetStateResponse*)p = *(_vbox__IStateChangedEvent_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter*)p = *(_vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter*)q;
		break;
	case SOAP_TYPE__vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapterResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapterResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapterResponse*)p = *(_vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapterResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPortChangedEvent_USCOREgetSerialPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPortChangedEvent_USCOREgetSerialPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPortChangedEvent_USCOREgetSerialPort*)p = *(_vbox__ISerialPortChangedEvent_USCOREgetSerialPort*)q;
		break;
	case SOAP_TYPE__vbox__ISerialPortChangedEvent_USCOREgetSerialPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISerialPortChangedEvent_USCOREgetSerialPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISerialPortChangedEvent_USCOREgetSerialPortResponse*)p = *(_vbox__ISerialPortChangedEvent_USCOREgetSerialPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPortChangedEvent_USCOREgetParallelPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPortChangedEvent_USCOREgetParallelPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPortChangedEvent_USCOREgetParallelPort*)p = *(_vbox__IParallelPortChangedEvent_USCOREgetParallelPort*)q;
		break;
	case SOAP_TYPE__vbox__IParallelPortChangedEvent_USCOREgetParallelPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IParallelPortChangedEvent_USCOREgetParallelPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IParallelPortChangedEvent_USCOREgetParallelPortResponse*)p = *(_vbox__IParallelPortChangedEvent_USCOREgetParallelPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IMediumChangedEvent_USCOREgetMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumChangedEvent_USCOREgetMediumAttachment type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumChangedEvent_USCOREgetMediumAttachment*)p = *(_vbox__IMediumChangedEvent_USCOREgetMediumAttachment*)q;
		break;
	case SOAP_TYPE__vbox__IMediumChangedEvent_USCOREgetMediumAttachmentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IMediumChangedEvent_USCOREgetMediumAttachmentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IMediumChangedEvent_USCOREgetMediumAttachmentResponse*)p = *(_vbox__IMediumChangedEvent_USCOREgetMediumAttachmentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode*)p = *(_vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode*)q;
		break;
	case SOAP_TYPE__vbox__IClipboardModeChangedEvent_USCOREgetClipboardModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IClipboardModeChangedEvent_USCOREgetClipboardModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IClipboardModeChangedEvent_USCOREgetClipboardModeResponse*)p = *(_vbox__IClipboardModeChangedEvent_USCOREgetClipboardModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IDnDModeChangedEvent_USCOREgetDndMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDModeChangedEvent_USCOREgetDndMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDModeChangedEvent_USCOREgetDndMode*)p = *(_vbox__IDnDModeChangedEvent_USCOREgetDndMode*)q;
		break;
	case SOAP_TYPE__vbox__IDnDModeChangedEvent_USCOREgetDndModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IDnDModeChangedEvent_USCOREgetDndModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IDnDModeChangedEvent_USCOREgetDndModeResponse*)p = *(_vbox__IDnDModeChangedEvent_USCOREgetDndModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICPUChangedEvent_USCOREgetCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUChangedEvent_USCOREgetCPU type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUChangedEvent_USCOREgetCPU*)p = *(_vbox__ICPUChangedEvent_USCOREgetCPU*)q;
		break;
	case SOAP_TYPE__vbox__ICPUChangedEvent_USCOREgetCPUResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUChangedEvent_USCOREgetCPUResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUChangedEvent_USCOREgetCPUResponse*)p = *(_vbox__ICPUChangedEvent_USCOREgetCPUResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICPUChangedEvent_USCOREgetAdd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUChangedEvent_USCOREgetAdd type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUChangedEvent_USCOREgetAdd*)p = *(_vbox__ICPUChangedEvent_USCOREgetAdd*)q;
		break;
	case SOAP_TYPE__vbox__ICPUChangedEvent_USCOREgetAddResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUChangedEvent_USCOREgetAddResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUChangedEvent_USCOREgetAddResponse*)p = *(_vbox__ICPUChangedEvent_USCOREgetAddResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap*)p = *(_vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap*)q;
		break;
	case SOAP_TYPE__vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCapResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCapResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCapResponse*)p = *(_vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCapResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestKeyboardEvent_USCOREgetScancodes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestKeyboardEvent_USCOREgetScancodes type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestKeyboardEvent_USCOREgetScancodes*)p = *(_vbox__IGuestKeyboardEvent_USCOREgetScancodes*)q;
		break;
	case SOAP_TYPE__vbox__IGuestKeyboardEvent_USCOREgetScancodesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestKeyboardEvent_USCOREgetScancodesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestKeyboardEvent_USCOREgetScancodesResponse*)p = *(_vbox__IGuestKeyboardEvent_USCOREgetScancodesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetMode type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetMode*)p = *(_vbox__IGuestMouseEvent_USCOREgetMode*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetModeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetModeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetModeResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetModeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetX type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetX*)p = *(_vbox__IGuestMouseEvent_USCOREgetX*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetXResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetXResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetXResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetXResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetY type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetY*)p = *(_vbox__IGuestMouseEvent_USCOREgetY*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetYResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetYResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetYResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetYResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetZ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetZ type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetZ*)p = *(_vbox__IGuestMouseEvent_USCOREgetZ*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetZResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetZResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetZResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetZResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetW:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetW type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetW*)p = *(_vbox__IGuestMouseEvent_USCOREgetW*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetWResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetWResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetWResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetWResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetButtons:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetButtons type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetButtons*)p = *(_vbox__IGuestMouseEvent_USCOREgetButtons*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMouseEvent_USCOREgetButtonsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMouseEvent_USCOREgetButtonsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMouseEvent_USCOREgetButtonsResponse*)p = *(_vbox__IGuestMouseEvent_USCOREgetButtonsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactCount type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactCount*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactCount*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactCountResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactCountResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactCountResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactCountResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetXPositions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetXPositions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetXPositions*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetXPositions*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetXPositionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetXPositionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetXPositionsResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetXPositionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetYPositions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetYPositions type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetYPositions*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetYPositions*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetYPositionsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetYPositionsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetYPositionsResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetYPositionsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactIds type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactIds*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactIds*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactIdsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactIdsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactIdsResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactIdsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactFlags type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactFlags*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactFlags*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetContactFlagsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetContactFlagsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetContactFlagsResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetContactFlagsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetScanTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetScanTime type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetScanTime*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetScanTime*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMultiTouchEvent_USCOREgetScanTimeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMultiTouchEvent_USCOREgetScanTimeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMultiTouchEvent_USCOREgetScanTimeResponse*)p = *(_vbox__IGuestMultiTouchEvent_USCOREgetScanTimeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionEvent_USCOREgetSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionEvent_USCOREgetSession type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionEvent_USCOREgetSession*)p = *(_vbox__IGuestSessionEvent_USCOREgetSession*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionEvent_USCOREgetSessionResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionEvent_USCOREgetSessionResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionEvent_USCOREgetSessionResponse*)p = *(_vbox__IGuestSessionEvent_USCOREgetSessionResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetId*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetIdResponse*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetStatus*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetStatusResponse*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetError*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionStateChangedEvent_USCOREgetErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionStateChangedEvent_USCOREgetErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionStateChangedEvent_USCOREgetErrorResponse*)p = *(_vbox__IGuestSessionStateChangedEvent_USCOREgetErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered*)p = *(_vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE__vbox__IGuestSessionRegisteredEvent_USCOREgetRegisteredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestSessionRegisteredEvent_USCOREgetRegisteredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestSessionRegisteredEvent_USCOREgetRegisteredResponse*)p = *(_vbox__IGuestSessionRegisteredEvent_USCOREgetRegisteredResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessEvent_USCOREgetProcess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessEvent_USCOREgetProcess type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessEvent_USCOREgetProcess*)p = *(_vbox__IGuestProcessEvent_USCOREgetProcess*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessEvent_USCOREgetProcessResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessEvent_USCOREgetProcessResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessEvent_USCOREgetProcessResponse*)p = *(_vbox__IGuestProcessEvent_USCOREgetProcessResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessEvent_USCOREgetPid:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessEvent_USCOREgetPid type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessEvent_USCOREgetPid*)p = *(_vbox__IGuestProcessEvent_USCOREgetPid*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessEvent_USCOREgetPidResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessEvent_USCOREgetPidResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessEvent_USCOREgetPidResponse*)p = *(_vbox__IGuestProcessEvent_USCOREgetPidResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered*)p = *(_vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessRegisteredEvent_USCOREgetRegisteredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessRegisteredEvent_USCOREgetRegisteredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessRegisteredEvent_USCOREgetRegisteredResponse*)p = *(_vbox__IGuestProcessRegisteredEvent_USCOREgetRegisteredResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessStateChangedEvent_USCOREgetStatus*)p = *(_vbox__IGuestProcessStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessStateChangedEvent_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessStateChangedEvent_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessStateChangedEvent_USCOREgetStatusResponse*)p = *(_vbox__IGuestProcessStateChangedEvent_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessStateChangedEvent_USCOREgetError*)p = *(_vbox__IGuestProcessStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessStateChangedEvent_USCOREgetErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessStateChangedEvent_USCOREgetErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessStateChangedEvent_USCOREgetErrorResponse*)p = *(_vbox__IGuestProcessStateChangedEvent_USCOREgetErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessIOEvent_USCOREgetHandle:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessIOEvent_USCOREgetHandle type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessIOEvent_USCOREgetHandle*)p = *(_vbox__IGuestProcessIOEvent_USCOREgetHandle*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessIOEvent_USCOREgetHandleResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessIOEvent_USCOREgetHandleResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessIOEvent_USCOREgetHandleResponse*)p = *(_vbox__IGuestProcessIOEvent_USCOREgetHandleResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessIOEvent_USCOREgetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessIOEvent_USCOREgetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessIOEvent_USCOREgetProcessed*)p = *(_vbox__IGuestProcessIOEvent_USCOREgetProcessed*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessIOEvent_USCOREgetProcessedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessIOEvent_USCOREgetProcessedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessIOEvent_USCOREgetProcessedResponse*)p = *(_vbox__IGuestProcessIOEvent_USCOREgetProcessedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus*)p = *(_vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessInputNotifyEvent_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessInputNotifyEvent_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessInputNotifyEvent_USCOREgetStatusResponse*)p = *(_vbox__IGuestProcessInputNotifyEvent_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessOutputEvent_USCOREgetData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessOutputEvent_USCOREgetData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessOutputEvent_USCOREgetData*)p = *(_vbox__IGuestProcessOutputEvent_USCOREgetData*)q;
		break;
	case SOAP_TYPE__vbox__IGuestProcessOutputEvent_USCOREgetDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestProcessOutputEvent_USCOREgetDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestProcessOutputEvent_USCOREgetDataResponse*)p = *(_vbox__IGuestProcessOutputEvent_USCOREgetDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileEvent_USCOREgetFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileEvent_USCOREgetFile type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileEvent_USCOREgetFile*)p = *(_vbox__IGuestFileEvent_USCOREgetFile*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileEvent_USCOREgetFileResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileEvent_USCOREgetFileResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileEvent_USCOREgetFileResponse*)p = *(_vbox__IGuestFileEvent_USCOREgetFileResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileRegisteredEvent_USCOREgetRegistered*)p = *(_vbox__IGuestFileRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileRegisteredEvent_USCOREgetRegisteredResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileRegisteredEvent_USCOREgetRegisteredResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileRegisteredEvent_USCOREgetRegisteredResponse*)p = *(_vbox__IGuestFileRegisteredEvent_USCOREgetRegisteredResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileStateChangedEvent_USCOREgetStatus*)p = *(_vbox__IGuestFileStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileStateChangedEvent_USCOREgetStatusResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileStateChangedEvent_USCOREgetStatusResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileStateChangedEvent_USCOREgetStatusResponse*)p = *(_vbox__IGuestFileStateChangedEvent_USCOREgetStatusResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileStateChangedEvent_USCOREgetError*)p = *(_vbox__IGuestFileStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileStateChangedEvent_USCOREgetErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileStateChangedEvent_USCOREgetErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileStateChangedEvent_USCOREgetErrorResponse*)p = *(_vbox__IGuestFileStateChangedEvent_USCOREgetErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileIOEvent_USCOREgetOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileIOEvent_USCOREgetOffset type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileIOEvent_USCOREgetOffset*)p = *(_vbox__IGuestFileIOEvent_USCOREgetOffset*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileIOEvent_USCOREgetOffsetResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileIOEvent_USCOREgetOffsetResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileIOEvent_USCOREgetOffsetResponse*)p = *(_vbox__IGuestFileIOEvent_USCOREgetOffsetResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileIOEvent_USCOREgetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileIOEvent_USCOREgetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileIOEvent_USCOREgetProcessed*)p = *(_vbox__IGuestFileIOEvent_USCOREgetProcessed*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileIOEvent_USCOREgetProcessedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileIOEvent_USCOREgetProcessedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileIOEvent_USCOREgetProcessedResponse*)p = *(_vbox__IGuestFileIOEvent_USCOREgetProcessedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileReadEvent_USCOREgetData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileReadEvent_USCOREgetData type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileReadEvent_USCOREgetData*)p = *(_vbox__IGuestFileReadEvent_USCOREgetData*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileReadEvent_USCOREgetDataResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileReadEvent_USCOREgetDataResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileReadEvent_USCOREgetDataResponse*)p = *(_vbox__IGuestFileReadEvent_USCOREgetDataResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetDeviceResponse*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetAttachedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetAttachedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetAttachedResponse*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetAttachedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetError*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE__vbox__IUSBDeviceStateChangedEvent_USCOREgetErrorResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IUSBDeviceStateChangedEvent_USCOREgetErrorResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IUSBDeviceStateChangedEvent_USCOREgetErrorResponse*)p = *(_vbox__IUSBDeviceStateChangedEvent_USCOREgetErrorResponse*)q;
		break;
	case SOAP_TYPE__vbox__ISharedFolderChangedEvent_USCOREgetScope:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISharedFolderChangedEvent_USCOREgetScope type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISharedFolderChangedEvent_USCOREgetScope*)p = *(_vbox__ISharedFolderChangedEvent_USCOREgetScope*)q;
		break;
	case SOAP_TYPE__vbox__ISharedFolderChangedEvent_USCOREgetScopeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ISharedFolderChangedEvent_USCOREgetScopeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ISharedFolderChangedEvent_USCOREgetScopeResponse*)p = *(_vbox__ISharedFolderChangedEvent_USCOREgetScopeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetFatal:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetFatal type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetFatal*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetFatal*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetFatalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetFatalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetFatalResponse*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetFatalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetId*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetId*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetIdResponse*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetMessage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetMessage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetMessage*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetMessage*)q;
		break;
	case SOAP_TYPE__vbox__IRuntimeErrorEvent_USCOREgetMessageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IRuntimeErrorEvent_USCOREgetMessageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IRuntimeErrorEvent_USCOREgetMessageResponse*)p = *(_vbox__IRuntimeErrorEvent_USCOREgetMessageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSourceChangedEvent_USCOREgetListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSourceChangedEvent_USCOREgetListener type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSourceChangedEvent_USCOREgetListener*)p = *(_vbox__IEventSourceChangedEvent_USCOREgetListener*)q;
		break;
	case SOAP_TYPE__vbox__IEventSourceChangedEvent_USCOREgetListenerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSourceChangedEvent_USCOREgetListenerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSourceChangedEvent_USCOREgetListenerResponse*)p = *(_vbox__IEventSourceChangedEvent_USCOREgetListenerResponse*)q;
		break;
	case SOAP_TYPE__vbox__IEventSourceChangedEvent_USCOREgetAdd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSourceChangedEvent_USCOREgetAdd type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSourceChangedEvent_USCOREgetAdd*)p = *(_vbox__IEventSourceChangedEvent_USCOREgetAdd*)q;
		break;
	case SOAP_TYPE__vbox__IEventSourceChangedEvent_USCOREgetAddResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IEventSourceChangedEvent_USCOREgetAddResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IEventSourceChangedEvent_USCOREgetAddResponse*)p = *(_vbox__IEventSourceChangedEvent_USCOREgetAddResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetMachineId*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetMachineIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetMachineIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetMachineIdResponse*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetMachineIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetKey type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetKey*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetKey*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetKeyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetKeyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetKeyResponse*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetKeyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetValue*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataChangedEvent_USCOREgetValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataChangedEvent_USCOREgetValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataChangedEvent_USCOREgetValueResponse*)p = *(_vbox__IExtraDataChangedEvent_USCOREgetValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREaddVeto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREaddVeto type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREaddVeto*)p = *(_vbox__IVetoEvent_USCOREaddVeto*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREaddVetoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREaddVetoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREaddVetoResponse*)p = *(_vbox__IVetoEvent_USCOREaddVetoResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREisVetoed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREisVetoed type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREisVetoed*)p = *(_vbox__IVetoEvent_USCOREisVetoed*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREisVetoedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREisVetoedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREisVetoedResponse*)p = *(_vbox__IVetoEvent_USCOREisVetoedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREgetVetos:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREgetVetos type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREgetVetos*)p = *(_vbox__IVetoEvent_USCOREgetVetos*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREgetVetosResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREgetVetosResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREgetVetosResponse*)p = *(_vbox__IVetoEvent_USCOREgetVetosResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREaddApproval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREaddApproval type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREaddApproval*)p = *(_vbox__IVetoEvent_USCOREaddApproval*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREaddApprovalResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREaddApprovalResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREaddApprovalResponse*)p = *(_vbox__IVetoEvent_USCOREaddApprovalResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREisApproved:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREisApproved type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREisApproved*)p = *(_vbox__IVetoEvent_USCOREisApproved*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREisApprovedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREisApprovedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREisApprovedResponse*)p = *(_vbox__IVetoEvent_USCOREisApprovedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREgetApprovals:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREgetApprovals type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREgetApprovals*)p = *(_vbox__IVetoEvent_USCOREgetApprovals*)q;
		break;
	case SOAP_TYPE__vbox__IVetoEvent_USCOREgetApprovalsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVetoEvent_USCOREgetApprovalsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVetoEvent_USCOREgetApprovalsResponse*)p = *(_vbox__IVetoEvent_USCOREgetApprovalsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetMachineId*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetMachineIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetMachineIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetMachineIdResponse*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetMachineIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetKey type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetKey*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetKey*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetKeyResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetKeyResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetKeyResponse*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetKeyResponse*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetValue*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE__vbox__IExtraDataCanChangeEvent_USCOREgetValueResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IExtraDataCanChangeEvent_USCOREgetValueResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IExtraDataCanChangeEvent_USCOREgetValueResponse*)p = *(_vbox__IExtraDataCanChangeEvent_USCOREgetValueResponse*)q;
		break;
	case SOAP_TYPE__vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__IShowWindowEvent_USCOREgetWinId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IShowWindowEvent_USCOREgetWinId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IShowWindowEvent_USCOREgetWinId*)p = *(_vbox__IShowWindowEvent_USCOREgetWinId*)q;
		break;
	case SOAP_TYPE__vbox__IShowWindowEvent_USCOREgetWinIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IShowWindowEvent_USCOREgetWinIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IShowWindowEvent_USCOREgetWinIdResponse*)p = *(_vbox__IShowWindowEvent_USCOREgetWinIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IShowWindowEvent_USCOREsetWinId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IShowWindowEvent_USCOREsetWinId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IShowWindowEvent_USCOREsetWinId*)p = *(_vbox__IShowWindowEvent_USCOREsetWinId*)q;
		break;
	case SOAP_TYPE__vbox__IShowWindowEvent_USCOREsetWinIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IShowWindowEvent_USCOREsetWinIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IShowWindowEvent_USCOREsetWinIdResponse*)p = *(_vbox__IShowWindowEvent_USCOREsetWinIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetSlot*)p = *(_vbox__INATRedirectEvent_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetSlotResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetSlotResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetSlotResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetSlotResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetRemove type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetRemove*)p = *(_vbox__INATRedirectEvent_USCOREgetRemove*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetRemoveResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetRemoveResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetRemoveResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetRemoveResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetName*)p = *(_vbox__INATRedirectEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetNameResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetProto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetProto type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetProto*)p = *(_vbox__INATRedirectEvent_USCOREgetProto*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetProtoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetProtoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetProtoResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetProtoResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetHostIP*)p = *(_vbox__INATRedirectEvent_USCOREgetHostIP*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetHostIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetHostIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetHostIPResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetHostIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetHostPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetHostPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetHostPort*)p = *(_vbox__INATRedirectEvent_USCOREgetHostPort*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetHostPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetHostPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetHostPortResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetHostPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetGuestIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetGuestIP type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetGuestIP*)p = *(_vbox__INATRedirectEvent_USCOREgetGuestIP*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetGuestIPResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetGuestIPResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetGuestIPResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetGuestIPResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetGuestPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetGuestPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetGuestPort*)p = *(_vbox__INATRedirectEvent_USCOREgetGuestPort*)q;
		break;
	case SOAP_TYPE__vbox__INATRedirectEvent_USCOREgetGuestPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATRedirectEvent_USCOREgetGuestPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATRedirectEvent_USCOREgetGuestPortResponse*)p = *(_vbox__INATRedirectEvent_USCOREgetGuestPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetPluggedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetPluggedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetPluggedResponse*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetPluggedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetSuccessResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetSuccessResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetSuccessResponse*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetSuccessResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetAttachmentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetAttachmentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetAttachmentResponse*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetAttachmentResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetMessage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetMessage type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetMessage*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetMessage*)q;
		break;
	case SOAP_TYPE__vbox__IHostPCIDevicePlugEvent_USCOREgetMessageResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostPCIDevicePlugEvent_USCOREgetMessageResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostPCIDevicePlugEvent_USCOREgetMessageResponse*)p = *(_vbox__IHostPCIDevicePlugEvent_USCOREgetMessageResponse*)q;
		break;
	case SOAP_TYPE__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable*)p = *(_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable*)q;
		break;
	case SOAP_TYPE__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse*)p = *(_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup*)p = *(_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse*)p = *(_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetWidth*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetHeight*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse*)p = *(_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetName*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetDomain type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetDomain*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetDomain*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetState*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails*)q;
		break;
	case SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse*)p = *(_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetSilent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetSilent*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetSilent*)q;
		break;
	case SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse*)p = *(_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkChangedEvent_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkChangedEvent_USCOREgetNetworkName*)p = *(_vbox__INATNetworkChangedEvent_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse*)p = *(_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent*)p = *(_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse*)p = *(_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent*)p = *(_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse*)p = *(_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetEnabled*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetNetwork*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGateway:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetGateway type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetGateway*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetGateway*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse*)p = *(_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetCreate type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetCreate*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetCreate*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetName*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetProto type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetProto*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetProto*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort*)q;
		break;
	case SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse*)p = *(_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse*)q;
		break;
	case SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)p = *(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse*)q;
		break;
	case SOAP_TYPE__vbox__InvalidObjectFault:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__InvalidObjectFault type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__InvalidObjectFault*)p = *(_vbox__InvalidObjectFault*)q;
		break;
	case SOAP_TYPE__vbox__RuntimeFault:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy _vbox__RuntimeFault type=%d location=%p object=%p\n", t, p, q));
		*(_vbox__RuntimeFault*)p = *(_vbox__RuntimeFault*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetResultCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultCode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultCode*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetResultDetail*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetInterfaceID*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetComponent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetComponent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetComponent*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetText:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetText type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetText*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetText*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBoxErrorInfo_USCOREgetNext:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBoxErrorInfo_USCOREgetNext type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBoxErrorInfo_USCOREgetNext*)p = *(struct __vbox__IVirtualBoxErrorInfo_USCOREgetNext*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetNetworkName*)p = *(struct __vbox__INATNetwork_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetNetworkName*)p = *(struct __vbox__INATNetwork_USCOREsetNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetEnabled*)p = *(struct __vbox__INATNetwork_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetEnabled*)p = *(struct __vbox__INATNetwork_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetNetwork*)p = *(struct __vbox__INATNetwork_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetNetwork*)p = *(struct __vbox__INATNetwork_USCOREsetNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetGateway:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetGateway type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetGateway*)p = *(struct __vbox__INATNetwork_USCOREgetGateway*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetIPv6Enabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetIPv6Enabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetIPv6Enabled*)p = *(struct __vbox__INATNetwork_USCOREgetIPv6Enabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetIPv6Enabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetIPv6Enabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetIPv6Enabled*)p = *(struct __vbox__INATNetwork_USCOREsetIPv6Enabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetIPv6Prefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetIPv6Prefix type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetIPv6Prefix*)p = *(struct __vbox__INATNetwork_USCOREgetIPv6Prefix*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetIPv6Prefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetIPv6Prefix type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetIPv6Prefix*)p = *(struct __vbox__INATNetwork_USCOREsetIPv6Prefix*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)p = *(struct __vbox__INATNetwork_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled*)p = *(struct __vbox__INATNetwork_USCOREsetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetNeedDhcpServer*)p = *(struct __vbox__INATNetwork_USCOREgetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetNeedDhcpServer*)p = *(struct __vbox__INATNetwork_USCOREsetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetEventSource*)p = *(struct __vbox__INATNetwork_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetPortForwardRules4:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetPortForwardRules4 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetPortForwardRules4*)p = *(struct __vbox__INATNetwork_USCOREgetPortForwardRules4*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetLocalMappings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetLocalMappings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetLocalMappings*)p = *(struct __vbox__INATNetwork_USCOREgetLocalMappings*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetLoopbackIp6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetLoopbackIp6 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetLoopbackIp6*)p = *(struct __vbox__INATNetwork_USCOREgetLoopbackIp6*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREsetLoopbackIp6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREsetLoopbackIp6 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREsetLoopbackIp6*)p = *(struct __vbox__INATNetwork_USCOREsetLoopbackIp6*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREgetPortForwardRules6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREgetPortForwardRules6 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREgetPortForwardRules6*)p = *(struct __vbox__INATNetwork_USCOREgetPortForwardRules6*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREaddLocalMapping:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREaddLocalMapping type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREaddLocalMapping*)p = *(struct __vbox__INATNetwork_USCOREaddLocalMapping*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREaddPortForwardRule:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREaddPortForwardRule type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREaddPortForwardRule*)p = *(struct __vbox__INATNetwork_USCOREaddPortForwardRule*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREremovePortForwardRule:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREremovePortForwardRule type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREremovePortForwardRule*)p = *(struct __vbox__INATNetwork_USCOREremovePortForwardRule*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREstart:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREstart type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREstart*)p = *(struct __vbox__INATNetwork_USCOREstart*)q;
		break;
	case SOAP_TYPE___vbox__INATNetwork_USCOREstop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetwork_USCOREstop type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetwork_USCOREstop*)p = *(struct __vbox__INATNetwork_USCOREstop*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetEventSource*)p = *(struct __vbox__IDHCPServer_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetEnabled*)p = *(struct __vbox__IDHCPServer_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREsetEnabled*)p = *(struct __vbox__IDHCPServer_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetIPAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetIPAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetIPAddress*)p = *(struct __vbox__IDHCPServer_USCOREgetIPAddress*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkMask:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetNetworkMask type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetNetworkMask*)p = *(struct __vbox__IDHCPServer_USCOREgetNetworkMask*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetNetworkName*)p = *(struct __vbox__IDHCPServer_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetLowerIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetLowerIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetLowerIP*)p = *(struct __vbox__IDHCPServer_USCOREgetLowerIP*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetUpperIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetUpperIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetUpperIP*)p = *(struct __vbox__IDHCPServer_USCOREgetUpperIP*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetGlobalOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetGlobalOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetGlobalOptions*)p = *(struct __vbox__IDHCPServer_USCOREgetGlobalOptions*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetVmConfigs:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetVmConfigs type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetVmConfigs*)p = *(struct __vbox__IDHCPServer_USCOREgetVmConfigs*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREaddGlobalOption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREaddGlobalOption type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREaddGlobalOption*)p = *(struct __vbox__IDHCPServer_USCOREaddGlobalOption*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREaddVmSlotOption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREaddVmSlotOption type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREaddVmSlotOption*)p = *(struct __vbox__IDHCPServer_USCOREaddVmSlotOption*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREremoveVmSlotOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREremoveVmSlotOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREremoveVmSlotOptions*)p = *(struct __vbox__IDHCPServer_USCOREremoveVmSlotOptions*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetVmSlotOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetVmSlotOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetVmSlotOptions*)p = *(struct __vbox__IDHCPServer_USCOREgetVmSlotOptions*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREgetMacOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREgetMacOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREgetMacOptions*)p = *(struct __vbox__IDHCPServer_USCOREgetMacOptions*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREsetConfiguration:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREsetConfiguration type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREsetConfiguration*)p = *(struct __vbox__IDHCPServer_USCOREsetConfiguration*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstart:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREstart type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREstart*)p = *(struct __vbox__IDHCPServer_USCOREstart*)q;
		break;
	case SOAP_TYPE___vbox__IDHCPServer_USCOREstop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDHCPServer_USCOREstop type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDHCPServer_USCOREstop*)p = *(struct __vbox__IDHCPServer_USCOREstop*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetVersion*)p = *(struct __vbox__IVirtualBox_USCOREgetVersion*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetVersionNormalized:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetVersionNormalized type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetVersionNormalized*)p = *(struct __vbox__IVirtualBox_USCOREgetVersionNormalized*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetRevision*)p = *(struct __vbox__IVirtualBox_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPackageType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetPackageType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetPackageType*)p = *(struct __vbox__IVirtualBox_USCOREgetPackageType*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetAPIVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetAPIVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetAPIVersion*)p = *(struct __vbox__IVirtualBox_USCOREgetAPIVersion*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetAPIRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetAPIRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetAPIRevision*)p = *(struct __vbox__IVirtualBox_USCOREgetAPIRevision*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHomeFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetHomeFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetHomeFolder*)p = *(struct __vbox__IVirtualBox_USCOREgetHomeFolder*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetSettingsFilePath*)p = *(struct __vbox__IVirtualBox_USCOREgetSettingsFilePath*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHost:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetHost type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetHost*)p = *(struct __vbox__IVirtualBox_USCOREgetHost*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSystemProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetSystemProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetSystemProperties*)p = *(struct __vbox__IVirtualBox_USCOREgetSystemProperties*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetMachines type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetMachines*)p = *(struct __vbox__IVirtualBox_USCOREgetMachines*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachineGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetMachineGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetMachineGroups*)p = *(struct __vbox__IVirtualBox_USCOREgetMachineGroups*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetHardDisks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetHardDisks type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetHardDisks*)p = *(struct __vbox__IVirtualBox_USCOREgetHardDisks*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDVDImages:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetDVDImages type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetDVDImages*)p = *(struct __vbox__IVirtualBox_USCOREgetDVDImages*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetFloppyImages:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetFloppyImages type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetFloppyImages*)p = *(struct __vbox__IVirtualBox_USCOREgetFloppyImages*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetProgressOperations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetProgressOperations type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetProgressOperations*)p = *(struct __vbox__IVirtualBox_USCOREgetProgressOperations*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSTypes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetGuestOSTypes type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetGuestOSTypes*)p = *(struct __vbox__IVirtualBox_USCOREgetGuestOSTypes*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetSharedFolders*)p = *(struct __vbox__IVirtualBox_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetPerformanceCollector:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetPerformanceCollector type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetPerformanceCollector*)p = *(struct __vbox__IVirtualBox_USCOREgetPerformanceCollector*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetDHCPServers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetDHCPServers type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetDHCPServers*)p = *(struct __vbox__IVirtualBox_USCOREgetDHCPServers*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetNATNetworks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetNATNetworks type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetNATNetworks*)p = *(struct __vbox__IVirtualBox_USCOREgetNATNetworks*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetEventSource*)p = *(struct __vbox__IVirtualBox_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetInternalNetworks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetInternalNetworks type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetInternalNetworks*)p = *(struct __vbox__IVirtualBox_USCOREgetInternalNetworks*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGenericNetworkDrivers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetGenericNetworkDrivers type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetGenericNetworkDrivers*)p = *(struct __vbox__IVirtualBox_USCOREgetGenericNetworkDrivers*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcomposeMachineFilename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcomposeMachineFilename type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcomposeMachineFilename*)p = *(struct __vbox__IVirtualBox_USCOREcomposeMachineFilename*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateMachine*)p = *(struct __vbox__IVirtualBox_USCOREcreateMachine*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREopenMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREopenMachine*)p = *(struct __vbox__IVirtualBox_USCOREopenMachine*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREregisterMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREregisterMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREregisterMachine*)p = *(struct __vbox__IVirtualBox_USCOREregisterMachine*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREfindMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREfindMachine*)p = *(struct __vbox__IVirtualBox_USCOREfindMachine*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachinesByGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetMachinesByGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetMachinesByGroups*)p = *(struct __vbox__IVirtualBox_USCOREgetMachinesByGroups*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetMachineStates:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetMachineStates type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetMachineStates*)p = *(struct __vbox__IVirtualBox_USCOREgetMachineStates*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateAppliance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateAppliance type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateAppliance*)p = *(struct __vbox__IVirtualBox_USCOREcreateAppliance*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateMedium*)p = *(struct __vbox__IVirtualBox_USCOREcreateMedium*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREopenMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREopenMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREopenMedium*)p = *(struct __vbox__IVirtualBox_USCOREopenMedium*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetGuestOSType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetGuestOSType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetGuestOSType*)p = *(struct __vbox__IVirtualBox_USCOREgetGuestOSType*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateSharedFolder*)p = *(struct __vbox__IVirtualBox_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREremoveSharedFolder*)p = *(struct __vbox__IVirtualBox_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraDataKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetExtraDataKeys type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetExtraDataKeys*)p = *(struct __vbox__IVirtualBox_USCOREgetExtraDataKeys*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREgetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREgetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREgetExtraData*)p = *(struct __vbox__IVirtualBox_USCOREgetExtraData*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREsetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREsetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREsetExtraData*)p = *(struct __vbox__IVirtualBox_USCOREsetExtraData*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREsetSettingsSecret:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREsetSettingsSecret type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREsetSettingsSecret*)p = *(struct __vbox__IVirtualBox_USCOREsetSettingsSecret*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateDHCPServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateDHCPServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateDHCPServer*)p = *(struct __vbox__IVirtualBox_USCOREcreateDHCPServer*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)p = *(struct __vbox__IVirtualBox_USCOREfindDHCPServerByNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveDHCPServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREremoveDHCPServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREremoveDHCPServer*)p = *(struct __vbox__IVirtualBox_USCOREremoveDHCPServer*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcreateNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcreateNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcreateNATNetwork*)p = *(struct __vbox__IVirtualBox_USCOREcreateNATNetwork*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREfindNATNetworkByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREfindNATNetworkByName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREfindNATNetworkByName*)p = *(struct __vbox__IVirtualBox_USCOREfindNATNetworkByName*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREremoveNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREremoveNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREremoveNATNetwork*)p = *(struct __vbox__IVirtualBox_USCOREremoveNATNetwork*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualBox_USCOREcheckFirmwarePresent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualBox_USCOREcheckFirmwarePresent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualBox_USCOREcheckFirmwarePresent*)p = *(struct __vbox__IVirtualBox_USCOREcheckFirmwarePresent*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREgetPath*)p = *(struct __vbox__IVFSExplorer_USCOREgetPath*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREgetType*)p = *(struct __vbox__IVFSExplorer_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREupdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREupdate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREupdate*)p = *(struct __vbox__IVFSExplorer_USCOREupdate*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREcd type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREcd*)p = *(struct __vbox__IVFSExplorer_USCOREcd*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREcdUp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREcdUp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREcdUp*)p = *(struct __vbox__IVFSExplorer_USCOREcdUp*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREentryList:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREentryList type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREentryList*)p = *(struct __vbox__IVFSExplorer_USCOREentryList*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREexists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREexists type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREexists*)p = *(struct __vbox__IVFSExplorer_USCOREexists*)q;
		break;
	case SOAP_TYPE___vbox__IVFSExplorer_USCOREremove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVFSExplorer_USCOREremove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVFSExplorer_USCOREremove*)p = *(struct __vbox__IVFSExplorer_USCOREremove*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetVersionNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetVersionNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetVersionNumber*)p = *(struct __vbox__ICertificate_USCOREgetVersionNumber*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSerialNumber*)p = *(struct __vbox__ICertificate_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSignatureAlgorithmOID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSignatureAlgorithmOID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSignatureAlgorithmOID*)p = *(struct __vbox__ICertificate_USCOREgetSignatureAlgorithmOID*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSignatureAlgorithmName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSignatureAlgorithmName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSignatureAlgorithmName*)p = *(struct __vbox__ICertificate_USCOREgetSignatureAlgorithmName*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetIssuerName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetIssuerName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetIssuerName*)p = *(struct __vbox__ICertificate_USCOREgetIssuerName*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSubjectName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSubjectName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSubjectName*)p = *(struct __vbox__ICertificate_USCOREgetSubjectName*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetFriendlyName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetFriendlyName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetFriendlyName*)p = *(struct __vbox__ICertificate_USCOREgetFriendlyName*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetValidityPeriodNotBefore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetValidityPeriodNotBefore type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetValidityPeriodNotBefore*)p = *(struct __vbox__ICertificate_USCOREgetValidityPeriodNotBefore*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetValidityPeriodNotAfter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetValidityPeriodNotAfter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetValidityPeriodNotAfter*)p = *(struct __vbox__ICertificate_USCOREgetValidityPeriodNotAfter*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID*)p = *(struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithmOID*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetPublicKeyAlgorithm:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithm type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithm*)p = *(struct __vbox__ICertificate_USCOREgetPublicKeyAlgorithm*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSubjectPublicKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSubjectPublicKey type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSubjectPublicKey*)p = *(struct __vbox__ICertificate_USCOREgetSubjectPublicKey*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetIssuerUniqueIdentifier:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetIssuerUniqueIdentifier type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetIssuerUniqueIdentifier*)p = *(struct __vbox__ICertificate_USCOREgetIssuerUniqueIdentifier*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSubjectUniqueIdentifier:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSubjectUniqueIdentifier type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSubjectUniqueIdentifier*)p = *(struct __vbox__ICertificate_USCOREgetSubjectUniqueIdentifier*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetCertificateAuthority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetCertificateAuthority type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetCertificateAuthority*)p = *(struct __vbox__ICertificate_USCOREgetCertificateAuthority*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetKeyUsage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetKeyUsage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetKeyUsage*)p = *(struct __vbox__ICertificate_USCOREgetKeyUsage*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetExtendedKeyUsage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetExtendedKeyUsage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetExtendedKeyUsage*)p = *(struct __vbox__ICertificate_USCOREgetExtendedKeyUsage*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetRawCertData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetRawCertData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetRawCertData*)p = *(struct __vbox__ICertificate_USCOREgetRawCertData*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetSelfSigned:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetSelfSigned type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetSelfSigned*)p = *(struct __vbox__ICertificate_USCOREgetSelfSigned*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetTrusted:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetTrusted type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetTrusted*)p = *(struct __vbox__ICertificate_USCOREgetTrusted*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREgetExpired:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREgetExpired type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREgetExpired*)p = *(struct __vbox__ICertificate_USCOREgetExpired*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREisCurrentlyExpired:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREisCurrentlyExpired type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREisCurrentlyExpired*)p = *(struct __vbox__ICertificate_USCOREisCurrentlyExpired*)q;
		break;
	case SOAP_TYPE___vbox__ICertificate_USCOREqueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICertificate_USCOREqueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICertificate_USCOREqueryInfo*)p = *(struct __vbox__ICertificate_USCOREqueryInfo*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetPath*)p = *(struct __vbox__IAppliance_USCOREgetPath*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetDisks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetDisks type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetDisks*)p = *(struct __vbox__IAppliance_USCOREgetDisks*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetVirtualSystemDescriptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetVirtualSystemDescriptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)p = *(struct __vbox__IAppliance_USCOREgetVirtualSystemDescriptions*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetMachines type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetMachines*)p = *(struct __vbox__IAppliance_USCOREgetMachines*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetCertificate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetCertificate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetCertificate*)p = *(struct __vbox__IAppliance_USCOREgetCertificate*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREread*)p = *(struct __vbox__IAppliance_USCOREread*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREinterpret:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREinterpret type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREinterpret*)p = *(struct __vbox__IAppliance_USCOREinterpret*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREimportMachines:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREimportMachines type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREimportMachines*)p = *(struct __vbox__IAppliance_USCOREimportMachines*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREcreateVFSExplorer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREcreateVFSExplorer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREcreateVFSExplorer*)p = *(struct __vbox__IAppliance_USCOREcreateVFSExplorer*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREwrite*)p = *(struct __vbox__IAppliance_USCOREwrite*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetWarnings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetWarnings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetWarnings*)p = *(struct __vbox__IAppliance_USCOREgetWarnings*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetPasswordIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetPasswordIds type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetPasswordIds*)p = *(struct __vbox__IAppliance_USCOREgetPasswordIds*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREgetMediumIdsForPasswordId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREgetMediumIdsForPasswordId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREgetMediumIdsForPasswordId*)p = *(struct __vbox__IAppliance_USCOREgetMediumIdsForPasswordId*)q;
		break;
	case SOAP_TYPE___vbox__IAppliance_USCOREaddPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAppliance_USCOREaddPasswords type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAppliance_USCOREaddPasswords*)p = *(struct __vbox__IAppliance_USCOREaddPasswords*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREgetCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREgetCount*)p = *(struct __vbox__IVirtualSystemDescription_USCOREgetCount*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREgetDescription*)p = *(struct __vbox__IVirtualSystemDescription_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetDescriptionByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREgetDescriptionByType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)p = *(struct __vbox__IVirtualSystemDescription_USCOREgetDescriptionByType*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREgetValuesByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREgetValuesByType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREgetValuesByType*)p = *(struct __vbox__IVirtualSystemDescription_USCOREgetValuesByType*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREsetFinalValues:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREsetFinalValues type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREsetFinalValues*)p = *(struct __vbox__IVirtualSystemDescription_USCOREsetFinalValues*)q;
		break;
	case SOAP_TYPE___vbox__IVirtualSystemDescription_USCOREaddDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVirtualSystemDescription_USCOREaddDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVirtualSystemDescription_USCOREaddDescription*)p = *(struct __vbox__IVirtualSystemDescription_USCOREaddDescription*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetLogoFadeIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetLogoFadeIn*)p = *(struct __vbox__IBIOSSettings_USCOREgetLogoFadeIn*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetLogoFadeIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetLogoFadeIn*)p = *(struct __vbox__IBIOSSettings_USCOREsetLogoFadeIn*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoFadeOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetLogoFadeOut type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetLogoFadeOut*)p = *(struct __vbox__IBIOSSettings_USCOREgetLogoFadeOut*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoFadeOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetLogoFadeOut type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetLogoFadeOut*)p = *(struct __vbox__IBIOSSettings_USCOREsetLogoFadeOut*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoDisplayTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetLogoDisplayTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)p = *(struct __vbox__IBIOSSettings_USCOREgetLogoDisplayTime*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoDisplayTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetLogoDisplayTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)p = *(struct __vbox__IBIOSSettings_USCOREsetLogoDisplayTime*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetLogoImagePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetLogoImagePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetLogoImagePath*)p = *(struct __vbox__IBIOSSettings_USCOREgetLogoImagePath*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetLogoImagePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetLogoImagePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetLogoImagePath*)p = *(struct __vbox__IBIOSSettings_USCOREsetLogoImagePath*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetBootMenuMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetBootMenuMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetBootMenuMode*)p = *(struct __vbox__IBIOSSettings_USCOREgetBootMenuMode*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetBootMenuMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetBootMenuMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetBootMenuMode*)p = *(struct __vbox__IBIOSSettings_USCOREsetBootMenuMode*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetACPIEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetACPIEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetACPIEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREgetACPIEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetACPIEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetACPIEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetACPIEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREsetACPIEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetIOAPICEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetIOAPICEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREgetIOAPICEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetIOAPICEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetIOAPICEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREsetIOAPICEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetAPICMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetAPICMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetAPICMode*)p = *(struct __vbox__IBIOSSettings_USCOREgetAPICMode*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetAPICMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetAPICMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetAPICMode*)p = *(struct __vbox__IBIOSSettings_USCOREsetAPICMode*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetTimeOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetTimeOffset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetTimeOffset*)p = *(struct __vbox__IBIOSSettings_USCOREgetTimeOffset*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetTimeOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetTimeOffset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetTimeOffset*)p = *(struct __vbox__IBIOSSettings_USCOREsetTimeOffset*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetPXEDebugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetPXEDebugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREgetPXEDebugEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREsetPXEDebugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREsetPXEDebugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)p = *(struct __vbox__IBIOSSettings_USCOREsetPXEDebugEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile*)p = *(struct __vbox__IBIOSSettings_USCOREgetNonVolatileStorageFile*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREgetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREgetBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREgetBus*)p = *(struct __vbox__IPCIAddress_USCOREgetBus*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREsetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREsetBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREsetBus*)p = *(struct __vbox__IPCIAddress_USCOREsetBus*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREgetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREgetDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREgetDevice*)p = *(struct __vbox__IPCIAddress_USCOREgetDevice*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREsetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREsetDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREsetDevice*)p = *(struct __vbox__IPCIAddress_USCOREsetDevice*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREgetDevFunction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREgetDevFunction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREgetDevFunction*)p = *(struct __vbox__IPCIAddress_USCOREgetDevFunction*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREsetDevFunction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREsetDevFunction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREsetDevFunction*)p = *(struct __vbox__IPCIAddress_USCOREsetDevFunction*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREasLong:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREasLong type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREasLong*)p = *(struct __vbox__IPCIAddress_USCOREasLong*)q;
		break;
	case SOAP_TYPE___vbox__IPCIAddress_USCOREfromLong:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPCIAddress_USCOREfromLong type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPCIAddress_USCOREfromLong*)p = *(struct __vbox__IPCIAddress_USCOREfromLong*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetParent*)p = *(struct __vbox__IMachine_USCOREgetParent*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetIcon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetIcon type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetIcon*)p = *(struct __vbox__IMachine_USCOREgetIcon*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetIcon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetIcon type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetIcon*)p = *(struct __vbox__IMachine_USCOREsetIcon*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAccessible type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAccessible*)p = *(struct __vbox__IMachine_USCOREgetAccessible*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccessError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAccessError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAccessError*)p = *(struct __vbox__IMachine_USCOREgetAccessError*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetName*)p = *(struct __vbox__IMachine_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetName*)p = *(struct __vbox__IMachine_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetDescription*)p = *(struct __vbox__IMachine_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetDescription*)p = *(struct __vbox__IMachine_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetId*)p = *(struct __vbox__IMachine_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetGroups*)p = *(struct __vbox__IMachine_USCOREgetGroups*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetGroups*)p = *(struct __vbox__IMachine_USCOREsetGroups*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetOSTypeId*)p = *(struct __vbox__IMachine_USCOREgetOSTypeId*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetOSTypeId*)p = *(struct __vbox__IMachine_USCOREsetOSTypeId*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetHardwareVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetHardwareVersion*)p = *(struct __vbox__IMachine_USCOREgetHardwareVersion*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetHardwareVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetHardwareVersion*)p = *(struct __vbox__IMachine_USCOREsetHardwareVersion*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHardwareUUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetHardwareUUID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetHardwareUUID*)p = *(struct __vbox__IMachine_USCOREgetHardwareUUID*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHardwareUUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetHardwareUUID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetHardwareUUID*)p = *(struct __vbox__IMachine_USCOREsetHardwareUUID*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUCount*)p = *(struct __vbox__IMachine_USCOREgetCPUCount*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUCount*)p = *(struct __vbox__IMachine_USCOREsetCPUCount*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUHotPlugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUHotPlugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUHotPlugEnabled*)p = *(struct __vbox__IMachine_USCOREgetCPUHotPlugEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUHotPlugEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUHotPlugEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUHotPlugEnabled*)p = *(struct __vbox__IMachine_USCOREsetCPUHotPlugEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUExecutionCap*)p = *(struct __vbox__IMachine_USCOREgetCPUExecutionCap*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUExecutionCap*)p = *(struct __vbox__IMachine_USCOREsetCPUExecutionCap*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUIDPortabilityLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUIDPortabilityLevel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUIDPortabilityLevel*)p = *(struct __vbox__IMachine_USCOREgetCPUIDPortabilityLevel*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUIDPortabilityLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUIDPortabilityLevel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUIDPortabilityLevel*)p = *(struct __vbox__IMachine_USCOREsetCPUIDPortabilityLevel*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMemorySize*)p = *(struct __vbox__IMachine_USCOREgetMemorySize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetMemorySize*)p = *(struct __vbox__IMachine_USCOREsetMemorySize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMemoryBalloonSize*)p = *(struct __vbox__IMachine_USCOREgetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetMemoryBalloonSize*)p = *(struct __vbox__IMachine_USCOREsetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetPageFusionEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetPageFusionEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetPageFusionEnabled*)p = *(struct __vbox__IMachine_USCOREgetPageFusionEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetPageFusionEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetPageFusionEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetPageFusionEnabled*)p = *(struct __vbox__IMachine_USCOREsetPageFusionEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGraphicsControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetGraphicsControllerType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetGraphicsControllerType*)p = *(struct __vbox__IMachine_USCOREgetGraphicsControllerType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGraphicsControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetGraphicsControllerType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetGraphicsControllerType*)p = *(struct __vbox__IMachine_USCOREsetGraphicsControllerType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRAMSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVRAMSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVRAMSize*)p = *(struct __vbox__IMachine_USCOREgetVRAMSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVRAMSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVRAMSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVRAMSize*)p = *(struct __vbox__IMachine_USCOREsetVRAMSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate3DEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAccelerate3DEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAccelerate3DEnabled*)p = *(struct __vbox__IMachine_USCOREgetAccelerate3DEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate3DEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAccelerate3DEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAccelerate3DEnabled*)p = *(struct __vbox__IMachine_USCOREsetAccelerate3DEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAccelerate2DVideoEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAccelerate2DVideoEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)p = *(struct __vbox__IMachine_USCOREgetAccelerate2DVideoEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAccelerate2DVideoEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAccelerate2DVideoEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)p = *(struct __vbox__IMachine_USCOREsetAccelerate2DVideoEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMonitorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMonitorCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMonitorCount*)p = *(struct __vbox__IMachine_USCOREgetMonitorCount*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetMonitorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetMonitorCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetMonitorCount*)p = *(struct __vbox__IMachine_USCOREsetMonitorCount*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureEnabled*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureEnabled*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureScreens:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureScreens type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureScreens*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureScreens*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureScreens:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureScreens type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureScreens*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureScreens*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureFile*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureFile*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureFile*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureFile*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureWidth*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureWidth*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureWidth*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureWidth*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureHeight*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureHeight*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureHeight*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureHeight*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureRate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureRate*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureRate*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureRate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureRate*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureRate*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureFPS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureFPS type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureFPS*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureFPS*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureFPS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureFPS type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureFPS*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureFPS*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureMaxTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureMaxTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureMaxTime*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureMaxTime*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureMaxTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureMaxTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureMaxTime*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureMaxTime*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureMaxFileSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureMaxFileSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureMaxFileSize*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureMaxFileSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureMaxFileSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureMaxFileSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureMaxFileSize*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureMaxFileSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVideoCaptureOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVideoCaptureOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVideoCaptureOptions*)p = *(struct __vbox__IMachine_USCOREgetVideoCaptureOptions*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVideoCaptureOptions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVideoCaptureOptions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVideoCaptureOptions*)p = *(struct __vbox__IMachine_USCOREsetVideoCaptureOptions*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetBIOSSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetBIOSSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetBIOSSettings*)p = *(struct __vbox__IMachine_USCOREgetBIOSSettings*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFirmwareType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFirmwareType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFirmwareType*)p = *(struct __vbox__IMachine_USCOREgetFirmwareType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFirmwareType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFirmwareType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFirmwareType*)p = *(struct __vbox__IMachine_USCOREsetFirmwareType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetPointingHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetPointingHIDType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetPointingHIDType*)p = *(struct __vbox__IMachine_USCOREgetPointingHIDType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetPointingHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetPointingHIDType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetPointingHIDType*)p = *(struct __vbox__IMachine_USCOREsetPointingHIDType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetKeyboardHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetKeyboardHIDType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetKeyboardHIDType*)p = *(struct __vbox__IMachine_USCOREgetKeyboardHIDType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetKeyboardHIDType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetKeyboardHIDType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetKeyboardHIDType*)p = *(struct __vbox__IMachine_USCOREsetKeyboardHIDType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHPETEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetHPETEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetHPETEnabled*)p = *(struct __vbox__IMachine_USCOREgetHPETEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHPETEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetHPETEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetHPETEnabled*)p = *(struct __vbox__IMachine_USCOREsetHPETEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetChipsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetChipsetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetChipsetType*)p = *(struct __vbox__IMachine_USCOREgetChipsetType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetChipsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetChipsetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetChipsetType*)p = *(struct __vbox__IMachine_USCOREsetChipsetType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSnapshotFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSnapshotFolder*)p = *(struct __vbox__IMachine_USCOREgetSnapshotFolder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetSnapshotFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetSnapshotFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetSnapshotFolder*)p = *(struct __vbox__IMachine_USCOREsetSnapshotFolder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVRDEServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVRDEServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVRDEServer*)p = *(struct __vbox__IMachine_USCOREgetVRDEServer*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled*)p = *(struct __vbox__IMachine_USCOREgetEmulatedUSBCardReaderEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled*)p = *(struct __vbox__IMachine_USCOREsetEmulatedUSBCardReaderEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMediumAttachments type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMediumAttachments*)p = *(struct __vbox__IMachine_USCOREgetMediumAttachments*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBControllers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetUSBControllers type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetUSBControllers*)p = *(struct __vbox__IMachine_USCOREgetUSBControllers*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetUSBDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetUSBDeviceFilters*)p = *(struct __vbox__IMachine_USCOREgetUSBDeviceFilters*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAudioAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAudioAdapter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAudioAdapter*)p = *(struct __vbox__IMachine_USCOREgetAudioAdapter*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetStorageControllers type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetStorageControllers*)p = *(struct __vbox__IMachine_USCOREgetStorageControllers*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSettingsFilePath*)p = *(struct __vbox__IMachine_USCOREgetSettingsFilePath*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsAuxFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSettingsAuxFilePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSettingsAuxFilePath*)p = *(struct __vbox__IMachine_USCOREgetSettingsAuxFilePath*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSettingsModified:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSettingsModified type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSettingsModified*)p = *(struct __vbox__IMachine_USCOREgetSettingsModified*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSessionState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSessionState*)p = *(struct __vbox__IMachine_USCOREgetSessionState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSessionName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSessionName*)p = *(struct __vbox__IMachine_USCOREgetSessionName*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSessionPID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSessionPID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSessionPID*)p = *(struct __vbox__IMachine_USCOREgetSessionPID*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetState*)p = *(struct __vbox__IMachine_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetLastStateChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetLastStateChange type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetLastStateChange*)p = *(struct __vbox__IMachine_USCOREgetLastStateChange*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStateFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetStateFilePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetStateFilePath*)p = *(struct __vbox__IMachine_USCOREgetStateFilePath*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetLogFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetLogFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetLogFolder*)p = *(struct __vbox__IMachine_USCOREgetLogFolder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCurrentSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCurrentSnapshot*)p = *(struct __vbox__IMachine_USCOREgetCurrentSnapshot*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSnapshotCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSnapshotCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSnapshotCount*)p = *(struct __vbox__IMachine_USCOREgetSnapshotCount*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCurrentStateModified:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCurrentStateModified type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCurrentStateModified*)p = *(struct __vbox__IMachine_USCOREgetCurrentStateModified*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSharedFolders*)p = *(struct __vbox__IMachine_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetClipboardMode*)p = *(struct __vbox__IMachine_USCOREgetClipboardMode*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetClipboardMode*)p = *(struct __vbox__IMachine_USCOREsetClipboardMode*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetDnDMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetDnDMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetDnDMode*)p = *(struct __vbox__IMachine_USCOREgetDnDMode*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetDnDMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetDnDMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetDnDMode*)p = *(struct __vbox__IMachine_USCOREsetDnDMode*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTeleporterEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTeleporterEnabled*)p = *(struct __vbox__IMachine_USCOREgetTeleporterEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTeleporterEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTeleporterEnabled*)p = *(struct __vbox__IMachine_USCOREsetTeleporterEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTeleporterPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTeleporterPort*)p = *(struct __vbox__IMachine_USCOREgetTeleporterPort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTeleporterPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTeleporterPort*)p = *(struct __vbox__IMachine_USCOREsetTeleporterPort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTeleporterAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTeleporterAddress*)p = *(struct __vbox__IMachine_USCOREgetTeleporterAddress*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTeleporterAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTeleporterAddress*)p = *(struct __vbox__IMachine_USCOREsetTeleporterAddress*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTeleporterPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTeleporterPassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTeleporterPassword*)p = *(struct __vbox__IMachine_USCOREgetTeleporterPassword*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTeleporterPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTeleporterPassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTeleporterPassword*)p = *(struct __vbox__IMachine_USCOREsetTeleporterPassword*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetParavirtProvider*)p = *(struct __vbox__IMachine_USCOREgetParavirtProvider*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetParavirtProvider*)p = *(struct __vbox__IMachine_USCOREsetParavirtProvider*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFaultToleranceState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFaultToleranceState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFaultToleranceState*)p = *(struct __vbox__IMachine_USCOREgetFaultToleranceState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFaultToleranceState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFaultToleranceState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFaultToleranceState*)p = *(struct __vbox__IMachine_USCOREsetFaultToleranceState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFaultTolerancePort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFaultTolerancePort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFaultTolerancePort*)p = *(struct __vbox__IMachine_USCOREgetFaultTolerancePort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFaultTolerancePort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFaultTolerancePort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFaultTolerancePort*)p = *(struct __vbox__IMachine_USCOREsetFaultTolerancePort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFaultToleranceAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFaultToleranceAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFaultToleranceAddress*)p = *(struct __vbox__IMachine_USCOREgetFaultToleranceAddress*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFaultToleranceAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFaultToleranceAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFaultToleranceAddress*)p = *(struct __vbox__IMachine_USCOREsetFaultToleranceAddress*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFaultTolerancePassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFaultTolerancePassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFaultTolerancePassword*)p = *(struct __vbox__IMachine_USCOREgetFaultTolerancePassword*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFaultTolerancePassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFaultTolerancePassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFaultTolerancePassword*)p = *(struct __vbox__IMachine_USCOREsetFaultTolerancePassword*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetFaultToleranceSyncInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetFaultToleranceSyncInterval type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetFaultToleranceSyncInterval*)p = *(struct __vbox__IMachine_USCOREgetFaultToleranceSyncInterval*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetFaultToleranceSyncInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetFaultToleranceSyncInterval type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetFaultToleranceSyncInterval*)p = *(struct __vbox__IMachine_USCOREsetFaultToleranceSyncInterval*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetRTCUseUTC:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetRTCUseUTC type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetRTCUseUTC*)p = *(struct __vbox__IMachine_USCOREgetRTCUseUTC*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetRTCUseUTC:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetRTCUseUTC type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetRTCUseUTC*)p = *(struct __vbox__IMachine_USCOREsetRTCUseUTC*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetIOCacheEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetIOCacheEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetIOCacheEnabled*)p = *(struct __vbox__IMachine_USCOREgetIOCacheEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetIOCacheEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetIOCacheEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetIOCacheEnabled*)p = *(struct __vbox__IMachine_USCOREsetIOCacheEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetIOCacheSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetIOCacheSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetIOCacheSize*)p = *(struct __vbox__IMachine_USCOREgetIOCacheSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetIOCacheSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetIOCacheSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetIOCacheSize*)p = *(struct __vbox__IMachine_USCOREsetIOCacheSize*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetPCIDeviceAssignments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetPCIDeviceAssignments type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetPCIDeviceAssignments*)p = *(struct __vbox__IMachine_USCOREgetPCIDeviceAssignments*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetBandwidthControl:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetBandwidthControl type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetBandwidthControl*)p = *(struct __vbox__IMachine_USCOREgetBandwidthControl*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTracingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTracingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTracingEnabled*)p = *(struct __vbox__IMachine_USCOREgetTracingEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTracingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTracingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTracingEnabled*)p = *(struct __vbox__IMachine_USCOREsetTracingEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetTracingConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetTracingConfig type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetTracingConfig*)p = *(struct __vbox__IMachine_USCOREgetTracingConfig*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetTracingConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetTracingConfig type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetTracingConfig*)p = *(struct __vbox__IMachine_USCOREsetTracingConfig*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAllowTracingToAccessVM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAllowTracingToAccessVM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAllowTracingToAccessVM*)p = *(struct __vbox__IMachine_USCOREgetAllowTracingToAccessVM*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAllowTracingToAccessVM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAllowTracingToAccessVM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAllowTracingToAccessVM*)p = *(struct __vbox__IMachine_USCOREsetAllowTracingToAccessVM*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAutostartEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAutostartEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAutostartEnabled*)p = *(struct __vbox__IMachine_USCOREgetAutostartEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAutostartEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAutostartEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAutostartEnabled*)p = *(struct __vbox__IMachine_USCOREsetAutostartEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAutostartDelay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAutostartDelay type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAutostartDelay*)p = *(struct __vbox__IMachine_USCOREgetAutostartDelay*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAutostartDelay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAutostartDelay type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAutostartDelay*)p = *(struct __vbox__IMachine_USCOREsetAutostartDelay*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetAutostopType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetAutostopType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetAutostopType*)p = *(struct __vbox__IMachine_USCOREgetAutostopType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAutostopType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAutostopType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAutostopType*)p = *(struct __vbox__IMachine_USCOREsetAutostopType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetDefaultFrontend*)p = *(struct __vbox__IMachine_USCOREgetDefaultFrontend*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetDefaultFrontend*)p = *(struct __vbox__IMachine_USCOREsetDefaultFrontend*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBProxyAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetUSBProxyAvailable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetUSBProxyAvailable*)p = *(struct __vbox__IMachine_USCOREgetUSBProxyAvailable*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetVMProcessPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetVMProcessPriority type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetVMProcessPriority*)p = *(struct __vbox__IMachine_USCOREgetVMProcessPriority*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetVMProcessPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetVMProcessPriority type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetVMProcessPriority*)p = *(struct __vbox__IMachine_USCOREsetVMProcessPriority*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParavirtDebug:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetParavirtDebug type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetParavirtDebug*)p = *(struct __vbox__IMachine_USCOREgetParavirtDebug*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetParavirtDebug:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetParavirtDebug type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetParavirtDebug*)p = *(struct __vbox__IMachine_USCOREsetParavirtDebug*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUProfile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUProfile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUProfile*)p = *(struct __vbox__IMachine_USCOREgetCPUProfile*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUProfile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUProfile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUProfile*)p = *(struct __vbox__IMachine_USCOREsetCPUProfile*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCORElockMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCORElockMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCORElockMachine*)p = *(struct __vbox__IMachine_USCORElockMachine*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCORElaunchVMProcess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCORElaunchVMProcess type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCORElaunchVMProcess*)p = *(struct __vbox__IMachine_USCORElaunchVMProcess*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetBootOrder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetBootOrder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetBootOrder*)p = *(struct __vbox__IMachine_USCOREsetBootOrder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetBootOrder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetBootOrder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetBootOrder*)p = *(struct __vbox__IMachine_USCOREgetBootOrder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREattachDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREattachDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREattachDevice*)p = *(struct __vbox__IMachine_USCOREattachDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREattachDeviceWithoutMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREattachDeviceWithoutMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREattachDeviceWithoutMedium*)p = *(struct __vbox__IMachine_USCOREattachDeviceWithoutMedium*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdetachDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdetachDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdetachDevice*)p = *(struct __vbox__IMachine_USCOREdetachDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREpassthroughDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREpassthroughDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREpassthroughDevice*)p = *(struct __vbox__IMachine_USCOREpassthroughDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREtemporaryEjectDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREtemporaryEjectDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREtemporaryEjectDevice*)p = *(struct __vbox__IMachine_USCOREtemporaryEjectDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREnonRotationalDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREnonRotationalDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREnonRotationalDevice*)p = *(struct __vbox__IMachine_USCOREnonRotationalDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetAutoDiscardForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetAutoDiscardForDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetAutoDiscardForDevice*)p = *(struct __vbox__IMachine_USCOREsetAutoDiscardForDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHotPluggableForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetHotPluggableForDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetHotPluggableForDevice*)p = *(struct __vbox__IMachine_USCOREsetHotPluggableForDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetBandwidthGroupForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetBandwidthGroupForDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetBandwidthGroupForDevice*)p = *(struct __vbox__IMachine_USCOREsetBandwidthGroupForDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetNoBandwidthGroupForDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetNoBandwidthGroupForDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetNoBandwidthGroupForDevice*)p = *(struct __vbox__IMachine_USCOREsetNoBandwidthGroupForDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREunmountMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREunmountMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREunmountMedium*)p = *(struct __vbox__IMachine_USCOREunmountMedium*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREmountMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREmountMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREmountMedium*)p = *(struct __vbox__IMachine_USCOREmountMedium*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMedium*)p = *(struct __vbox__IMachine_USCOREgetMedium*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachmentsOfController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMediumAttachmentsOfController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMediumAttachmentsOfController*)p = *(struct __vbox__IMachine_USCOREgetMediumAttachmentsOfController*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetMediumAttachment type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetMediumAttachment*)p = *(struct __vbox__IMachine_USCOREgetMediumAttachment*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREattachHostPCIDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREattachHostPCIDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREattachHostPCIDevice*)p = *(struct __vbox__IMachine_USCOREattachHostPCIDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdetachHostPCIDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdetachHostPCIDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdetachHostPCIDevice*)p = *(struct __vbox__IMachine_USCOREdetachHostPCIDevice*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetNetworkAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetNetworkAdapter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetNetworkAdapter*)p = *(struct __vbox__IMachine_USCOREgetNetworkAdapter*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREaddStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREaddStorageController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREaddStorageController*)p = *(struct __vbox__IMachine_USCOREaddStorageController*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetStorageControllerByName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetStorageControllerByName*)p = *(struct __vbox__IMachine_USCOREgetStorageControllerByName*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetStorageControllerByInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetStorageControllerByInstance type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetStorageControllerByInstance*)p = *(struct __vbox__IMachine_USCOREgetStorageControllerByInstance*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREremoveStorageController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREremoveStorageController*)p = *(struct __vbox__IMachine_USCOREremoveStorageController*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetStorageControllerBootable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetStorageControllerBootable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetStorageControllerBootable*)p = *(struct __vbox__IMachine_USCOREsetStorageControllerBootable*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREaddUSBController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREaddUSBController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREaddUSBController*)p = *(struct __vbox__IMachine_USCOREaddUSBController*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveUSBController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREremoveUSBController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREremoveUSBController*)p = *(struct __vbox__IMachine_USCOREremoveUSBController*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBControllerByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetUSBControllerByName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetUSBControllerByName*)p = *(struct __vbox__IMachine_USCOREgetUSBControllerByName*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetUSBControllerCountByType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetUSBControllerCountByType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetUSBControllerCountByType*)p = *(struct __vbox__IMachine_USCOREgetUSBControllerCountByType*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetSerialPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetSerialPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetSerialPort*)p = *(struct __vbox__IMachine_USCOREgetSerialPort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetParallelPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetParallelPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetParallelPort*)p = *(struct __vbox__IMachine_USCOREgetParallelPort*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraDataKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetExtraDataKeys type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetExtraDataKeys*)p = *(struct __vbox__IMachine_USCOREgetExtraDataKeys*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetExtraData*)p = *(struct __vbox__IMachine_USCOREgetExtraData*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetExtraData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetExtraData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetExtraData*)p = *(struct __vbox__IMachine_USCOREsetExtraData*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUProperty*)p = *(struct __vbox__IMachine_USCOREgetCPUProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUProperty*)p = *(struct __vbox__IMachine_USCOREsetCPUProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUIDLeaf*)p = *(struct __vbox__IMachine_USCOREgetCPUIDLeaf*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetCPUIDLeaf*)p = *(struct __vbox__IMachine_USCOREsetCPUIDLeaf*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREremoveCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREremoveCPUIDLeaf*)p = *(struct __vbox__IMachine_USCOREremoveCPUIDLeaf*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveAllCPUIDLeaves:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREremoveAllCPUIDLeaves type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREremoveAllCPUIDLeaves*)p = *(struct __vbox__IMachine_USCOREremoveAllCPUIDLeaves*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetHWVirtExProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetHWVirtExProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetHWVirtExProperty*)p = *(struct __vbox__IMachine_USCOREgetHWVirtExProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetHWVirtExProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetHWVirtExProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetHWVirtExProperty*)p = *(struct __vbox__IMachine_USCOREsetHWVirtExProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetSettingsFilePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetSettingsFilePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetSettingsFilePath*)p = *(struct __vbox__IMachine_USCOREsetSettingsFilePath*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsaveSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsaveSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsaveSettings*)p = *(struct __vbox__IMachine_USCOREsaveSettings*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdiscardSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdiscardSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdiscardSettings*)p = *(struct __vbox__IMachine_USCOREdiscardSettings*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREunregister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREunregister type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREunregister*)p = *(struct __vbox__IMachine_USCOREunregister*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdeleteConfig type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdeleteConfig*)p = *(struct __vbox__IMachine_USCOREdeleteConfig*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREexportTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREexportTo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREexportTo*)p = *(struct __vbox__IMachine_USCOREexportTo*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREfindSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREfindSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREfindSnapshot*)p = *(struct __vbox__IMachine_USCOREfindSnapshot*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREcreateSharedFolder*)p = *(struct __vbox__IMachine_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREremoveSharedFolder*)p = *(struct __vbox__IMachine_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREcanShowConsoleWindow:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREcanShowConsoleWindow type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREcanShowConsoleWindow*)p = *(struct __vbox__IMachine_USCOREcanShowConsoleWindow*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREshowConsoleWindow:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREshowConsoleWindow type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREshowConsoleWindow*)p = *(struct __vbox__IMachine_USCOREshowConsoleWindow*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetGuestProperty*)p = *(struct __vbox__IMachine_USCOREgetGuestProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetGuestPropertyValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetGuestPropertyValue*)p = *(struct __vbox__IMachine_USCOREgetGuestPropertyValue*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetGuestPropertyTimestamp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetGuestPropertyTimestamp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetGuestPropertyTimestamp*)p = *(struct __vbox__IMachine_USCOREgetGuestPropertyTimestamp*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetGuestProperty*)p = *(struct __vbox__IMachine_USCOREsetGuestProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsetGuestPropertyValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsetGuestPropertyValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsetGuestPropertyValue*)p = *(struct __vbox__IMachine_USCOREsetGuestPropertyValue*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteGuestProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdeleteGuestProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdeleteGuestProperty*)p = *(struct __vbox__IMachine_USCOREdeleteGuestProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREenumerateGuestProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREenumerateGuestProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREenumerateGuestProperties*)p = *(struct __vbox__IMachine_USCOREenumerateGuestProperties*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedGuestScreenInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREquerySavedGuestScreenInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREquerySavedGuestScreenInfo*)p = *(struct __vbox__IMachine_USCOREquerySavedGuestScreenInfo*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedThumbnailToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREreadSavedThumbnailToArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREreadSavedThumbnailToArray*)p = *(struct __vbox__IMachine_USCOREreadSavedThumbnailToArray*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREquerySavedScreenshotInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREquerySavedScreenshotInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREquerySavedScreenshotInfo*)p = *(struct __vbox__IMachine_USCOREquerySavedScreenshotInfo*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREreadSavedScreenshotToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREreadSavedScreenshotToArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREreadSavedScreenshotToArray*)p = *(struct __vbox__IMachine_USCOREreadSavedScreenshotToArray*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREhotPlugCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREhotPlugCPU type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREhotPlugCPU*)p = *(struct __vbox__IMachine_USCOREhotPlugCPU*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREhotUnplugCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREhotUnplugCPU type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREhotUnplugCPU*)p = *(struct __vbox__IMachine_USCOREhotUnplugCPU*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetCPUStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetCPUStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetCPUStatus*)p = *(struct __vbox__IMachine_USCOREgetCPUStatus*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREgetEffectiveParavirtProvider:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREgetEffectiveParavirtProvider type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREgetEffectiveParavirtProvider*)p = *(struct __vbox__IMachine_USCOREgetEffectiveParavirtProvider*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREqueryLogFilename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREqueryLogFilename type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREqueryLogFilename*)p = *(struct __vbox__IMachine_USCOREqueryLogFilename*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREreadLog:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREreadLog type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREreadLog*)p = *(struct __vbox__IMachine_USCOREreadLog*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREcloneTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREcloneTo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREcloneTo*)p = *(struct __vbox__IMachine_USCOREcloneTo*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREsaveState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREsaveState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREsaveState*)p = *(struct __vbox__IMachine_USCOREsaveState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREadoptSavedState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREadoptSavedState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREadoptSavedState*)p = *(struct __vbox__IMachine_USCOREadoptSavedState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdiscardSavedState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdiscardSavedState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdiscardSavedState*)p = *(struct __vbox__IMachine_USCOREdiscardSavedState*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREtakeSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREtakeSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREtakeSnapshot*)p = *(struct __vbox__IMachine_USCOREtakeSnapshot*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdeleteSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdeleteSnapshot*)p = *(struct __vbox__IMachine_USCOREdeleteSnapshot*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteSnapshotAndAllChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdeleteSnapshotAndAllChildren type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdeleteSnapshotAndAllChildren*)p = *(struct __vbox__IMachine_USCOREdeleteSnapshotAndAllChildren*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREdeleteSnapshotRange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREdeleteSnapshotRange type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREdeleteSnapshotRange*)p = *(struct __vbox__IMachine_USCOREdeleteSnapshotRange*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCORErestoreSnapshot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCORErestoreSnapshot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCORErestoreSnapshot*)p = *(struct __vbox__IMachine_USCORErestoreSnapshot*)q;
		break;
	case SOAP_TYPE___vbox__IMachine_USCOREapplyDefaults:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachine_USCOREapplyDefaults type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachine_USCOREapplyDefaults*)p = *(struct __vbox__IMachine_USCOREapplyDefaults*)q;
		break;
	case SOAP_TYPE___vbox__IEmulatedUSB_USCOREgetWebcams:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEmulatedUSB_USCOREgetWebcams type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEmulatedUSB_USCOREgetWebcams*)p = *(struct __vbox__IEmulatedUSB_USCOREgetWebcams*)q;
		break;
	case SOAP_TYPE___vbox__IEmulatedUSB_USCOREwebcamAttach:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEmulatedUSB_USCOREwebcamAttach type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEmulatedUSB_USCOREwebcamAttach*)p = *(struct __vbox__IEmulatedUSB_USCOREwebcamAttach*)q;
		break;
	case SOAP_TYPE___vbox__IEmulatedUSB_USCOREwebcamDetach:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEmulatedUSB_USCOREwebcamDetach type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEmulatedUSB_USCOREwebcamDetach*)p = *(struct __vbox__IEmulatedUSB_USCOREwebcamDetach*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetMachine*)p = *(struct __vbox__IConsole_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetState*)p = *(struct __vbox__IConsole_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetGuest type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetGuest*)p = *(struct __vbox__IConsole_USCOREgetGuest*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetKeyboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetKeyboard type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetKeyboard*)p = *(struct __vbox__IConsole_USCOREgetKeyboard*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetMouse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetMouse type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetMouse*)p = *(struct __vbox__IConsole_USCOREgetMouse*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetDisplay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetDisplay type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetDisplay*)p = *(struct __vbox__IConsole_USCOREgetDisplay*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetDebugger:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetDebugger type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetDebugger*)p = *(struct __vbox__IConsole_USCOREgetDebugger*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetUSBDevices*)p = *(struct __vbox__IConsole_USCOREgetUSBDevices*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetRemoteUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetRemoteUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetRemoteUSBDevices*)p = *(struct __vbox__IConsole_USCOREgetRemoteUSBDevices*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetSharedFolders:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetSharedFolders type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetSharedFolders*)p = *(struct __vbox__IConsole_USCOREgetSharedFolders*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetVRDEServerInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetVRDEServerInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetVRDEServerInfo*)p = *(struct __vbox__IConsole_USCOREgetVRDEServerInfo*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetEventSource*)p = *(struct __vbox__IConsole_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetAttachedPCIDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetAttachedPCIDevices type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetAttachedPCIDevices*)p = *(struct __vbox__IConsole_USCOREgetAttachedPCIDevices*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetUseHostClipboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetUseHostClipboard type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetUseHostClipboard*)p = *(struct __vbox__IConsole_USCOREgetUseHostClipboard*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREsetUseHostClipboard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREsetUseHostClipboard type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREsetUseHostClipboard*)p = *(struct __vbox__IConsole_USCOREsetUseHostClipboard*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetEmulatedUSB:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetEmulatedUSB type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetEmulatedUSB*)p = *(struct __vbox__IConsole_USCOREgetEmulatedUSB*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREpowerUp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREpowerUp*)p = *(struct __vbox__IConsole_USCOREpowerUp*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerUpPaused:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREpowerUpPaused type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREpowerUpPaused*)p = *(struct __vbox__IConsole_USCOREpowerUpPaused*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerDown:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREpowerDown type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREpowerDown*)p = *(struct __vbox__IConsole_USCOREpowerDown*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREreset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREreset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREreset*)p = *(struct __vbox__IConsole_USCOREreset*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpause:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREpause type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREpause*)p = *(struct __vbox__IConsole_USCOREpause*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREresume:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREresume type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREresume*)p = *(struct __vbox__IConsole_USCOREresume*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREpowerButton:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREpowerButton type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREpowerButton*)p = *(struct __vbox__IConsole_USCOREpowerButton*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREsleepButton:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREsleepButton type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREsleepButton*)p = *(struct __vbox__IConsole_USCOREsleepButton*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetPowerButtonHandled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetPowerButtonHandled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetPowerButtonHandled*)p = *(struct __vbox__IConsole_USCOREgetPowerButtonHandled*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetGuestEnteredACPIMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetGuestEnteredACPIMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetGuestEnteredACPIMode*)p = *(struct __vbox__IConsole_USCOREgetGuestEnteredACPIMode*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREgetDeviceActivity:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREgetDeviceActivity type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREgetDeviceActivity*)p = *(struct __vbox__IConsole_USCOREgetDeviceActivity*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREattachUSBDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREattachUSBDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREattachUSBDevice*)p = *(struct __vbox__IConsole_USCOREattachUSBDevice*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREdetachUSBDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREdetachUSBDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREdetachUSBDevice*)p = *(struct __vbox__IConsole_USCOREdetachUSBDevice*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceByAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREfindUSBDeviceByAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREfindUSBDeviceByAddress*)p = *(struct __vbox__IConsole_USCOREfindUSBDeviceByAddress*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREfindUSBDeviceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREfindUSBDeviceById type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREfindUSBDeviceById*)p = *(struct __vbox__IConsole_USCOREfindUSBDeviceById*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREcreateSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREcreateSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREcreateSharedFolder*)p = *(struct __vbox__IConsole_USCOREcreateSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREremoveSharedFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREremoveSharedFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREremoveSharedFolder*)p = *(struct __vbox__IConsole_USCOREremoveSharedFolder*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREteleport:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREteleport type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREteleport*)p = *(struct __vbox__IConsole_USCOREteleport*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREaddDiskEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREaddDiskEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREaddDiskEncryptionPassword*)p = *(struct __vbox__IConsole_USCOREaddDiskEncryptionPassword*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREaddDiskEncryptionPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREaddDiskEncryptionPasswords type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREaddDiskEncryptionPasswords*)p = *(struct __vbox__IConsole_USCOREaddDiskEncryptionPasswords*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREremoveDiskEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREremoveDiskEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREremoveDiskEncryptionPassword*)p = *(struct __vbox__IConsole_USCOREremoveDiskEncryptionPassword*)q;
		break;
	case SOAP_TYPE___vbox__IConsole_USCOREclearAllDiskEncryptionPasswords:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IConsole_USCOREclearAllDiskEncryptionPasswords type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IConsole_USCOREclearAllDiskEncryptionPasswords*)p = *(struct __vbox__IConsole_USCOREclearAllDiskEncryptionPasswords*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetName*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetShortName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetShortName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetShortName*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetShortName*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetId*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetNetworkName*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetDHCPEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetDHCPEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetDHCPEnabled*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetDHCPEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetIPAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetIPAddress*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetIPAddress*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetNetworkMask:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetNetworkMask type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetNetworkMask*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetNetworkMask*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Supported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetIPV6Supported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetIPV6Supported*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6Address:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetIPV6Address type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetIPV6Address*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetIPV6Address*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetIPV6NetworkMaskPrefixLength*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetHardwareAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetHardwareAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetHardwareAddress*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetMediumType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetMediumType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetMediumType*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetMediumType*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetStatus*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREgetInterfaceType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREgetInterfaceType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREgetInterfaceType*)p = *(struct __vbox__IHostNetworkInterface_USCOREgetInterfaceType*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIPConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfig type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfig*)p = *(struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfig*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6*)p = *(struct __vbox__IHostNetworkInterface_USCOREenableStaticIPConfigV6*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig*)p = *(struct __vbox__IHostNetworkInterface_USCOREenableDynamicIPConfig*)q;
		break;
	case SOAP_TYPE___vbox__IHostNetworkInterface_USCOREDHCPRediscover:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNetworkInterface_USCOREDHCPRediscover type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNetworkInterface_USCOREDHCPRediscover*)p = *(struct __vbox__IHostNetworkInterface_USCOREDHCPRediscover*)q;
		break;
	case SOAP_TYPE___vbox__IHostVideoInputDevice_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostVideoInputDevice_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostVideoInputDevice_USCOREgetName*)p = *(struct __vbox__IHostVideoInputDevice_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IHostVideoInputDevice_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostVideoInputDevice_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostVideoInputDevice_USCOREgetPath*)p = *(struct __vbox__IHostVideoInputDevice_USCOREgetPath*)q;
		break;
	case SOAP_TYPE___vbox__IHostVideoInputDevice_USCOREgetAlias:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostVideoInputDevice_USCOREgetAlias type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostVideoInputDevice_USCOREgetAlias*)p = *(struct __vbox__IHostVideoInputDevice_USCOREgetAlias*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetDVDDrives:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetDVDDrives type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetDVDDrives*)p = *(struct __vbox__IHost_USCOREgetDVDDrives*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetFloppyDrives:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetFloppyDrives type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetFloppyDrives*)p = *(struct __vbox__IHost_USCOREgetFloppyDrives*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetUSBDevices type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetUSBDevices*)p = *(struct __vbox__IHost_USCOREgetUSBDevices*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUSBDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetUSBDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetUSBDeviceFilters*)p = *(struct __vbox__IHost_USCOREgetUSBDeviceFilters*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetNetworkInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetNetworkInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetNetworkInterfaces*)p = *(struct __vbox__IHost_USCOREgetNetworkInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetNameServers:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetNameServers type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetNameServers*)p = *(struct __vbox__IHost_USCOREgetNameServers*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetDomainName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetDomainName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetDomainName*)p = *(struct __vbox__IHost_USCOREgetDomainName*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetSearchStrings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetSearchStrings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetSearchStrings*)p = *(struct __vbox__IHost_USCOREgetSearchStrings*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorCount*)p = *(struct __vbox__IHost_USCOREgetProcessorCount*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorOnlineCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorOnlineCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorOnlineCount*)p = *(struct __vbox__IHost_USCOREgetProcessorOnlineCount*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCoreCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorCoreCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorCoreCount*)p = *(struct __vbox__IHost_USCOREgetProcessorCoreCount*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorOnlineCoreCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorOnlineCoreCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorOnlineCoreCount*)p = *(struct __vbox__IHost_USCOREgetProcessorOnlineCoreCount*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetMemorySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetMemorySize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetMemorySize*)p = *(struct __vbox__IHost_USCOREgetMemorySize*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetMemoryAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetMemoryAvailable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetMemoryAvailable*)p = *(struct __vbox__IHost_USCOREgetMemoryAvailable*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetOperatingSystem:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetOperatingSystem type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetOperatingSystem*)p = *(struct __vbox__IHost_USCOREgetOperatingSystem*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetOSVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetOSVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetOSVersion*)p = *(struct __vbox__IHost_USCOREgetOSVersion*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetUTCTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetUTCTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetUTCTime*)p = *(struct __vbox__IHost_USCOREgetUTCTime*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetAcceleration3DAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetAcceleration3DAvailable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetAcceleration3DAvailable*)p = *(struct __vbox__IHost_USCOREgetAcceleration3DAvailable*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetVideoInputDevices:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetVideoInputDevices type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetVideoInputDevices*)p = *(struct __vbox__IHost_USCOREgetVideoInputDevices*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorSpeed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorSpeed*)p = *(struct __vbox__IHost_USCOREgetProcessorSpeed*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorFeature:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorFeature type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorFeature*)p = *(struct __vbox__IHost_USCOREgetProcessorFeature*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorDescription*)p = *(struct __vbox__IHost_USCOREgetProcessorDescription*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgetProcessorCPUIDLeaf:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgetProcessorCPUIDLeaf type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgetProcessorCPUIDLeaf*)p = *(struct __vbox__IHost_USCOREgetProcessorCPUIDLeaf*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREcreateHostOnlyNetworkInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREcreateHostOnlyNetworkInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)p = *(struct __vbox__IHost_USCOREcreateHostOnlyNetworkInterface*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREremoveHostOnlyNetworkInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREremoveHostOnlyNetworkInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)p = *(struct __vbox__IHost_USCOREremoveHostOnlyNetworkInterface*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREcreateUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREcreateUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREcreateUSBDeviceFilter*)p = *(struct __vbox__IHost_USCOREcreateUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREinsertUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREinsertUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREinsertUSBDeviceFilter*)p = *(struct __vbox__IHost_USCOREinsertUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREremoveUSBDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREremoveUSBDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREremoveUSBDeviceFilter*)p = *(struct __vbox__IHost_USCOREremoveUSBDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostDVDDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindHostDVDDrive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindHostDVDDrive*)p = *(struct __vbox__IHost_USCOREfindHostDVDDrive*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostFloppyDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindHostFloppyDrive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindHostFloppyDrive*)p = *(struct __vbox__IHost_USCOREfindHostFloppyDrive*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceByName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindHostNetworkInterfaceByName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindHostNetworkInterfaceByName*)p = *(struct __vbox__IHost_USCOREfindHostNetworkInterfaceByName*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfaceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindHostNetworkInterfaceById type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindHostNetworkInterfaceById*)p = *(struct __vbox__IHost_USCOREfindHostNetworkInterfaceById*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindHostNetworkInterfacesOfType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindHostNetworkInterfacesOfType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)p = *(struct __vbox__IHost_USCOREfindHostNetworkInterfacesOfType*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceById:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindUSBDeviceById type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindUSBDeviceById*)p = *(struct __vbox__IHost_USCOREfindUSBDeviceById*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREfindUSBDeviceByAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREfindUSBDeviceByAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREfindUSBDeviceByAddress*)p = *(struct __vbox__IHost_USCOREfindUSBDeviceByAddress*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREgenerateMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREgenerateMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREgenerateMACAddress*)p = *(struct __vbox__IHost_USCOREgenerateMACAddress*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREaddUSBDeviceSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREaddUSBDeviceSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREaddUSBDeviceSource*)p = *(struct __vbox__IHost_USCOREaddUSBDeviceSource*)q;
		break;
	case SOAP_TYPE___vbox__IHost_USCOREremoveUSBDeviceSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHost_USCOREremoveUSBDeviceSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHost_USCOREremoveUSBDeviceSource*)p = *(struct __vbox__IHost_USCOREremoveUSBDeviceSource*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMinGuestRAM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMinGuestRAM*)p = *(struct __vbox__ISystemProperties_USCOREgetMinGuestRAM*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxGuestRAM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxGuestRAM*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxGuestRAM*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestVRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMinGuestVRAM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMinGuestVRAM*)p = *(struct __vbox__ISystemProperties_USCOREgetMinGuestVRAM*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestVRAM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxGuestVRAM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxGuestVRAM*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinGuestCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMinGuestCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)p = *(struct __vbox__ISystemProperties_USCOREgetMinGuestCPUCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestCPUCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxGuestCPUCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxGuestCPUCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxGuestMonitors:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxGuestMonitors type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxGuestMonitors*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxGuestMonitors*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetInfoVDSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetInfoVDSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetInfoVDSize*)p = *(struct __vbox__ISystemProperties_USCOREgetInfoVDSize*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetSerialPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetSerialPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetSerialPortCount*)p = *(struct __vbox__ISystemProperties_USCOREgetSerialPortCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetParallelPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetParallelPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetParallelPortCount*)p = *(struct __vbox__ISystemProperties_USCOREgetParallelPortCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxBootPosition:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxBootPosition type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxBootPosition*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxBootPosition*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetRawModeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetRawModeSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetRawModeSupported*)p = *(struct __vbox__ISystemProperties_USCOREgetRawModeSupported*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetExclusiveHwVirt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetExclusiveHwVirt type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetExclusiveHwVirt*)p = *(struct __vbox__ISystemProperties_USCOREgetExclusiveHwVirt*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetExclusiveHwVirt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetExclusiveHwVirt type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetExclusiveHwVirt*)p = *(struct __vbox__ISystemProperties_USCOREsetExclusiveHwVirt*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultMachineFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultMachineFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultMachineFolder*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultMachineFolder:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetDefaultMachineFolder type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)p = *(struct __vbox__ISystemProperties_USCOREsetDefaultMachineFolder*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetLoggingLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetLoggingLevel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetLoggingLevel*)p = *(struct __vbox__ISystemProperties_USCOREgetLoggingLevel*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetLoggingLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetLoggingLevel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetLoggingLevel*)p = *(struct __vbox__ISystemProperties_USCOREsetLoggingLevel*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMediumFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMediumFormats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMediumFormats*)p = *(struct __vbox__ISystemProperties_USCOREgetMediumFormats*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultHardDiskFormat*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)p = *(struct __vbox__ISystemProperties_USCOREsetDefaultHardDiskFormat*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning*)p = *(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceWarning*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning*)p = *(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceWarning*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning*)p = *(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentWarning*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning*)p = *(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentWarning*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetFreeDiskSpaceError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceError*)p = *(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpaceError*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetFreeDiskSpaceError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceError*)p = *(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpaceError*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError*)p = *(struct __vbox__ISystemProperties_USCOREgetFreeDiskSpacePercentError*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError*)p = *(struct __vbox__ISystemProperties_USCOREsetFreeDiskSpacePercentError*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetVRDEAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetVRDEAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetVRDEAuthLibrary*)p = *(struct __vbox__ISystemProperties_USCOREgetVRDEAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetVRDEAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetVRDEAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetVRDEAuthLibrary*)p = *(struct __vbox__ISystemProperties_USCOREsetVRDEAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)p = *(struct __vbox__ISystemProperties_USCOREgetWebServiceAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)p = *(struct __vbox__ISystemProperties_USCOREsetWebServiceAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultVRDEExtPack*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack*)p = *(struct __vbox__ISystemProperties_USCOREsetDefaultVRDEExtPack*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetLogHistoryCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetLogHistoryCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetLogHistoryCount*)p = *(struct __vbox__ISystemProperties_USCOREgetLogHistoryCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetLogHistoryCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetLogHistoryCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetLogHistoryCount*)p = *(struct __vbox__ISystemProperties_USCOREsetLogHistoryCount*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultAudioDriver*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetAutostartDatabasePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetAutostartDatabasePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetAutostartDatabasePath*)p = *(struct __vbox__ISystemProperties_USCOREgetAutostartDatabasePath*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetAutostartDatabasePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetAutostartDatabasePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetAutostartDatabasePath*)p = *(struct __vbox__ISystemProperties_USCOREsetAutostartDatabasePath*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultAdditionsISO:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultAdditionsISO type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultAdditionsISO*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultAdditionsISO*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultAdditionsISO:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetDefaultAdditionsISO type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetDefaultAdditionsISO*)p = *(struct __vbox__ISystemProperties_USCOREsetDefaultAdditionsISO*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultFrontend*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultFrontend*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREsetDefaultFrontend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREsetDefaultFrontend type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREsetDefaultFrontend*)p = *(struct __vbox__ISystemProperties_USCOREsetDefaultFrontend*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetScreenShotFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetScreenShotFormats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetScreenShotFormats*)p = *(struct __vbox__ISystemProperties_USCOREgetScreenShotFormats*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxNetworkAdapters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdapters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdapters*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdapters*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxNetworkAdaptersOfType*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxDevicesPerPortForStorageBus*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)p = *(struct __vbox__ISystemProperties_USCOREgetMinPortCountForStorageBus*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxPortCountForStorageBus*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfStorageBus*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)p = *(struct __vbox__ISystemProperties_USCOREgetDeviceTypesForStorageBus*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController*)p = *(struct __vbox__ISystemProperties_USCOREgetDefaultIoCacheSettingForStorageController*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable*)p = *(struct __vbox__ISystemProperties_USCOREgetStorageControllerHotplugCapable*)q;
		break;
	case SOAP_TYPE___vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType*)p = *(struct __vbox__ISystemProperties_USCOREgetMaxInstancesOfUSBControllerType*)q;
		break;
	case SOAP_TYPE___vbox__IDnDBase_USCOREgetFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDBase_USCOREgetFormats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDBase_USCOREgetFormats*)p = *(struct __vbox__IDnDBase_USCOREgetFormats*)q;
		break;
	case SOAP_TYPE___vbox__IDnDBase_USCOREgetProtocolVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDBase_USCOREgetProtocolVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDBase_USCOREgetProtocolVersion*)p = *(struct __vbox__IDnDBase_USCOREgetProtocolVersion*)q;
		break;
	case SOAP_TYPE___vbox__IDnDBase_USCOREisFormatSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDBase_USCOREisFormatSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDBase_USCOREisFormatSupported*)p = *(struct __vbox__IDnDBase_USCOREisFormatSupported*)q;
		break;
	case SOAP_TYPE___vbox__IDnDBase_USCOREaddFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDBase_USCOREaddFormats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDBase_USCOREaddFormats*)p = *(struct __vbox__IDnDBase_USCOREaddFormats*)q;
		break;
	case SOAP_TYPE___vbox__IDnDBase_USCOREremoveFormats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDBase_USCOREremoveFormats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDBase_USCOREremoveFormats*)p = *(struct __vbox__IDnDBase_USCOREremoveFormats*)q;
		break;
	case SOAP_TYPE___vbox__IDnDSource_USCOREdragIsPending:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDSource_USCOREdragIsPending type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDSource_USCOREdragIsPending*)p = *(struct __vbox__IDnDSource_USCOREdragIsPending*)q;
		break;
	case SOAP_TYPE___vbox__IDnDSource_USCOREdrop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDSource_USCOREdrop type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDSource_USCOREdrop*)p = *(struct __vbox__IDnDSource_USCOREdrop*)q;
		break;
	case SOAP_TYPE___vbox__IDnDSource_USCOREreceiveData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDSource_USCOREreceiveData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDSource_USCOREreceiveData*)p = *(struct __vbox__IDnDSource_USCOREreceiveData*)q;
		break;
	case SOAP_TYPE___vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestDnDSource_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREenter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREenter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREenter*)p = *(struct __vbox__IDnDTarget_USCOREenter*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREmove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREmove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREmove*)p = *(struct __vbox__IDnDTarget_USCOREmove*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREleave:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREleave type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREleave*)p = *(struct __vbox__IDnDTarget_USCOREleave*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREdrop:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREdrop type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREdrop*)p = *(struct __vbox__IDnDTarget_USCOREdrop*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREsendData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREsendData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREsendData*)p = *(struct __vbox__IDnDTarget_USCOREsendData*)q;
		break;
	case SOAP_TYPE___vbox__IDnDTarget_USCOREcancel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDTarget_USCOREcancel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDTarget_USCOREcancel*)p = *(struct __vbox__IDnDTarget_USCOREcancel*)q;
		break;
	case SOAP_TYPE___vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestDnDTarget_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetUser type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetUser*)p = *(struct __vbox__IGuestSession_USCOREgetUser*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetDomain type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetDomain*)p = *(struct __vbox__IGuestSession_USCOREgetDomain*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetName*)p = *(struct __vbox__IGuestSession_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetId*)p = *(struct __vbox__IGuestSession_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetTimeout*)p = *(struct __vbox__IGuestSession_USCOREgetTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsetTimeout*)p = *(struct __vbox__IGuestSession_USCOREsetTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetProtocolVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetProtocolVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetProtocolVersion*)p = *(struct __vbox__IGuestSession_USCOREgetProtocolVersion*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetStatus*)p = *(struct __vbox__IGuestSession_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetEnvironmentChanges:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetEnvironmentChanges type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetEnvironmentChanges*)p = *(struct __vbox__IGuestSession_USCOREgetEnvironmentChanges*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsetEnvironmentChanges:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsetEnvironmentChanges type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsetEnvironmentChanges*)p = *(struct __vbox__IGuestSession_USCOREsetEnvironmentChanges*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetEnvironmentBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetEnvironmentBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetEnvironmentBase*)p = *(struct __vbox__IGuestSession_USCOREgetEnvironmentBase*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetProcesses:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetProcesses type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetProcesses*)p = *(struct __vbox__IGuestSession_USCOREgetProcesses*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetPathStyle:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetPathStyle type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetPathStyle*)p = *(struct __vbox__IGuestSession_USCOREgetPathStyle*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetCurrentDirectory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetCurrentDirectory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetCurrentDirectory*)p = *(struct __vbox__IGuestSession_USCOREgetCurrentDirectory*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsetCurrentDirectory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsetCurrentDirectory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsetCurrentDirectory*)p = *(struct __vbox__IGuestSession_USCOREsetCurrentDirectory*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetDirectories:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetDirectories type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetDirectories*)p = *(struct __vbox__IGuestSession_USCOREgetDirectories*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetFiles:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetFiles type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetFiles*)p = *(struct __vbox__IGuestSession_USCOREgetFiles*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREgetEventSource*)p = *(struct __vbox__IGuestSession_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREclose*)p = *(struct __vbox__IGuestSession_USCOREclose*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryCopy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryCopy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryCopy*)p = *(struct __vbox__IGuestSession_USCOREdirectoryCopy*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryCopyFromGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryCopyFromGuest type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryCopyFromGuest*)p = *(struct __vbox__IGuestSession_USCOREdirectoryCopyFromGuest*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryCopyToGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryCopyToGuest type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryCopyToGuest*)p = *(struct __vbox__IGuestSession_USCOREdirectoryCopyToGuest*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryCreate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryCreate*)p = *(struct __vbox__IGuestSession_USCOREdirectoryCreate*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryCreateTemp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryCreateTemp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryCreateTemp*)p = *(struct __vbox__IGuestSession_USCOREdirectoryCreateTemp*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryExists type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryExists*)p = *(struct __vbox__IGuestSession_USCOREdirectoryExists*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryOpen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryOpen type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryOpen*)p = *(struct __vbox__IGuestSession_USCOREdirectoryOpen*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryRemove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryRemove*)p = *(struct __vbox__IGuestSession_USCOREdirectoryRemove*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREdirectoryRemoveRecursive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREdirectoryRemoveRecursive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREdirectoryRemoveRecursive*)p = *(struct __vbox__IGuestSession_USCOREdirectoryRemoveRecursive*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREenvironmentScheduleSet:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREenvironmentScheduleSet type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREenvironmentScheduleSet*)p = *(struct __vbox__IGuestSession_USCOREenvironmentScheduleSet*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREenvironmentScheduleUnset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREenvironmentScheduleUnset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREenvironmentScheduleUnset*)p = *(struct __vbox__IGuestSession_USCOREenvironmentScheduleUnset*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREenvironmentGetBaseVariable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREenvironmentGetBaseVariable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREenvironmentGetBaseVariable*)p = *(struct __vbox__IGuestSession_USCOREenvironmentGetBaseVariable*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist*)p = *(struct __vbox__IGuestSession_USCOREenvironmentDoesBaseVariableExist*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileCopy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileCopy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileCopy*)p = *(struct __vbox__IGuestSession_USCOREfileCopy*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileCopyFromGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileCopyFromGuest type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileCopyFromGuest*)p = *(struct __vbox__IGuestSession_USCOREfileCopyFromGuest*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileCopyToGuest:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileCopyToGuest type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileCopyToGuest*)p = *(struct __vbox__IGuestSession_USCOREfileCopyToGuest*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileCreateTemp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileCreateTemp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileCreateTemp*)p = *(struct __vbox__IGuestSession_USCOREfileCreateTemp*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileExists type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileExists*)p = *(struct __vbox__IGuestSession_USCOREfileExists*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileOpen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileOpen type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileOpen*)p = *(struct __vbox__IGuestSession_USCOREfileOpen*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileOpenEx:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileOpenEx type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileOpenEx*)p = *(struct __vbox__IGuestSession_USCOREfileOpenEx*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfileQuerySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfileQuerySize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfileQuerySize*)p = *(struct __vbox__IGuestSession_USCOREfileQuerySize*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjExists type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjExists*)p = *(struct __vbox__IGuestSession_USCOREfsObjExists*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjQueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjQueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjQueryInfo*)p = *(struct __vbox__IGuestSession_USCOREfsObjQueryInfo*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjRemove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjRemove*)p = *(struct __vbox__IGuestSession_USCOREfsObjRemove*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjRename:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjRename type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjRename*)p = *(struct __vbox__IGuestSession_USCOREfsObjRename*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjMove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjMove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjMove*)p = *(struct __vbox__IGuestSession_USCOREfsObjMove*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREfsObjSetACL:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREfsObjSetACL type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREfsObjSetACL*)p = *(struct __vbox__IGuestSession_USCOREfsObjSetACL*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREprocessCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREprocessCreate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREprocessCreate*)p = *(struct __vbox__IGuestSession_USCOREprocessCreate*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREprocessCreateEx:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREprocessCreateEx type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREprocessCreateEx*)p = *(struct __vbox__IGuestSession_USCOREprocessCreateEx*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREprocessGet:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREprocessGet type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREprocessGet*)p = *(struct __vbox__IGuestSession_USCOREprocessGet*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsymlinkCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsymlinkCreate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsymlinkCreate*)p = *(struct __vbox__IGuestSession_USCOREsymlinkCreate*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsymlinkExists:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsymlinkExists type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsymlinkExists*)p = *(struct __vbox__IGuestSession_USCOREsymlinkExists*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREsymlinkRead:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREsymlinkRead type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREsymlinkRead*)p = *(struct __vbox__IGuestSession_USCOREsymlinkRead*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREwaitFor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREwaitFor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREwaitFor*)p = *(struct __vbox__IGuestSession_USCOREwaitFor*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSession_USCOREwaitForArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSession_USCOREwaitForArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSession_USCOREwaitForArray*)p = *(struct __vbox__IGuestSession_USCOREwaitForArray*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetArguments:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetArguments type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetArguments*)p = *(struct __vbox__IProcess_USCOREgetArguments*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetEnvironment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetEnvironment type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetEnvironment*)p = *(struct __vbox__IProcess_USCOREgetEnvironment*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetEventSource*)p = *(struct __vbox__IProcess_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetExecutablePath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetExecutablePath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetExecutablePath*)p = *(struct __vbox__IProcess_USCOREgetExecutablePath*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetExitCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetExitCode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetExitCode*)p = *(struct __vbox__IProcess_USCOREgetExitCode*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetName*)p = *(struct __vbox__IProcess_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetPID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetPID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetPID*)p = *(struct __vbox__IProcess_USCOREgetPID*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREgetStatus*)p = *(struct __vbox__IProcess_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREwaitFor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREwaitFor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREwaitFor*)p = *(struct __vbox__IProcess_USCOREwaitFor*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREwaitForArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREwaitForArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREwaitForArray*)p = *(struct __vbox__IProcess_USCOREwaitForArray*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREread*)p = *(struct __vbox__IProcess_USCOREread*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREwrite*)p = *(struct __vbox__IProcess_USCOREwrite*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREwriteArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREwriteArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREwriteArray*)p = *(struct __vbox__IProcess_USCOREwriteArray*)q;
		break;
	case SOAP_TYPE___vbox__IProcess_USCOREterminate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProcess_USCOREterminate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProcess_USCOREterminate*)p = *(struct __vbox__IProcess_USCOREterminate*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestProcess_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IDirectory_USCOREgetDirectoryName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDirectory_USCOREgetDirectoryName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDirectory_USCOREgetDirectoryName*)p = *(struct __vbox__IDirectory_USCOREgetDirectoryName*)q;
		break;
	case SOAP_TYPE___vbox__IDirectory_USCOREgetFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDirectory_USCOREgetFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDirectory_USCOREgetFilter*)p = *(struct __vbox__IDirectory_USCOREgetFilter*)q;
		break;
	case SOAP_TYPE___vbox__IDirectory_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDirectory_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDirectory_USCOREclose*)p = *(struct __vbox__IDirectory_USCOREclose*)q;
		break;
	case SOAP_TYPE___vbox__IDirectory_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDirectory_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDirectory_USCOREread*)p = *(struct __vbox__IDirectory_USCOREread*)q;
		break;
	case SOAP_TYPE___vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestDirectory_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetEventSource*)p = *(struct __vbox__IFile_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetId*)p = *(struct __vbox__IFile_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetInitialSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetInitialSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetInitialSize*)p = *(struct __vbox__IFile_USCOREgetInitialSize*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetOffset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetOffset*)p = *(struct __vbox__IFile_USCOREgetOffset*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetStatus*)p = *(struct __vbox__IFile_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetFileName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetFileName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetFileName*)p = *(struct __vbox__IFile_USCOREgetFileName*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetCreationMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetCreationMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetCreationMode*)p = *(struct __vbox__IFile_USCOREgetCreationMode*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetOpenAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetOpenAction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetOpenAction*)p = *(struct __vbox__IFile_USCOREgetOpenAction*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREgetAccessMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREgetAccessMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREgetAccessMode*)p = *(struct __vbox__IFile_USCOREgetAccessMode*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREclose*)p = *(struct __vbox__IFile_USCOREclose*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREqueryInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREqueryInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREqueryInfo*)p = *(struct __vbox__IFile_USCOREqueryInfo*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREquerySize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREquerySize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREquerySize*)p = *(struct __vbox__IFile_USCOREquerySize*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREread:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREread type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREread*)p = *(struct __vbox__IFile_USCOREread*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREreadAt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREreadAt type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREreadAt*)p = *(struct __vbox__IFile_USCOREreadAt*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREseek:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREseek type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREseek*)p = *(struct __vbox__IFile_USCOREseek*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREsetACL:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREsetACL type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREsetACL*)p = *(struct __vbox__IFile_USCOREsetACL*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREsetSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREsetSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREsetSize*)p = *(struct __vbox__IFile_USCOREsetSize*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREwrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREwrite type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREwrite*)p = *(struct __vbox__IFile_USCOREwrite*)q;
		break;
	case SOAP_TYPE___vbox__IFile_USCOREwriteAt:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFile_USCOREwriteAt type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFile_USCOREwriteAt*)p = *(struct __vbox__IFile_USCOREwriteAt*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestFile_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetAccessTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetAccessTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetAccessTime*)p = *(struct __vbox__IFsObjInfo_USCOREgetAccessTime*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetAllocatedSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetAllocatedSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetAllocatedSize*)p = *(struct __vbox__IFsObjInfo_USCOREgetAllocatedSize*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetBirthTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetBirthTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetBirthTime*)p = *(struct __vbox__IFsObjInfo_USCOREgetBirthTime*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetChangeTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetChangeTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetChangeTime*)p = *(struct __vbox__IFsObjInfo_USCOREgetChangeTime*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetDeviceNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetDeviceNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetDeviceNumber*)p = *(struct __vbox__IFsObjInfo_USCOREgetDeviceNumber*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetFileAttributes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetFileAttributes type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetFileAttributes*)p = *(struct __vbox__IFsObjInfo_USCOREgetFileAttributes*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetGenerationId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetGenerationId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetGenerationId*)p = *(struct __vbox__IFsObjInfo_USCOREgetGenerationId*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetGID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetGID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetGID*)p = *(struct __vbox__IFsObjInfo_USCOREgetGID*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetGroupName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetGroupName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetGroupName*)p = *(struct __vbox__IFsObjInfo_USCOREgetGroupName*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetHardLinks:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetHardLinks type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetHardLinks*)p = *(struct __vbox__IFsObjInfo_USCOREgetHardLinks*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetModificationTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetModificationTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetModificationTime*)p = *(struct __vbox__IFsObjInfo_USCOREgetModificationTime*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetName*)p = *(struct __vbox__IFsObjInfo_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetNodeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetNodeId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetNodeId*)p = *(struct __vbox__IFsObjInfo_USCOREgetNodeId*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetNodeIdDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetNodeIdDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetNodeIdDevice*)p = *(struct __vbox__IFsObjInfo_USCOREgetNodeIdDevice*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetObjectSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetObjectSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetObjectSize*)p = *(struct __vbox__IFsObjInfo_USCOREgetObjectSize*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetType*)p = *(struct __vbox__IFsObjInfo_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetUID:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetUID type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetUID*)p = *(struct __vbox__IFsObjInfo_USCOREgetUID*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetUserFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetUserFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetUserFlags*)p = *(struct __vbox__IFsObjInfo_USCOREgetUserFlags*)q;
		break;
	case SOAP_TYPE___vbox__IFsObjInfo_USCOREgetUserName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFsObjInfo_USCOREgetUserName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFsObjInfo_USCOREgetUserName*)p = *(struct __vbox__IFsObjInfo_USCOREgetUserName*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestFsObjInfo_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetOSTypeId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetOSTypeId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetOSTypeId*)p = *(struct __vbox__IGuest_USCOREgetOSTypeId*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsRunLevel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetAdditionsRunLevel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetAdditionsRunLevel*)p = *(struct __vbox__IGuest_USCOREgetAdditionsRunLevel*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetAdditionsVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetAdditionsVersion*)p = *(struct __vbox__IGuest_USCOREgetAdditionsVersion*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetAdditionsRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetAdditionsRevision*)p = *(struct __vbox__IGuest_USCOREgetAdditionsRevision*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetDnDSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetDnDSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetDnDSource*)p = *(struct __vbox__IGuest_USCOREgetDnDSource*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetDnDTarget:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetDnDTarget type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetDnDTarget*)p = *(struct __vbox__IGuest_USCOREgetDnDTarget*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetEventSource*)p = *(struct __vbox__IGuest_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetFacilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetFacilities type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetFacilities*)p = *(struct __vbox__IGuest_USCOREgetFacilities*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetSessions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetSessions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetSessions*)p = *(struct __vbox__IGuest_USCOREgetSessions*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetMemoryBalloonSize*)p = *(struct __vbox__IGuest_USCOREgetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetMemoryBalloonSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREsetMemoryBalloonSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREsetMemoryBalloonSize*)p = *(struct __vbox__IGuest_USCOREsetMemoryBalloonSize*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetStatisticsUpdateInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetStatisticsUpdateInterval type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetStatisticsUpdateInterval*)p = *(struct __vbox__IGuest_USCOREgetStatisticsUpdateInterval*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetStatisticsUpdateInterval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREsetStatisticsUpdateInterval type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREsetStatisticsUpdateInterval*)p = *(struct __vbox__IGuest_USCOREsetStatisticsUpdateInterval*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREinternalGetStatistics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREinternalGetStatistics type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREinternalGetStatistics*)p = *(struct __vbox__IGuest_USCOREinternalGetStatistics*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetFacilityStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetFacilityStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetFacilityStatus*)p = *(struct __vbox__IGuest_USCOREgetFacilityStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREgetAdditionsStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREgetAdditionsStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREgetAdditionsStatus*)p = *(struct __vbox__IGuest_USCOREgetAdditionsStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREsetCredentials:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREsetCredentials type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREsetCredentials*)p = *(struct __vbox__IGuest_USCOREsetCredentials*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREcreateSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREcreateSession type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREcreateSession*)p = *(struct __vbox__IGuest_USCOREcreateSession*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREfindSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREfindSession type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREfindSession*)p = *(struct __vbox__IGuest_USCOREfindSession*)q;
		break;
	case SOAP_TYPE___vbox__IGuest_USCOREupdateGuestAdditions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuest_USCOREupdateGuestAdditions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuest_USCOREupdateGuestAdditions*)p = *(struct __vbox__IGuest_USCOREupdateGuestAdditions*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetId*)p = *(struct __vbox__IProgress_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetDescription*)p = *(struct __vbox__IProgress_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetInitiator:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetInitiator type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetInitiator*)p = *(struct __vbox__IProgress_USCOREgetInitiator*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCancelable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetCancelable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetCancelable*)p = *(struct __vbox__IProgress_USCOREgetCancelable*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetPercent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetPercent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetPercent*)p = *(struct __vbox__IProgress_USCOREgetPercent*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeRemaining:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetTimeRemaining type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetTimeRemaining*)p = *(struct __vbox__IProgress_USCOREgetTimeRemaining*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCompleted:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetCompleted type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetCompleted*)p = *(struct __vbox__IProgress_USCOREgetCompleted*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetCanceled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetCanceled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetCanceled*)p = *(struct __vbox__IProgress_USCOREgetCanceled*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetResultCode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetResultCode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetResultCode*)p = *(struct __vbox__IProgress_USCOREgetResultCode*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetErrorInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetErrorInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetErrorInfo*)p = *(struct __vbox__IProgress_USCOREgetErrorInfo*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetOperationCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetOperationCount*)p = *(struct __vbox__IProgress_USCOREgetOperationCount*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetOperation type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetOperation*)p = *(struct __vbox__IProgress_USCOREgetOperation*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetOperationDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetOperationDescription*)p = *(struct __vbox__IProgress_USCOREgetOperationDescription*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationPercent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetOperationPercent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetOperationPercent*)p = *(struct __vbox__IProgress_USCOREgetOperationPercent*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetOperationWeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetOperationWeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetOperationWeight*)p = *(struct __vbox__IProgress_USCOREgetOperationWeight*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREgetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREgetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREgetTimeout*)p = *(struct __vbox__IProgress_USCOREgetTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREsetTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREsetTimeout*)p = *(struct __vbox__IProgress_USCOREsetTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetCurrentOperationProgress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREsetCurrentOperationProgress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREsetCurrentOperationProgress*)p = *(struct __vbox__IProgress_USCOREsetCurrentOperationProgress*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREsetNextOperation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREsetNextOperation type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREsetNextOperation*)p = *(struct __vbox__IProgress_USCOREsetNextOperation*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREwaitForCompletion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREwaitForCompletion*)p = *(struct __vbox__IProgress_USCOREwaitForCompletion*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForOperationCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREwaitForOperationCompletion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREwaitForOperationCompletion*)p = *(struct __vbox__IProgress_USCOREwaitForOperationCompletion*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREwaitForAsyncProgressCompletion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREwaitForAsyncProgressCompletion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREwaitForAsyncProgressCompletion*)p = *(struct __vbox__IProgress_USCOREwaitForAsyncProgressCompletion*)q;
		break;
	case SOAP_TYPE___vbox__IProgress_USCOREcancel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IProgress_USCOREcancel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IProgress_USCOREcancel*)p = *(struct __vbox__IProgress_USCOREcancel*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetId*)p = *(struct __vbox__ISnapshot_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetName*)p = *(struct __vbox__ISnapshot_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREsetName*)p = *(struct __vbox__ISnapshot_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetDescription*)p = *(struct __vbox__ISnapshot_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREsetDescription*)p = *(struct __vbox__ISnapshot_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetTimeStamp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetTimeStamp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetTimeStamp*)p = *(struct __vbox__ISnapshot_USCOREgetTimeStamp*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetOnline:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetOnline type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetOnline*)p = *(struct __vbox__ISnapshot_USCOREgetOnline*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetMachine*)p = *(struct __vbox__ISnapshot_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetParent*)p = *(struct __vbox__ISnapshot_USCOREgetParent*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetChildren type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetChildren*)p = *(struct __vbox__ISnapshot_USCOREgetChildren*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshot_USCOREgetChildrenCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshot_USCOREgetChildrenCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshot_USCOREgetChildrenCount*)p = *(struct __vbox__ISnapshot_USCOREgetChildrenCount*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetId*)p = *(struct __vbox__IMedium_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetDescription*)p = *(struct __vbox__IMedium_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetDescription*)p = *(struct __vbox__IMedium_USCOREsetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetState*)p = *(struct __vbox__IMedium_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetVariant:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetVariant type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetVariant*)p = *(struct __vbox__IMedium_USCOREgetVariant*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLocation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetLocation type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetLocation*)p = *(struct __vbox__IMedium_USCOREgetLocation*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetName*)p = *(struct __vbox__IMedium_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetDeviceType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetDeviceType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetDeviceType*)p = *(struct __vbox__IMedium_USCOREgetDeviceType*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetHostDrive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetHostDrive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetHostDrive*)p = *(struct __vbox__IMedium_USCOREgetHostDrive*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetSize*)p = *(struct __vbox__IMedium_USCOREgetSize*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetFormat type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetFormat*)p = *(struct __vbox__IMedium_USCOREgetFormat*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetMediumFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetMediumFormat type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetMediumFormat*)p = *(struct __vbox__IMedium_USCOREgetMediumFormat*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetType*)p = *(struct __vbox__IMedium_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetType*)p = *(struct __vbox__IMedium_USCOREsetType*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetAllowedTypes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetAllowedTypes type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetAllowedTypes*)p = *(struct __vbox__IMedium_USCOREgetAllowedTypes*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetParent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetParent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetParent*)p = *(struct __vbox__IMedium_USCOREgetParent*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetChildren:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetChildren type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetChildren*)p = *(struct __vbox__IMedium_USCOREgetChildren*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetBase*)p = *(struct __vbox__IMedium_USCOREgetBase*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetReadOnly:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetReadOnly type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetReadOnly*)p = *(struct __vbox__IMedium_USCOREgetReadOnly*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLogicalSize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetLogicalSize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetLogicalSize*)p = *(struct __vbox__IMedium_USCOREgetLogicalSize*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetAutoReset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetAutoReset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetAutoReset*)p = *(struct __vbox__IMedium_USCOREgetAutoReset*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetAutoReset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetAutoReset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetAutoReset*)p = *(struct __vbox__IMedium_USCOREsetAutoReset*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetLastAccessError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetLastAccessError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetLastAccessError*)p = *(struct __vbox__IMedium_USCOREgetLastAccessError*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetMachineIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetMachineIds type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetMachineIds*)p = *(struct __vbox__IMedium_USCOREgetMachineIds*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetIds type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetIds*)p = *(struct __vbox__IMedium_USCOREsetIds*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORErefreshState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCORErefreshState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCORErefreshState*)p = *(struct __vbox__IMedium_USCORErefreshState*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetSnapshotIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetSnapshotIds type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetSnapshotIds*)p = *(struct __vbox__IMedium_USCOREgetSnapshotIds*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORElockRead:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCORElockRead type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCORElockRead*)p = *(struct __vbox__IMedium_USCORElockRead*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCORElockWrite:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCORElockWrite type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCORElockWrite*)p = *(struct __vbox__IMedium_USCORElockWrite*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREclose:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREclose type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREclose*)p = *(struct __vbox__IMedium_USCOREclose*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetProperty*)p = *(struct __vbox__IMedium_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetProperty*)p = *(struct __vbox__IMedium_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetProperties*)p = *(struct __vbox__IMedium_USCOREgetProperties*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetProperties*)p = *(struct __vbox__IMedium_USCOREsetProperties*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcreateBaseStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcreateBaseStorage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcreateBaseStorage*)p = *(struct __vbox__IMedium_USCOREcreateBaseStorage*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREdeleteStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREdeleteStorage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREdeleteStorage*)p = *(struct __vbox__IMedium_USCOREdeleteStorage*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcreateDiffStorage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcreateDiffStorage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcreateDiffStorage*)p = *(struct __vbox__IMedium_USCOREcreateDiffStorage*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREmergeTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREmergeTo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREmergeTo*)p = *(struct __vbox__IMedium_USCOREmergeTo*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcloneTo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcloneTo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcloneTo*)p = *(struct __vbox__IMedium_USCOREcloneTo*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcloneToBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcloneToBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcloneToBase*)p = *(struct __vbox__IMedium_USCOREcloneToBase*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREsetLocation:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREsetLocation type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREsetLocation*)p = *(struct __vbox__IMedium_USCOREsetLocation*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcompact:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcompact type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcompact*)p = *(struct __vbox__IMedium_USCOREcompact*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREresize:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREresize type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREresize*)p = *(struct __vbox__IMedium_USCOREresize*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREreset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREreset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREreset*)p = *(struct __vbox__IMedium_USCOREreset*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREchangeEncryption:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREchangeEncryption type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREchangeEncryption*)p = *(struct __vbox__IMedium_USCOREchangeEncryption*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREgetEncryptionSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREgetEncryptionSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREgetEncryptionSettings*)p = *(struct __vbox__IMedium_USCOREgetEncryptionSettings*)q;
		break;
	case SOAP_TYPE___vbox__IMedium_USCOREcheckEncryptionPassword:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMedium_USCOREcheckEncryptionPassword type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMedium_USCOREcheckEncryptionPassword*)p = *(struct __vbox__IMedium_USCOREcheckEncryptionPassword*)q;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumFormat_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumFormat_USCOREgetId*)p = *(struct __vbox__IMediumFormat_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumFormat_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumFormat_USCOREgetName*)p = *(struct __vbox__IMediumFormat_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREgetCapabilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumFormat_USCOREgetCapabilities type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumFormat_USCOREgetCapabilities*)p = *(struct __vbox__IMediumFormat_USCOREgetCapabilities*)q;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREdescribeFileExtensions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumFormat_USCOREdescribeFileExtensions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumFormat_USCOREdescribeFileExtensions*)p = *(struct __vbox__IMediumFormat_USCOREdescribeFileExtensions*)q;
		break;
	case SOAP_TYPE___vbox__IMediumFormat_USCOREdescribeProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumFormat_USCOREdescribeProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumFormat_USCOREdescribeProperties*)p = *(struct __vbox__IMediumFormat_USCOREdescribeProperties*)q;
		break;
	case SOAP_TYPE___vbox__IToken_USCOREabandon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IToken_USCOREabandon type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IToken_USCOREabandon*)p = *(struct __vbox__IToken_USCOREabandon*)q;
		break;
	case SOAP_TYPE___vbox__IToken_USCOREdummy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IToken_USCOREdummy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IToken_USCOREdummy*)p = *(struct __vbox__IToken_USCOREdummy*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREgetKeyboardLEDs:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREgetKeyboardLEDs type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREgetKeyboardLEDs*)p = *(struct __vbox__IKeyboard_USCOREgetKeyboardLEDs*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREgetEventSource*)p = *(struct __vbox__IKeyboard_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREputScancode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREputScancode*)p = *(struct __vbox__IKeyboard_USCOREputScancode*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputScancodes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREputScancodes type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREputScancodes*)p = *(struct __vbox__IKeyboard_USCOREputScancodes*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREputCAD:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREputCAD type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREputCAD*)p = *(struct __vbox__IKeyboard_USCOREputCAD*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboard_USCOREreleaseKeys:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboard_USCOREreleaseKeys type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboard_USCOREreleaseKeys*)p = *(struct __vbox__IKeyboard_USCOREreleaseKeys*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetVisible*)p = *(struct __vbox__IMousePointerShape_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetAlpha*)p = *(struct __vbox__IMousePointerShape_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetHotX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetHotX type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetHotX*)p = *(struct __vbox__IMousePointerShape_USCOREgetHotX*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetHotY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetHotY type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetHotY*)p = *(struct __vbox__IMousePointerShape_USCOREgetHotY*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetWidth*)p = *(struct __vbox__IMousePointerShape_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetHeight*)p = *(struct __vbox__IMousePointerShape_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShape_USCOREgetShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShape_USCOREgetShape type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShape_USCOREgetShape*)p = *(struct __vbox__IMousePointerShape_USCOREgetShape*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetAbsoluteSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetAbsoluteSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetAbsoluteSupported*)p = *(struct __vbox__IMouse_USCOREgetAbsoluteSupported*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetRelativeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetRelativeSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetRelativeSupported*)p = *(struct __vbox__IMouse_USCOREgetRelativeSupported*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetMultiTouchSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetMultiTouchSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetMultiTouchSupported*)p = *(struct __vbox__IMouse_USCOREgetMultiTouchSupported*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetNeedsHostCursor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetNeedsHostCursor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetNeedsHostCursor*)p = *(struct __vbox__IMouse_USCOREgetNeedsHostCursor*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetPointerShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetPointerShape type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetPointerShape*)p = *(struct __vbox__IMouse_USCOREgetPointerShape*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREgetEventSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREgetEventSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREgetEventSource*)p = *(struct __vbox__IMouse_USCOREgetEventSource*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREputMouseEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREputMouseEvent*)p = *(struct __vbox__IMouse_USCOREputMouseEvent*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputMouseEventAbsolute:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREputMouseEventAbsolute type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREputMouseEventAbsolute*)p = *(struct __vbox__IMouse_USCOREputMouseEventAbsolute*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputEventMultiTouch:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREputEventMultiTouch type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREputEventMultiTouch*)p = *(struct __vbox__IMouse_USCOREputEventMultiTouch*)q;
		break;
	case SOAP_TYPE___vbox__IMouse_USCOREputEventMultiTouchString:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouse_USCOREputEventMultiTouchString type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouse_USCOREputEventMultiTouchString*)p = *(struct __vbox__IMouse_USCOREputEventMultiTouchString*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetWidth*)p = *(struct __vbox__IFramebuffer_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetHeight*)p = *(struct __vbox__IFramebuffer_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetBitsPerPixel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetBitsPerPixel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetBitsPerPixel*)p = *(struct __vbox__IFramebuffer_USCOREgetBitsPerPixel*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetBytesPerLine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetBytesPerLine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetBytesPerLine*)p = *(struct __vbox__IFramebuffer_USCOREgetBytesPerLine*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetPixelFormat:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetPixelFormat type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetPixelFormat*)p = *(struct __vbox__IFramebuffer_USCOREgetPixelFormat*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetHeightReduction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetHeightReduction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetHeightReduction*)p = *(struct __vbox__IFramebuffer_USCOREgetHeightReduction*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetOverlay:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetOverlay type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetOverlay*)p = *(struct __vbox__IFramebuffer_USCOREgetOverlay*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREgetCapabilities:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREgetCapabilities type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREgetCapabilities*)p = *(struct __vbox__IFramebuffer_USCOREgetCapabilities*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREnotifyUpdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREnotifyUpdate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREnotifyUpdate*)p = *(struct __vbox__IFramebuffer_USCOREnotifyUpdate*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREnotifyUpdateImage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREnotifyUpdateImage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREnotifyUpdateImage*)p = *(struct __vbox__IFramebuffer_USCOREnotifyUpdateImage*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREnotifyChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREnotifyChange type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREnotifyChange*)p = *(struct __vbox__IFramebuffer_USCOREnotifyChange*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREvideoModeSupported:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREvideoModeSupported type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREvideoModeSupported*)p = *(struct __vbox__IFramebuffer_USCOREvideoModeSupported*)q;
		break;
	case SOAP_TYPE___vbox__IFramebuffer_USCOREnotify3DEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebuffer_USCOREnotify3DEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebuffer_USCOREnotify3DEvent*)p = *(struct __vbox__IFramebuffer_USCOREnotify3DEvent*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREgetX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREgetX type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREgetX*)p = *(struct __vbox__IFramebufferOverlay_USCOREgetX*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREgetY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREgetY type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREgetY*)p = *(struct __vbox__IFramebufferOverlay_USCOREgetY*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREgetVisible*)p = *(struct __vbox__IFramebufferOverlay_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREsetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREsetVisible type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREsetVisible*)p = *(struct __vbox__IFramebufferOverlay_USCOREsetVisible*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREgetAlpha*)p = *(struct __vbox__IFramebufferOverlay_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREsetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREsetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREsetAlpha*)p = *(struct __vbox__IFramebufferOverlay_USCOREsetAlpha*)q;
		break;
	case SOAP_TYPE___vbox__IFramebufferOverlay_USCOREmove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IFramebufferOverlay_USCOREmove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IFramebufferOverlay_USCOREmove*)p = *(struct __vbox__IFramebufferOverlay_USCOREmove*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetScreenId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetScreenId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetScreenId*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetScreenId*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetGuestMonitorStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetPrimary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetPrimary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetPrimary*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetPrimary*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetOrigin:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetOrigin type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetOrigin*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetOrigin*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetOriginX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetOriginX type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetOriginX*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetOriginX*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetOriginY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetOriginY type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetOriginY*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetOriginY*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetWidth*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetHeight*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE___vbox__IGuestScreenInfo_USCOREgetBitsPerPixel:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestScreenInfo_USCOREgetBitsPerPixel type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestScreenInfo_USCOREgetBitsPerPixel*)p = *(struct __vbox__IGuestScreenInfo_USCOREgetBitsPerPixel*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREgetGuestScreenLayout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREgetGuestScreenLayout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREgetGuestScreenLayout*)p = *(struct __vbox__IDisplay_USCOREgetGuestScreenLayout*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREgetScreenResolution:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREgetScreenResolution type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREgetScreenResolution*)p = *(struct __vbox__IDisplay_USCOREgetScreenResolution*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREattachFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREattachFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREattachFramebuffer*)p = *(struct __vbox__IDisplay_USCOREattachFramebuffer*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREdetachFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREdetachFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREdetachFramebuffer*)p = *(struct __vbox__IDisplay_USCOREdetachFramebuffer*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREqueryFramebuffer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREqueryFramebuffer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREqueryFramebuffer*)p = *(struct __vbox__IDisplay_USCOREqueryFramebuffer*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREsetVideoModeHint:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREsetVideoModeHint type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREsetVideoModeHint*)p = *(struct __vbox__IDisplay_USCOREsetVideoModeHint*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREsetSeamlessMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREsetSeamlessMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREsetSeamlessMode*)p = *(struct __vbox__IDisplay_USCOREsetSeamlessMode*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREtakeScreenShotToArray:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREtakeScreenShotToArray type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREtakeScreenShotToArray*)p = *(struct __vbox__IDisplay_USCOREtakeScreenShotToArray*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREinvalidateAndUpdate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREinvalidateAndUpdate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREinvalidateAndUpdate*)p = *(struct __vbox__IDisplay_USCOREinvalidateAndUpdate*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREinvalidateAndUpdateScreen:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREinvalidateAndUpdateScreen type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREinvalidateAndUpdateScreen*)p = *(struct __vbox__IDisplay_USCOREinvalidateAndUpdateScreen*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREviewportChanged:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREviewportChanged type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREviewportChanged*)p = *(struct __vbox__IDisplay_USCOREviewportChanged*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREnotifyScaleFactorChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREnotifyScaleFactorChange type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREnotifyScaleFactorChange*)p = *(struct __vbox__IDisplay_USCOREnotifyScaleFactorChange*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange*)p = *(struct __vbox__IDisplay_USCOREnotifyHiDPIOutputPolicyChange*)q;
		break;
	case SOAP_TYPE___vbox__IDisplay_USCOREsetScreenLayout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDisplay_USCOREsetScreenLayout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDisplay_USCOREsetScreenLayout*)p = *(struct __vbox__IDisplay_USCOREsetScreenLayout*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAdapterType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetAdapterType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetAdapterType*)p = *(struct __vbox__INetworkAdapter_USCOREgetAdapterType*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetAdapterType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetAdapterType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetAdapterType*)p = *(struct __vbox__INetworkAdapter_USCOREsetAdapterType*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetSlot*)p = *(struct __vbox__INetworkAdapter_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetEnabled*)p = *(struct __vbox__INetworkAdapter_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetEnabled*)p = *(struct __vbox__INetworkAdapter_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetMACAddress*)p = *(struct __vbox__INetworkAdapter_USCOREgetMACAddress*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetMACAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetMACAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetMACAddress*)p = *(struct __vbox__INetworkAdapter_USCOREsetMACAddress*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetAttachmentType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetAttachmentType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetAttachmentType*)p = *(struct __vbox__INetworkAdapter_USCOREgetAttachmentType*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetAttachmentType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetAttachmentType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetAttachmentType*)p = *(struct __vbox__INetworkAdapter_USCOREsetAttachmentType*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetBridgedInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetBridgedInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetBridgedInterface*)p = *(struct __vbox__INetworkAdapter_USCOREgetBridgedInterface*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetBridgedInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetBridgedInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetBridgedInterface*)p = *(struct __vbox__INetworkAdapter_USCOREsetBridgedInterface*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetHostOnlyInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetHostOnlyInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetHostOnlyInterface*)p = *(struct __vbox__INetworkAdapter_USCOREgetHostOnlyInterface*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetHostOnlyInterface:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetHostOnlyInterface type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetHostOnlyInterface*)p = *(struct __vbox__INetworkAdapter_USCOREsetHostOnlyInterface*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetInternalNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetInternalNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetInternalNetwork*)p = *(struct __vbox__INetworkAdapter_USCOREgetInternalNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetInternalNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetInternalNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetInternalNetwork*)p = *(struct __vbox__INetworkAdapter_USCOREsetInternalNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetNATNetwork*)p = *(struct __vbox__INetworkAdapter_USCOREgetNATNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetNATNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetNATNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetNATNetwork*)p = *(struct __vbox__INetworkAdapter_USCOREsetNATNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetGenericDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetGenericDriver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetGenericDriver*)p = *(struct __vbox__INetworkAdapter_USCOREgetGenericDriver*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetGenericDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetGenericDriver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetGenericDriver*)p = *(struct __vbox__INetworkAdapter_USCOREsetGenericDriver*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetCableConnected:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetCableConnected type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetCableConnected*)p = *(struct __vbox__INetworkAdapter_USCOREgetCableConnected*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetCableConnected:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetCableConnected type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetCableConnected*)p = *(struct __vbox__INetworkAdapter_USCOREsetCableConnected*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetLineSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetLineSpeed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetLineSpeed*)p = *(struct __vbox__INetworkAdapter_USCOREgetLineSpeed*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetLineSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetLineSpeed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetLineSpeed*)p = *(struct __vbox__INetworkAdapter_USCOREsetLineSpeed*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetPromiscModePolicy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetPromiscModePolicy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetPromiscModePolicy*)p = *(struct __vbox__INetworkAdapter_USCOREgetPromiscModePolicy*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetPromiscModePolicy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetPromiscModePolicy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetPromiscModePolicy*)p = *(struct __vbox__INetworkAdapter_USCOREsetPromiscModePolicy*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetTraceEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetTraceEnabled*)p = *(struct __vbox__INetworkAdapter_USCOREgetTraceEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetTraceEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetTraceEnabled*)p = *(struct __vbox__INetworkAdapter_USCOREsetTraceEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetTraceFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetTraceFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetTraceFile*)p = *(struct __vbox__INetworkAdapter_USCOREgetTraceFile*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetTraceFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetTraceFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetTraceFile*)p = *(struct __vbox__INetworkAdapter_USCOREsetTraceFile*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetNATEngine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetNATEngine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetNATEngine*)p = *(struct __vbox__INetworkAdapter_USCOREgetNATEngine*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetBootPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetBootPriority type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetBootPriority*)p = *(struct __vbox__INetworkAdapter_USCOREgetBootPriority*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetBootPriority:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetBootPriority type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetBootPriority*)p = *(struct __vbox__INetworkAdapter_USCOREsetBootPriority*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetBandwidthGroup*)p = *(struct __vbox__INetworkAdapter_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetBandwidthGroup*)p = *(struct __vbox__INetworkAdapter_USCOREsetBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetProperty*)p = *(struct __vbox__INetworkAdapter_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREsetProperty*)p = *(struct __vbox__INetworkAdapter_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapter_USCOREgetProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapter_USCOREgetProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapter_USCOREgetProperties*)p = *(struct __vbox__INetworkAdapter_USCOREgetProperties*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetSlot*)p = *(struct __vbox__ISerialPort_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetEnabled*)p = *(struct __vbox__ISerialPort_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetEnabled*)p = *(struct __vbox__ISerialPort_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetIOBase*)p = *(struct __vbox__ISerialPort_USCOREgetIOBase*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetIOBase*)p = *(struct __vbox__ISerialPort_USCOREsetIOBase*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetIRQ*)p = *(struct __vbox__ISerialPort_USCOREgetIRQ*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetIRQ*)p = *(struct __vbox__ISerialPort_USCOREsetIRQ*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetHostMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetHostMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetHostMode*)p = *(struct __vbox__ISerialPort_USCOREgetHostMode*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetHostMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetHostMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetHostMode*)p = *(struct __vbox__ISerialPort_USCOREsetHostMode*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetServer*)p = *(struct __vbox__ISerialPort_USCOREgetServer*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetServer*)p = *(struct __vbox__ISerialPort_USCOREsetServer*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREgetPath*)p = *(struct __vbox__ISerialPort_USCOREgetPath*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPort_USCOREsetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPort_USCOREsetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPort_USCOREsetPath*)p = *(struct __vbox__ISerialPort_USCOREsetPath*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREgetSlot*)p = *(struct __vbox__IParallelPort_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREgetEnabled*)p = *(struct __vbox__IParallelPort_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREsetEnabled*)p = *(struct __vbox__IParallelPort_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREgetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREgetIOBase*)p = *(struct __vbox__IParallelPort_USCOREgetIOBase*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIOBase:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREsetIOBase type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREsetIOBase*)p = *(struct __vbox__IParallelPort_USCOREsetIOBase*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREgetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREgetIRQ*)p = *(struct __vbox__IParallelPort_USCOREgetIRQ*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetIRQ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREsetIRQ type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREsetIRQ*)p = *(struct __vbox__IParallelPort_USCOREsetIRQ*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREgetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREgetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREgetPath*)p = *(struct __vbox__IParallelPort_USCOREgetPath*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPort_USCOREsetPath:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPort_USCOREsetPath type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPort_USCOREsetPath*)p = *(struct __vbox__IParallelPort_USCOREsetPath*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetSingleStep:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetSingleStep type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetSingleStep*)p = *(struct __vbox__IMachineDebugger_USCOREgetSingleStep*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetSingleStep:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetSingleStep type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetSingleStep*)p = *(struct __vbox__IMachineDebugger_USCOREsetSingleStep*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetRecompileUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetRecompileUser type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetRecompileUser*)p = *(struct __vbox__IMachineDebugger_USCOREgetRecompileUser*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetRecompileUser:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetRecompileUser type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetRecompileUser*)p = *(struct __vbox__IMachineDebugger_USCOREsetRecompileUser*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetRecompileSupervisor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetRecompileSupervisor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetRecompileSupervisor*)p = *(struct __vbox__IMachineDebugger_USCOREgetRecompileSupervisor*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetRecompileSupervisor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetRecompileSupervisor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetRecompileSupervisor*)p = *(struct __vbox__IMachineDebugger_USCOREsetRecompileSupervisor*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetExecuteAllInIEM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetExecuteAllInIEM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetExecuteAllInIEM*)p = *(struct __vbox__IMachineDebugger_USCOREgetExecuteAllInIEM*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetExecuteAllInIEM:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetExecuteAllInIEM type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetExecuteAllInIEM*)p = *(struct __vbox__IMachineDebugger_USCOREsetExecuteAllInIEM*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetPATMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetPATMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetPATMEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetPATMEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetPATMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetPATMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetPATMEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREsetPATMEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetCSAMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetCSAMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetCSAMEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetCSAMEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetCSAMEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetCSAMEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetCSAMEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREsetCSAMEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetLogEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetLogEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetLogEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREsetLogEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogDbgFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogDbgFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogDbgFlags*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogDbgFlags*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogDbgGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogDbgGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogDbgGroups*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogDbgGroups*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogDbgDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogDbgDestinations type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogDbgDestinations*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogDbgDestinations*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogRelFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogRelFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogRelFlags*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogRelFlags*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogRelGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogRelGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogRelGroups*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogRelGroups*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetLogRelDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetLogRelDestinations type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetLogRelDestinations*)p = *(struct __vbox__IMachineDebugger_USCOREgetLogRelDestinations*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetHWVirtExEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetHWVirtExEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetHWVirtExEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetHWVirtExEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetHWVirtExNestedPagingEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetHWVirtExVPIDEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetHWVirtExUXEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetOSName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetOSName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetOSName*)p = *(struct __vbox__IMachineDebugger_USCOREgetOSName*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetOSVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetOSVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetOSVersion*)p = *(struct __vbox__IMachineDebugger_USCOREgetOSVersion*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetPAEEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetPAEEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetPAEEnabled*)p = *(struct __vbox__IMachineDebugger_USCOREgetPAEEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetVirtualTimeRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetVirtualTimeRate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetVirtualTimeRate*)p = *(struct __vbox__IMachineDebugger_USCOREgetVirtualTimeRate*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetVirtualTimeRate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetVirtualTimeRate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetVirtualTimeRate*)p = *(struct __vbox__IMachineDebugger_USCOREsetVirtualTimeRate*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetUptime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetUptime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetUptime*)p = *(struct __vbox__IMachineDebugger_USCOREgetUptime*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREdumpGuestCore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREdumpGuestCore type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREdumpGuestCore*)p = *(struct __vbox__IMachineDebugger_USCOREdumpGuestCore*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREdumpHostProcessCore:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREdumpHostProcessCore type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREdumpHostProcessCore*)p = *(struct __vbox__IMachineDebugger_USCOREdumpHostProcessCore*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREinfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREinfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREinfo*)p = *(struct __vbox__IMachineDebugger_USCOREinfo*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREinjectNMI:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREinjectNMI type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREinjectNMI*)p = *(struct __vbox__IMachineDebugger_USCOREinjectNMI*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREmodifyLogGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREmodifyLogGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREmodifyLogGroups*)p = *(struct __vbox__IMachineDebugger_USCOREmodifyLogGroups*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREmodifyLogFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREmodifyLogFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREmodifyLogFlags*)p = *(struct __vbox__IMachineDebugger_USCOREmodifyLogFlags*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREmodifyLogDestinations:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREmodifyLogDestinations type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREmodifyLogDestinations*)p = *(struct __vbox__IMachineDebugger_USCOREmodifyLogDestinations*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREreadPhysicalMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREreadPhysicalMemory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREreadPhysicalMemory*)p = *(struct __vbox__IMachineDebugger_USCOREreadPhysicalMemory*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREwritePhysicalMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREwritePhysicalMemory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREwritePhysicalMemory*)p = *(struct __vbox__IMachineDebugger_USCOREwritePhysicalMemory*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREreadVirtualMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREreadVirtualMemory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREreadVirtualMemory*)p = *(struct __vbox__IMachineDebugger_USCOREreadVirtualMemory*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREwriteVirtualMemory:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREwriteVirtualMemory type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREwriteVirtualMemory*)p = *(struct __vbox__IMachineDebugger_USCOREwriteVirtualMemory*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREloadPlugIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREloadPlugIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREloadPlugIn*)p = *(struct __vbox__IMachineDebugger_USCOREloadPlugIn*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREunloadPlugIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREunloadPlugIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREunloadPlugIn*)p = *(struct __vbox__IMachineDebugger_USCOREunloadPlugIn*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREdetectOS:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREdetectOS type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREdetectOS*)p = *(struct __vbox__IMachineDebugger_USCOREdetectOS*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREqueryOSKernelLog:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREqueryOSKernelLog type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREqueryOSKernelLog*)p = *(struct __vbox__IMachineDebugger_USCOREqueryOSKernelLog*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetRegister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetRegister type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetRegister*)p = *(struct __vbox__IMachineDebugger_USCOREgetRegister*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetRegisters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetRegisters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetRegisters*)p = *(struct __vbox__IMachineDebugger_USCOREgetRegisters*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetRegister:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetRegister type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetRegister*)p = *(struct __vbox__IMachineDebugger_USCOREsetRegister*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREsetRegisters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREsetRegisters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREsetRegisters*)p = *(struct __vbox__IMachineDebugger_USCOREsetRegisters*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREdumpGuestStack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREdumpGuestStack type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREdumpGuestStack*)p = *(struct __vbox__IMachineDebugger_USCOREdumpGuestStack*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREresetStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREresetStats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREresetStats*)p = *(struct __vbox__IMachineDebugger_USCOREresetStats*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREdumpStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREdumpStats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREdumpStats*)p = *(struct __vbox__IMachineDebugger_USCOREdumpStats*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDebugger_USCOREgetStats:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDebugger_USCOREgetStats type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDebugger_USCOREgetStats*)p = *(struct __vbox__IMachineDebugger_USCOREgetStats*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilters_USCOREgetDeviceFilters:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilters_USCOREgetDeviceFilters type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilters_USCOREgetDeviceFilters*)p = *(struct __vbox__IUSBDeviceFilters_USCOREgetDeviceFilters*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter*)p = *(struct __vbox__IUSBDeviceFilters_USCOREcreateDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter*)p = *(struct __vbox__IUSBDeviceFilters_USCOREinsertDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter*)p = *(struct __vbox__IUSBDeviceFilters_USCOREremoveDeviceFilter*)q;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBController_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBController_USCOREgetName*)p = *(struct __vbox__IUSBController_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBController_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBController_USCOREsetName*)p = *(struct __vbox__IUSBController_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBController_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBController_USCOREgetType*)p = *(struct __vbox__IUSBController_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREsetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBController_USCOREsetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBController_USCOREsetType*)p = *(struct __vbox__IUSBController_USCOREsetType*)q;
		break;
	case SOAP_TYPE___vbox__IUSBController_USCOREgetUSBStandard:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBController_USCOREgetUSBStandard type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBController_USCOREgetUSBStandard*)p = *(struct __vbox__IUSBController_USCOREgetUSBStandard*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetId*)p = *(struct __vbox__IUSBDevice_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetVendorId*)p = *(struct __vbox__IUSBDevice_USCOREgetVendorId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetProductId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetProductId*)p = *(struct __vbox__IUSBDevice_USCOREgetProductId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetRevision*)p = *(struct __vbox__IUSBDevice_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetManufacturer*)p = *(struct __vbox__IUSBDevice_USCOREgetManufacturer*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetProduct type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetProduct*)p = *(struct __vbox__IUSBDevice_USCOREgetProduct*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetSerialNumber*)p = *(struct __vbox__IUSBDevice_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetAddress:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetAddress type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetAddress*)p = *(struct __vbox__IUSBDevice_USCOREgetAddress*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetPort*)p = *(struct __vbox__IUSBDevice_USCOREgetPort*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetVersion*)p = *(struct __vbox__IUSBDevice_USCOREgetVersion*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetPortVersion:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetPortVersion type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetPortVersion*)p = *(struct __vbox__IUSBDevice_USCOREgetPortVersion*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetSpeed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetSpeed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetSpeed*)p = *(struct __vbox__IUSBDevice_USCOREgetSpeed*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetRemote type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetRemote*)p = *(struct __vbox__IUSBDevice_USCOREgetRemote*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetDeviceInfo:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetDeviceInfo type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetDeviceInfo*)p = *(struct __vbox__IUSBDevice_USCOREgetDeviceInfo*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDevice_USCOREgetBackend:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDevice_USCOREgetBackend type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDevice_USCOREgetBackend*)p = *(struct __vbox__IUSBDevice_USCOREgetBackend*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetName*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetName*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetActive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetActive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetActive*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetActive*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetActive:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetActive type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetActive*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetActive*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetVendorId*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetVendorId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetVendorId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetVendorId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetVendorId*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetVendorId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetProductId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetProductId*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetProductId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProductId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetProductId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetProductId*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetProductId*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetRevision*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetRevision*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRevision:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetRevision type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetRevision*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetRevision*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetManufacturer*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetManufacturer*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetManufacturer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetManufacturer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetManufacturer*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetManufacturer*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetProduct type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetProduct*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetProduct*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetProduct:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetProduct type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetProduct*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetProduct*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetSerialNumber*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetSerialNumber:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetSerialNumber type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetSerialNumber*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetPort*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetPort*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetPort*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetPort*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetRemote type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetRemote*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetRemote*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetRemote:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetRemote type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetRemote*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetRemote*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)p = *(struct __vbox__IUSBDeviceFilter_USCOREgetMaskedInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)p = *(struct __vbox__IUSBDeviceFilter_USCOREsetMaskedInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IHostUSBDevice_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostUSBDevice_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostUSBDevice_USCOREgetState*)p = *(struct __vbox__IHostUSBDevice_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREgetAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostUSBDeviceFilter_USCOREgetAction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostUSBDeviceFilter_USCOREgetAction*)p = *(struct __vbox__IHostUSBDeviceFilter_USCOREgetAction*)q;
		break;
	case SOAP_TYPE___vbox__IHostUSBDeviceFilter_USCOREsetAction:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostUSBDeviceFilter_USCOREsetAction type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostUSBDeviceFilter_USCOREsetAction*)p = *(struct __vbox__IHostUSBDeviceFilter_USCOREsetAction*)q;
		break;
	case SOAP_TYPE___vbox__IUSBProxyBackend_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBProxyBackend_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBProxyBackend_USCOREgetName*)p = *(struct __vbox__IUSBProxyBackend_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IUSBProxyBackend_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBProxyBackend_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBProxyBackend_USCOREgetType*)p = *(struct __vbox__IUSBProxyBackend_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetEnabled*)p = *(struct __vbox__IAudioAdapter_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetEnabled*)p = *(struct __vbox__IAudioAdapter_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetEnabledIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetEnabledIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetEnabledIn*)p = *(struct __vbox__IAudioAdapter_USCOREgetEnabledIn*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetEnabledIn:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetEnabledIn type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetEnabledIn*)p = *(struct __vbox__IAudioAdapter_USCOREsetEnabledIn*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetEnabledOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetEnabledOut type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetEnabledOut*)p = *(struct __vbox__IAudioAdapter_USCOREgetEnabledOut*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetEnabledOut:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetEnabledOut type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetEnabledOut*)p = *(struct __vbox__IAudioAdapter_USCOREsetEnabledOut*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetAudioController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetAudioController*)p = *(struct __vbox__IAudioAdapter_USCOREgetAudioController*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioController:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetAudioController type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetAudioController*)p = *(struct __vbox__IAudioAdapter_USCOREsetAudioController*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioCodec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetAudioCodec type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetAudioCodec*)p = *(struct __vbox__IAudioAdapter_USCOREgetAudioCodec*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioCodec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetAudioCodec type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetAudioCodec*)p = *(struct __vbox__IAudioAdapter_USCOREsetAudioCodec*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetAudioDriver*)p = *(struct __vbox__IAudioAdapter_USCOREgetAudioDriver*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetAudioDriver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetAudioDriver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetAudioDriver*)p = *(struct __vbox__IAudioAdapter_USCOREsetAudioDriver*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetPropertiesList:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetPropertiesList type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetPropertiesList*)p = *(struct __vbox__IAudioAdapter_USCOREgetPropertiesList*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREsetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREsetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREsetProperty*)p = *(struct __vbox__IAudioAdapter_USCOREsetProperty*)q;
		break;
	case SOAP_TYPE___vbox__IAudioAdapter_USCOREgetProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAudioAdapter_USCOREgetProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAudioAdapter_USCOREgetProperty*)p = *(struct __vbox__IAudioAdapter_USCOREgetProperty*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetEnabled*)p = *(struct __vbox__IVRDEServer_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetEnabled*)p = *(struct __vbox__IVRDEServer_USCOREsetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetAuthType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetAuthType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetAuthType*)p = *(struct __vbox__IVRDEServer_USCOREgetAuthType*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetAuthType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetAuthType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetAuthType*)p = *(struct __vbox__IVRDEServer_USCOREsetAuthType*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetAuthTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetAuthTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetAuthTimeout*)p = *(struct __vbox__IVRDEServer_USCOREgetAuthTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetAuthTimeout:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetAuthTimeout type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetAuthTimeout*)p = *(struct __vbox__IVRDEServer_USCOREsetAuthTimeout*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetAllowMultiConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetAllowMultiConnection type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetAllowMultiConnection*)p = *(struct __vbox__IVRDEServer_USCOREgetAllowMultiConnection*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetAllowMultiConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetAllowMultiConnection type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetAllowMultiConnection*)p = *(struct __vbox__IVRDEServer_USCOREsetAllowMultiConnection*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetReuseSingleConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetReuseSingleConnection type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetReuseSingleConnection*)p = *(struct __vbox__IVRDEServer_USCOREgetReuseSingleConnection*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetReuseSingleConnection:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetReuseSingleConnection type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetReuseSingleConnection*)p = *(struct __vbox__IVRDEServer_USCOREsetReuseSingleConnection*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetVRDEExtPack*)p = *(struct __vbox__IVRDEServer_USCOREgetVRDEExtPack*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetVRDEExtPack:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetVRDEExtPack type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetVRDEExtPack*)p = *(struct __vbox__IVRDEServer_USCOREsetVRDEExtPack*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetAuthLibrary*)p = *(struct __vbox__IVRDEServer_USCOREgetAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetAuthLibrary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetAuthLibrary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetAuthLibrary*)p = *(struct __vbox__IVRDEServer_USCOREsetAuthLibrary*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetVRDEProperties:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetVRDEProperties type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetVRDEProperties*)p = *(struct __vbox__IVRDEServer_USCOREgetVRDEProperties*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREsetVRDEProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREsetVRDEProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREsetVRDEProperty*)p = *(struct __vbox__IVRDEServer_USCOREsetVRDEProperty*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServer_USCOREgetVRDEProperty:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServer_USCOREgetVRDEProperty type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServer_USCOREgetVRDEProperty*)p = *(struct __vbox__IVRDEServer_USCOREgetVRDEProperty*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREgetState*)p = *(struct __vbox__ISession_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREgetType*)p = *(struct __vbox__ISession_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREgetName*)p = *(struct __vbox__ISession_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREsetName*)p = *(struct __vbox__ISession_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREgetMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREgetMachine*)p = *(struct __vbox__ISession_USCOREgetMachine*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREgetConsole:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREgetConsole type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREgetConsole*)p = *(struct __vbox__ISession_USCOREgetConsole*)q;
		break;
	case SOAP_TYPE___vbox__ISession_USCOREunlockMachine:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISession_USCOREunlockMachine type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISession_USCOREunlockMachine*)p = *(struct __vbox__ISession_USCOREunlockMachine*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetName*)p = *(struct __vbox__IStorageController_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREsetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREsetName*)p = *(struct __vbox__IStorageController_USCOREsetName*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxDevicesPerPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetMaxDevicesPerPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)p = *(struct __vbox__IStorageController_USCOREgetMaxDevicesPerPortCount*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMinPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetMinPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetMinPortCount*)p = *(struct __vbox__IStorageController_USCOREgetMinPortCount*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetMaxPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetMaxPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetMaxPortCount*)p = *(struct __vbox__IStorageController_USCOREgetMaxPortCount*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetInstance type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetInstance*)p = *(struct __vbox__IStorageController_USCOREgetInstance*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetInstance:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREsetInstance type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREsetInstance*)p = *(struct __vbox__IStorageController_USCOREsetInstance*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetPortCount*)p = *(struct __vbox__IStorageController_USCOREgetPortCount*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetPortCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREsetPortCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREsetPortCount*)p = *(struct __vbox__IStorageController_USCOREsetPortCount*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetBus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetBus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetBus*)p = *(struct __vbox__IStorageController_USCOREgetBus*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetControllerType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetControllerType*)p = *(struct __vbox__IStorageController_USCOREgetControllerType*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetControllerType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREsetControllerType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREsetControllerType*)p = *(struct __vbox__IStorageController_USCOREsetControllerType*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetUseHostIOCache:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetUseHostIOCache type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetUseHostIOCache*)p = *(struct __vbox__IStorageController_USCOREgetUseHostIOCache*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREsetUseHostIOCache:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREsetUseHostIOCache type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREsetUseHostIOCache*)p = *(struct __vbox__IStorageController_USCOREsetUseHostIOCache*)q;
		break;
	case SOAP_TYPE___vbox__IStorageController_USCOREgetBootable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageController_USCOREgetBootable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageController_USCOREgetBootable*)p = *(struct __vbox__IStorageController_USCOREgetBootable*)q;
		break;
	case SOAP_TYPE___vbox__IManagedObjectRef_USCOREgetInterfaceName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IManagedObjectRef_USCOREgetInterfaceName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IManagedObjectRef_USCOREgetInterfaceName*)p = *(struct __vbox__IManagedObjectRef_USCOREgetInterfaceName*)q;
		break;
	case SOAP_TYPE___vbox__IManagedObjectRef_USCORErelease:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IManagedObjectRef_USCORErelease type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IManagedObjectRef_USCORErelease*)p = *(struct __vbox__IManagedObjectRef_USCORErelease*)q;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogon:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IWebsessionManager_USCORElogon type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IWebsessionManager_USCORElogon*)p = *(struct __vbox__IWebsessionManager_USCORElogon*)q;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCOREgetSessionObject:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IWebsessionManager_USCOREgetSessionObject type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IWebsessionManager_USCOREgetSessionObject*)p = *(struct __vbox__IWebsessionManager_USCOREgetSessionObject*)q;
		break;
	case SOAP_TYPE___vbox__IWebsessionManager_USCORElogoff:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IWebsessionManager_USCORElogoff type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IWebsessionManager_USCORElogoff*)p = *(struct __vbox__IWebsessionManager_USCORElogoff*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMetricName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetMetricName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetMetricName*)p = *(struct __vbox__IPerformanceMetric_USCOREgetMetricName*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetObject:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetObject type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetObject*)p = *(struct __vbox__IPerformanceMetric_USCOREgetObject*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetDescription:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetDescription type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetDescription*)p = *(struct __vbox__IPerformanceMetric_USCOREgetDescription*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetPeriod:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetPeriod type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetPeriod*)p = *(struct __vbox__IPerformanceMetric_USCOREgetPeriod*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetCount*)p = *(struct __vbox__IPerformanceMetric_USCOREgetCount*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetUnit:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetUnit type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetUnit*)p = *(struct __vbox__IPerformanceMetric_USCOREgetUnit*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMinimumValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetMinimumValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetMinimumValue*)p = *(struct __vbox__IPerformanceMetric_USCOREgetMinimumValue*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceMetric_USCOREgetMaximumValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceMetric_USCOREgetMaximumValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceMetric_USCOREgetMaximumValue*)p = *(struct __vbox__IPerformanceMetric_USCOREgetMaximumValue*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetricNames:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREgetMetricNames type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREgetMetricNames*)p = *(struct __vbox__IPerformanceCollector_USCOREgetMetricNames*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREgetMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREgetMetrics type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREgetMetrics*)p = *(struct __vbox__IPerformanceCollector_USCOREgetMetrics*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREsetupMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREsetupMetrics type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREsetupMetrics*)p = *(struct __vbox__IPerformanceCollector_USCOREsetupMetrics*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREenableMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREenableMetrics type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREenableMetrics*)p = *(struct __vbox__IPerformanceCollector_USCOREenableMetrics*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREdisableMetrics:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREdisableMetrics type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREdisableMetrics*)p = *(struct __vbox__IPerformanceCollector_USCOREdisableMetrics*)q;
		break;
	case SOAP_TYPE___vbox__IPerformanceCollector_USCOREqueryMetricsData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IPerformanceCollector_USCOREqueryMetricsData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IPerformanceCollector_USCOREqueryMetricsData*)p = *(struct __vbox__IPerformanceCollector_USCOREqueryMetricsData*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetNetwork*)p = *(struct __vbox__INATEngine_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetNetwork*)p = *(struct __vbox__INATEngine_USCOREsetNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetHostIP*)p = *(struct __vbox__INATEngine_USCOREgetHostIP*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetHostIP*)p = *(struct __vbox__INATEngine_USCOREsetHostIP*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetTFTPPrefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetTFTPPrefix type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetTFTPPrefix*)p = *(struct __vbox__INATEngine_USCOREgetTFTPPrefix*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetTFTPPrefix:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetTFTPPrefix type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetTFTPPrefix*)p = *(struct __vbox__INATEngine_USCOREsetTFTPPrefix*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetTFTPBootFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetTFTPBootFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetTFTPBootFile*)p = *(struct __vbox__INATEngine_USCOREgetTFTPBootFile*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetTFTPBootFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetTFTPBootFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetTFTPBootFile*)p = *(struct __vbox__INATEngine_USCOREsetTFTPBootFile*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetTFTPNextServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetTFTPNextServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetTFTPNextServer*)p = *(struct __vbox__INATEngine_USCOREgetTFTPNextServer*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetTFTPNextServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetTFTPNextServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetTFTPNextServer*)p = *(struct __vbox__INATEngine_USCOREsetTFTPNextServer*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetAliasMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetAliasMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetAliasMode*)p = *(struct __vbox__INATEngine_USCOREgetAliasMode*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetAliasMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetAliasMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetAliasMode*)p = *(struct __vbox__INATEngine_USCOREsetAliasMode*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetDNSPassDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetDNSPassDomain type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetDNSPassDomain*)p = *(struct __vbox__INATEngine_USCOREgetDNSPassDomain*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetDNSPassDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetDNSPassDomain type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetDNSPassDomain*)p = *(struct __vbox__INATEngine_USCOREsetDNSPassDomain*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetDNSProxy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetDNSProxy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetDNSProxy*)p = *(struct __vbox__INATEngine_USCOREgetDNSProxy*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetDNSProxy:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetDNSProxy type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetDNSProxy*)p = *(struct __vbox__INATEngine_USCOREsetDNSProxy*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetDNSUseHostResolver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetDNSUseHostResolver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetDNSUseHostResolver*)p = *(struct __vbox__INATEngine_USCOREgetDNSUseHostResolver*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetDNSUseHostResolver:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetDNSUseHostResolver type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetDNSUseHostResolver*)p = *(struct __vbox__INATEngine_USCOREsetDNSUseHostResolver*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetRedirects:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetRedirects type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetRedirects*)p = *(struct __vbox__INATEngine_USCOREgetRedirects*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREsetNetworkSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREsetNetworkSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREsetNetworkSettings*)p = *(struct __vbox__INATEngine_USCOREsetNetworkSettings*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREgetNetworkSettings:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREgetNetworkSettings type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREgetNetworkSettings*)p = *(struct __vbox__INATEngine_USCOREgetNetworkSettings*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREaddRedirect:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREaddRedirect type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREaddRedirect*)p = *(struct __vbox__INATEngine_USCOREaddRedirect*)q;
		break;
	case SOAP_TYPE___vbox__INATEngine_USCOREremoveRedirect:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATEngine_USCOREremoveRedirect type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATEngine_USCOREremoveRedirect*)p = *(struct __vbox__INATEngine_USCOREremoveRedirect*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroup_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroup_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroup_USCOREgetName*)p = *(struct __vbox__IBandwidthGroup_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroup_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroup_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroup_USCOREgetType*)p = *(struct __vbox__IBandwidthGroup_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroup_USCOREgetReference:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroup_USCOREgetReference type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroup_USCOREgetReference*)p = *(struct __vbox__IBandwidthGroup_USCOREgetReference*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec*)p = *(struct __vbox__IBandwidthGroup_USCOREgetMaxBytesPerSec*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec*)p = *(struct __vbox__IBandwidthGroup_USCOREsetMaxBytesPerSec*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthControl_USCOREgetNumGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthControl_USCOREgetNumGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthControl_USCOREgetNumGroups*)p = *(struct __vbox__IBandwidthControl_USCOREgetNumGroups*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthControl_USCOREcreateBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthControl_USCOREcreateBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthControl_USCOREcreateBandwidthGroup*)p = *(struct __vbox__IBandwidthControl_USCOREcreateBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthControl_USCOREdeleteBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthControl_USCOREdeleteBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthControl_USCOREdeleteBandwidthGroup*)p = *(struct __vbox__IBandwidthControl_USCOREdeleteBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthControl_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthControl_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthControl_USCOREgetBandwidthGroup*)p = *(struct __vbox__IBandwidthControl_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthControl_USCOREgetAllBandwidthGroups:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthControl_USCOREgetAllBandwidthGroups type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthControl_USCOREgetAllBandwidthGroups*)p = *(struct __vbox__IBandwidthControl_USCOREgetAllBandwidthGroups*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREcreateListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREcreateListener type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREcreateListener*)p = *(struct __vbox__IEventSource_USCOREcreateListener*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREcreateAggregator:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREcreateAggregator type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREcreateAggregator*)p = *(struct __vbox__IEventSource_USCOREcreateAggregator*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREregisterListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREregisterListener type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREregisterListener*)p = *(struct __vbox__IEventSource_USCOREregisterListener*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREunregisterListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREunregisterListener type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREunregisterListener*)p = *(struct __vbox__IEventSource_USCOREunregisterListener*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREfireEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREfireEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREfireEvent*)p = *(struct __vbox__IEventSource_USCOREfireEvent*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREgetEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREgetEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREgetEvent*)p = *(struct __vbox__IEventSource_USCOREgetEvent*)q;
		break;
	case SOAP_TYPE___vbox__IEventSource_USCOREeventProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSource_USCOREeventProcessed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSource_USCOREeventProcessed*)p = *(struct __vbox__IEventSource_USCOREeventProcessed*)q;
		break;
	case SOAP_TYPE___vbox__IEventListener_USCOREhandleEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventListener_USCOREhandleEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventListener_USCOREhandleEvent*)p = *(struct __vbox__IEventListener_USCOREhandleEvent*)q;
		break;
	case SOAP_TYPE___vbox__IEvent_USCOREgetType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEvent_USCOREgetType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEvent_USCOREgetType*)p = *(struct __vbox__IEvent_USCOREgetType*)q;
		break;
	case SOAP_TYPE___vbox__IEvent_USCOREgetSource:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEvent_USCOREgetSource type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEvent_USCOREgetSource*)p = *(struct __vbox__IEvent_USCOREgetSource*)q;
		break;
	case SOAP_TYPE___vbox__IEvent_USCOREgetWaitable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEvent_USCOREgetWaitable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEvent_USCOREgetWaitable*)p = *(struct __vbox__IEvent_USCOREgetWaitable*)q;
		break;
	case SOAP_TYPE___vbox__IEvent_USCOREsetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEvent_USCOREsetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEvent_USCOREsetProcessed*)p = *(struct __vbox__IEvent_USCOREsetProcessed*)q;
		break;
	case SOAP_TYPE___vbox__IEvent_USCOREwaitProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEvent_USCOREwaitProcessed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEvent_USCOREwaitProcessed*)p = *(struct __vbox__IEvent_USCOREwaitProcessed*)q;
		break;
	case SOAP_TYPE___vbox__IReusableEvent_USCOREgetGeneration:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IReusableEvent_USCOREgetGeneration type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IReusableEvent_USCOREgetGeneration*)p = *(struct __vbox__IReusableEvent_USCOREgetGeneration*)q;
		break;
	case SOAP_TYPE___vbox__IReusableEvent_USCOREreuse:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IReusableEvent_USCOREreuse type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IReusableEvent_USCOREreuse*)p = *(struct __vbox__IReusableEvent_USCOREreuse*)q;
		break;
	case SOAP_TYPE___vbox__IMachineEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineEvent_USCOREgetMachineId*)p = *(struct __vbox__IMachineEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE___vbox__IMachineStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineStateChangedEvent_USCOREgetState*)p = *(struct __vbox__IMachineStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IMachineDataChangedEvent_USCOREgetTemporary:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineDataChangedEvent_USCOREgetTemporary type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineDataChangedEvent_USCOREgetTemporary*)p = *(struct __vbox__IMachineDataChangedEvent_USCOREgetTemporary*)q;
		break;
	case SOAP_TYPE___vbox__IMediumRegisteredEvent_USCOREgetMediumId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumRegisteredEvent_USCOREgetMediumId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumRegisteredEvent_USCOREgetMediumId*)p = *(struct __vbox__IMediumRegisteredEvent_USCOREgetMediumId*)q;
		break;
	case SOAP_TYPE___vbox__IMediumRegisteredEvent_USCOREgetMediumType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumRegisteredEvent_USCOREgetMediumType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumRegisteredEvent_USCOREgetMediumType*)p = *(struct __vbox__IMediumRegisteredEvent_USCOREgetMediumType*)q;
		break;
	case SOAP_TYPE___vbox__IMediumRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumRegisteredEvent_USCOREgetRegistered*)p = *(struct __vbox__IMediumRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE___vbox__IMediumConfigChangedEvent_USCOREgetMedium:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumConfigChangedEvent_USCOREgetMedium type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumConfigChangedEvent_USCOREgetMedium*)p = *(struct __vbox__IMediumConfigChangedEvent_USCOREgetMedium*)q;
		break;
	case SOAP_TYPE___vbox__IMachineRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMachineRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMachineRegisteredEvent_USCOREgetRegistered*)p = *(struct __vbox__IMachineRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE___vbox__ISessionStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISessionStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISessionStateChangedEvent_USCOREgetState*)p = *(struct __vbox__ISessionStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IGuestPropertyChangedEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestPropertyChangedEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestPropertyChangedEvent_USCOREgetName*)p = *(struct __vbox__IGuestPropertyChangedEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IGuestPropertyChangedEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestPropertyChangedEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestPropertyChangedEvent_USCOREgetValue*)p = *(struct __vbox__IGuestPropertyChangedEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE___vbox__IGuestPropertyChangedEvent_USCOREgetFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestPropertyChangedEvent_USCOREgetFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestPropertyChangedEvent_USCOREgetFlags*)p = *(struct __vbox__IGuestPropertyChangedEvent_USCOREgetFlags*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshotEvent_USCOREgetSnapshotId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshotEvent_USCOREgetSnapshotId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshotEvent_USCOREgetSnapshotId*)p = *(struct __vbox__ISnapshotEvent_USCOREgetSnapshotId*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__ISnapshotTakenEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__ISnapshotDeletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__ISnapshotRestoredEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__ISnapshotChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetVisible:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetVisible type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetVisible*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetVisible*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetAlpha*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetXhot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetXhot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetXhot*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetXhot*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetYhot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetYhot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetYhot*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetYhot*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetWidth*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetHeight*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE___vbox__IMousePointerShapeChangedEvent_USCOREgetShape:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMousePointerShapeChangedEvent_USCOREgetShape type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetShape*)p = *(struct __vbox__IMousePointerShapeChangedEvent_USCOREgetShape*)q;
		break;
	case SOAP_TYPE___vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute*)p = *(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsAbsolute*)q;
		break;
	case SOAP_TYPE___vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative*)p = *(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsRelative*)q;
		break;
	case SOAP_TYPE___vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch*)p = *(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetSupportsMultiTouch*)q;
		break;
	case SOAP_TYPE___vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor*)p = *(struct __vbox__IMouseCapabilityChangedEvent_USCOREgetNeedsHostCursor*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock*)p = *(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetNumLock*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock*)p = *(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetCapsLock*)q;
		break;
	case SOAP_TYPE___vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock*)p = *(struct __vbox__IKeyboardLedsChangedEvent_USCOREgetScrollLock*)q;
		break;
	case SOAP_TYPE___vbox__IStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStateChangedEvent_USCOREgetState*)p = *(struct __vbox__IStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IAdditionsStateChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter*)p = *(struct __vbox__INetworkAdapterChangedEvent_USCOREgetNetworkAdapter*)q;
		break;
	case SOAP_TYPE___vbox__ISerialPortChangedEvent_USCOREgetSerialPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISerialPortChangedEvent_USCOREgetSerialPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISerialPortChangedEvent_USCOREgetSerialPort*)p = *(struct __vbox__ISerialPortChangedEvent_USCOREgetSerialPort*)q;
		break;
	case SOAP_TYPE___vbox__IParallelPortChangedEvent_USCOREgetParallelPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IParallelPortChangedEvent_USCOREgetParallelPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IParallelPortChangedEvent_USCOREgetParallelPort*)p = *(struct __vbox__IParallelPortChangedEvent_USCOREgetParallelPort*)q;
		break;
	case SOAP_TYPE___vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IStorageControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IMediumChangedEvent_USCOREgetMediumAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IMediumChangedEvent_USCOREgetMediumAttachment type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IMediumChangedEvent_USCOREgetMediumAttachment*)p = *(struct __vbox__IMediumChangedEvent_USCOREgetMediumAttachment*)q;
		break;
	case SOAP_TYPE___vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode*)p = *(struct __vbox__IClipboardModeChangedEvent_USCOREgetClipboardMode*)q;
		break;
	case SOAP_TYPE___vbox__IDnDModeChangedEvent_USCOREgetDndMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IDnDModeChangedEvent_USCOREgetDndMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IDnDModeChangedEvent_USCOREgetDndMode*)p = *(struct __vbox__IDnDModeChangedEvent_USCOREgetDndMode*)q;
		break;
	case SOAP_TYPE___vbox__ICPUChangedEvent_USCOREgetCPU:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICPUChangedEvent_USCOREgetCPU type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICPUChangedEvent_USCOREgetCPU*)p = *(struct __vbox__ICPUChangedEvent_USCOREgetCPU*)q;
		break;
	case SOAP_TYPE___vbox__ICPUChangedEvent_USCOREgetAdd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICPUChangedEvent_USCOREgetAdd type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICPUChangedEvent_USCOREgetAdd*)p = *(struct __vbox__ICPUChangedEvent_USCOREgetAdd*)q;
		break;
	case SOAP_TYPE___vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap*)p = *(struct __vbox__ICPUExecutionCapChangedEvent_USCOREgetExecutionCap*)q;
		break;
	case SOAP_TYPE___vbox__IGuestKeyboardEvent_USCOREgetScancodes:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestKeyboardEvent_USCOREgetScancodes type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestKeyboardEvent_USCOREgetScancodes*)p = *(struct __vbox__IGuestKeyboardEvent_USCOREgetScancodes*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetMode:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetMode type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetMode*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetMode*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetX type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetX*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetX*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetY type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetY*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetY*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetZ:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetZ type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetZ*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetZ*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetW:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetW type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetW*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetW*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMouseEvent_USCOREgetButtons:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMouseEvent_USCOREgetButtons type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMouseEvent_USCOREgetButtons*)p = *(struct __vbox__IGuestMouseEvent_USCOREgetButtons*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetContactCount:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetContactCount type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactCount*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactCount*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetXPositions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetXPositions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetXPositions*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetXPositions*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetYPositions:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetYPositions type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetYPositions*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetYPositions*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetContactIds:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetContactIds type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactIds*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactIds*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetContactFlags:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetContactFlags type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactFlags*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetContactFlags*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMultiTouchEvent_USCOREgetScanTime:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMultiTouchEvent_USCOREgetScanTime type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMultiTouchEvent_USCOREgetScanTime*)p = *(struct __vbox__IGuestMultiTouchEvent_USCOREgetScanTime*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSessionEvent_USCOREgetSession:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSessionEvent_USCOREgetSession type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSessionEvent_USCOREgetSession*)p = *(struct __vbox__IGuestSessionEvent_USCOREgetSession*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSessionStateChangedEvent_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSessionStateChangedEvent_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetId*)p = *(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSessionStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSessionStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetStatus*)p = *(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSessionStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSessionStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetError*)p = *(struct __vbox__IGuestSessionStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE___vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered*)p = *(struct __vbox__IGuestSessionRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessEvent_USCOREgetProcess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessEvent_USCOREgetProcess type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessEvent_USCOREgetProcess*)p = *(struct __vbox__IGuestProcessEvent_USCOREgetProcess*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessEvent_USCOREgetPid:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessEvent_USCOREgetPid type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessEvent_USCOREgetPid*)p = *(struct __vbox__IGuestProcessEvent_USCOREgetPid*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered*)p = *(struct __vbox__IGuestProcessRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessStateChangedEvent_USCOREgetStatus*)p = *(struct __vbox__IGuestProcessStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessStateChangedEvent_USCOREgetError*)p = *(struct __vbox__IGuestProcessStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessIOEvent_USCOREgetHandle:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessIOEvent_USCOREgetHandle type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessIOEvent_USCOREgetHandle*)p = *(struct __vbox__IGuestProcessIOEvent_USCOREgetHandle*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessIOEvent_USCOREgetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessIOEvent_USCOREgetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessIOEvent_USCOREgetProcessed*)p = *(struct __vbox__IGuestProcessIOEvent_USCOREgetProcessed*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus*)p = *(struct __vbox__IGuestProcessInputNotifyEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestProcessOutputEvent_USCOREgetData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestProcessOutputEvent_USCOREgetData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestProcessOutputEvent_USCOREgetData*)p = *(struct __vbox__IGuestProcessOutputEvent_USCOREgetData*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileEvent_USCOREgetFile:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileEvent_USCOREgetFile type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileEvent_USCOREgetFile*)p = *(struct __vbox__IGuestFileEvent_USCOREgetFile*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileRegisteredEvent_USCOREgetRegistered:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileRegisteredEvent_USCOREgetRegistered type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileRegisteredEvent_USCOREgetRegistered*)p = *(struct __vbox__IGuestFileRegisteredEvent_USCOREgetRegistered*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileStateChangedEvent_USCOREgetStatus:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileStateChangedEvent_USCOREgetStatus type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileStateChangedEvent_USCOREgetStatus*)p = *(struct __vbox__IGuestFileStateChangedEvent_USCOREgetStatus*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileStateChangedEvent_USCOREgetError*)p = *(struct __vbox__IGuestFileStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileIOEvent_USCOREgetOffset:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileIOEvent_USCOREgetOffset type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileIOEvent_USCOREgetOffset*)p = *(struct __vbox__IGuestFileIOEvent_USCOREgetOffset*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileIOEvent_USCOREgetProcessed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileIOEvent_USCOREgetProcessed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileIOEvent_USCOREgetProcessed*)p = *(struct __vbox__IGuestFileIOEvent_USCOREgetProcessed*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestFileOffsetChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileReadEvent_USCOREgetData:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileReadEvent_USCOREgetData type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileReadEvent_USCOREgetData*)p = *(struct __vbox__IGuestFileReadEvent_USCOREgetData*)q;
		break;
	case SOAP_TYPE___vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IGuestFileWriteEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IVRDEServerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IVRDEServerInfoChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IVideoCaptureChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IUSBControllerChangedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice*)p = *(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetDevice*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached*)p = *(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetAttached*)q;
		break;
	case SOAP_TYPE___vbox__IUSBDeviceStateChangedEvent_USCOREgetError:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetError type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetError*)p = *(struct __vbox__IUSBDeviceStateChangedEvent_USCOREgetError*)q;
		break;
	case SOAP_TYPE___vbox__ISharedFolderChangedEvent_USCOREgetScope:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ISharedFolderChangedEvent_USCOREgetScope type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ISharedFolderChangedEvent_USCOREgetScope*)p = *(struct __vbox__ISharedFolderChangedEvent_USCOREgetScope*)q;
		break;
	case SOAP_TYPE___vbox__IRuntimeErrorEvent_USCOREgetFatal:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IRuntimeErrorEvent_USCOREgetFatal type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IRuntimeErrorEvent_USCOREgetFatal*)p = *(struct __vbox__IRuntimeErrorEvent_USCOREgetFatal*)q;
		break;
	case SOAP_TYPE___vbox__IRuntimeErrorEvent_USCOREgetId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IRuntimeErrorEvent_USCOREgetId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IRuntimeErrorEvent_USCOREgetId*)p = *(struct __vbox__IRuntimeErrorEvent_USCOREgetId*)q;
		break;
	case SOAP_TYPE___vbox__IRuntimeErrorEvent_USCOREgetMessage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IRuntimeErrorEvent_USCOREgetMessage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IRuntimeErrorEvent_USCOREgetMessage*)p = *(struct __vbox__IRuntimeErrorEvent_USCOREgetMessage*)q;
		break;
	case SOAP_TYPE___vbox__IEventSourceChangedEvent_USCOREgetListener:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSourceChangedEvent_USCOREgetListener type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSourceChangedEvent_USCOREgetListener*)p = *(struct __vbox__IEventSourceChangedEvent_USCOREgetListener*)q;
		break;
	case SOAP_TYPE___vbox__IEventSourceChangedEvent_USCOREgetAdd:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IEventSourceChangedEvent_USCOREgetAdd type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IEventSourceChangedEvent_USCOREgetAdd*)p = *(struct __vbox__IEventSourceChangedEvent_USCOREgetAdd*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataChangedEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataChangedEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataChangedEvent_USCOREgetMachineId*)p = *(struct __vbox__IExtraDataChangedEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataChangedEvent_USCOREgetKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataChangedEvent_USCOREgetKey type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataChangedEvent_USCOREgetKey*)p = *(struct __vbox__IExtraDataChangedEvent_USCOREgetKey*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataChangedEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataChangedEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataChangedEvent_USCOREgetValue*)p = *(struct __vbox__IExtraDataChangedEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREaddVeto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREaddVeto type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREaddVeto*)p = *(struct __vbox__IVetoEvent_USCOREaddVeto*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREisVetoed:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREisVetoed type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREisVetoed*)p = *(struct __vbox__IVetoEvent_USCOREisVetoed*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREgetVetos:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREgetVetos type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREgetVetos*)p = *(struct __vbox__IVetoEvent_USCOREgetVetos*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREaddApproval:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREaddApproval type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREaddApproval*)p = *(struct __vbox__IVetoEvent_USCOREaddApproval*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREisApproved:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREisApproved type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREisApproved*)p = *(struct __vbox__IVetoEvent_USCOREisApproved*)q;
		break;
	case SOAP_TYPE___vbox__IVetoEvent_USCOREgetApprovals:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVetoEvent_USCOREgetApprovals type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVetoEvent_USCOREgetApprovals*)p = *(struct __vbox__IVetoEvent_USCOREgetApprovals*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataCanChangeEvent_USCOREgetMachineId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataCanChangeEvent_USCOREgetMachineId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataCanChangeEvent_USCOREgetMachineId*)p = *(struct __vbox__IExtraDataCanChangeEvent_USCOREgetMachineId*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataCanChangeEvent_USCOREgetKey:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataCanChangeEvent_USCOREgetKey type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataCanChangeEvent_USCOREgetKey*)p = *(struct __vbox__IExtraDataCanChangeEvent_USCOREgetKey*)q;
		break;
	case SOAP_TYPE___vbox__IExtraDataCanChangeEvent_USCOREgetValue:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IExtraDataCanChangeEvent_USCOREgetValue type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IExtraDataCanChangeEvent_USCOREgetValue*)p = *(struct __vbox__IExtraDataCanChangeEvent_USCOREgetValue*)q;
		break;
	case SOAP_TYPE___vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__ICanShowWindowEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__IShowWindowEvent_USCOREgetWinId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IShowWindowEvent_USCOREgetWinId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IShowWindowEvent_USCOREgetWinId*)p = *(struct __vbox__IShowWindowEvent_USCOREgetWinId*)q;
		break;
	case SOAP_TYPE___vbox__IShowWindowEvent_USCOREsetWinId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IShowWindowEvent_USCOREsetWinId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IShowWindowEvent_USCOREsetWinId*)p = *(struct __vbox__IShowWindowEvent_USCOREsetWinId*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetSlot:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetSlot type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetSlot*)p = *(struct __vbox__INATRedirectEvent_USCOREgetSlot*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetRemove:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetRemove type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetRemove*)p = *(struct __vbox__INATRedirectEvent_USCOREgetRemove*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetName*)p = *(struct __vbox__INATRedirectEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetProto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetProto type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetProto*)p = *(struct __vbox__INATRedirectEvent_USCOREgetProto*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetHostIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetHostIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetHostIP*)p = *(struct __vbox__INATRedirectEvent_USCOREgetHostIP*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetHostPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetHostPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetHostPort*)p = *(struct __vbox__INATRedirectEvent_USCOREgetHostPort*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetGuestIP:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetGuestIP type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetGuestIP*)p = *(struct __vbox__INATRedirectEvent_USCOREgetGuestIP*)q;
		break;
	case SOAP_TYPE___vbox__INATRedirectEvent_USCOREgetGuestPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATRedirectEvent_USCOREgetGuestPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATRedirectEvent_USCOREgetGuestPort*)p = *(struct __vbox__INATRedirectEvent_USCOREgetGuestPort*)q;
		break;
	case SOAP_TYPE___vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged*)p = *(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetPlugged*)q;
		break;
	case SOAP_TYPE___vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess*)p = *(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetSuccess*)q;
		break;
	case SOAP_TYPE___vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment*)p = *(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetAttachment*)q;
		break;
	case SOAP_TYPE___vbox__IHostPCIDevicePlugEvent_USCOREgetMessage:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostPCIDevicePlugEvent_USCOREgetMessage type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetMessage*)p = *(struct __vbox__IHostPCIDevicePlugEvent_USCOREgetMessage*)q;
		break;
	case SOAP_TYPE___vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable*)p = *(struct __vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailable*)q;
		break;
	case SOAP_TYPE___vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup*)p = *(struct __vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetChangeType:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetChangeType type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetChangeType*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetChangeType*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetScreenId:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetScreenId type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetScreenId*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetScreenId*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetOriginX:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginX type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginX*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginX*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetOriginY:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginY type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginY*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetOriginY*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetWidth:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetWidth type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetWidth*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetWidth*)q;
		break;
	case SOAP_TYPE___vbox__IGuestMonitorChangedEvent_USCOREgetHeight:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestMonitorChangedEvent_USCOREgetHeight type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestMonitorChangedEvent_USCOREgetHeight*)p = *(struct __vbox__IGuestMonitorChangedEvent_USCOREgetHeight*)q;
		break;
	case SOAP_TYPE___vbox__IGuestUserStateChangedEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestUserStateChangedEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestUserStateChangedEvent_USCOREgetName*)p = *(struct __vbox__IGuestUserStateChangedEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__IGuestUserStateChangedEvent_USCOREgetDomain:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestUserStateChangedEvent_USCOREgetDomain type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestUserStateChangedEvent_USCOREgetDomain*)p = *(struct __vbox__IGuestUserStateChangedEvent_USCOREgetDomain*)q;
		break;
	case SOAP_TYPE___vbox__IGuestUserStateChangedEvent_USCOREgetState:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestUserStateChangedEvent_USCOREgetState type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestUserStateChangedEvent_USCOREgetState*)p = *(struct __vbox__IGuestUserStateChangedEvent_USCOREgetState*)q;
		break;
	case SOAP_TYPE___vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails*)p = *(struct __vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails*)q;
		break;
	case SOAP_TYPE___vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice*)p = *(struct __vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice*)q;
		break;
	case SOAP_TYPE___vbox__IStorageDeviceChangedEvent_USCOREgetRemoved:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageDeviceChangedEvent_USCOREgetRemoved type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageDeviceChangedEvent_USCOREgetRemoved*)p = *(struct __vbox__IStorageDeviceChangedEvent_USCOREgetRemoved*)q;
		break;
	case SOAP_TYPE___vbox__IStorageDeviceChangedEvent_USCOREgetSilent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IStorageDeviceChangedEvent_USCOREgetSilent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IStorageDeviceChangedEvent_USCOREgetSilent*)p = *(struct __vbox__IStorageDeviceChangedEvent_USCOREgetSilent*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkChangedEvent_USCOREgetNetworkName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkChangedEvent_USCOREgetNetworkName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkChangedEvent_USCOREgetNetworkName*)p = *(struct __vbox__INATNetworkChangedEvent_USCOREgetNetworkName*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkStartStopEvent_USCOREgetStartEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkStartStopEvent_USCOREgetStartEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkStartStopEvent_USCOREgetStartEvent*)p = *(struct __vbox__INATNetworkStartStopEvent_USCOREgetStartEvent*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent*)p = *(struct __vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkSettingEvent_USCOREgetEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkSettingEvent_USCOREgetEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkSettingEvent_USCOREgetEnabled*)p = *(struct __vbox__INATNetworkSettingEvent_USCOREgetEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkSettingEvent_USCOREgetNetwork:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkSettingEvent_USCOREgetNetwork type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkSettingEvent_USCOREgetNetwork*)p = *(struct __vbox__INATNetworkSettingEvent_USCOREgetNetwork*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkSettingEvent_USCOREgetGateway:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkSettingEvent_USCOREgetGateway type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkSettingEvent_USCOREgetGateway*)p = *(struct __vbox__INATNetworkSettingEvent_USCOREgetGateway*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)p = *(struct __vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer*)p = *(struct __vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetCreate:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetCreate type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetCreate*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetCreate*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetIpv6:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetIpv6*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetIpv6*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetName:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetName type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetName*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetName*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetProto:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetProto type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetProto*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetProto*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetHostIp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostIp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostIp*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostIp*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetHostPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostPort*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetHostPort*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp*)q;
		break;
	case SOAP_TYPE___vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort*)p = *(struct __vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort*)q;
		break;
	case SOAP_TYPE___vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct __vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces type=%d location=%p object=%p\n", t, p, q));
		*(struct __vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)p = *(struct __vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces*)q;
		break;
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Header:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct SOAP_ENV__Header type=%d location=%p object=%p\n", t, p, q));
		*(struct SOAP_ENV__Header*)p = *(struct SOAP_ENV__Header*)q;
		break;
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Code:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct SOAP_ENV__Code type=%d location=%p object=%p\n", t, p, q));
		*(struct SOAP_ENV__Code*)p = *(struct SOAP_ENV__Code*)q;
		break;
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Reason:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct SOAP_ENV__Reason type=%d location=%p object=%p\n", t, p, q));
		*(struct SOAP_ENV__Reason*)p = *(struct SOAP_ENV__Reason*)q;
		break;
#endif
#ifndef WITH_NOGLOBAL
	case SOAP_TYPE_SOAP_ENV__Fault:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Copy struct SOAP_ENV__Fault type=%d location=%p object=%p\n", t, p, q));
		*(struct SOAP_ENV__Fault*)p = *(struct SOAP_ENV__Fault*)q;
		break;
#endif
	default:
		DBGLOG(TEST, SOAP_MESSAGE(fdebug, "Could not insert type = %d in %d\n", t, tt));
	}
}
#ifdef WIN32
#pragma warning(pop)
#endif
#endif

SOAP_FMAC3 void SOAP_FMAC4 soap_default_byte(struct soap *soap, char *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_byte
	*a = SOAP_DEFAULT_byte;
#else
	*a = (char)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_byte(struct soap *soap, const char *tag, int id, const char *a, const char *type)
{
	return soap_outbyte(soap, tag, id, a, type, SOAP_TYPE_byte);
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_in_byte(struct soap *soap, const char *tag, char *a, const char *type)
{
	a = soap_inbyte(soap, tag, a, type, SOAP_TYPE_byte);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_byte(struct soap *soap, const char *a, const char *tag, const char *type)
{
	if (soap_out_byte(soap, tag?tag:"byte", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 char * SOAP_FMAC4 soap_get_byte(struct soap *soap, char *p, const char *tag, const char *type)
{
	if ((p = soap_in_byte(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_short(struct soap *soap, short *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_short
	*a = SOAP_DEFAULT_short;
#else
	*a = (short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_short(struct soap *soap, const char *tag, int id, const short *a, const char *type)
{
	return soap_outshort(soap, tag, id, a, type, SOAP_TYPE_short);
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_in_short(struct soap *soap, const char *tag, short *a, const char *type)
{
	a = soap_inshort(soap, tag, a, type, SOAP_TYPE_short);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_short(struct soap *soap, const short *a, const char *tag, const char *type)
{
	if (soap_out_short(soap, tag?tag:"short", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 short * SOAP_FMAC4 soap_get_short(struct soap *soap, short *p, const char *tag, const char *type)
{
	if ((p = soap_in_short(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_int(struct soap *soap, int *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_int
	*a = SOAP_DEFAULT_int;
#else
	*a = (int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_int(struct soap *soap, const char *tag, int id, const int *a, const char *type)
{
	return soap_outint(soap, tag, id, a, type, SOAP_TYPE_int);
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_in_int(struct soap *soap, const char *tag, int *a, const char *type)
{
	a = soap_inint(soap, tag, a, type, SOAP_TYPE_int);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_int(struct soap *soap, const int *a, const char *tag, const char *type)
{
	if (soap_out_int(soap, tag?tag:"int", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 int * SOAP_FMAC4 soap_get_int(struct soap *soap, int *p, const char *tag, const char *type)
{
	if ((p = soap_in_int(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_LONG64(struct soap *soap, LONG64 *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_LONG64
	*a = SOAP_DEFAULT_LONG64;
#else
	*a = (LONG64)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_LONG64(struct soap *soap, const char *tag, int id, const LONG64 *a, const char *type)
{
	return soap_outLONG64(soap, tag, id, a, type, SOAP_TYPE_LONG64);
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_in_LONG64(struct soap *soap, const char *tag, LONG64 *a, const char *type)
{
	a = soap_inLONG64(soap, tag, a, type, SOAP_TYPE_LONG64);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_LONG64(struct soap *soap, const LONG64 *a, const char *tag, const char *type)
{
	if (soap_out_LONG64(soap, tag?tag:"long", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 LONG64 * SOAP_FMAC4 soap_get_LONG64(struct soap *soap, LONG64 *p, const char *tag, const char *type)
{
	if ((p = soap_in_LONG64(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedShort(struct soap *soap, unsigned short *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedShort
	*a = SOAP_DEFAULT_unsignedShort;
#else
	*a = (unsigned short)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedShort(struct soap *soap, const char *tag, int id, const unsigned short *a, const char *type)
{
	return soap_outunsignedShort(soap, tag, id, a, type, SOAP_TYPE_unsignedShort);
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_in_unsignedShort(struct soap *soap, const char *tag, unsigned short *a, const char *type)
{
	a = soap_inunsignedShort(soap, tag, a, type, SOAP_TYPE_unsignedShort);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedShort(struct soap *soap, const unsigned short *a, const char *tag, const char *type)
{
	if (soap_out_unsignedShort(soap, tag?tag:"unsignedShort", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 unsigned short * SOAP_FMAC4 soap_get_unsignedShort(struct soap *soap, unsigned short *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedShort(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_unsignedInt(struct soap *soap, unsigned int *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedInt
	*a = SOAP_DEFAULT_unsignedInt;
#else
	*a = (unsigned int)0;
#endif
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_unsignedInt(struct soap *soap, const char *tag, int id, const unsigned int *a, const char *type)
{
	return soap_outunsignedInt(soap, tag, id, a, type, SOAP_TYPE_unsignedInt);
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_in_unsignedInt(struct soap *soap, const char *tag, unsigned int *a, const char *type)
{
	a = soap_inunsignedInt(soap, tag, a, type, SOAP_TYPE_unsignedInt);
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_unsignedInt(struct soap *soap, const unsigned int *a, const char *tag, const char *type)
{
	if (soap_out_unsignedInt(soap, tag?tag:"unsignedInt", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 unsigned int * SOAP_FMAC4 soap_get_unsignedInt(struct soap *soap, unsigned int *p, const char *tag, const char *type)
{
	if ((p = soap_in_unsignedInt(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_bool(struct soap *soap, bool *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_bool
	*a = SOAP_DEFAULT_bool;
#else
	*a = (bool)0;
#endif
}

static const struct soap_code_map soap_codes_bool[] =
{	{ (LONG64)false, "false" },
	{ (LONG64)true, "true" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_bool2s(struct soap *soap, bool n)
{
	(void)soap; /* appease -Wall -Werror */
return soap_code_str(soap_codes_bool, n != 0);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_bool(struct soap *soap, const char *tag, int id, const bool *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_bool), type) || soap_send(soap, soap_bool2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2bool(struct soap *soap, const char *s, bool *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_bool, s);
	if (map)
		*a = (bool)(map->code != 0);
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || n < 0 || n > 1)
			return soap->error = SOAP_TYPE;
		*a = (bool)(n != 0);
	}
	return SOAP_OK;
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_in_bool(struct soap *soap, const char *tag, bool *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	if (*soap->type && soap_match_tag(soap, soap->type, type) && soap_match_tag(soap, soap->type, ":boolean"))
	{	soap->error = SOAP_TYPE;
		return NULL;
	}
	a = (bool *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_bool, sizeof(bool), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2bool(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (bool *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_bool, SOAP_TYPE_bool, sizeof(bool), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_bool(struct soap *soap, const bool *a, const char *tag, const char *type)
{
	if (soap_out_bool(soap, tag?tag:"boolean", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 bool * SOAP_FMAC4 soap_get_bool(struct soap *soap, bool *p, const char *tag, const char *type)
{
	if ((p = soap_in_bool(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMonitorChangedEventType
	*a = SOAP_DEFAULT_vbox__GuestMonitorChangedEventType;
#else
	*a = (enum vbox__GuestMonitorChangedEventType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestMonitorChangedEventType[] =
{	{ (LONG64)vbox__GuestMonitorChangedEventType__Enabled, "Enabled" },
	{ (LONG64)vbox__GuestMonitorChangedEventType__Disabled, "Disabled" },
	{ (LONG64)vbox__GuestMonitorChangedEventType__NewOrigin, "NewOrigin" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestMonitorChangedEventType2s(struct soap *soap, enum vbox__GuestMonitorChangedEventType n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestMonitorChangedEventType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *tag, int id, const enum vbox__GuestMonitorChangedEventType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestMonitorChangedEventType), type) || soap_send(soap, soap_vbox__GuestMonitorChangedEventType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestMonitorChangedEventType(struct soap *soap, const char *s, enum vbox__GuestMonitorChangedEventType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestMonitorChangedEventType, s);
	if (map)
		*a = (enum vbox__GuestMonitorChangedEventType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestMonitorChangedEventType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestMonitorChangedEventType * SOAP_FMAC4 soap_in_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *tag, enum vbox__GuestMonitorChangedEventType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestMonitorChangedEventType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestMonitorChangedEventType, sizeof(enum vbox__GuestMonitorChangedEventType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestMonitorChangedEventType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestMonitorChangedEventType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestMonitorChangedEventType, SOAP_TYPE_vbox__GuestMonitorChangedEventType, sizeof(enum vbox__GuestMonitorChangedEventType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestMonitorChangedEventType(struct soap *soap, const enum vbox__GuestMonitorChangedEventType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestMonitorChangedEventType(soap, tag?tag:"vbox:GuestMonitorChangedEventType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestMonitorChangedEventType * SOAP_FMAC4 soap_get_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestMonitorChangedEventType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMouseEventMode
	*a = SOAP_DEFAULT_vbox__GuestMouseEventMode;
#else
	*a = (enum vbox__GuestMouseEventMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestMouseEventMode[] =
{	{ (LONG64)vbox__GuestMouseEventMode__Relative, "Relative" },
	{ (LONG64)vbox__GuestMouseEventMode__Absolute, "Absolute" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestMouseEventMode2s(struct soap *soap, enum vbox__GuestMouseEventMode n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestMouseEventMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestMouseEventMode(struct soap *soap, const char *tag, int id, const enum vbox__GuestMouseEventMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestMouseEventMode), type) || soap_send(soap, soap_vbox__GuestMouseEventMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestMouseEventMode(struct soap *soap, const char *s, enum vbox__GuestMouseEventMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestMouseEventMode, s);
	if (map)
		*a = (enum vbox__GuestMouseEventMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestMouseEventMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestMouseEventMode * SOAP_FMAC4 soap_in_vbox__GuestMouseEventMode(struct soap *soap, const char *tag, enum vbox__GuestMouseEventMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestMouseEventMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestMouseEventMode, sizeof(enum vbox__GuestMouseEventMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestMouseEventMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestMouseEventMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestMouseEventMode, SOAP_TYPE_vbox__GuestMouseEventMode, sizeof(enum vbox__GuestMouseEventMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestMouseEventMode(struct soap *soap, const enum vbox__GuestMouseEventMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestMouseEventMode(soap, tag?tag:"vbox:GuestMouseEventMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestMouseEventMode * SOAP_FMAC4 soap_get_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestMouseEventMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VBoxEventType
	*a = SOAP_DEFAULT_vbox__VBoxEventType;
#else
	*a = (enum vbox__VBoxEventType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__VBoxEventType[] =
{	{ (LONG64)vbox__VBoxEventType__Invalid, "Invalid" },
	{ (LONG64)vbox__VBoxEventType__Any, "Any" },
	{ (LONG64)vbox__VBoxEventType__Vetoable, "Vetoable" },
	{ (LONG64)vbox__VBoxEventType__MachineEvent, "MachineEvent" },
	{ (LONG64)vbox__VBoxEventType__SnapshotEvent, "SnapshotEvent" },
	{ (LONG64)vbox__VBoxEventType__InputEvent, "InputEvent" },
	{ (LONG64)vbox__VBoxEventType__LastWildcard, "LastWildcard" },
	{ (LONG64)vbox__VBoxEventType__OnMachineStateChanged, "OnMachineStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnMachineDataChanged, "OnMachineDataChanged" },
	{ (LONG64)vbox__VBoxEventType__OnExtraDataChanged, "OnExtraDataChanged" },
	{ (LONG64)vbox__VBoxEventType__OnExtraDataCanChange, "OnExtraDataCanChange" },
	{ (LONG64)vbox__VBoxEventType__OnMediumRegistered, "OnMediumRegistered" },
	{ (LONG64)vbox__VBoxEventType__OnMachineRegistered, "OnMachineRegistered" },
	{ (LONG64)vbox__VBoxEventType__OnSessionStateChanged, "OnSessionStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnSnapshotTaken, "OnSnapshotTaken" },
	{ (LONG64)vbox__VBoxEventType__OnSnapshotDeleted, "OnSnapshotDeleted" },
	{ (LONG64)vbox__VBoxEventType__OnSnapshotChanged, "OnSnapshotChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestPropertyChanged, "OnGuestPropertyChanged" },
	{ (LONG64)vbox__VBoxEventType__OnMousePointerShapeChanged, "OnMousePointerShapeChanged" },
	{ (LONG64)vbox__VBoxEventType__OnMouseCapabilityChanged, "OnMouseCapabilityChanged" },
	{ (LONG64)vbox__VBoxEventType__OnKeyboardLedsChanged, "OnKeyboardLedsChanged" },
	{ (LONG64)vbox__VBoxEventType__OnStateChanged, "OnStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnAdditionsStateChanged, "OnAdditionsStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnNetworkAdapterChanged, "OnNetworkAdapterChanged" },
	{ (LONG64)vbox__VBoxEventType__OnSerialPortChanged, "OnSerialPortChanged" },
	{ (LONG64)vbox__VBoxEventType__OnParallelPortChanged, "OnParallelPortChanged" },
	{ (LONG64)vbox__VBoxEventType__OnStorageControllerChanged, "OnStorageControllerChanged" },
	{ (LONG64)vbox__VBoxEventType__OnMediumChanged, "OnMediumChanged" },
	{ (LONG64)vbox__VBoxEventType__OnVRDEServerChanged, "OnVRDEServerChanged" },
	{ (LONG64)vbox__VBoxEventType__OnUSBControllerChanged, "OnUSBControllerChanged" },
	{ (LONG64)vbox__VBoxEventType__OnUSBDeviceStateChanged, "OnUSBDeviceStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnSharedFolderChanged, "OnSharedFolderChanged" },
	{ (LONG64)vbox__VBoxEventType__OnRuntimeError, "OnRuntimeError" },
	{ (LONG64)vbox__VBoxEventType__OnCanShowWindow, "OnCanShowWindow" },
	{ (LONG64)vbox__VBoxEventType__OnShowWindow, "OnShowWindow" },
	{ (LONG64)vbox__VBoxEventType__OnCPUChanged, "OnCPUChanged" },
	{ (LONG64)vbox__VBoxEventType__OnVRDEServerInfoChanged, "OnVRDEServerInfoChanged" },
	{ (LONG64)vbox__VBoxEventType__OnEventSourceChanged, "OnEventSourceChanged" },
	{ (LONG64)vbox__VBoxEventType__OnCPUExecutionCapChanged, "OnCPUExecutionCapChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestKeyboard, "OnGuestKeyboard" },
	{ (LONG64)vbox__VBoxEventType__OnGuestMouse, "OnGuestMouse" },
	{ (LONG64)vbox__VBoxEventType__OnNATRedirect, "OnNATRedirect" },
	{ (LONG64)vbox__VBoxEventType__OnHostPCIDevicePlug, "OnHostPCIDevicePlug" },
	{ (LONG64)vbox__VBoxEventType__OnVBoxSVCAvailabilityChanged, "OnVBoxSVCAvailabilityChanged" },
	{ (LONG64)vbox__VBoxEventType__OnBandwidthGroupChanged, "OnBandwidthGroupChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestMonitorChanged, "OnGuestMonitorChanged" },
	{ (LONG64)vbox__VBoxEventType__OnStorageDeviceChanged, "OnStorageDeviceChanged" },
	{ (LONG64)vbox__VBoxEventType__OnClipboardModeChanged, "OnClipboardModeChanged" },
	{ (LONG64)vbox__VBoxEventType__OnDnDModeChanged, "OnDnDModeChanged" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkChanged, "OnNATNetworkChanged" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkStartStop, "OnNATNetworkStartStop" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkAlter, "OnNATNetworkAlter" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkCreationDeletion, "OnNATNetworkCreationDeletion" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkSetting, "OnNATNetworkSetting" },
	{ (LONG64)vbox__VBoxEventType__OnNATNetworkPortForward, "OnNATNetworkPortForward" },
	{ (LONG64)vbox__VBoxEventType__OnGuestSessionStateChanged, "OnGuestSessionStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestSessionRegistered, "OnGuestSessionRegistered" },
	{ (LONG64)vbox__VBoxEventType__OnGuestProcessRegistered, "OnGuestProcessRegistered" },
	{ (LONG64)vbox__VBoxEventType__OnGuestProcessStateChanged, "OnGuestProcessStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestProcessInputNotify, "OnGuestProcessInputNotify" },
	{ (LONG64)vbox__VBoxEventType__OnGuestProcessOutput, "OnGuestProcessOutput" },
	{ (LONG64)vbox__VBoxEventType__OnGuestFileRegistered, "OnGuestFileRegistered" },
	{ (LONG64)vbox__VBoxEventType__OnGuestFileStateChanged, "OnGuestFileStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestFileOffsetChanged, "OnGuestFileOffsetChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestFileRead, "OnGuestFileRead" },
	{ (LONG64)vbox__VBoxEventType__OnGuestFileWrite, "OnGuestFileWrite" },
	{ (LONG64)vbox__VBoxEventType__OnVideoCaptureChanged, "OnVideoCaptureChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestUserStateChanged, "OnGuestUserStateChanged" },
	{ (LONG64)vbox__VBoxEventType__OnGuestMultiTouch, "OnGuestMultiTouch" },
	{ (LONG64)vbox__VBoxEventType__OnHostNameResolutionConfigurationChange, "OnHostNameResolutionConfigurationChange" },
	{ (LONG64)vbox__VBoxEventType__OnSnapshotRestored, "OnSnapshotRestored" },
	{ (LONG64)vbox__VBoxEventType__OnMediumConfigChanged, "OnMediumConfigChanged" },
	{ (LONG64)vbox__VBoxEventType__Last, "Last" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VBoxEventType2s(struct soap *soap, enum vbox__VBoxEventType n)
{	const char *s = soap_code_str(soap_codes_vbox__VBoxEventType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VBoxEventType(struct soap *soap, const char *tag, int id, const enum vbox__VBoxEventType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VBoxEventType), type) || soap_send(soap, soap_vbox__VBoxEventType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VBoxEventType(struct soap *soap, const char *s, enum vbox__VBoxEventType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VBoxEventType, s);
	if (map)
		*a = (enum vbox__VBoxEventType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 72)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VBoxEventType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VBoxEventType * SOAP_FMAC4 soap_in_vbox__VBoxEventType(struct soap *soap, const char *tag, enum vbox__VBoxEventType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VBoxEventType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VBoxEventType, sizeof(enum vbox__VBoxEventType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__VBoxEventType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VBoxEventType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VBoxEventType, SOAP_TYPE_vbox__VBoxEventType, sizeof(enum vbox__VBoxEventType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VBoxEventType(struct soap *soap, const enum vbox__VBoxEventType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__VBoxEventType(soap, tag?tag:"vbox:VBoxEventType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__VBoxEventType * SOAP_FMAC4 soap_get_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VBoxEventType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BandwidthGroupType
	*a = SOAP_DEFAULT_vbox__BandwidthGroupType;
#else
	*a = (enum vbox__BandwidthGroupType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__BandwidthGroupType[] =
{	{ (LONG64)vbox__BandwidthGroupType__Null, "Null" },
	{ (LONG64)vbox__BandwidthGroupType__Disk, "Disk" },
	{ (LONG64)vbox__BandwidthGroupType__Network, "Network" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__BandwidthGroupType2s(struct soap *soap, enum vbox__BandwidthGroupType n)
{	const char *s = soap_code_str(soap_codes_vbox__BandwidthGroupType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__BandwidthGroupType(struct soap *soap, const char *tag, int id, const enum vbox__BandwidthGroupType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__BandwidthGroupType), type) || soap_send(soap, soap_vbox__BandwidthGroupType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__BandwidthGroupType(struct soap *soap, const char *s, enum vbox__BandwidthGroupType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__BandwidthGroupType, s);
	if (map)
		*a = (enum vbox__BandwidthGroupType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__BandwidthGroupType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__BandwidthGroupType * SOAP_FMAC4 soap_in_vbox__BandwidthGroupType(struct soap *soap, const char *tag, enum vbox__BandwidthGroupType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__BandwidthGroupType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__BandwidthGroupType, sizeof(enum vbox__BandwidthGroupType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__BandwidthGroupType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__BandwidthGroupType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__BandwidthGroupType, SOAP_TYPE_vbox__BandwidthGroupType, sizeof(enum vbox__BandwidthGroupType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__BandwidthGroupType(struct soap *soap, const enum vbox__BandwidthGroupType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__BandwidthGroupType(soap, tag?tag:"vbox:BandwidthGroupType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__BandwidthGroupType * SOAP_FMAC4 soap_get_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__BandwidthGroupType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NATProtocol
	*a = SOAP_DEFAULT_vbox__NATProtocol;
#else
	*a = (enum vbox__NATProtocol)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__NATProtocol[] =
{	{ (LONG64)vbox__NATProtocol__UDP, "UDP" },
	{ (LONG64)vbox__NATProtocol__TCP, "TCP" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NATProtocol2s(struct soap *soap, enum vbox__NATProtocol n)
{	const char *s = soap_code_str(soap_codes_vbox__NATProtocol, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NATProtocol(struct soap *soap, const char *tag, int id, const enum vbox__NATProtocol *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NATProtocol), type) || soap_send(soap, soap_vbox__NATProtocol2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NATProtocol(struct soap *soap, const char *s, enum vbox__NATProtocol *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NATProtocol, s);
	if (map)
		*a = (enum vbox__NATProtocol)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NATProtocol)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NATProtocol * SOAP_FMAC4 soap_in_vbox__NATProtocol(struct soap *soap, const char *tag, enum vbox__NATProtocol *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NATProtocol *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NATProtocol, sizeof(enum vbox__NATProtocol), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__NATProtocol(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NATProtocol *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NATProtocol, SOAP_TYPE_vbox__NATProtocol, sizeof(enum vbox__NATProtocol), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NATProtocol(struct soap *soap, const enum vbox__NATProtocol *a, const char *tag, const char *type)
{
	if (soap_out_vbox__NATProtocol(soap, tag?tag:"vbox:NATProtocol", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__NATProtocol * SOAP_FMAC4 soap_get_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NATProtocol(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NATAliasMode
	*a = SOAP_DEFAULT_vbox__NATAliasMode;
#else
	*a = (enum vbox__NATAliasMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__NATAliasMode[] =
{	{ (LONG64)vbox__NATAliasMode__AliasLog, "AliasLog" },
	{ (LONG64)vbox__NATAliasMode__AliasProxyOnly, "AliasProxyOnly" },
	{ (LONG64)vbox__NATAliasMode__AliasUseSamePorts, "AliasUseSamePorts" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NATAliasMode2s(struct soap *soap, enum vbox__NATAliasMode n)
{	const char *s = soap_code_str(soap_codes_vbox__NATAliasMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NATAliasMode(struct soap *soap, const char *tag, int id, const enum vbox__NATAliasMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NATAliasMode), type) || soap_send(soap, soap_vbox__NATAliasMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NATAliasMode(struct soap *soap, const char *s, enum vbox__NATAliasMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NATAliasMode, s);
	if (map)
		*a = (enum vbox__NATAliasMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NATAliasMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NATAliasMode * SOAP_FMAC4 soap_in_vbox__NATAliasMode(struct soap *soap, const char *tag, enum vbox__NATAliasMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NATAliasMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NATAliasMode, sizeof(enum vbox__NATAliasMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__NATAliasMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NATAliasMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NATAliasMode, SOAP_TYPE_vbox__NATAliasMode, sizeof(enum vbox__NATAliasMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NATAliasMode(struct soap *soap, const enum vbox__NATAliasMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__NATAliasMode(soap, tag?tag:"vbox:NATAliasMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__NATAliasMode * SOAP_FMAC4 soap_get_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NATAliasMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ChipsetType
	*a = SOAP_DEFAULT_vbox__ChipsetType;
#else
	*a = (enum vbox__ChipsetType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ChipsetType[] =
{	{ (LONG64)vbox__ChipsetType__Null, "Null" },
	{ (LONG64)vbox__ChipsetType__PIIX3, "PIIX3" },
	{ (LONG64)vbox__ChipsetType__ICH9, "ICH9" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ChipsetType2s(struct soap *soap, enum vbox__ChipsetType n)
{	const char *s = soap_code_str(soap_codes_vbox__ChipsetType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ChipsetType(struct soap *soap, const char *tag, int id, const enum vbox__ChipsetType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ChipsetType), type) || soap_send(soap, soap_vbox__ChipsetType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ChipsetType(struct soap *soap, const char *s, enum vbox__ChipsetType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ChipsetType, s);
	if (map)
		*a = (enum vbox__ChipsetType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ChipsetType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ChipsetType * SOAP_FMAC4 soap_in_vbox__ChipsetType(struct soap *soap, const char *tag, enum vbox__ChipsetType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ChipsetType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ChipsetType, sizeof(enum vbox__ChipsetType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ChipsetType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ChipsetType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ChipsetType, SOAP_TYPE_vbox__ChipsetType, sizeof(enum vbox__ChipsetType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ChipsetType(struct soap *soap, const enum vbox__ChipsetType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ChipsetType(soap, tag?tag:"vbox:ChipsetType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ChipsetType * SOAP_FMAC4 soap_get_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ChipsetType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageControllerType
	*a = SOAP_DEFAULT_vbox__StorageControllerType;
#else
	*a = (enum vbox__StorageControllerType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__StorageControllerType[] =
{	{ (LONG64)vbox__StorageControllerType__Null, "Null" },
	{ (LONG64)vbox__StorageControllerType__LsiLogic, "LsiLogic" },
	{ (LONG64)vbox__StorageControllerType__BusLogic, "BusLogic" },
	{ (LONG64)vbox__StorageControllerType__IntelAhci, "IntelAhci" },
	{ (LONG64)vbox__StorageControllerType__PIIX3, "PIIX3" },
	{ (LONG64)vbox__StorageControllerType__PIIX4, "PIIX4" },
	{ (LONG64)vbox__StorageControllerType__ICH6, "ICH6" },
	{ (LONG64)vbox__StorageControllerType__I82078, "I82078" },
	{ (LONG64)vbox__StorageControllerType__LsiLogicSas, "LsiLogicSas" },
	{ (LONG64)vbox__StorageControllerType__USB, "USB" },
	{ (LONG64)vbox__StorageControllerType__NVMe, "NVMe" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageControllerType2s(struct soap *soap, enum vbox__StorageControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageControllerType(struct soap *soap, const char *tag, int id, const enum vbox__StorageControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageControllerType), type) || soap_send(soap, soap_vbox__StorageControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageControllerType(struct soap *soap, const char *s, enum vbox__StorageControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__StorageControllerType, s);
	if (map)
		*a = (enum vbox__StorageControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 10)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_in_vbox__StorageControllerType(struct soap *soap, const char *tag, enum vbox__StorageControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageControllerType, sizeof(enum vbox__StorageControllerType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__StorageControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageControllerType, SOAP_TYPE_vbox__StorageControllerType, sizeof(enum vbox__StorageControllerType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageControllerType(struct soap *soap, const enum vbox__StorageControllerType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__StorageControllerType(soap, tag?tag:"vbox:StorageControllerType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__StorageControllerType * SOAP_FMAC4 soap_get_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageBus
	*a = SOAP_DEFAULT_vbox__StorageBus;
#else
	*a = (enum vbox__StorageBus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__StorageBus[] =
{	{ (LONG64)vbox__StorageBus__Null, "Null" },
	{ (LONG64)vbox__StorageBus__IDE, "IDE" },
	{ (LONG64)vbox__StorageBus__SATA, "SATA" },
	{ (LONG64)vbox__StorageBus__SCSI, "SCSI" },
	{ (LONG64)vbox__StorageBus__Floppy, "Floppy" },
	{ (LONG64)vbox__StorageBus__SAS, "SAS" },
	{ (LONG64)vbox__StorageBus__USB, "USB" },
	{ (LONG64)vbox__StorageBus__PCIe, "PCIe" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__StorageBus2s(struct soap *soap, enum vbox__StorageBus n)
{	const char *s = soap_code_str(soap_codes_vbox__StorageBus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__StorageBus(struct soap *soap, const char *tag, int id, const enum vbox__StorageBus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__StorageBus), type) || soap_send(soap, soap_vbox__StorageBus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__StorageBus(struct soap *soap, const char *s, enum vbox__StorageBus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__StorageBus, s);
	if (map)
		*a = (enum vbox__StorageBus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__StorageBus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_in_vbox__StorageBus(struct soap *soap, const char *tag, enum vbox__StorageBus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__StorageBus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__StorageBus, sizeof(enum vbox__StorageBus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__StorageBus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__StorageBus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__StorageBus, SOAP_TYPE_vbox__StorageBus, sizeof(enum vbox__StorageBus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__StorageBus(struct soap *soap, const enum vbox__StorageBus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__StorageBus(soap, tag?tag:"vbox:StorageBus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__StorageBus * SOAP_FMAC4 soap_get_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__StorageBus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__Reason(struct soap *soap, enum vbox__Reason *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Reason
	*a = SOAP_DEFAULT_vbox__Reason;
#else
	*a = (enum vbox__Reason)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__Reason[] =
{	{ (LONG64)vbox__Reason__Unspecified, "Unspecified" },
	{ (LONG64)vbox__Reason__HostSuspend, "HostSuspend" },
	{ (LONG64)vbox__Reason__HostResume, "HostResume" },
	{ (LONG64)vbox__Reason__HostBatteryLow, "HostBatteryLow" },
	{ (LONG64)vbox__Reason__Snapshot, "Snapshot" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__Reason2s(struct soap *soap, enum vbox__Reason n)
{	const char *s = soap_code_str(soap_codes_vbox__Reason, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__Reason(struct soap *soap, const char *tag, int id, const enum vbox__Reason *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__Reason), type) || soap_send(soap, soap_vbox__Reason2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__Reason(struct soap *soap, const char *s, enum vbox__Reason *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__Reason, s);
	if (map)
		*a = (enum vbox__Reason)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__Reason)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__Reason * SOAP_FMAC4 soap_in_vbox__Reason(struct soap *soap, const char *tag, enum vbox__Reason *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__Reason *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__Reason, sizeof(enum vbox__Reason), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__Reason(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__Reason *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__Reason, SOAP_TYPE_vbox__Reason, sizeof(enum vbox__Reason), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__Reason(struct soap *soap, const enum vbox__Reason *a, const char *tag, const char *type)
{
	if (soap_out_vbox__Reason(soap, tag?tag:"vbox:Reason", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__Reason * SOAP_FMAC4 soap_get_vbox__Reason(struct soap *soap, enum vbox__Reason *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__Reason(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AuthType(struct soap *soap, enum vbox__AuthType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AuthType
	*a = SOAP_DEFAULT_vbox__AuthType;
#else
	*a = (enum vbox__AuthType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AuthType[] =
{	{ (LONG64)vbox__AuthType__Null, "Null" },
	{ (LONG64)vbox__AuthType__External, "External" },
	{ (LONG64)vbox__AuthType__Guest, "Guest" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AuthType2s(struct soap *soap, enum vbox__AuthType n)
{	const char *s = soap_code_str(soap_codes_vbox__AuthType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AuthType(struct soap *soap, const char *tag, int id, const enum vbox__AuthType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AuthType), type) || soap_send(soap, soap_vbox__AuthType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AuthType(struct soap *soap, const char *s, enum vbox__AuthType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AuthType, s);
	if (map)
		*a = (enum vbox__AuthType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AuthType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AuthType * SOAP_FMAC4 soap_in_vbox__AuthType(struct soap *soap, const char *tag, enum vbox__AuthType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AuthType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AuthType, sizeof(enum vbox__AuthType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AuthType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AuthType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AuthType, SOAP_TYPE_vbox__AuthType, sizeof(enum vbox__AuthType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AuthType(struct soap *soap, const enum vbox__AuthType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AuthType(soap, tag?tag:"vbox:AuthType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AuthType * SOAP_FMAC4 soap_get_vbox__AuthType(struct soap *soap, enum vbox__AuthType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AuthType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioCodecType
	*a = SOAP_DEFAULT_vbox__AudioCodecType;
#else
	*a = (enum vbox__AudioCodecType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AudioCodecType[] =
{	{ (LONG64)vbox__AudioCodecType__Null, "Null" },
	{ (LONG64)vbox__AudioCodecType__SB16, "SB16" },
	{ (LONG64)vbox__AudioCodecType__STAC9700, "STAC9700" },
	{ (LONG64)vbox__AudioCodecType__AD1980, "AD1980" },
	{ (LONG64)vbox__AudioCodecType__STAC9221, "STAC9221" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioCodecType2s(struct soap *soap, enum vbox__AudioCodecType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioCodecType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioCodecType(struct soap *soap, const char *tag, int id, const enum vbox__AudioCodecType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioCodecType), type) || soap_send(soap, soap_vbox__AudioCodecType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioCodecType(struct soap *soap, const char *s, enum vbox__AudioCodecType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AudioCodecType, s);
	if (map)
		*a = (enum vbox__AudioCodecType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioCodecType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioCodecType * SOAP_FMAC4 soap_in_vbox__AudioCodecType(struct soap *soap, const char *tag, enum vbox__AudioCodecType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioCodecType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioCodecType, sizeof(enum vbox__AudioCodecType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AudioCodecType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioCodecType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioCodecType, SOAP_TYPE_vbox__AudioCodecType, sizeof(enum vbox__AudioCodecType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioCodecType(struct soap *soap, const enum vbox__AudioCodecType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AudioCodecType(soap, tag?tag:"vbox:AudioCodecType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AudioCodecType * SOAP_FMAC4 soap_get_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioCodecType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioControllerType
	*a = SOAP_DEFAULT_vbox__AudioControllerType;
#else
	*a = (enum vbox__AudioControllerType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AudioControllerType[] =
{	{ (LONG64)vbox__AudioControllerType__AC97, "AC97" },
	{ (LONG64)vbox__AudioControllerType__SB16, "SB16" },
	{ (LONG64)vbox__AudioControllerType__HDA, "HDA" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioControllerType2s(struct soap *soap, enum vbox__AudioControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioControllerType(struct soap *soap, const char *tag, int id, const enum vbox__AudioControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioControllerType), type) || soap_send(soap, soap_vbox__AudioControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioControllerType(struct soap *soap, const char *s, enum vbox__AudioControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AudioControllerType, s);
	if (map)
		*a = (enum vbox__AudioControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_in_vbox__AudioControllerType(struct soap *soap, const char *tag, enum vbox__AudioControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioControllerType, sizeof(enum vbox__AudioControllerType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AudioControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioControllerType, SOAP_TYPE_vbox__AudioControllerType, sizeof(enum vbox__AudioControllerType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioControllerType(struct soap *soap, const enum vbox__AudioControllerType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AudioControllerType(soap, tag?tag:"vbox:AudioControllerType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AudioControllerType * SOAP_FMAC4 soap_get_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDriverType
	*a = SOAP_DEFAULT_vbox__AudioDriverType;
#else
	*a = (enum vbox__AudioDriverType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AudioDriverType[] =
{	{ (LONG64)vbox__AudioDriverType__Null, "Null" },
	{ (LONG64)vbox__AudioDriverType__WinMM, "WinMM" },
	{ (LONG64)vbox__AudioDriverType__OSS, "OSS" },
	{ (LONG64)vbox__AudioDriverType__ALSA, "ALSA" },
	{ (LONG64)vbox__AudioDriverType__DirectSound, "DirectSound" },
	{ (LONG64)vbox__AudioDriverType__CoreAudio, "CoreAudio" },
	{ (LONG64)vbox__AudioDriverType__MMPM, "MMPM" },
	{ (LONG64)vbox__AudioDriverType__Pulse, "Pulse" },
	{ (LONG64)vbox__AudioDriverType__SolAudio, "SolAudio" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AudioDriverType2s(struct soap *soap, enum vbox__AudioDriverType n)
{	const char *s = soap_code_str(soap_codes_vbox__AudioDriverType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AudioDriverType(struct soap *soap, const char *tag, int id, const enum vbox__AudioDriverType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AudioDriverType), type) || soap_send(soap, soap_vbox__AudioDriverType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AudioDriverType(struct soap *soap, const char *s, enum vbox__AudioDriverType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AudioDriverType, s);
	if (map)
		*a = (enum vbox__AudioDriverType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AudioDriverType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_in_vbox__AudioDriverType(struct soap *soap, const char *tag, enum vbox__AudioDriverType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AudioDriverType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AudioDriverType, sizeof(enum vbox__AudioDriverType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AudioDriverType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AudioDriverType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AudioDriverType, SOAP_TYPE_vbox__AudioDriverType, sizeof(enum vbox__AudioDriverType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AudioDriverType(struct soap *soap, const enum vbox__AudioDriverType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AudioDriverType(soap, tag?tag:"vbox:AudioDriverType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AudioDriverType * SOAP_FMAC4 soap_get_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AudioDriverType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceFilterAction
	*a = SOAP_DEFAULT_vbox__USBDeviceFilterAction;
#else
	*a = (enum vbox__USBDeviceFilterAction)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__USBDeviceFilterAction[] =
{	{ (LONG64)vbox__USBDeviceFilterAction__Null, "Null" },
	{ (LONG64)vbox__USBDeviceFilterAction__Ignore, "Ignore" },
	{ (LONG64)vbox__USBDeviceFilterAction__Hold, "Hold" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceFilterAction2s(struct soap *soap, enum vbox__USBDeviceFilterAction n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceFilterAction, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceFilterAction *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceFilterAction), type) || soap_send(soap, soap_vbox__USBDeviceFilterAction2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceFilterAction(struct soap *soap, const char *s, enum vbox__USBDeviceFilterAction *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBDeviceFilterAction, s);
	if (map)
		*a = (enum vbox__USBDeviceFilterAction)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceFilterAction)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_in_vbox__USBDeviceFilterAction(struct soap *soap, const char *tag, enum vbox__USBDeviceFilterAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceFilterAction *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceFilterAction, sizeof(enum vbox__USBDeviceFilterAction), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__USBDeviceFilterAction(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceFilterAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceFilterAction, SOAP_TYPE_vbox__USBDeviceFilterAction, sizeof(enum vbox__USBDeviceFilterAction), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceFilterAction(struct soap *soap, const enum vbox__USBDeviceFilterAction *a, const char *tag, const char *type)
{
	if (soap_out_vbox__USBDeviceFilterAction(soap, tag?tag:"vbox:USBDeviceFilterAction", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__USBDeviceFilterAction * SOAP_FMAC4 soap_get_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceFilterAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceState
	*a = SOAP_DEFAULT_vbox__USBDeviceState;
#else
	*a = (enum vbox__USBDeviceState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__USBDeviceState[] =
{	{ (LONG64)vbox__USBDeviceState__NotSupported, "NotSupported" },
	{ (LONG64)vbox__USBDeviceState__Unavailable, "Unavailable" },
	{ (LONG64)vbox__USBDeviceState__Busy, "Busy" },
	{ (LONG64)vbox__USBDeviceState__Available, "Available" },
	{ (LONG64)vbox__USBDeviceState__Held, "Held" },
	{ (LONG64)vbox__USBDeviceState__Captured, "Captured" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBDeviceState2s(struct soap *soap, enum vbox__USBDeviceState n)
{	const char *s = soap_code_str(soap_codes_vbox__USBDeviceState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBDeviceState(struct soap *soap, const char *tag, int id, const enum vbox__USBDeviceState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBDeviceState), type) || soap_send(soap, soap_vbox__USBDeviceState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBDeviceState(struct soap *soap, const char *s, enum vbox__USBDeviceState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBDeviceState, s);
	if (map)
		*a = (enum vbox__USBDeviceState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBDeviceState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_in_vbox__USBDeviceState(struct soap *soap, const char *tag, enum vbox__USBDeviceState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBDeviceState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBDeviceState, sizeof(enum vbox__USBDeviceState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__USBDeviceState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBDeviceState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBDeviceState, SOAP_TYPE_vbox__USBDeviceState, sizeof(enum vbox__USBDeviceState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBDeviceState(struct soap *soap, const enum vbox__USBDeviceState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__USBDeviceState(soap, tag?tag:"vbox:USBDeviceState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__USBDeviceState * SOAP_FMAC4 soap_get_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBDeviceState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBConnectionSpeed
	*a = SOAP_DEFAULT_vbox__USBConnectionSpeed;
#else
	*a = (enum vbox__USBConnectionSpeed)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__USBConnectionSpeed[] =
{	{ (LONG64)vbox__USBConnectionSpeed__Null, "Null" },
	{ (LONG64)vbox__USBConnectionSpeed__Low, "Low" },
	{ (LONG64)vbox__USBConnectionSpeed__Full, "Full" },
	{ (LONG64)vbox__USBConnectionSpeed__High, "High" },
	{ (LONG64)vbox__USBConnectionSpeed__Super, "Super" },
	{ (LONG64)vbox__USBConnectionSpeed__SuperPlus, "SuperPlus" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBConnectionSpeed2s(struct soap *soap, enum vbox__USBConnectionSpeed n)
{	const char *s = soap_code_str(soap_codes_vbox__USBConnectionSpeed, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBConnectionSpeed(struct soap *soap, const char *tag, int id, const enum vbox__USBConnectionSpeed *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBConnectionSpeed), type) || soap_send(soap, soap_vbox__USBConnectionSpeed2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBConnectionSpeed(struct soap *soap, const char *s, enum vbox__USBConnectionSpeed *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBConnectionSpeed, s);
	if (map)
		*a = (enum vbox__USBConnectionSpeed)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBConnectionSpeed)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBConnectionSpeed * SOAP_FMAC4 soap_in_vbox__USBConnectionSpeed(struct soap *soap, const char *tag, enum vbox__USBConnectionSpeed *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBConnectionSpeed *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBConnectionSpeed, sizeof(enum vbox__USBConnectionSpeed), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__USBConnectionSpeed(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBConnectionSpeed *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBConnectionSpeed, SOAP_TYPE_vbox__USBConnectionSpeed, sizeof(enum vbox__USBConnectionSpeed), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBConnectionSpeed(struct soap *soap, const enum vbox__USBConnectionSpeed *a, const char *tag, const char *type)
{
	if (soap_out_vbox__USBConnectionSpeed(soap, tag?tag:"vbox:USBConnectionSpeed", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__USBConnectionSpeed * SOAP_FMAC4 soap_get_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBConnectionSpeed(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBControllerType
	*a = SOAP_DEFAULT_vbox__USBControllerType;
#else
	*a = (enum vbox__USBControllerType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__USBControllerType[] =
{	{ (LONG64)vbox__USBControllerType__Null, "Null" },
	{ (LONG64)vbox__USBControllerType__OHCI, "OHCI" },
	{ (LONG64)vbox__USBControllerType__EHCI, "EHCI" },
	{ (LONG64)vbox__USBControllerType__XHCI, "XHCI" },
	{ (LONG64)vbox__USBControllerType__Last, "Last" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__USBControllerType2s(struct soap *soap, enum vbox__USBControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__USBControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__USBControllerType(struct soap *soap, const char *tag, int id, const enum vbox__USBControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__USBControllerType), type) || soap_send(soap, soap_vbox__USBControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__USBControllerType(struct soap *soap, const char *s, enum vbox__USBControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__USBControllerType, s);
	if (map)
		*a = (enum vbox__USBControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__USBControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__USBControllerType * SOAP_FMAC4 soap_in_vbox__USBControllerType(struct soap *soap, const char *tag, enum vbox__USBControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__USBControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__USBControllerType, sizeof(enum vbox__USBControllerType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__USBControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__USBControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__USBControllerType, SOAP_TYPE_vbox__USBControllerType, sizeof(enum vbox__USBControllerType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__USBControllerType(struct soap *soap, const enum vbox__USBControllerType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__USBControllerType(soap, tag?tag:"vbox:USBControllerType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__USBControllerType * SOAP_FMAC4 soap_get_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__USBControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__PortMode(struct soap *soap, enum vbox__PortMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PortMode
	*a = SOAP_DEFAULT_vbox__PortMode;
#else
	*a = (enum vbox__PortMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__PortMode[] =
{	{ (LONG64)vbox__PortMode__Disconnected, "Disconnected" },
	{ (LONG64)vbox__PortMode__HostPipe, "HostPipe" },
	{ (LONG64)vbox__PortMode__HostDevice, "HostDevice" },
	{ (LONG64)vbox__PortMode__RawFile, "RawFile" },
	{ (LONG64)vbox__PortMode__TCP, "TCP" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__PortMode2s(struct soap *soap, enum vbox__PortMode n)
{	const char *s = soap_code_str(soap_codes_vbox__PortMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__PortMode(struct soap *soap, const char *tag, int id, const enum vbox__PortMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__PortMode), type) || soap_send(soap, soap_vbox__PortMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__PortMode(struct soap *soap, const char *s, enum vbox__PortMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__PortMode, s);
	if (map)
		*a = (enum vbox__PortMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__PortMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_in_vbox__PortMode(struct soap *soap, const char *tag, enum vbox__PortMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__PortMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__PortMode, sizeof(enum vbox__PortMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__PortMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__PortMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__PortMode, SOAP_TYPE_vbox__PortMode, sizeof(enum vbox__PortMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__PortMode(struct soap *soap, const enum vbox__PortMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__PortMode(soap, tag?tag:"vbox:PortMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__PortMode * SOAP_FMAC4 soap_get_vbox__PortMode(struct soap *soap, enum vbox__PortMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__PortMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterPromiscModePolicy
	*a = SOAP_DEFAULT_vbox__NetworkAdapterPromiscModePolicy;
#else
	*a = (enum vbox__NetworkAdapterPromiscModePolicy)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__NetworkAdapterPromiscModePolicy[] =
{	{ (LONG64)vbox__NetworkAdapterPromiscModePolicy__Deny, "Deny" },
	{ (LONG64)vbox__NetworkAdapterPromiscModePolicy__AllowNetwork, "AllowNetwork" },
	{ (LONG64)vbox__NetworkAdapterPromiscModePolicy__AllowAll, "AllowAll" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAdapterPromiscModePolicy2s(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAdapterPromiscModePolicy, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAdapterPromiscModePolicy *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAdapterPromiscModePolicy), type) || soap_send(soap, soap_vbox__NetworkAdapterPromiscModePolicy2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *s, enum vbox__NetworkAdapterPromiscModePolicy *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NetworkAdapterPromiscModePolicy, s);
	if (map)
		*a = (enum vbox__NetworkAdapterPromiscModePolicy)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAdapterPromiscModePolicy)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAdapterPromiscModePolicy * SOAP_FMAC4 soap_in_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *tag, enum vbox__NetworkAdapterPromiscModePolicy *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAdapterPromiscModePolicy *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAdapterPromiscModePolicy, sizeof(enum vbox__NetworkAdapterPromiscModePolicy), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__NetworkAdapterPromiscModePolicy(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAdapterPromiscModePolicy *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAdapterPromiscModePolicy, SOAP_TYPE_vbox__NetworkAdapterPromiscModePolicy, sizeof(enum vbox__NetworkAdapterPromiscModePolicy), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const enum vbox__NetworkAdapterPromiscModePolicy *a, const char *tag, const char *type)
{
	if (soap_out_vbox__NetworkAdapterPromiscModePolicy(soap, tag?tag:"vbox:NetworkAdapterPromiscModePolicy", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__NetworkAdapterPromiscModePolicy * SOAP_FMAC4 soap_get_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAdapterPromiscModePolicy(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterType
	*a = SOAP_DEFAULT_vbox__NetworkAdapterType;
#else
	*a = (enum vbox__NetworkAdapterType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__NetworkAdapterType[] =
{	{ (LONG64)vbox__NetworkAdapterType__Null, "Null" },
	{ (LONG64)vbox__NetworkAdapterType__Am79C970A, "Am79C970A" },
	{ (LONG64)vbox__NetworkAdapterType__Am79C973, "Am79C973" },
	{ (LONG64)vbox__NetworkAdapterType__I82540EM, "I82540EM" },
	{ (LONG64)vbox__NetworkAdapterType__I82543GC, "I82543GC" },
	{ (LONG64)vbox__NetworkAdapterType__I82545EM, "I82545EM" },
	{ (LONG64)vbox__NetworkAdapterType__Virtio, "Virtio" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAdapterType2s(struct soap *soap, enum vbox__NetworkAdapterType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAdapterType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAdapterType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAdapterType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAdapterType), type) || soap_send(soap, soap_vbox__NetworkAdapterType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAdapterType(struct soap *soap, const char *s, enum vbox__NetworkAdapterType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NetworkAdapterType, s);
	if (map)
		*a = (enum vbox__NetworkAdapterType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAdapterType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_in_vbox__NetworkAdapterType(struct soap *soap, const char *tag, enum vbox__NetworkAdapterType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAdapterType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAdapterType, sizeof(enum vbox__NetworkAdapterType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__NetworkAdapterType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAdapterType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAdapterType, SOAP_TYPE_vbox__NetworkAdapterType, sizeof(enum vbox__NetworkAdapterType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAdapterType(struct soap *soap, const enum vbox__NetworkAdapterType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__NetworkAdapterType(soap, tag?tag:"vbox:NetworkAdapterType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__NetworkAdapterType * SOAP_FMAC4 soap_get_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAdapterType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAttachmentType
	*a = SOAP_DEFAULT_vbox__NetworkAttachmentType;
#else
	*a = (enum vbox__NetworkAttachmentType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__NetworkAttachmentType[] =
{	{ (LONG64)vbox__NetworkAttachmentType__Null, "Null" },
	{ (LONG64)vbox__NetworkAttachmentType__NAT, "NAT" },
	{ (LONG64)vbox__NetworkAttachmentType__Bridged, "Bridged" },
	{ (LONG64)vbox__NetworkAttachmentType__Internal, "Internal" },
	{ (LONG64)vbox__NetworkAttachmentType__HostOnly, "HostOnly" },
	{ (LONG64)vbox__NetworkAttachmentType__Generic, "Generic" },
	{ (LONG64)vbox__NetworkAttachmentType__NATNetwork, "NATNetwork" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__NetworkAttachmentType2s(struct soap *soap, enum vbox__NetworkAttachmentType n)
{	const char *s = soap_code_str(soap_codes_vbox__NetworkAttachmentType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, int id, const enum vbox__NetworkAttachmentType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__NetworkAttachmentType), type) || soap_send(soap, soap_vbox__NetworkAttachmentType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__NetworkAttachmentType(struct soap *soap, const char *s, enum vbox__NetworkAttachmentType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__NetworkAttachmentType, s);
	if (map)
		*a = (enum vbox__NetworkAttachmentType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__NetworkAttachmentType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_in_vbox__NetworkAttachmentType(struct soap *soap, const char *tag, enum vbox__NetworkAttachmentType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__NetworkAttachmentType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__NetworkAttachmentType, sizeof(enum vbox__NetworkAttachmentType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__NetworkAttachmentType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__NetworkAttachmentType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__NetworkAttachmentType, SOAP_TYPE_vbox__NetworkAttachmentType, sizeof(enum vbox__NetworkAttachmentType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__NetworkAttachmentType(struct soap *soap, const enum vbox__NetworkAttachmentType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__NetworkAttachmentType(soap, tag?tag:"vbox:NetworkAttachmentType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__NetworkAttachmentType * SOAP_FMAC4 soap_get_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__NetworkAttachmentType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ScreenLayoutMode
	*a = SOAP_DEFAULT_vbox__ScreenLayoutMode;
#else
	*a = (enum vbox__ScreenLayoutMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ScreenLayoutMode[] =
{	{ (LONG64)vbox__ScreenLayoutMode__Apply, "Apply" },
	{ (LONG64)vbox__ScreenLayoutMode__Reset, "Reset" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ScreenLayoutMode2s(struct soap *soap, enum vbox__ScreenLayoutMode n)
{	const char *s = soap_code_str(soap_codes_vbox__ScreenLayoutMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ScreenLayoutMode(struct soap *soap, const char *tag, int id, const enum vbox__ScreenLayoutMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ScreenLayoutMode), type) || soap_send(soap, soap_vbox__ScreenLayoutMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ScreenLayoutMode(struct soap *soap, const char *s, enum vbox__ScreenLayoutMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ScreenLayoutMode, s);
	if (map)
		*a = (enum vbox__ScreenLayoutMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ScreenLayoutMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ScreenLayoutMode * SOAP_FMAC4 soap_in_vbox__ScreenLayoutMode(struct soap *soap, const char *tag, enum vbox__ScreenLayoutMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ScreenLayoutMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ScreenLayoutMode, sizeof(enum vbox__ScreenLayoutMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ScreenLayoutMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ScreenLayoutMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ScreenLayoutMode, SOAP_TYPE_vbox__ScreenLayoutMode, sizeof(enum vbox__ScreenLayoutMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ScreenLayoutMode(struct soap *soap, const enum vbox__ScreenLayoutMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ScreenLayoutMode(soap, tag?tag:"vbox:ScreenLayoutMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ScreenLayoutMode * SOAP_FMAC4 soap_get_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ScreenLayoutMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMonitorStatus
	*a = SOAP_DEFAULT_vbox__GuestMonitorStatus;
#else
	*a = (enum vbox__GuestMonitorStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestMonitorStatus[] =
{	{ (LONG64)vbox__GuestMonitorStatus__Disabled, "Disabled" },
	{ (LONG64)vbox__GuestMonitorStatus__Enabled, "Enabled" },
	{ (LONG64)vbox__GuestMonitorStatus__Blank, "Blank" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestMonitorStatus2s(struct soap *soap, enum vbox__GuestMonitorStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestMonitorStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestMonitorStatus(struct soap *soap, const char *tag, int id, const enum vbox__GuestMonitorStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestMonitorStatus), type) || soap_send(soap, soap_vbox__GuestMonitorStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestMonitorStatus(struct soap *soap, const char *s, enum vbox__GuestMonitorStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestMonitorStatus, s);
	if (map)
		*a = (enum vbox__GuestMonitorStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestMonitorStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestMonitorStatus * SOAP_FMAC4 soap_in_vbox__GuestMonitorStatus(struct soap *soap, const char *tag, enum vbox__GuestMonitorStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestMonitorStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestMonitorStatus, sizeof(enum vbox__GuestMonitorStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestMonitorStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestMonitorStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestMonitorStatus, SOAP_TYPE_vbox__GuestMonitorStatus, sizeof(enum vbox__GuestMonitorStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestMonitorStatus(struct soap *soap, const enum vbox__GuestMonitorStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestMonitorStatus(soap, tag?tag:"vbox:GuestMonitorStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestMonitorStatus * SOAP_FMAC4 soap_get_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestMonitorStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FramebufferCapabilities
	*a = SOAP_DEFAULT_vbox__FramebufferCapabilities;
#else
	*a = (enum vbox__FramebufferCapabilities)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FramebufferCapabilities[] =
{	{ (LONG64)vbox__FramebufferCapabilities__UpdateImage, "UpdateImage" },
	{ (LONG64)vbox__FramebufferCapabilities__VHWA, "VHWA" },
	{ (LONG64)vbox__FramebufferCapabilities__VisibleRegion, "VisibleRegion" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FramebufferCapabilities2s(struct soap *soap, enum vbox__FramebufferCapabilities n)
{	const char *s = soap_code_str(soap_codes_vbox__FramebufferCapabilities, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FramebufferCapabilities(struct soap *soap, const char *tag, int id, const enum vbox__FramebufferCapabilities *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FramebufferCapabilities), type) || soap_send(soap, soap_vbox__FramebufferCapabilities2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FramebufferCapabilities(struct soap *soap, const char *s, enum vbox__FramebufferCapabilities *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FramebufferCapabilities, s);
	if (map)
		*a = (enum vbox__FramebufferCapabilities)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FramebufferCapabilities)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FramebufferCapabilities * SOAP_FMAC4 soap_in_vbox__FramebufferCapabilities(struct soap *soap, const char *tag, enum vbox__FramebufferCapabilities *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FramebufferCapabilities *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FramebufferCapabilities, sizeof(enum vbox__FramebufferCapabilities), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FramebufferCapabilities(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FramebufferCapabilities *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FramebufferCapabilities, SOAP_TYPE_vbox__FramebufferCapabilities, sizeof(enum vbox__FramebufferCapabilities), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FramebufferCapabilities(struct soap *soap, const enum vbox__FramebufferCapabilities *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FramebufferCapabilities(soap, tag?tag:"vbox:FramebufferCapabilities", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FramebufferCapabilities * SOAP_FMAC4 soap_get_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FramebufferCapabilities(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__TouchContactState
	*a = SOAP_DEFAULT_vbox__TouchContactState;
#else
	*a = (enum vbox__TouchContactState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__TouchContactState[] =
{	{ (LONG64)vbox__TouchContactState__None, "None" },
	{ (LONG64)vbox__TouchContactState__InContact, "InContact" },
	{ (LONG64)vbox__TouchContactState__InRange, "InRange" },
	{ (LONG64)vbox__TouchContactState__ContactStateMask, "ContactStateMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__TouchContactState2s(struct soap *soap, enum vbox__TouchContactState n)
{	const char *s = soap_code_str(soap_codes_vbox__TouchContactState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__TouchContactState(struct soap *soap, const char *tag, int id, const enum vbox__TouchContactState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__TouchContactState), type) || soap_send(soap, soap_vbox__TouchContactState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__TouchContactState(struct soap *soap, const char *s, enum vbox__TouchContactState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__TouchContactState, s);
	if (map)
		*a = (enum vbox__TouchContactState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__TouchContactState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__TouchContactState * SOAP_FMAC4 soap_in_vbox__TouchContactState(struct soap *soap, const char *tag, enum vbox__TouchContactState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__TouchContactState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__TouchContactState, sizeof(enum vbox__TouchContactState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__TouchContactState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__TouchContactState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__TouchContactState, SOAP_TYPE_vbox__TouchContactState, sizeof(enum vbox__TouchContactState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__TouchContactState(struct soap *soap, const enum vbox__TouchContactState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__TouchContactState(soap, tag?tag:"vbox:TouchContactState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__TouchContactState * SOAP_FMAC4 soap_get_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__TouchContactState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MouseButtonState
	*a = SOAP_DEFAULT_vbox__MouseButtonState;
#else
	*a = (enum vbox__MouseButtonState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MouseButtonState[] =
{	{ (LONG64)vbox__MouseButtonState__LeftButton, "LeftButton" },
	{ (LONG64)vbox__MouseButtonState__RightButton, "RightButton" },
	{ (LONG64)vbox__MouseButtonState__MiddleButton, "MiddleButton" },
	{ (LONG64)vbox__MouseButtonState__WheelUp, "WheelUp" },
	{ (LONG64)vbox__MouseButtonState__WheelDown, "WheelDown" },
	{ (LONG64)vbox__MouseButtonState__XButton1, "XButton1" },
	{ (LONG64)vbox__MouseButtonState__XButton2, "XButton2" },
	{ (LONG64)vbox__MouseButtonState__MouseStateMask, "MouseStateMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MouseButtonState2s(struct soap *soap, enum vbox__MouseButtonState n)
{	const char *s = soap_code_str(soap_codes_vbox__MouseButtonState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MouseButtonState(struct soap *soap, const char *tag, int id, const enum vbox__MouseButtonState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MouseButtonState), type) || soap_send(soap, soap_vbox__MouseButtonState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MouseButtonState(struct soap *soap, const char *s, enum vbox__MouseButtonState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MouseButtonState, s);
	if (map)
		*a = (enum vbox__MouseButtonState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MouseButtonState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_in_vbox__MouseButtonState(struct soap *soap, const char *tag, enum vbox__MouseButtonState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MouseButtonState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MouseButtonState, sizeof(enum vbox__MouseButtonState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MouseButtonState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MouseButtonState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MouseButtonState, SOAP_TYPE_vbox__MouseButtonState, sizeof(enum vbox__MouseButtonState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MouseButtonState(struct soap *soap, const enum vbox__MouseButtonState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MouseButtonState(soap, tag?tag:"vbox:MouseButtonState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MouseButtonState * SOAP_FMAC4 soap_get_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MouseButtonState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__KeyboardLED
	*a = SOAP_DEFAULT_vbox__KeyboardLED;
#else
	*a = (enum vbox__KeyboardLED)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__KeyboardLED[] =
{	{ (LONG64)vbox__KeyboardLED__NumLock, "NumLock" },
	{ (LONG64)vbox__KeyboardLED__CapsLock, "CapsLock" },
	{ (LONG64)vbox__KeyboardLED__ScrollLock, "ScrollLock" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__KeyboardLED2s(struct soap *soap, enum vbox__KeyboardLED n)
{	const char *s = soap_code_str(soap_codes_vbox__KeyboardLED, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__KeyboardLED(struct soap *soap, const char *tag, int id, const enum vbox__KeyboardLED *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__KeyboardLED), type) || soap_send(soap, soap_vbox__KeyboardLED2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__KeyboardLED(struct soap *soap, const char *s, enum vbox__KeyboardLED *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__KeyboardLED, s);
	if (map)
		*a = (enum vbox__KeyboardLED)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__KeyboardLED)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__KeyboardLED * SOAP_FMAC4 soap_in_vbox__KeyboardLED(struct soap *soap, const char *tag, enum vbox__KeyboardLED *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__KeyboardLED *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__KeyboardLED, sizeof(enum vbox__KeyboardLED), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__KeyboardLED(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__KeyboardLED *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__KeyboardLED, SOAP_TYPE_vbox__KeyboardLED, sizeof(enum vbox__KeyboardLED), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__KeyboardLED(struct soap *soap, const enum vbox__KeyboardLED *a, const char *tag, const char *type)
{
	if (soap_out_vbox__KeyboardLED(soap, tag?tag:"vbox:KeyboardLED", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__KeyboardLED * SOAP_FMAC4 soap_get_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__KeyboardLED(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumFormatCapabilities
	*a = SOAP_DEFAULT_vbox__MediumFormatCapabilities;
#else
	*a = (enum vbox__MediumFormatCapabilities)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MediumFormatCapabilities[] =
{	{ (LONG64)vbox__MediumFormatCapabilities__Uuid, "Uuid" },
	{ (LONG64)vbox__MediumFormatCapabilities__CreateFixed, "CreateFixed" },
	{ (LONG64)vbox__MediumFormatCapabilities__CreateDynamic, "CreateDynamic" },
	{ (LONG64)vbox__MediumFormatCapabilities__CreateSplit2G, "CreateSplit2G" },
	{ (LONG64)vbox__MediumFormatCapabilities__Differencing, "Differencing" },
	{ (LONG64)vbox__MediumFormatCapabilities__Asynchronous, "Asynchronous" },
	{ (LONG64)vbox__MediumFormatCapabilities__File, "File" },
	{ (LONG64)vbox__MediumFormatCapabilities__Properties, "Properties" },
	{ (LONG64)vbox__MediumFormatCapabilities__TcpNetworking, "TcpNetworking" },
	{ (LONG64)vbox__MediumFormatCapabilities__VFS, "VFS" },
	{ (LONG64)vbox__MediumFormatCapabilities__Discard, "Discard" },
	{ (LONG64)vbox__MediumFormatCapabilities__Preferred, "Preferred" },
	{ (LONG64)vbox__MediumFormatCapabilities__CapabilityMask, "CapabilityMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumFormatCapabilities2s(struct soap *soap, enum vbox__MediumFormatCapabilities n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumFormatCapabilities, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumFormatCapabilities(struct soap *soap, const char *tag, int id, const enum vbox__MediumFormatCapabilities *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumFormatCapabilities), type) || soap_send(soap, soap_vbox__MediumFormatCapabilities2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumFormatCapabilities(struct soap *soap, const char *s, enum vbox__MediumFormatCapabilities *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MediumFormatCapabilities, s);
	if (map)
		*a = (enum vbox__MediumFormatCapabilities)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 12)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumFormatCapabilities)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumFormatCapabilities * SOAP_FMAC4 soap_in_vbox__MediumFormatCapabilities(struct soap *soap, const char *tag, enum vbox__MediumFormatCapabilities *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumFormatCapabilities *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumFormatCapabilities, sizeof(enum vbox__MediumFormatCapabilities), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MediumFormatCapabilities(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumFormatCapabilities *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumFormatCapabilities, SOAP_TYPE_vbox__MediumFormatCapabilities, sizeof(enum vbox__MediumFormatCapabilities), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumFormatCapabilities(struct soap *soap, const enum vbox__MediumFormatCapabilities *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MediumFormatCapabilities(soap, tag?tag:"vbox:MediumFormatCapabilities", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MediumFormatCapabilities * SOAP_FMAC4 soap_get_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumFormatCapabilities(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataFlags
	*a = SOAP_DEFAULT_vbox__DataFlags;
#else
	*a = (enum vbox__DataFlags)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DataFlags[] =
{	{ (LONG64)vbox__DataFlags__None, "None" },
	{ (LONG64)vbox__DataFlags__Mandatory, "Mandatory" },
	{ (LONG64)vbox__DataFlags__Expert, "Expert" },
	{ (LONG64)vbox__DataFlags__Array, "Array" },
	{ (LONG64)vbox__DataFlags__FlagMask, "FlagMask" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataFlags2s(struct soap *soap, enum vbox__DataFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__DataFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataFlags(struct soap *soap, const char *tag, int id, const enum vbox__DataFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataFlags), type) || soap_send(soap, soap_vbox__DataFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataFlags(struct soap *soap, const char *s, enum vbox__DataFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DataFlags, s);
	if (map)
		*a = (enum vbox__DataFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_in_vbox__DataFlags(struct soap *soap, const char *tag, enum vbox__DataFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataFlags, sizeof(enum vbox__DataFlags), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DataFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataFlags, SOAP_TYPE_vbox__DataFlags, sizeof(enum vbox__DataFlags), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataFlags(struct soap *soap, const enum vbox__DataFlags *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DataFlags(soap, tag?tag:"vbox:DataFlags", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DataFlags * SOAP_FMAC4 soap_get_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DataType(struct soap *soap, enum vbox__DataType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataType
	*a = SOAP_DEFAULT_vbox__DataType;
#else
	*a = (enum vbox__DataType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DataType[] =
{	{ (LONG64)vbox__DataType__Int32, "Int32" },
	{ (LONG64)vbox__DataType__Int8, "Int8" },
	{ (LONG64)vbox__DataType__String, "String" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DataType2s(struct soap *soap, enum vbox__DataType n)
{	const char *s = soap_code_str(soap_codes_vbox__DataType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DataType(struct soap *soap, const char *tag, int id, const enum vbox__DataType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DataType), type) || soap_send(soap, soap_vbox__DataType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DataType(struct soap *soap, const char *s, enum vbox__DataType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DataType, s);
	if (map)
		*a = (enum vbox__DataType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DataType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_in_vbox__DataType(struct soap *soap, const char *tag, enum vbox__DataType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DataType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DataType, sizeof(enum vbox__DataType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DataType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DataType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DataType, SOAP_TYPE_vbox__DataType, sizeof(enum vbox__DataType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DataType(struct soap *soap, const enum vbox__DataType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DataType(soap, tag?tag:"vbox:DataType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DataType * SOAP_FMAC4 soap_get_vbox__DataType(struct soap *soap, enum vbox__DataType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DataType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumVariant
	*a = SOAP_DEFAULT_vbox__MediumVariant;
#else
	*a = (enum vbox__MediumVariant)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MediumVariant[] =
{	{ (LONG64)vbox__MediumVariant__Standard, "Standard" },
	{ (LONG64)vbox__MediumVariant__VmdkSplit2G, "VmdkSplit2G" },
	{ (LONG64)vbox__MediumVariant__VmdkRawDisk, "VmdkRawDisk" },
	{ (LONG64)vbox__MediumVariant__VmdkStreamOptimized, "VmdkStreamOptimized" },
	{ (LONG64)vbox__MediumVariant__VmdkESX, "VmdkESX" },
	{ (LONG64)vbox__MediumVariant__VdiZeroExpand, "VdiZeroExpand" },
	{ (LONG64)vbox__MediumVariant__Fixed, "Fixed" },
	{ (LONG64)vbox__MediumVariant__Diff, "Diff" },
	{ (LONG64)vbox__MediumVariant__NoCreateDir, "NoCreateDir" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumVariant2s(struct soap *soap, enum vbox__MediumVariant n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumVariant, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumVariant(struct soap *soap, const char *tag, int id, const enum vbox__MediumVariant *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumVariant), type) || soap_send(soap, soap_vbox__MediumVariant2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumVariant(struct soap *soap, const char *s, enum vbox__MediumVariant *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MediumVariant, s);
	if (map)
		*a = (enum vbox__MediumVariant)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumVariant)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumVariant * SOAP_FMAC4 soap_in_vbox__MediumVariant(struct soap *soap, const char *tag, enum vbox__MediumVariant *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumVariant *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumVariant, sizeof(enum vbox__MediumVariant), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MediumVariant(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumVariant *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumVariant, SOAP_TYPE_vbox__MediumVariant, sizeof(enum vbox__MediumVariant), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumVariant(struct soap *soap, const enum vbox__MediumVariant *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MediumVariant(soap, tag?tag:"vbox:MediumVariant", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MediumVariant * SOAP_FMAC4 soap_get_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumVariant(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumType(struct soap *soap, enum vbox__MediumType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumType
	*a = SOAP_DEFAULT_vbox__MediumType;
#else
	*a = (enum vbox__MediumType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MediumType[] =
{	{ (LONG64)vbox__MediumType__Normal, "Normal" },
	{ (LONG64)vbox__MediumType__Immutable, "Immutable" },
	{ (LONG64)vbox__MediumType__Writethrough, "Writethrough" },
	{ (LONG64)vbox__MediumType__Shareable, "Shareable" },
	{ (LONG64)vbox__MediumType__Readonly, "Readonly" },
	{ (LONG64)vbox__MediumType__MultiAttach, "MultiAttach" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumType2s(struct soap *soap, enum vbox__MediumType n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumType(struct soap *soap, const char *tag, int id, const enum vbox__MediumType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumType), type) || soap_send(soap, soap_vbox__MediumType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumType(struct soap *soap, const char *s, enum vbox__MediumType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MediumType, s);
	if (map)
		*a = (enum vbox__MediumType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumType * SOAP_FMAC4 soap_in_vbox__MediumType(struct soap *soap, const char *tag, enum vbox__MediumType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumType, sizeof(enum vbox__MediumType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MediumType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumType, SOAP_TYPE_vbox__MediumType, sizeof(enum vbox__MediumType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumType(struct soap *soap, const enum vbox__MediumType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MediumType(soap, tag?tag:"vbox:MediumType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MediumType * SOAP_FMAC4 soap_get_vbox__MediumType(struct soap *soap, enum vbox__MediumType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MediumState(struct soap *soap, enum vbox__MediumState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumState
	*a = SOAP_DEFAULT_vbox__MediumState;
#else
	*a = (enum vbox__MediumState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MediumState[] =
{	{ (LONG64)vbox__MediumState__NotCreated, "NotCreated" },
	{ (LONG64)vbox__MediumState__Created, "Created" },
	{ (LONG64)vbox__MediumState__LockedRead, "LockedRead" },
	{ (LONG64)vbox__MediumState__LockedWrite, "LockedWrite" },
	{ (LONG64)vbox__MediumState__Inaccessible, "Inaccessible" },
	{ (LONG64)vbox__MediumState__Creating, "Creating" },
	{ (LONG64)vbox__MediumState__Deleting, "Deleting" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MediumState2s(struct soap *soap, enum vbox__MediumState n)
{	const char *s = soap_code_str(soap_codes_vbox__MediumState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MediumState(struct soap *soap, const char *tag, int id, const enum vbox__MediumState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MediumState), type) || soap_send(soap, soap_vbox__MediumState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MediumState(struct soap *soap, const char *s, enum vbox__MediumState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MediumState, s);
	if (map)
		*a = (enum vbox__MediumState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MediumState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MediumState * SOAP_FMAC4 soap_in_vbox__MediumState(struct soap *soap, const char *tag, enum vbox__MediumState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MediumState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MediumState, sizeof(enum vbox__MediumState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MediumState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MediumState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MediumState, SOAP_TYPE_vbox__MediumState, sizeof(enum vbox__MediumState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MediumState(struct soap *soap, const enum vbox__MediumState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MediumState(soap, tag?tag:"vbox:MediumState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MediumState * SOAP_FMAC4 soap_get_vbox__MediumState(struct soap *soap, enum vbox__MediumState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MediumState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryOpenFlag
	*a = SOAP_DEFAULT_vbox__DirectoryOpenFlag;
#else
	*a = (enum vbox__DirectoryOpenFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DirectoryOpenFlag[] =
{	{ (LONG64)vbox__DirectoryOpenFlag__None, "None" },
	{ (LONG64)vbox__DirectoryOpenFlag__NoSymlinks, "NoSymlinks" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DirectoryOpenFlag2s(struct soap *soap, enum vbox__DirectoryOpenFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__DirectoryOpenFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DirectoryOpenFlag(struct soap *soap, const char *tag, int id, const enum vbox__DirectoryOpenFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DirectoryOpenFlag), type) || soap_send(soap, soap_vbox__DirectoryOpenFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DirectoryOpenFlag(struct soap *soap, const char *s, enum vbox__DirectoryOpenFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DirectoryOpenFlag, s);
	if (map)
		*a = (enum vbox__DirectoryOpenFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DirectoryOpenFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DirectoryOpenFlag * SOAP_FMAC4 soap_in_vbox__DirectoryOpenFlag(struct soap *soap, const char *tag, enum vbox__DirectoryOpenFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DirectoryOpenFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DirectoryOpenFlag, sizeof(enum vbox__DirectoryOpenFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DirectoryOpenFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DirectoryOpenFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DirectoryOpenFlag, SOAP_TYPE_vbox__DirectoryOpenFlag, sizeof(enum vbox__DirectoryOpenFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DirectoryOpenFlag(struct soap *soap, const enum vbox__DirectoryOpenFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DirectoryOpenFlag(soap, tag?tag:"vbox:DirectoryOpenFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DirectoryOpenFlag * SOAP_FMAC4 soap_get_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DirectoryOpenFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DnDAction
	*a = SOAP_DEFAULT_vbox__DnDAction;
#else
	*a = (enum vbox__DnDAction)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DnDAction[] =
{	{ (LONG64)vbox__DnDAction__Ignore, "Ignore" },
	{ (LONG64)vbox__DnDAction__Copy, "Copy" },
	{ (LONG64)vbox__DnDAction__Move, "Move" },
	{ (LONG64)vbox__DnDAction__Link, "Link" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DnDAction2s(struct soap *soap, enum vbox__DnDAction n)
{	const char *s = soap_code_str(soap_codes_vbox__DnDAction, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DnDAction(struct soap *soap, const char *tag, int id, const enum vbox__DnDAction *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DnDAction), type) || soap_send(soap, soap_vbox__DnDAction2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DnDAction(struct soap *soap, const char *s, enum vbox__DnDAction *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DnDAction, s);
	if (map)
		*a = (enum vbox__DnDAction)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DnDAction)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DnDAction * SOAP_FMAC4 soap_in_vbox__DnDAction(struct soap *soap, const char *tag, enum vbox__DnDAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DnDAction *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DnDAction, sizeof(enum vbox__DnDAction), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DnDAction(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DnDAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DnDAction, SOAP_TYPE_vbox__DnDAction, sizeof(enum vbox__DnDAction), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DnDAction(struct soap *soap, const enum vbox__DnDAction *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DnDAction(soap, tag?tag:"vbox:DnDAction", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DnDAction * SOAP_FMAC4 soap_get_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DnDAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjType
	*a = SOAP_DEFAULT_vbox__FsObjType;
#else
	*a = (enum vbox__FsObjType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FsObjType[] =
{	{ (LONG64)vbox__FsObjType__Unknown, "Unknown" },
	{ (LONG64)vbox__FsObjType__Fifo, "Fifo" },
	{ (LONG64)vbox__FsObjType__DevChar, "DevChar" },
	{ (LONG64)vbox__FsObjType__Directory, "Directory" },
	{ (LONG64)vbox__FsObjType__DevBlock, "DevBlock" },
	{ (LONG64)vbox__FsObjType__File, "File" },
	{ (LONG64)vbox__FsObjType__Symlink, "Symlink" },
	{ (LONG64)vbox__FsObjType__Socket, "Socket" },
	{ (LONG64)vbox__FsObjType__WhiteOut, "WhiteOut" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FsObjType2s(struct soap *soap, enum vbox__FsObjType n)
{	const char *s = soap_code_str(soap_codes_vbox__FsObjType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FsObjType(struct soap *soap, const char *tag, int id, const enum vbox__FsObjType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FsObjType), type) || soap_send(soap, soap_vbox__FsObjType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FsObjType(struct soap *soap, const char *s, enum vbox__FsObjType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FsObjType, s);
	if (map)
		*a = (enum vbox__FsObjType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FsObjType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FsObjType * SOAP_FMAC4 soap_in_vbox__FsObjType(struct soap *soap, const char *tag, enum vbox__FsObjType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FsObjType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FsObjType, sizeof(enum vbox__FsObjType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FsObjType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FsObjType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FsObjType, SOAP_TYPE_vbox__FsObjType, sizeof(enum vbox__FsObjType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FsObjType(struct soap *soap, const enum vbox__FsObjType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FsObjType(soap, tag?tag:"vbox:FsObjType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FsObjType * SOAP_FMAC4 soap_get_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FsObjType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileStatus
	*a = SOAP_DEFAULT_vbox__FileStatus;
#else
	*a = (enum vbox__FileStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileStatus[] =
{	{ (LONG64)vbox__FileStatus__Undefined, "Undefined" },
	{ (LONG64)vbox__FileStatus__Opening, "Opening" },
	{ (LONG64)vbox__FileStatus__Open, "Open" },
	{ (LONG64)vbox__FileStatus__Closing, "Closing" },
	{ (LONG64)vbox__FileStatus__Closed, "Closed" },
	{ (LONG64)vbox__FileStatus__Down, "Down" },
	{ (LONG64)vbox__FileStatus__Error, "Error" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileStatus2s(struct soap *soap, enum vbox__FileStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__FileStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileStatus(struct soap *soap, const char *tag, int id, const enum vbox__FileStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileStatus), type) || soap_send(soap, soap_vbox__FileStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileStatus(struct soap *soap, const char *s, enum vbox__FileStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileStatus, s);
	if (map)
		*a = (enum vbox__FileStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileStatus * SOAP_FMAC4 soap_in_vbox__FileStatus(struct soap *soap, const char *tag, enum vbox__FileStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileStatus, sizeof(enum vbox__FileStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileStatus, SOAP_TYPE_vbox__FileStatus, sizeof(enum vbox__FileStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileStatus(struct soap *soap, const enum vbox__FileStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileStatus(soap, tag?tag:"vbox:FileStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileStatus * SOAP_FMAC4 soap_get_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileOpenExFlags(struct soap *soap, enum vbox__FileOpenExFlags *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileOpenExFlags
	*a = SOAP_DEFAULT_vbox__FileOpenExFlags;
#else
	*a = (enum vbox__FileOpenExFlags)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileOpenExFlags[] =
{	{ (LONG64)vbox__FileOpenExFlags__None, "None" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileOpenExFlags2s(struct soap *soap, enum vbox__FileOpenExFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__FileOpenExFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileOpenExFlags(struct soap *soap, const char *tag, int id, const enum vbox__FileOpenExFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileOpenExFlags), type) || soap_send(soap, soap_vbox__FileOpenExFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileOpenExFlags(struct soap *soap, const char *s, enum vbox__FileOpenExFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileOpenExFlags, s);
	if (map)
		*a = (enum vbox__FileOpenExFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 0)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileOpenExFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileOpenExFlags * SOAP_FMAC4 soap_in_vbox__FileOpenExFlags(struct soap *soap, const char *tag, enum vbox__FileOpenExFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileOpenExFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileOpenExFlags, sizeof(enum vbox__FileOpenExFlags), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileOpenExFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileOpenExFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileOpenExFlags, SOAP_TYPE_vbox__FileOpenExFlags, sizeof(enum vbox__FileOpenExFlags), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileOpenExFlags(struct soap *soap, const enum vbox__FileOpenExFlags *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileOpenExFlags(soap, tag?tag:"vbox:FileOpenExFlags", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileOpenExFlags * SOAP_FMAC4 soap_get_vbox__FileOpenExFlags(struct soap *soap, enum vbox__FileOpenExFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileOpenExFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileSharingMode
	*a = SOAP_DEFAULT_vbox__FileSharingMode;
#else
	*a = (enum vbox__FileSharingMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileSharingMode[] =
{	{ (LONG64)vbox__FileSharingMode__Read, "Read" },
	{ (LONG64)vbox__FileSharingMode__Write, "Write" },
	{ (LONG64)vbox__FileSharingMode__ReadWrite, "ReadWrite" },
	{ (LONG64)vbox__FileSharingMode__Delete, "Delete" },
	{ (LONG64)vbox__FileSharingMode__ReadDelete, "ReadDelete" },
	{ (LONG64)vbox__FileSharingMode__WriteDelete, "WriteDelete" },
	{ (LONG64)vbox__FileSharingMode__All, "All" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileSharingMode2s(struct soap *soap, enum vbox__FileSharingMode n)
{	const char *s = soap_code_str(soap_codes_vbox__FileSharingMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileSharingMode(struct soap *soap, const char *tag, int id, const enum vbox__FileSharingMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileSharingMode), type) || soap_send(soap, soap_vbox__FileSharingMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileSharingMode(struct soap *soap, const char *s, enum vbox__FileSharingMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileSharingMode, s);
	if (map)
		*a = (enum vbox__FileSharingMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileSharingMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileSharingMode * SOAP_FMAC4 soap_in_vbox__FileSharingMode(struct soap *soap, const char *tag, enum vbox__FileSharingMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileSharingMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileSharingMode, sizeof(enum vbox__FileSharingMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileSharingMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileSharingMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileSharingMode, SOAP_TYPE_vbox__FileSharingMode, sizeof(enum vbox__FileSharingMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileSharingMode(struct soap *soap, const enum vbox__FileSharingMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileSharingMode(soap, tag?tag:"vbox:FileSharingMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileSharingMode * SOAP_FMAC4 soap_get_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileSharingMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileOpenAction
	*a = SOAP_DEFAULT_vbox__FileOpenAction;
#else
	*a = (enum vbox__FileOpenAction)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileOpenAction[] =
{	{ (LONG64)vbox__FileOpenAction__OpenExisting, "OpenExisting" },
	{ (LONG64)vbox__FileOpenAction__OpenOrCreate, "OpenOrCreate" },
	{ (LONG64)vbox__FileOpenAction__CreateNew, "CreateNew" },
	{ (LONG64)vbox__FileOpenAction__CreateOrReplace, "CreateOrReplace" },
	{ (LONG64)vbox__FileOpenAction__OpenExistingTruncated, "OpenExistingTruncated" },
	{ (LONG64)vbox__FileOpenAction__AppendOrCreate, "AppendOrCreate" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileOpenAction2s(struct soap *soap, enum vbox__FileOpenAction n)
{	const char *s = soap_code_str(soap_codes_vbox__FileOpenAction, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileOpenAction(struct soap *soap, const char *tag, int id, const enum vbox__FileOpenAction *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileOpenAction), type) || soap_send(soap, soap_vbox__FileOpenAction2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileOpenAction(struct soap *soap, const char *s, enum vbox__FileOpenAction *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileOpenAction, s);
	if (map)
		*a = (enum vbox__FileOpenAction)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileOpenAction)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileOpenAction * SOAP_FMAC4 soap_in_vbox__FileOpenAction(struct soap *soap, const char *tag, enum vbox__FileOpenAction *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileOpenAction *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileOpenAction, sizeof(enum vbox__FileOpenAction), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileOpenAction(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileOpenAction *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileOpenAction, SOAP_TYPE_vbox__FileOpenAction, sizeof(enum vbox__FileOpenAction), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileOpenAction(struct soap *soap, const enum vbox__FileOpenAction *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileOpenAction(soap, tag?tag:"vbox:FileOpenAction", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileOpenAction * SOAP_FMAC4 soap_get_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileOpenAction(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileAccessMode
	*a = SOAP_DEFAULT_vbox__FileAccessMode;
#else
	*a = (enum vbox__FileAccessMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileAccessMode[] =
{	{ (LONG64)vbox__FileAccessMode__ReadOnly, "ReadOnly" },
	{ (LONG64)vbox__FileAccessMode__WriteOnly, "WriteOnly" },
	{ (LONG64)vbox__FileAccessMode__ReadWrite, "ReadWrite" },
	{ (LONG64)vbox__FileAccessMode__AppendOnly, "AppendOnly" },
	{ (LONG64)vbox__FileAccessMode__AppendRead, "AppendRead" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileAccessMode2s(struct soap *soap, enum vbox__FileAccessMode n)
{	const char *s = soap_code_str(soap_codes_vbox__FileAccessMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileAccessMode(struct soap *soap, const char *tag, int id, const enum vbox__FileAccessMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileAccessMode), type) || soap_send(soap, soap_vbox__FileAccessMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileAccessMode(struct soap *soap, const char *s, enum vbox__FileAccessMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileAccessMode, s);
	if (map)
		*a = (enum vbox__FileAccessMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileAccessMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileAccessMode * SOAP_FMAC4 soap_in_vbox__FileAccessMode(struct soap *soap, const char *tag, enum vbox__FileAccessMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileAccessMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileAccessMode, sizeof(enum vbox__FileAccessMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileAccessMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileAccessMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileAccessMode, SOAP_TYPE_vbox__FileAccessMode, sizeof(enum vbox__FileAccessMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileAccessMode(struct soap *soap, const enum vbox__FileAccessMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileAccessMode(soap, tag?tag:"vbox:FileAccessMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileAccessMode * SOAP_FMAC4 soap_get_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileAccessMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PathStyle
	*a = SOAP_DEFAULT_vbox__PathStyle;
#else
	*a = (enum vbox__PathStyle)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__PathStyle[] =
{	{ (LONG64)vbox__PathStyle__DOS, "DOS" },
	{ (LONG64)vbox__PathStyle__UNIX, "UNIX" },
	{ (LONG64)vbox__PathStyle__Unknown, "Unknown" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__PathStyle2s(struct soap *soap, enum vbox__PathStyle n)
{	const char *s = soap_code_str(soap_codes_vbox__PathStyle, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__PathStyle(struct soap *soap, const char *tag, int id, const enum vbox__PathStyle *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__PathStyle), type) || soap_send(soap, soap_vbox__PathStyle2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__PathStyle(struct soap *soap, const char *s, enum vbox__PathStyle *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__PathStyle, s);
	if (map)
		*a = (enum vbox__PathStyle)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__PathStyle)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__PathStyle * SOAP_FMAC4 soap_in_vbox__PathStyle(struct soap *soap, const char *tag, enum vbox__PathStyle *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__PathStyle *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__PathStyle, sizeof(enum vbox__PathStyle), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__PathStyle(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__PathStyle *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__PathStyle, SOAP_TYPE_vbox__PathStyle, sizeof(enum vbox__PathStyle), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__PathStyle(struct soap *soap, const enum vbox__PathStyle *a, const char *tag, const char *type)
{
	if (soap_out_vbox__PathStyle(soap, tag?tag:"vbox:PathStyle", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__PathStyle * SOAP_FMAC4 soap_get_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__PathStyle(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessInputStatus
	*a = SOAP_DEFAULT_vbox__ProcessInputStatus;
#else
	*a = (enum vbox__ProcessInputStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessInputStatus[] =
{	{ (LONG64)vbox__ProcessInputStatus__Undefined, "Undefined" },
	{ (LONG64)vbox__ProcessInputStatus__Broken, "Broken" },
	{ (LONG64)vbox__ProcessInputStatus__Available, "Available" },
	{ (LONG64)vbox__ProcessInputStatus__Written, "Written" },
	{ (LONG64)vbox__ProcessInputStatus__Overflow, "Overflow" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessInputStatus2s(struct soap *soap, enum vbox__ProcessInputStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessInputStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessInputStatus(struct soap *soap, const char *tag, int id, const enum vbox__ProcessInputStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessInputStatus), type) || soap_send(soap, soap_vbox__ProcessInputStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessInputStatus(struct soap *soap, const char *s, enum vbox__ProcessInputStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessInputStatus, s);
	if (map)
		*a = (enum vbox__ProcessInputStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessInputStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessInputStatus * SOAP_FMAC4 soap_in_vbox__ProcessInputStatus(struct soap *soap, const char *tag, enum vbox__ProcessInputStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessInputStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessInputStatus, sizeof(enum vbox__ProcessInputStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessInputStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessInputStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessInputStatus, SOAP_TYPE_vbox__ProcessInputStatus, sizeof(enum vbox__ProcessInputStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessInputStatus(struct soap *soap, const enum vbox__ProcessInputStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessInputStatus(soap, tag?tag:"vbox:ProcessInputStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessInputStatus * SOAP_FMAC4 soap_get_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessInputStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessStatus
	*a = SOAP_DEFAULT_vbox__ProcessStatus;
#else
	*a = (enum vbox__ProcessStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessStatus[] =
{	{ (LONG64)vbox__ProcessStatus__Undefined, "Undefined" },
	{ (LONG64)vbox__ProcessStatus__Starting, "Starting" },
	{ (LONG64)vbox__ProcessStatus__Started, "Started" },
	{ (LONG64)vbox__ProcessStatus__Paused, "Paused" },
	{ (LONG64)vbox__ProcessStatus__Terminating, "Terminating" },
	{ (LONG64)vbox__ProcessStatus__TerminatedNormally, "TerminatedNormally" },
	{ (LONG64)vbox__ProcessStatus__TerminatedSignal, "TerminatedSignal" },
	{ (LONG64)vbox__ProcessStatus__TerminatedAbnormally, "TerminatedAbnormally" },
	{ (LONG64)vbox__ProcessStatus__TimedOutKilled, "TimedOutKilled" },
	{ (LONG64)vbox__ProcessStatus__TimedOutAbnormally, "TimedOutAbnormally" },
	{ (LONG64)vbox__ProcessStatus__Down, "Down" },
	{ (LONG64)vbox__ProcessStatus__Error, "Error" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessStatus2s(struct soap *soap, enum vbox__ProcessStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessStatus(struct soap *soap, const char *tag, int id, const enum vbox__ProcessStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessStatus), type) || soap_send(soap, soap_vbox__ProcessStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessStatus(struct soap *soap, const char *s, enum vbox__ProcessStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessStatus, s);
	if (map)
		*a = (enum vbox__ProcessStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 11)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessStatus * SOAP_FMAC4 soap_in_vbox__ProcessStatus(struct soap *soap, const char *tag, enum vbox__ProcessStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessStatus, sizeof(enum vbox__ProcessStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessStatus, SOAP_TYPE_vbox__ProcessStatus, sizeof(enum vbox__ProcessStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessStatus(struct soap *soap, const enum vbox__ProcessStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessStatus(soap, tag?tag:"vbox:ProcessStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessStatus * SOAP_FMAC4 soap_get_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SymlinkReadFlag
	*a = SOAP_DEFAULT_vbox__SymlinkReadFlag;
#else
	*a = (enum vbox__SymlinkReadFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__SymlinkReadFlag[] =
{	{ (LONG64)vbox__SymlinkReadFlag__None, "None" },
	{ (LONG64)vbox__SymlinkReadFlag__NoSymlinks, "NoSymlinks" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SymlinkReadFlag2s(struct soap *soap, enum vbox__SymlinkReadFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__SymlinkReadFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SymlinkReadFlag(struct soap *soap, const char *tag, int id, const enum vbox__SymlinkReadFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SymlinkReadFlag), type) || soap_send(soap, soap_vbox__SymlinkReadFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SymlinkReadFlag(struct soap *soap, const char *s, enum vbox__SymlinkReadFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SymlinkReadFlag, s);
	if (map)
		*a = (enum vbox__SymlinkReadFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SymlinkReadFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SymlinkReadFlag * SOAP_FMAC4 soap_in_vbox__SymlinkReadFlag(struct soap *soap, const char *tag, enum vbox__SymlinkReadFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SymlinkReadFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SymlinkReadFlag, sizeof(enum vbox__SymlinkReadFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__SymlinkReadFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SymlinkReadFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SymlinkReadFlag, SOAP_TYPE_vbox__SymlinkReadFlag, sizeof(enum vbox__SymlinkReadFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SymlinkReadFlag(struct soap *soap, const enum vbox__SymlinkReadFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__SymlinkReadFlag(soap, tag?tag:"vbox:SymlinkReadFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__SymlinkReadFlag * SOAP_FMAC4 soap_get_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SymlinkReadFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SymlinkType
	*a = SOAP_DEFAULT_vbox__SymlinkType;
#else
	*a = (enum vbox__SymlinkType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__SymlinkType[] =
{	{ (LONG64)vbox__SymlinkType__Unknown, "Unknown" },
	{ (LONG64)vbox__SymlinkType__Directory, "Directory" },
	{ (LONG64)vbox__SymlinkType__File, "File" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SymlinkType2s(struct soap *soap, enum vbox__SymlinkType n)
{	const char *s = soap_code_str(soap_codes_vbox__SymlinkType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SymlinkType(struct soap *soap, const char *tag, int id, const enum vbox__SymlinkType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SymlinkType), type) || soap_send(soap, soap_vbox__SymlinkType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SymlinkType(struct soap *soap, const char *s, enum vbox__SymlinkType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SymlinkType, s);
	if (map)
		*a = (enum vbox__SymlinkType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SymlinkType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SymlinkType * SOAP_FMAC4 soap_in_vbox__SymlinkType(struct soap *soap, const char *tag, enum vbox__SymlinkType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SymlinkType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SymlinkType, sizeof(enum vbox__SymlinkType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__SymlinkType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SymlinkType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SymlinkType, SOAP_TYPE_vbox__SymlinkType, sizeof(enum vbox__SymlinkType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SymlinkType(struct soap *soap, const enum vbox__SymlinkType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__SymlinkType(soap, tag?tag:"vbox:SymlinkType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__SymlinkType * SOAP_FMAC4 soap_get_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SymlinkType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessPriority
	*a = SOAP_DEFAULT_vbox__ProcessPriority;
#else
	*a = (enum vbox__ProcessPriority)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessPriority[] =
{	{ (LONG64)vbox__ProcessPriority__Invalid, "Invalid" },
	{ (LONG64)vbox__ProcessPriority__Default, "Default" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessPriority2s(struct soap *soap, enum vbox__ProcessPriority n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessPriority, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessPriority(struct soap *soap, const char *tag, int id, const enum vbox__ProcessPriority *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessPriority), type) || soap_send(soap, soap_vbox__ProcessPriority2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessPriority(struct soap *soap, const char *s, enum vbox__ProcessPriority *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessPriority, s);
	if (map)
		*a = (enum vbox__ProcessPriority)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessPriority)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessPriority * SOAP_FMAC4 soap_in_vbox__ProcessPriority(struct soap *soap, const char *tag, enum vbox__ProcessPriority *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessPriority *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessPriority, sizeof(enum vbox__ProcessPriority), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessPriority(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessPriority *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessPriority, SOAP_TYPE_vbox__ProcessPriority, sizeof(enum vbox__ProcessPriority), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessPriority(struct soap *soap, const enum vbox__ProcessPriority *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessPriority(soap, tag?tag:"vbox:ProcessPriority", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessPriority * SOAP_FMAC4 soap_get_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessPriority(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessCreateFlag
	*a = SOAP_DEFAULT_vbox__ProcessCreateFlag;
#else
	*a = (enum vbox__ProcessCreateFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessCreateFlag[] =
{	{ (LONG64)vbox__ProcessCreateFlag__None, "None" },
	{ (LONG64)vbox__ProcessCreateFlag__WaitForProcessStartOnly, "WaitForProcessStartOnly" },
	{ (LONG64)vbox__ProcessCreateFlag__IgnoreOrphanedProcesses, "IgnoreOrphanedProcesses" },
	{ (LONG64)vbox__ProcessCreateFlag__Hidden, "Hidden" },
	{ (LONG64)vbox__ProcessCreateFlag__Profile, "Profile" },
	{ (LONG64)vbox__ProcessCreateFlag__WaitForStdOut, "WaitForStdOut" },
	{ (LONG64)vbox__ProcessCreateFlag__WaitForStdErr, "WaitForStdErr" },
	{ (LONG64)vbox__ProcessCreateFlag__ExpandArguments, "ExpandArguments" },
	{ (LONG64)vbox__ProcessCreateFlag__UnquotedArguments, "UnquotedArguments" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessCreateFlag2s(struct soap *soap, enum vbox__ProcessCreateFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessCreateFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessCreateFlag(struct soap *soap, const char *tag, int id, const enum vbox__ProcessCreateFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessCreateFlag), type) || soap_send(soap, soap_vbox__ProcessCreateFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessCreateFlag(struct soap *soap, const char *s, enum vbox__ProcessCreateFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessCreateFlag, s);
	if (map)
		*a = (enum vbox__ProcessCreateFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessCreateFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessCreateFlag * SOAP_FMAC4 soap_in_vbox__ProcessCreateFlag(struct soap *soap, const char *tag, enum vbox__ProcessCreateFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessCreateFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessCreateFlag, sizeof(enum vbox__ProcessCreateFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessCreateFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessCreateFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessCreateFlag, SOAP_TYPE_vbox__ProcessCreateFlag, sizeof(enum vbox__ProcessCreateFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessCreateFlag(struct soap *soap, const enum vbox__ProcessCreateFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessCreateFlag(soap, tag?tag:"vbox:ProcessCreateFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessCreateFlag * SOAP_FMAC4 soap_get_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessCreateFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjRenameFlag
	*a = SOAP_DEFAULT_vbox__FsObjRenameFlag;
#else
	*a = (enum vbox__FsObjRenameFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FsObjRenameFlag[] =
{	{ (LONG64)vbox__FsObjRenameFlag__NoReplace, "NoReplace" },
	{ (LONG64)vbox__FsObjRenameFlag__Replace, "Replace" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FsObjRenameFlag2s(struct soap *soap, enum vbox__FsObjRenameFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__FsObjRenameFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FsObjRenameFlag(struct soap *soap, const char *tag, int id, const enum vbox__FsObjRenameFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FsObjRenameFlag), type) || soap_send(soap, soap_vbox__FsObjRenameFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FsObjRenameFlag(struct soap *soap, const char *s, enum vbox__FsObjRenameFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FsObjRenameFlag, s);
	if (map)
		*a = (enum vbox__FsObjRenameFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FsObjRenameFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FsObjRenameFlag * SOAP_FMAC4 soap_in_vbox__FsObjRenameFlag(struct soap *soap, const char *tag, enum vbox__FsObjRenameFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FsObjRenameFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FsObjRenameFlag, sizeof(enum vbox__FsObjRenameFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FsObjRenameFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FsObjRenameFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FsObjRenameFlag, SOAP_TYPE_vbox__FsObjRenameFlag, sizeof(enum vbox__FsObjRenameFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FsObjRenameFlag(struct soap *soap, const enum vbox__FsObjRenameFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FsObjRenameFlag(soap, tag?tag:"vbox:FsObjRenameFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FsObjRenameFlag * SOAP_FMAC4 soap_get_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FsObjRenameFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryRemoveRecFlag
	*a = SOAP_DEFAULT_vbox__DirectoryRemoveRecFlag;
#else
	*a = (enum vbox__DirectoryRemoveRecFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DirectoryRemoveRecFlag[] =
{	{ (LONG64)vbox__DirectoryRemoveRecFlag__None, "None" },
	{ (LONG64)vbox__DirectoryRemoveRecFlag__ContentAndDir, "ContentAndDir" },
	{ (LONG64)vbox__DirectoryRemoveRecFlag__ContentOnly, "ContentOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DirectoryRemoveRecFlag2s(struct soap *soap, enum vbox__DirectoryRemoveRecFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__DirectoryRemoveRecFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *tag, int id, const enum vbox__DirectoryRemoveRecFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DirectoryRemoveRecFlag), type) || soap_send(soap, soap_vbox__DirectoryRemoveRecFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *s, enum vbox__DirectoryRemoveRecFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DirectoryRemoveRecFlag, s);
	if (map)
		*a = (enum vbox__DirectoryRemoveRecFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DirectoryRemoveRecFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DirectoryRemoveRecFlag * SOAP_FMAC4 soap_in_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *tag, enum vbox__DirectoryRemoveRecFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DirectoryRemoveRecFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DirectoryRemoveRecFlag, sizeof(enum vbox__DirectoryRemoveRecFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DirectoryRemoveRecFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DirectoryRemoveRecFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DirectoryRemoveRecFlag, SOAP_TYPE_vbox__DirectoryRemoveRecFlag, sizeof(enum vbox__DirectoryRemoveRecFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DirectoryRemoveRecFlag(struct soap *soap, const enum vbox__DirectoryRemoveRecFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DirectoryRemoveRecFlag(soap, tag?tag:"vbox:DirectoryRemoveRecFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DirectoryRemoveRecFlag * SOAP_FMAC4 soap_get_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DirectoryRemoveRecFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DirectoryCopyFlags(struct soap *soap, enum vbox__DirectoryCopyFlags *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryCopyFlags
	*a = SOAP_DEFAULT_vbox__DirectoryCopyFlags;
#else
	*a = (enum vbox__DirectoryCopyFlags)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DirectoryCopyFlags[] =
{	{ (LONG64)vbox__DirectoryCopyFlags__None, "None" },
	{ (LONG64)vbox__DirectoryCopyFlags__CopyIntoExisting, "CopyIntoExisting" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DirectoryCopyFlags2s(struct soap *soap, enum vbox__DirectoryCopyFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__DirectoryCopyFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DirectoryCopyFlags(struct soap *soap, const char *tag, int id, const enum vbox__DirectoryCopyFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DirectoryCopyFlags), type) || soap_send(soap, soap_vbox__DirectoryCopyFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DirectoryCopyFlags(struct soap *soap, const char *s, enum vbox__DirectoryCopyFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DirectoryCopyFlags, s);
	if (map)
		*a = (enum vbox__DirectoryCopyFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DirectoryCopyFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DirectoryCopyFlags * SOAP_FMAC4 soap_in_vbox__DirectoryCopyFlags(struct soap *soap, const char *tag, enum vbox__DirectoryCopyFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DirectoryCopyFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DirectoryCopyFlags, sizeof(enum vbox__DirectoryCopyFlags), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DirectoryCopyFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DirectoryCopyFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DirectoryCopyFlags, SOAP_TYPE_vbox__DirectoryCopyFlags, sizeof(enum vbox__DirectoryCopyFlags), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DirectoryCopyFlags(struct soap *soap, const enum vbox__DirectoryCopyFlags *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DirectoryCopyFlags(soap, tag?tag:"vbox:DirectoryCopyFlags", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DirectoryCopyFlags * SOAP_FMAC4 soap_get_vbox__DirectoryCopyFlags(struct soap *soap, enum vbox__DirectoryCopyFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DirectoryCopyFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryCreateFlag
	*a = SOAP_DEFAULT_vbox__DirectoryCreateFlag;
#else
	*a = (enum vbox__DirectoryCreateFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DirectoryCreateFlag[] =
{	{ (LONG64)vbox__DirectoryCreateFlag__None, "None" },
	{ (LONG64)vbox__DirectoryCreateFlag__Parents, "Parents" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DirectoryCreateFlag2s(struct soap *soap, enum vbox__DirectoryCreateFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__DirectoryCreateFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DirectoryCreateFlag(struct soap *soap, const char *tag, int id, const enum vbox__DirectoryCreateFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DirectoryCreateFlag), type) || soap_send(soap, soap_vbox__DirectoryCreateFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DirectoryCreateFlag(struct soap *soap, const char *s, enum vbox__DirectoryCreateFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DirectoryCreateFlag, s);
	if (map)
		*a = (enum vbox__DirectoryCreateFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DirectoryCreateFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DirectoryCreateFlag * SOAP_FMAC4 soap_in_vbox__DirectoryCreateFlag(struct soap *soap, const char *tag, enum vbox__DirectoryCreateFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DirectoryCreateFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DirectoryCreateFlag, sizeof(enum vbox__DirectoryCreateFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DirectoryCreateFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DirectoryCreateFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DirectoryCreateFlag, SOAP_TYPE_vbox__DirectoryCreateFlag, sizeof(enum vbox__DirectoryCreateFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DirectoryCreateFlag(struct soap *soap, const enum vbox__DirectoryCreateFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DirectoryCreateFlag(soap, tag?tag:"vbox:DirectoryCreateFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DirectoryCreateFlag * SOAP_FMAC4 soap_get_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DirectoryCreateFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FsObjMoveFlags(struct soap *soap, enum vbox__FsObjMoveFlags *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjMoveFlags
	*a = SOAP_DEFAULT_vbox__FsObjMoveFlags;
#else
	*a = (enum vbox__FsObjMoveFlags)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FsObjMoveFlags[] =
{	{ (LONG64)vbox__FsObjMoveFlags__None, "None" },
	{ (LONG64)vbox__FsObjMoveFlags__Replace, "Replace" },
	{ (LONG64)vbox__FsObjMoveFlags__FollowLinks, "FollowLinks" },
	{ (LONG64)vbox__FsObjMoveFlags__AllowDirectoryMoves, "AllowDirectoryMoves" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FsObjMoveFlags2s(struct soap *soap, enum vbox__FsObjMoveFlags n)
{	const char *s = soap_code_str(soap_codes_vbox__FsObjMoveFlags, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FsObjMoveFlags(struct soap *soap, const char *tag, int id, const enum vbox__FsObjMoveFlags *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FsObjMoveFlags), type) || soap_send(soap, soap_vbox__FsObjMoveFlags2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FsObjMoveFlags(struct soap *soap, const char *s, enum vbox__FsObjMoveFlags *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FsObjMoveFlags, s);
	if (map)
		*a = (enum vbox__FsObjMoveFlags)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FsObjMoveFlags)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FsObjMoveFlags * SOAP_FMAC4 soap_in_vbox__FsObjMoveFlags(struct soap *soap, const char *tag, enum vbox__FsObjMoveFlags *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FsObjMoveFlags *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FsObjMoveFlags, sizeof(enum vbox__FsObjMoveFlags), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FsObjMoveFlags(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FsObjMoveFlags *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FsObjMoveFlags, SOAP_TYPE_vbox__FsObjMoveFlags, sizeof(enum vbox__FsObjMoveFlags), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FsObjMoveFlags(struct soap *soap, const enum vbox__FsObjMoveFlags *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FsObjMoveFlags(soap, tag?tag:"vbox:FsObjMoveFlags", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FsObjMoveFlags * SOAP_FMAC4 soap_get_vbox__FsObjMoveFlags(struct soap *soap, enum vbox__FsObjMoveFlags *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FsObjMoveFlags(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileCopyFlag
	*a = SOAP_DEFAULT_vbox__FileCopyFlag;
#else
	*a = (enum vbox__FileCopyFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileCopyFlag[] =
{	{ (LONG64)vbox__FileCopyFlag__None, "None" },
	{ (LONG64)vbox__FileCopyFlag__NoReplace, "NoReplace" },
	{ (LONG64)vbox__FileCopyFlag__FollowLinks, "FollowLinks" },
	{ (LONG64)vbox__FileCopyFlag__Update, "Update" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileCopyFlag2s(struct soap *soap, enum vbox__FileCopyFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__FileCopyFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileCopyFlag(struct soap *soap, const char *tag, int id, const enum vbox__FileCopyFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileCopyFlag), type) || soap_send(soap, soap_vbox__FileCopyFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileCopyFlag(struct soap *soap, const char *s, enum vbox__FileCopyFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileCopyFlag, s);
	if (map)
		*a = (enum vbox__FileCopyFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileCopyFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileCopyFlag * SOAP_FMAC4 soap_in_vbox__FileCopyFlag(struct soap *soap, const char *tag, enum vbox__FileCopyFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileCopyFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileCopyFlag, sizeof(enum vbox__FileCopyFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileCopyFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileCopyFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileCopyFlag, SOAP_TYPE_vbox__FileCopyFlag, sizeof(enum vbox__FileCopyFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileCopyFlag(struct soap *soap, const enum vbox__FileCopyFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileCopyFlag(soap, tag?tag:"vbox:FileCopyFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileCopyFlag * SOAP_FMAC4 soap_get_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileCopyFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessWaitResult
	*a = SOAP_DEFAULT_vbox__ProcessWaitResult;
#else
	*a = (enum vbox__ProcessWaitResult)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessWaitResult[] =
{	{ (LONG64)vbox__ProcessWaitResult__None, "None" },
	{ (LONG64)vbox__ProcessWaitResult__Start, "Start" },
	{ (LONG64)vbox__ProcessWaitResult__Terminate, "Terminate" },
	{ (LONG64)vbox__ProcessWaitResult__Status, "Status" },
	{ (LONG64)vbox__ProcessWaitResult__Error, "Error" },
	{ (LONG64)vbox__ProcessWaitResult__Timeout, "Timeout" },
	{ (LONG64)vbox__ProcessWaitResult__StdIn, "StdIn" },
	{ (LONG64)vbox__ProcessWaitResult__StdOut, "StdOut" },
	{ (LONG64)vbox__ProcessWaitResult__StdErr, "StdErr" },
	{ (LONG64)vbox__ProcessWaitResult__WaitFlagNotSupported, "WaitFlagNotSupported" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessWaitResult2s(struct soap *soap, enum vbox__ProcessWaitResult n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessWaitResult, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessWaitResult(struct soap *soap, const char *tag, int id, const enum vbox__ProcessWaitResult *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessWaitResult), type) || soap_send(soap, soap_vbox__ProcessWaitResult2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessWaitResult(struct soap *soap, const char *s, enum vbox__ProcessWaitResult *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessWaitResult, s);
	if (map)
		*a = (enum vbox__ProcessWaitResult)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 9)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessWaitResult)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessWaitResult * SOAP_FMAC4 soap_in_vbox__ProcessWaitResult(struct soap *soap, const char *tag, enum vbox__ProcessWaitResult *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessWaitResult *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessWaitResult, sizeof(enum vbox__ProcessWaitResult), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessWaitResult(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessWaitResult *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessWaitResult, SOAP_TYPE_vbox__ProcessWaitResult, sizeof(enum vbox__ProcessWaitResult), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessWaitResult(struct soap *soap, const enum vbox__ProcessWaitResult *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessWaitResult(soap, tag?tag:"vbox:ProcessWaitResult", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessWaitResult * SOAP_FMAC4 soap_get_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessWaitResult(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessWaitForFlag
	*a = SOAP_DEFAULT_vbox__ProcessWaitForFlag;
#else
	*a = (enum vbox__ProcessWaitForFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessWaitForFlag[] =
{	{ (LONG64)vbox__ProcessWaitForFlag__None, "None" },
	{ (LONG64)vbox__ProcessWaitForFlag__Start, "Start" },
	{ (LONG64)vbox__ProcessWaitForFlag__Terminate, "Terminate" },
	{ (LONG64)vbox__ProcessWaitForFlag__StdIn, "StdIn" },
	{ (LONG64)vbox__ProcessWaitForFlag__StdOut, "StdOut" },
	{ (LONG64)vbox__ProcessWaitForFlag__StdErr, "StdErr" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessWaitForFlag2s(struct soap *soap, enum vbox__ProcessWaitForFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessWaitForFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessWaitForFlag(struct soap *soap, const char *tag, int id, const enum vbox__ProcessWaitForFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessWaitForFlag), type) || soap_send(soap, soap_vbox__ProcessWaitForFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessWaitForFlag(struct soap *soap, const char *s, enum vbox__ProcessWaitForFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessWaitForFlag, s);
	if (map)
		*a = (enum vbox__ProcessWaitForFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessWaitForFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessWaitForFlag * SOAP_FMAC4 soap_in_vbox__ProcessWaitForFlag(struct soap *soap, const char *tag, enum vbox__ProcessWaitForFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessWaitForFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessWaitForFlag, sizeof(enum vbox__ProcessWaitForFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessWaitForFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessWaitForFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessWaitForFlag, SOAP_TYPE_vbox__ProcessWaitForFlag, sizeof(enum vbox__ProcessWaitForFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessWaitForFlag(struct soap *soap, const enum vbox__ProcessWaitForFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessWaitForFlag(soap, tag?tag:"vbox:ProcessWaitForFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessWaitForFlag * SOAP_FMAC4 soap_get_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessWaitForFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessOutputFlag
	*a = SOAP_DEFAULT_vbox__ProcessOutputFlag;
#else
	*a = (enum vbox__ProcessOutputFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessOutputFlag[] =
{	{ (LONG64)vbox__ProcessOutputFlag__None, "None" },
	{ (LONG64)vbox__ProcessOutputFlag__StdErr, "StdErr" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessOutputFlag2s(struct soap *soap, enum vbox__ProcessOutputFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessOutputFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessOutputFlag(struct soap *soap, const char *tag, int id, const enum vbox__ProcessOutputFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessOutputFlag), type) || soap_send(soap, soap_vbox__ProcessOutputFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessOutputFlag(struct soap *soap, const char *s, enum vbox__ProcessOutputFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessOutputFlag, s);
	if (map)
		*a = (enum vbox__ProcessOutputFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessOutputFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessOutputFlag * SOAP_FMAC4 soap_in_vbox__ProcessOutputFlag(struct soap *soap, const char *tag, enum vbox__ProcessOutputFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessOutputFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessOutputFlag, sizeof(enum vbox__ProcessOutputFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessOutputFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessOutputFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessOutputFlag, SOAP_TYPE_vbox__ProcessOutputFlag, sizeof(enum vbox__ProcessOutputFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessOutputFlag(struct soap *soap, const enum vbox__ProcessOutputFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessOutputFlag(soap, tag?tag:"vbox:ProcessOutputFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessOutputFlag * SOAP_FMAC4 soap_get_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessOutputFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessInputFlag
	*a = SOAP_DEFAULT_vbox__ProcessInputFlag;
#else
	*a = (enum vbox__ProcessInputFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessInputFlag[] =
{	{ (LONG64)vbox__ProcessInputFlag__None, "None" },
	{ (LONG64)vbox__ProcessInputFlag__EndOfFile, "EndOfFile" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessInputFlag2s(struct soap *soap, enum vbox__ProcessInputFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessInputFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessInputFlag(struct soap *soap, const char *tag, int id, const enum vbox__ProcessInputFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessInputFlag), type) || soap_send(soap, soap_vbox__ProcessInputFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessInputFlag(struct soap *soap, const char *s, enum vbox__ProcessInputFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessInputFlag, s);
	if (map)
		*a = (enum vbox__ProcessInputFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessInputFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessInputFlag * SOAP_FMAC4 soap_in_vbox__ProcessInputFlag(struct soap *soap, const char *tag, enum vbox__ProcessInputFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessInputFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessInputFlag, sizeof(enum vbox__ProcessInputFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessInputFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessInputFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessInputFlag, SOAP_TYPE_vbox__ProcessInputFlag, sizeof(enum vbox__ProcessInputFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessInputFlag(struct soap *soap, const enum vbox__ProcessInputFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessInputFlag(soap, tag?tag:"vbox:ProcessInputFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessInputFlag * SOAP_FMAC4 soap_get_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessInputFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileSeekOrigin
	*a = SOAP_DEFAULT_vbox__FileSeekOrigin;
#else
	*a = (enum vbox__FileSeekOrigin)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FileSeekOrigin[] =
{	{ (LONG64)vbox__FileSeekOrigin__Begin, "Begin" },
	{ (LONG64)vbox__FileSeekOrigin__Current, "Current" },
	{ (LONG64)vbox__FileSeekOrigin__End, "End" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FileSeekOrigin2s(struct soap *soap, enum vbox__FileSeekOrigin n)
{	const char *s = soap_code_str(soap_codes_vbox__FileSeekOrigin, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FileSeekOrigin(struct soap *soap, const char *tag, int id, const enum vbox__FileSeekOrigin *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FileSeekOrigin), type) || soap_send(soap, soap_vbox__FileSeekOrigin2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FileSeekOrigin(struct soap *soap, const char *s, enum vbox__FileSeekOrigin *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FileSeekOrigin, s);
	if (map)
		*a = (enum vbox__FileSeekOrigin)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FileSeekOrigin)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FileSeekOrigin * SOAP_FMAC4 soap_in_vbox__FileSeekOrigin(struct soap *soap, const char *tag, enum vbox__FileSeekOrigin *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FileSeekOrigin *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FileSeekOrigin, sizeof(enum vbox__FileSeekOrigin), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FileSeekOrigin(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FileSeekOrigin *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FileSeekOrigin, SOAP_TYPE_vbox__FileSeekOrigin, sizeof(enum vbox__FileSeekOrigin), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FileSeekOrigin(struct soap *soap, const enum vbox__FileSeekOrigin *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FileSeekOrigin(soap, tag?tag:"vbox:FileSeekOrigin", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FileSeekOrigin * SOAP_FMAC4 soap_get_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FileSeekOrigin(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestUserState
	*a = SOAP_DEFAULT_vbox__GuestUserState;
#else
	*a = (enum vbox__GuestUserState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestUserState[] =
{	{ (LONG64)vbox__GuestUserState__Unknown, "Unknown" },
	{ (LONG64)vbox__GuestUserState__LoggedIn, "LoggedIn" },
	{ (LONG64)vbox__GuestUserState__LoggedOut, "LoggedOut" },
	{ (LONG64)vbox__GuestUserState__Locked, "Locked" },
	{ (LONG64)vbox__GuestUserState__Unlocked, "Unlocked" },
	{ (LONG64)vbox__GuestUserState__Disabled, "Disabled" },
	{ (LONG64)vbox__GuestUserState__Idle, "Idle" },
	{ (LONG64)vbox__GuestUserState__InUse, "InUse" },
	{ (LONG64)vbox__GuestUserState__Created, "Created" },
	{ (LONG64)vbox__GuestUserState__Deleted, "Deleted" },
	{ (LONG64)vbox__GuestUserState__SessionChanged, "SessionChanged" },
	{ (LONG64)vbox__GuestUserState__CredentialsChanged, "CredentialsChanged" },
	{ (LONG64)vbox__GuestUserState__RoleChanged, "RoleChanged" },
	{ (LONG64)vbox__GuestUserState__GroupAdded, "GroupAdded" },
	{ (LONG64)vbox__GuestUserState__GroupRemoved, "GroupRemoved" },
	{ (LONG64)vbox__GuestUserState__Elevated, "Elevated" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestUserState2s(struct soap *soap, enum vbox__GuestUserState n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestUserState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestUserState(struct soap *soap, const char *tag, int id, const enum vbox__GuestUserState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestUserState), type) || soap_send(soap, soap_vbox__GuestUserState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestUserState(struct soap *soap, const char *s, enum vbox__GuestUserState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestUserState, s);
	if (map)
		*a = (enum vbox__GuestUserState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 15)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestUserState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestUserState * SOAP_FMAC4 soap_in_vbox__GuestUserState(struct soap *soap, const char *tag, enum vbox__GuestUserState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestUserState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestUserState, sizeof(enum vbox__GuestUserState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestUserState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestUserState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestUserState, SOAP_TYPE_vbox__GuestUserState, sizeof(enum vbox__GuestUserState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestUserState(struct soap *soap, const enum vbox__GuestUserState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestUserState(soap, tag?tag:"vbox:GuestUserState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestUserState * SOAP_FMAC4 soap_get_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestUserState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionWaitResult
	*a = SOAP_DEFAULT_vbox__GuestSessionWaitResult;
#else
	*a = (enum vbox__GuestSessionWaitResult)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestSessionWaitResult[] =
{	{ (LONG64)vbox__GuestSessionWaitResult__None, "None" },
	{ (LONG64)vbox__GuestSessionWaitResult__Start, "Start" },
	{ (LONG64)vbox__GuestSessionWaitResult__Terminate, "Terminate" },
	{ (LONG64)vbox__GuestSessionWaitResult__Status, "Status" },
	{ (LONG64)vbox__GuestSessionWaitResult__Error, "Error" },
	{ (LONG64)vbox__GuestSessionWaitResult__Timeout, "Timeout" },
	{ (LONG64)vbox__GuestSessionWaitResult__WaitFlagNotSupported, "WaitFlagNotSupported" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestSessionWaitResult2s(struct soap *soap, enum vbox__GuestSessionWaitResult n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestSessionWaitResult, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestSessionWaitResult(struct soap *soap, const char *tag, int id, const enum vbox__GuestSessionWaitResult *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestSessionWaitResult), type) || soap_send(soap, soap_vbox__GuestSessionWaitResult2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestSessionWaitResult(struct soap *soap, const char *s, enum vbox__GuestSessionWaitResult *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestSessionWaitResult, s);
	if (map)
		*a = (enum vbox__GuestSessionWaitResult)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestSessionWaitResult)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestSessionWaitResult * SOAP_FMAC4 soap_in_vbox__GuestSessionWaitResult(struct soap *soap, const char *tag, enum vbox__GuestSessionWaitResult *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestSessionWaitResult *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestSessionWaitResult, sizeof(enum vbox__GuestSessionWaitResult), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestSessionWaitResult(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestSessionWaitResult *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestSessionWaitResult, SOAP_TYPE_vbox__GuestSessionWaitResult, sizeof(enum vbox__GuestSessionWaitResult), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestSessionWaitResult(struct soap *soap, const enum vbox__GuestSessionWaitResult *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestSessionWaitResult(soap, tag?tag:"vbox:GuestSessionWaitResult", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestSessionWaitResult * SOAP_FMAC4 soap_get_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestSessionWaitResult(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionWaitForFlag
	*a = SOAP_DEFAULT_vbox__GuestSessionWaitForFlag;
#else
	*a = (enum vbox__GuestSessionWaitForFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestSessionWaitForFlag[] =
{	{ (LONG64)vbox__GuestSessionWaitForFlag__None, "None" },
	{ (LONG64)vbox__GuestSessionWaitForFlag__Start, "Start" },
	{ (LONG64)vbox__GuestSessionWaitForFlag__Terminate, "Terminate" },
	{ (LONG64)vbox__GuestSessionWaitForFlag__Status, "Status" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestSessionWaitForFlag2s(struct soap *soap, enum vbox__GuestSessionWaitForFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestSessionWaitForFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *tag, int id, const enum vbox__GuestSessionWaitForFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestSessionWaitForFlag), type) || soap_send(soap, soap_vbox__GuestSessionWaitForFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestSessionWaitForFlag(struct soap *soap, const char *s, enum vbox__GuestSessionWaitForFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestSessionWaitForFlag, s);
	if (map)
		*a = (enum vbox__GuestSessionWaitForFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestSessionWaitForFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestSessionWaitForFlag * SOAP_FMAC4 soap_in_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *tag, enum vbox__GuestSessionWaitForFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestSessionWaitForFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestSessionWaitForFlag, sizeof(enum vbox__GuestSessionWaitForFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestSessionWaitForFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestSessionWaitForFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestSessionWaitForFlag, SOAP_TYPE_vbox__GuestSessionWaitForFlag, sizeof(enum vbox__GuestSessionWaitForFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestSessionWaitForFlag(struct soap *soap, const enum vbox__GuestSessionWaitForFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestSessionWaitForFlag(soap, tag?tag:"vbox:GuestSessionWaitForFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestSessionWaitForFlag * SOAP_FMAC4 soap_get_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestSessionWaitForFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionStatus
	*a = SOAP_DEFAULT_vbox__GuestSessionStatus;
#else
	*a = (enum vbox__GuestSessionStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GuestSessionStatus[] =
{	{ (LONG64)vbox__GuestSessionStatus__Undefined, "Undefined" },
	{ (LONG64)vbox__GuestSessionStatus__Starting, "Starting" },
	{ (LONG64)vbox__GuestSessionStatus__Started, "Started" },
	{ (LONG64)vbox__GuestSessionStatus__Terminating, "Terminating" },
	{ (LONG64)vbox__GuestSessionStatus__Terminated, "Terminated" },
	{ (LONG64)vbox__GuestSessionStatus__TimedOutKilled, "TimedOutKilled" },
	{ (LONG64)vbox__GuestSessionStatus__TimedOutAbnormally, "TimedOutAbnormally" },
	{ (LONG64)vbox__GuestSessionStatus__Down, "Down" },
	{ (LONG64)vbox__GuestSessionStatus__Error, "Error" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GuestSessionStatus2s(struct soap *soap, enum vbox__GuestSessionStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__GuestSessionStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GuestSessionStatus(struct soap *soap, const char *tag, int id, const enum vbox__GuestSessionStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GuestSessionStatus), type) || soap_send(soap, soap_vbox__GuestSessionStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GuestSessionStatus(struct soap *soap, const char *s, enum vbox__GuestSessionStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GuestSessionStatus, s);
	if (map)
		*a = (enum vbox__GuestSessionStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GuestSessionStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GuestSessionStatus * SOAP_FMAC4 soap_in_vbox__GuestSessionStatus(struct soap *soap, const char *tag, enum vbox__GuestSessionStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GuestSessionStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GuestSessionStatus, sizeof(enum vbox__GuestSessionStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GuestSessionStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GuestSessionStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GuestSessionStatus, SOAP_TYPE_vbox__GuestSessionStatus, sizeof(enum vbox__GuestSessionStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GuestSessionStatus(struct soap *soap, const enum vbox__GuestSessionStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GuestSessionStatus(soap, tag?tag:"vbox:GuestSessionStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GuestSessionStatus * SOAP_FMAC4 soap_get_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GuestSessionStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsUpdateFlag
	*a = SOAP_DEFAULT_vbox__AdditionsUpdateFlag;
#else
	*a = (enum vbox__AdditionsUpdateFlag)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AdditionsUpdateFlag[] =
{	{ (LONG64)vbox__AdditionsUpdateFlag__None, "None" },
	{ (LONG64)vbox__AdditionsUpdateFlag__WaitForUpdateStartOnly, "WaitForUpdateStartOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AdditionsUpdateFlag2s(struct soap *soap, enum vbox__AdditionsUpdateFlag n)
{	const char *s = soap_code_str(soap_codes_vbox__AdditionsUpdateFlag, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AdditionsUpdateFlag(struct soap *soap, const char *tag, int id, const enum vbox__AdditionsUpdateFlag *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AdditionsUpdateFlag), type) || soap_send(soap, soap_vbox__AdditionsUpdateFlag2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AdditionsUpdateFlag(struct soap *soap, const char *s, enum vbox__AdditionsUpdateFlag *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AdditionsUpdateFlag, s);
	if (map)
		*a = (enum vbox__AdditionsUpdateFlag)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AdditionsUpdateFlag)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AdditionsUpdateFlag * SOAP_FMAC4 soap_in_vbox__AdditionsUpdateFlag(struct soap *soap, const char *tag, enum vbox__AdditionsUpdateFlag *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AdditionsUpdateFlag *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AdditionsUpdateFlag, sizeof(enum vbox__AdditionsUpdateFlag), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AdditionsUpdateFlag(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AdditionsUpdateFlag *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AdditionsUpdateFlag, SOAP_TYPE_vbox__AdditionsUpdateFlag, sizeof(enum vbox__AdditionsUpdateFlag), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AdditionsUpdateFlag(struct soap *soap, const enum vbox__AdditionsUpdateFlag *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AdditionsUpdateFlag(soap, tag?tag:"vbox:AdditionsUpdateFlag", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AdditionsUpdateFlag * SOAP_FMAC4 soap_get_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AdditionsUpdateFlag(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsRunLevelType
	*a = SOAP_DEFAULT_vbox__AdditionsRunLevelType;
#else
	*a = (enum vbox__AdditionsRunLevelType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AdditionsRunLevelType[] =
{	{ (LONG64)vbox__AdditionsRunLevelType__None, "None" },
	{ (LONG64)vbox__AdditionsRunLevelType__System, "System" },
	{ (LONG64)vbox__AdditionsRunLevelType__Userland, "Userland" },
	{ (LONG64)vbox__AdditionsRunLevelType__Desktop, "Desktop" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AdditionsRunLevelType2s(struct soap *soap, enum vbox__AdditionsRunLevelType n)
{	const char *s = soap_code_str(soap_codes_vbox__AdditionsRunLevelType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AdditionsRunLevelType(struct soap *soap, const char *tag, int id, const enum vbox__AdditionsRunLevelType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AdditionsRunLevelType), type) || soap_send(soap, soap_vbox__AdditionsRunLevelType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AdditionsRunLevelType(struct soap *soap, const char *s, enum vbox__AdditionsRunLevelType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AdditionsRunLevelType, s);
	if (map)
		*a = (enum vbox__AdditionsRunLevelType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AdditionsRunLevelType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AdditionsRunLevelType * SOAP_FMAC4 soap_in_vbox__AdditionsRunLevelType(struct soap *soap, const char *tag, enum vbox__AdditionsRunLevelType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AdditionsRunLevelType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AdditionsRunLevelType, sizeof(enum vbox__AdditionsRunLevelType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AdditionsRunLevelType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AdditionsRunLevelType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AdditionsRunLevelType, SOAP_TYPE_vbox__AdditionsRunLevelType, sizeof(enum vbox__AdditionsRunLevelType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AdditionsRunLevelType(struct soap *soap, const enum vbox__AdditionsRunLevelType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AdditionsRunLevelType(soap, tag?tag:"vbox:AdditionsRunLevelType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AdditionsRunLevelType * SOAP_FMAC4 soap_get_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AdditionsRunLevelType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityStatus
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityStatus;
#else
	*a = (enum vbox__AdditionsFacilityStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AdditionsFacilityStatus[] =
{	{ (LONG64)vbox__AdditionsFacilityStatus__Inactive, "Inactive" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Paused, "Paused" },
	{ (LONG64)vbox__AdditionsFacilityStatus__PreInit, "PreInit" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Init, "Init" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Active, "Active" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Terminating, "Terminating" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Terminated, "Terminated" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Failed, "Failed" },
	{ (LONG64)vbox__AdditionsFacilityStatus__Unknown, "Unknown" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AdditionsFacilityStatus2s(struct soap *soap, enum vbox__AdditionsFacilityStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__AdditionsFacilityStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AdditionsFacilityStatus(struct soap *soap, const char *tag, int id, const enum vbox__AdditionsFacilityStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AdditionsFacilityStatus), type) || soap_send(soap, soap_vbox__AdditionsFacilityStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AdditionsFacilityStatus(struct soap *soap, const char *s, enum vbox__AdditionsFacilityStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AdditionsFacilityStatus, s);
	if (map)
		*a = (enum vbox__AdditionsFacilityStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 8)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AdditionsFacilityStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AdditionsFacilityStatus * SOAP_FMAC4 soap_in_vbox__AdditionsFacilityStatus(struct soap *soap, const char *tag, enum vbox__AdditionsFacilityStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AdditionsFacilityStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AdditionsFacilityStatus, sizeof(enum vbox__AdditionsFacilityStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AdditionsFacilityStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AdditionsFacilityStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AdditionsFacilityStatus, SOAP_TYPE_vbox__AdditionsFacilityStatus, sizeof(enum vbox__AdditionsFacilityStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AdditionsFacilityStatus(struct soap *soap, const enum vbox__AdditionsFacilityStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AdditionsFacilityStatus(soap, tag?tag:"vbox:AdditionsFacilityStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AdditionsFacilityStatus * SOAP_FMAC4 soap_get_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AdditionsFacilityStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityClass
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityClass;
#else
	*a = (enum vbox__AdditionsFacilityClass)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AdditionsFacilityClass[] =
{	{ (LONG64)vbox__AdditionsFacilityClass__None, "None" },
	{ (LONG64)vbox__AdditionsFacilityClass__Driver, "Driver" },
	{ (LONG64)vbox__AdditionsFacilityClass__Service, "Service" },
	{ (LONG64)vbox__AdditionsFacilityClass__Program, "Program" },
	{ (LONG64)vbox__AdditionsFacilityClass__Feature, "Feature" },
	{ (LONG64)vbox__AdditionsFacilityClass__ThirdParty, "ThirdParty" },
	{ (LONG64)vbox__AdditionsFacilityClass__All, "All" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AdditionsFacilityClass2s(struct soap *soap, enum vbox__AdditionsFacilityClass n)
{	const char *s = soap_code_str(soap_codes_vbox__AdditionsFacilityClass, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AdditionsFacilityClass(struct soap *soap, const char *tag, int id, const enum vbox__AdditionsFacilityClass *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AdditionsFacilityClass), type) || soap_send(soap, soap_vbox__AdditionsFacilityClass2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AdditionsFacilityClass(struct soap *soap, const char *s, enum vbox__AdditionsFacilityClass *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AdditionsFacilityClass, s);
	if (map)
		*a = (enum vbox__AdditionsFacilityClass)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AdditionsFacilityClass)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AdditionsFacilityClass * SOAP_FMAC4 soap_in_vbox__AdditionsFacilityClass(struct soap *soap, const char *tag, enum vbox__AdditionsFacilityClass *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AdditionsFacilityClass *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AdditionsFacilityClass, sizeof(enum vbox__AdditionsFacilityClass), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AdditionsFacilityClass(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AdditionsFacilityClass *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AdditionsFacilityClass, SOAP_TYPE_vbox__AdditionsFacilityClass, sizeof(enum vbox__AdditionsFacilityClass), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AdditionsFacilityClass(struct soap *soap, const enum vbox__AdditionsFacilityClass *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AdditionsFacilityClass(soap, tag?tag:"vbox:AdditionsFacilityClass", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AdditionsFacilityClass * SOAP_FMAC4 soap_get_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AdditionsFacilityClass(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityType
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityType;
#else
	*a = (enum vbox__AdditionsFacilityType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AdditionsFacilityType[] =
{	{ (LONG64)vbox__AdditionsFacilityType__None, "None" },
	{ (LONG64)vbox__AdditionsFacilityType__VBoxGuestDriver, "VBoxGuestDriver" },
	{ (LONG64)vbox__AdditionsFacilityType__AutoLogon, "AutoLogon" },
	{ (LONG64)vbox__AdditionsFacilityType__VBoxService, "VBoxService" },
	{ (LONG64)vbox__AdditionsFacilityType__VBoxTrayClient, "VBoxTrayClient" },
	{ (LONG64)vbox__AdditionsFacilityType__Seamless, "Seamless" },
	{ (LONG64)vbox__AdditionsFacilityType__Graphics, "Graphics" },
	{ (LONG64)vbox__AdditionsFacilityType__All, "All" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AdditionsFacilityType2s(struct soap *soap, enum vbox__AdditionsFacilityType n)
{	const char *s = soap_code_str(soap_codes_vbox__AdditionsFacilityType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AdditionsFacilityType(struct soap *soap, const char *tag, int id, const enum vbox__AdditionsFacilityType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AdditionsFacilityType), type) || soap_send(soap, soap_vbox__AdditionsFacilityType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AdditionsFacilityType(struct soap *soap, const char *s, enum vbox__AdditionsFacilityType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AdditionsFacilityType, s);
	if (map)
		*a = (enum vbox__AdditionsFacilityType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AdditionsFacilityType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AdditionsFacilityType * SOAP_FMAC4 soap_in_vbox__AdditionsFacilityType(struct soap *soap, const char *tag, enum vbox__AdditionsFacilityType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AdditionsFacilityType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AdditionsFacilityType, sizeof(enum vbox__AdditionsFacilityType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AdditionsFacilityType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AdditionsFacilityType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AdditionsFacilityType, SOAP_TYPE_vbox__AdditionsFacilityType, sizeof(enum vbox__AdditionsFacilityType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AdditionsFacilityType(struct soap *soap, const enum vbox__AdditionsFacilityType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AdditionsFacilityType(soap, tag?tag:"vbox:AdditionsFacilityType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AdditionsFacilityType * SOAP_FMAC4 soap_get_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AdditionsFacilityType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceType;
#else
	*a = (enum vbox__HostNetworkInterfaceType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceType[] =
{	{ (LONG64)vbox__HostNetworkInterfaceType__Bridged, "Bridged" },
	{ (LONG64)vbox__HostNetworkInterfaceType__HostOnly, "HostOnly" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceType2s(struct soap *soap, enum vbox__HostNetworkInterfaceType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceType, sizeof(enum vbox__HostNetworkInterfaceType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__HostNetworkInterfaceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceType, SOAP_TYPE_vbox__HostNetworkInterfaceType, sizeof(enum vbox__HostNetworkInterfaceType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceType(struct soap *soap, const enum vbox__HostNetworkInterfaceType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__HostNetworkInterfaceType(soap, tag?tag:"vbox:HostNetworkInterfaceType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus;
#else
	*a = (enum vbox__HostNetworkInterfaceStatus)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceStatus[] =
{	{ (LONG64)vbox__HostNetworkInterfaceStatus__Unknown, "Unknown" },
	{ (LONG64)vbox__HostNetworkInterfaceStatus__Up, "Up" },
	{ (LONG64)vbox__HostNetworkInterfaceStatus__Down, "Down" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceStatus2s(struct soap *soap, enum vbox__HostNetworkInterfaceStatus n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceStatus, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceStatus2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceStatus *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceStatus, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceStatus)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceStatus)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceStatus *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, sizeof(enum vbox__HostNetworkInterfaceStatus), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__HostNetworkInterfaceStatus(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceStatus *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, SOAP_TYPE_vbox__HostNetworkInterfaceStatus, sizeof(enum vbox__HostNetworkInterfaceStatus), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceStatus(struct soap *soap, const enum vbox__HostNetworkInterfaceStatus *a, const char *tag, const char *type)
{
	if (soap_out_vbox__HostNetworkInterfaceStatus(soap, tag?tag:"vbox:HostNetworkInterfaceStatus", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceStatus * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceStatus(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType;
#else
	*a = (enum vbox__HostNetworkInterfaceMediumType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__HostNetworkInterfaceMediumType[] =
{	{ (LONG64)vbox__HostNetworkInterfaceMediumType__Unknown, "Unknown" },
	{ (LONG64)vbox__HostNetworkInterfaceMediumType__Ethernet, "Ethernet" },
	{ (LONG64)vbox__HostNetworkInterfaceMediumType__PPP, "PPP" },
	{ (LONG64)vbox__HostNetworkInterfaceMediumType__SLIP, "SLIP" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HostNetworkInterfaceMediumType2s(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType n)
{	const char *s = soap_code_str(soap_codes_vbox__HostNetworkInterfaceMediumType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, int id, const enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType), type) || soap_send(soap, soap_vbox__HostNetworkInterfaceMediumType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *s, enum vbox__HostNetworkInterfaceMediumType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HostNetworkInterfaceMediumType, s);
	if (map)
		*a = (enum vbox__HostNetworkInterfaceMediumType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HostNetworkInterfaceMediumType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_in_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *tag, enum vbox__HostNetworkInterfaceMediumType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, sizeof(enum vbox__HostNetworkInterfaceMediumType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__HostNetworkInterfaceMediumType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HostNetworkInterfaceMediumType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, SOAP_TYPE_vbox__HostNetworkInterfaceMediumType, sizeof(enum vbox__HostNetworkInterfaceMediumType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const enum vbox__HostNetworkInterfaceMediumType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__HostNetworkInterfaceMediumType(soap, tag?tag:"vbox:HostNetworkInterfaceMediumType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__HostNetworkInterfaceMediumType * SOAP_FMAC4 soap_get_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HostNetworkInterfaceMediumType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AutostopType
	*a = SOAP_DEFAULT_vbox__AutostopType;
#else
	*a = (enum vbox__AutostopType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AutostopType[] =
{	{ (LONG64)vbox__AutostopType__Disabled, "Disabled" },
	{ (LONG64)vbox__AutostopType__SaveState, "SaveState" },
	{ (LONG64)vbox__AutostopType__PowerOff, "PowerOff" },
	{ (LONG64)vbox__AutostopType__AcpiShutdown, "AcpiShutdown" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AutostopType2s(struct soap *soap, enum vbox__AutostopType n)
{	const char *s = soap_code_str(soap_codes_vbox__AutostopType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AutostopType(struct soap *soap, const char *tag, int id, const enum vbox__AutostopType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AutostopType), type) || soap_send(soap, soap_vbox__AutostopType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AutostopType(struct soap *soap, const char *s, enum vbox__AutostopType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AutostopType, s);
	if (map)
		*a = (enum vbox__AutostopType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AutostopType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AutostopType * SOAP_FMAC4 soap_in_vbox__AutostopType(struct soap *soap, const char *tag, enum vbox__AutostopType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AutostopType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AutostopType, sizeof(enum vbox__AutostopType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AutostopType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AutostopType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AutostopType, SOAP_TYPE_vbox__AutostopType, sizeof(enum vbox__AutostopType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AutostopType(struct soap *soap, const enum vbox__AutostopType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AutostopType(soap, tag?tag:"vbox:AutostopType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AutostopType * SOAP_FMAC4 soap_get_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AutostopType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloneOptions
	*a = SOAP_DEFAULT_vbox__CloneOptions;
#else
	*a = (enum vbox__CloneOptions)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__CloneOptions[] =
{	{ (LONG64)vbox__CloneOptions__Link, "Link" },
	{ (LONG64)vbox__CloneOptions__KeepAllMACs, "KeepAllMACs" },
	{ (LONG64)vbox__CloneOptions__KeepNATMACs, "KeepNATMACs" },
	{ (LONG64)vbox__CloneOptions__KeepDiskNames, "KeepDiskNames" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CloneOptions2s(struct soap *soap, enum vbox__CloneOptions n)
{	const char *s = soap_code_str(soap_codes_vbox__CloneOptions, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CloneOptions(struct soap *soap, const char *tag, int id, const enum vbox__CloneOptions *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CloneOptions), type) || soap_send(soap, soap_vbox__CloneOptions2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CloneOptions(struct soap *soap, const char *s, enum vbox__CloneOptions *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CloneOptions, s);
	if (map)
		*a = (enum vbox__CloneOptions)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CloneOptions)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CloneOptions * SOAP_FMAC4 soap_in_vbox__CloneOptions(struct soap *soap, const char *tag, enum vbox__CloneOptions *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CloneOptions *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CloneOptions, sizeof(enum vbox__CloneOptions), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__CloneOptions(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CloneOptions *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CloneOptions, SOAP_TYPE_vbox__CloneOptions, sizeof(enum vbox__CloneOptions), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CloneOptions(struct soap *soap, const enum vbox__CloneOptions *a, const char *tag, const char *type)
{
	if (soap_out_vbox__CloneOptions(soap, tag?tag:"vbox:CloneOptions", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__CloneOptions * SOAP_FMAC4 soap_get_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CloneOptions(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloneMode
	*a = SOAP_DEFAULT_vbox__CloneMode;
#else
	*a = (enum vbox__CloneMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__CloneMode[] =
{	{ (LONG64)vbox__CloneMode__MachineState, "MachineState" },
	{ (LONG64)vbox__CloneMode__MachineAndChildStates, "MachineAndChildStates" },
	{ (LONG64)vbox__CloneMode__AllStates, "AllStates" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CloneMode2s(struct soap *soap, enum vbox__CloneMode n)
{	const char *s = soap_code_str(soap_codes_vbox__CloneMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CloneMode(struct soap *soap, const char *tag, int id, const enum vbox__CloneMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CloneMode), type) || soap_send(soap, soap_vbox__CloneMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CloneMode(struct soap *soap, const char *s, enum vbox__CloneMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CloneMode, s);
	if (map)
		*a = (enum vbox__CloneMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CloneMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CloneMode * SOAP_FMAC4 soap_in_vbox__CloneMode(struct soap *soap, const char *tag, enum vbox__CloneMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CloneMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CloneMode, sizeof(enum vbox__CloneMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__CloneMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CloneMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CloneMode, SOAP_TYPE_vbox__CloneMode, sizeof(enum vbox__CloneMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CloneMode(struct soap *soap, const enum vbox__CloneMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__CloneMode(soap, tag?tag:"vbox:CloneMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__CloneMode * SOAP_FMAC4 soap_get_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CloneMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CleanupMode
	*a = SOAP_DEFAULT_vbox__CleanupMode;
#else
	*a = (enum vbox__CleanupMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__CleanupMode[] =
{	{ (LONG64)vbox__CleanupMode__UnregisterOnly, "UnregisterOnly" },
	{ (LONG64)vbox__CleanupMode__DetachAllReturnNone, "DetachAllReturnNone" },
	{ (LONG64)vbox__CleanupMode__DetachAllReturnHardDisksOnly, "DetachAllReturnHardDisksOnly" },
	{ (LONG64)vbox__CleanupMode__Full, "Full" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CleanupMode2s(struct soap *soap, enum vbox__CleanupMode n)
{	const char *s = soap_code_str(soap_codes_vbox__CleanupMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CleanupMode(struct soap *soap, const char *tag, int id, const enum vbox__CleanupMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CleanupMode), type) || soap_send(soap, soap_vbox__CleanupMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CleanupMode(struct soap *soap, const char *s, enum vbox__CleanupMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CleanupMode, s);
	if (map)
		*a = (enum vbox__CleanupMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CleanupMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CleanupMode * SOAP_FMAC4 soap_in_vbox__CleanupMode(struct soap *soap, const char *tag, enum vbox__CleanupMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CleanupMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CleanupMode, sizeof(enum vbox__CleanupMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__CleanupMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CleanupMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CleanupMode, SOAP_TYPE_vbox__CleanupMode, sizeof(enum vbox__CleanupMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CleanupMode(struct soap *soap, const enum vbox__CleanupMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__CleanupMode(soap, tag?tag:"vbox:CleanupMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__CleanupMode * SOAP_FMAC4 soap_get_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CleanupMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GraphicsControllerType
	*a = SOAP_DEFAULT_vbox__GraphicsControllerType;
#else
	*a = (enum vbox__GraphicsControllerType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__GraphicsControllerType[] =
{	{ (LONG64)vbox__GraphicsControllerType__Null, "Null" },
	{ (LONG64)vbox__GraphicsControllerType__VBoxVGA, "VBoxVGA" },
	{ (LONG64)vbox__GraphicsControllerType__VMSVGA, "VMSVGA" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__GraphicsControllerType2s(struct soap *soap, enum vbox__GraphicsControllerType n)
{	const char *s = soap_code_str(soap_codes_vbox__GraphicsControllerType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__GraphicsControllerType(struct soap *soap, const char *tag, int id, const enum vbox__GraphicsControllerType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__GraphicsControllerType), type) || soap_send(soap, soap_vbox__GraphicsControllerType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__GraphicsControllerType(struct soap *soap, const char *s, enum vbox__GraphicsControllerType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__GraphicsControllerType, s);
	if (map)
		*a = (enum vbox__GraphicsControllerType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__GraphicsControllerType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__GraphicsControllerType * SOAP_FMAC4 soap_in_vbox__GraphicsControllerType(struct soap *soap, const char *tag, enum vbox__GraphicsControllerType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__GraphicsControllerType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__GraphicsControllerType, sizeof(enum vbox__GraphicsControllerType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__GraphicsControllerType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__GraphicsControllerType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__GraphicsControllerType, SOAP_TYPE_vbox__GraphicsControllerType, sizeof(enum vbox__GraphicsControllerType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__GraphicsControllerType(struct soap *soap, const enum vbox__GraphicsControllerType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__GraphicsControllerType(soap, tag?tag:"vbox:GraphicsControllerType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__GraphicsControllerType * SOAP_FMAC4 soap_get_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__GraphicsControllerType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType;
#else
	*a = (enum vbox__VirtualSystemDescriptionValueType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionValueType[] =
{	{ (LONG64)vbox__VirtualSystemDescriptionValueType__Reference, "Reference" },
	{ (LONG64)vbox__VirtualSystemDescriptionValueType__Original, "Original" },
	{ (LONG64)vbox__VirtualSystemDescriptionValueType__Auto, "Auto" },
	{ (LONG64)vbox__VirtualSystemDescriptionValueType__ExtraConfig, "ExtraConfig" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionValueType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionValueType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionValueType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionValueType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionValueType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionValueType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionValueType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionValueType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, sizeof(enum vbox__VirtualSystemDescriptionValueType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__VirtualSystemDescriptionValueType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionValueType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, SOAP_TYPE_vbox__VirtualSystemDescriptionValueType, sizeof(enum vbox__VirtualSystemDescriptionValueType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const enum vbox__VirtualSystemDescriptionValueType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__VirtualSystemDescriptionValueType(soap, tag?tag:"vbox:VirtualSystemDescriptionValueType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionValueType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionValueType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionType;
#else
	*a = (enum vbox__VirtualSystemDescriptionType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__VirtualSystemDescriptionType[] =
{	{ (LONG64)vbox__VirtualSystemDescriptionType__Ignore, "Ignore" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__OS, "OS" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Name, "Name" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Product, "Product" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Vendor, "Vendor" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Version, "Version" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__ProductUrl, "ProductUrl" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__VendorUrl, "VendorUrl" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Description, "Description" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__License, "License" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Miscellaneous, "Miscellaneous" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__CPU, "CPU" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Memory, "Memory" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__HardDiskControllerIDE, "HardDiskControllerIDE" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__HardDiskControllerSATA, "HardDiskControllerSATA" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__HardDiskControllerSCSI, "HardDiskControllerSCSI" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__HardDiskControllerSAS, "HardDiskControllerSAS" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__HardDiskImage, "HardDiskImage" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__Floppy, "Floppy" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__CDROM, "CDROM" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__NetworkAdapter, "NetworkAdapter" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__USBController, "USBController" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__SoundCard, "SoundCard" },
	{ (LONG64)vbox__VirtualSystemDescriptionType__SettingsFile, "SettingsFile" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VirtualSystemDescriptionType2s(struct soap *soap, enum vbox__VirtualSystemDescriptionType n)
{	const char *s = soap_code_str(soap_codes_vbox__VirtualSystemDescriptionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, int id, const enum vbox__VirtualSystemDescriptionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType), type) || soap_send(soap, soap_vbox__VirtualSystemDescriptionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VirtualSystemDescriptionType(struct soap *soap, const char *s, enum vbox__VirtualSystemDescriptionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VirtualSystemDescriptionType, s);
	if (map)
		*a = (enum vbox__VirtualSystemDescriptionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 23)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VirtualSystemDescriptionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_in_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *tag, enum vbox__VirtualSystemDescriptionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VirtualSystemDescriptionType, sizeof(enum vbox__VirtualSystemDescriptionType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__VirtualSystemDescriptionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VirtualSystemDescriptionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VirtualSystemDescriptionType, SOAP_TYPE_vbox__VirtualSystemDescriptionType, sizeof(enum vbox__VirtualSystemDescriptionType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VirtualSystemDescriptionType(struct soap *soap, const enum vbox__VirtualSystemDescriptionType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__VirtualSystemDescriptionType(soap, tag?tag:"vbox:VirtualSystemDescriptionType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__VirtualSystemDescriptionType * SOAP_FMAC4 soap_get_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VirtualSystemDescriptionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CertificateVersion
	*a = SOAP_DEFAULT_vbox__CertificateVersion;
#else
	*a = (enum vbox__CertificateVersion)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__CertificateVersion[] =
{	{ (LONG64)vbox__CertificateVersion__V1, "V1" },
	{ (LONG64)vbox__CertificateVersion__V2, "V2" },
	{ (LONG64)vbox__CertificateVersion__V3, "V3" },
	{ (LONG64)vbox__CertificateVersion__Unknown, "Unknown" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CertificateVersion2s(struct soap *soap, enum vbox__CertificateVersion n)
{	const char *s = soap_code_str(soap_codes_vbox__CertificateVersion, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CertificateVersion(struct soap *soap, const char *tag, int id, const enum vbox__CertificateVersion *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CertificateVersion), type) || soap_send(soap, soap_vbox__CertificateVersion2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CertificateVersion(struct soap *soap, const char *s, enum vbox__CertificateVersion *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CertificateVersion, s);
	if (map)
		*a = (enum vbox__CertificateVersion)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CertificateVersion)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CertificateVersion * SOAP_FMAC4 soap_in_vbox__CertificateVersion(struct soap *soap, const char *tag, enum vbox__CertificateVersion *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CertificateVersion *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CertificateVersion, sizeof(enum vbox__CertificateVersion), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__CertificateVersion(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CertificateVersion *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CertificateVersion, SOAP_TYPE_vbox__CertificateVersion, sizeof(enum vbox__CertificateVersion), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CertificateVersion(struct soap *soap, const enum vbox__CertificateVersion *a, const char *tag, const char *type)
{
	if (soap_out_vbox__CertificateVersion(soap, tag?tag:"vbox:CertificateVersion", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__CertificateVersion * SOAP_FMAC4 soap_get_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CertificateVersion(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ExportOptions
	*a = SOAP_DEFAULT_vbox__ExportOptions;
#else
	*a = (enum vbox__ExportOptions)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ExportOptions[] =
{	{ (LONG64)vbox__ExportOptions__CreateManifest, "CreateManifest" },
	{ (LONG64)vbox__ExportOptions__ExportDVDImages, "ExportDVDImages" },
	{ (LONG64)vbox__ExportOptions__StripAllMACs, "StripAllMACs" },
	{ (LONG64)vbox__ExportOptions__StripAllNonNATMACs, "StripAllNonNATMACs" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ExportOptions2s(struct soap *soap, enum vbox__ExportOptions n)
{	const char *s = soap_code_str(soap_codes_vbox__ExportOptions, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ExportOptions(struct soap *soap, const char *tag, int id, const enum vbox__ExportOptions *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ExportOptions), type) || soap_send(soap, soap_vbox__ExportOptions2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ExportOptions(struct soap *soap, const char *s, enum vbox__ExportOptions *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ExportOptions, s);
	if (map)
		*a = (enum vbox__ExportOptions)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ExportOptions)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ExportOptions * SOAP_FMAC4 soap_in_vbox__ExportOptions(struct soap *soap, const char *tag, enum vbox__ExportOptions *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ExportOptions *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ExportOptions, sizeof(enum vbox__ExportOptions), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ExportOptions(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ExportOptions *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ExportOptions, SOAP_TYPE_vbox__ExportOptions, sizeof(enum vbox__ExportOptions), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ExportOptions(struct soap *soap, const enum vbox__ExportOptions *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ExportOptions(soap, tag?tag:"vbox:ExportOptions", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ExportOptions * SOAP_FMAC4 soap_get_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ExportOptions(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ImportOptions
	*a = SOAP_DEFAULT_vbox__ImportOptions;
#else
	*a = (enum vbox__ImportOptions)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ImportOptions[] =
{	{ (LONG64)vbox__ImportOptions__KeepAllMACs, "KeepAllMACs" },
	{ (LONG64)vbox__ImportOptions__KeepNATMACs, "KeepNATMACs" },
	{ (LONG64)vbox__ImportOptions__ImportToVDI, "ImportToVDI" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ImportOptions2s(struct soap *soap, enum vbox__ImportOptions n)
{	const char *s = soap_code_str(soap_codes_vbox__ImportOptions, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ImportOptions(struct soap *soap, const char *tag, int id, const enum vbox__ImportOptions *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ImportOptions), type) || soap_send(soap, soap_vbox__ImportOptions2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ImportOptions(struct soap *soap, const char *s, enum vbox__ImportOptions *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ImportOptions, s);
	if (map)
		*a = (enum vbox__ImportOptions)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ImportOptions)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ImportOptions * SOAP_FMAC4 soap_in_vbox__ImportOptions(struct soap *soap, const char *tag, enum vbox__ImportOptions *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ImportOptions *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ImportOptions, sizeof(enum vbox__ImportOptions), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ImportOptions(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ImportOptions *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ImportOptions, SOAP_TYPE_vbox__ImportOptions, sizeof(enum vbox__ImportOptions), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ImportOptions(struct soap *soap, const enum vbox__ImportOptions *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ImportOptions(soap, tag?tag:"vbox:ImportOptions", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ImportOptions * SOAP_FMAC4 soap_get_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ImportOptions(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__VFSType(struct soap *soap, enum vbox__VFSType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSType
	*a = SOAP_DEFAULT_vbox__VFSType;
#else
	*a = (enum vbox__VFSType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__VFSType[] =
{	{ (LONG64)vbox__VFSType__File, "File" },
	{ (LONG64)vbox__VFSType__Cloud, "Cloud" },
	{ (LONG64)vbox__VFSType__S3, "S3" },
	{ (LONG64)vbox__VFSType__WebDav, "WebDav" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__VFSType2s(struct soap *soap, enum vbox__VFSType n)
{	const char *s = soap_code_str(soap_codes_vbox__VFSType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__VFSType(struct soap *soap, const char *tag, int id, const enum vbox__VFSType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__VFSType), type) || soap_send(soap, soap_vbox__VFSType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__VFSType(struct soap *soap, const char *s, enum vbox__VFSType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__VFSType, s);
	if (map)
		*a = (enum vbox__VFSType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__VFSType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_in_vbox__VFSType(struct soap *soap, const char *tag, enum vbox__VFSType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__VFSType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__VFSType, sizeof(enum vbox__VFSType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__VFSType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__VFSType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__VFSType, SOAP_TYPE_vbox__VFSType, sizeof(enum vbox__VFSType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__VFSType(struct soap *soap, const enum vbox__VFSType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__VFSType(soap, tag?tag:"vbox:VFSType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__VFSType * SOAP_FMAC4 soap_get_vbox__VFSType(struct soap *soap, enum vbox__VFSType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__VFSType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DhcpOptEncoding(struct soap *soap, enum vbox__DhcpOptEncoding *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DhcpOptEncoding
	*a = SOAP_DEFAULT_vbox__DhcpOptEncoding;
#else
	*a = (enum vbox__DhcpOptEncoding)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DhcpOptEncoding[] =
{	{ (LONG64)vbox__DhcpOptEncoding__Legacy, "Legacy" },
	{ (LONG64)vbox__DhcpOptEncoding__Hex, "Hex" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DhcpOptEncoding2s(struct soap *soap, enum vbox__DhcpOptEncoding n)
{	const char *s = soap_code_str(soap_codes_vbox__DhcpOptEncoding, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DhcpOptEncoding(struct soap *soap, const char *tag, int id, const enum vbox__DhcpOptEncoding *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DhcpOptEncoding), type) || soap_send(soap, soap_vbox__DhcpOptEncoding2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DhcpOptEncoding(struct soap *soap, const char *s, enum vbox__DhcpOptEncoding *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DhcpOptEncoding, s);
	if (map)
		*a = (enum vbox__DhcpOptEncoding)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DhcpOptEncoding)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DhcpOptEncoding * SOAP_FMAC4 soap_in_vbox__DhcpOptEncoding(struct soap *soap, const char *tag, enum vbox__DhcpOptEncoding *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DhcpOptEncoding *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DhcpOptEncoding, sizeof(enum vbox__DhcpOptEncoding), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DhcpOptEncoding(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DhcpOptEncoding *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DhcpOptEncoding, SOAP_TYPE_vbox__DhcpOptEncoding, sizeof(enum vbox__DhcpOptEncoding), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DhcpOptEncoding(struct soap *soap, const enum vbox__DhcpOptEncoding *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DhcpOptEncoding(soap, tag?tag:"vbox:DhcpOptEncoding", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DhcpOptEncoding * SOAP_FMAC4 soap_get_vbox__DhcpOptEncoding(struct soap *soap, enum vbox__DhcpOptEncoding *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DhcpOptEncoding(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DhcpOpt(struct soap *soap, enum vbox__DhcpOpt *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DhcpOpt
	*a = SOAP_DEFAULT_vbox__DhcpOpt;
#else
	*a = (enum vbox__DhcpOpt)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DhcpOpt[] =
{	{ (LONG64)vbox__DhcpOpt__SubnetMask, "SubnetMask" },
	{ (LONG64)vbox__DhcpOpt__TimeOffset, "TimeOffset" },
	{ (LONG64)vbox__DhcpOpt__Router, "Router" },
	{ (LONG64)vbox__DhcpOpt__TimeServer, "TimeServer" },
	{ (LONG64)vbox__DhcpOpt__NameServer, "NameServer" },
	{ (LONG64)vbox__DhcpOpt__DomainNameServer, "DomainNameServer" },
	{ (LONG64)vbox__DhcpOpt__LogServer, "LogServer" },
	{ (LONG64)vbox__DhcpOpt__Cookie, "Cookie" },
	{ (LONG64)vbox__DhcpOpt__LPRServer, "LPRServer" },
	{ (LONG64)vbox__DhcpOpt__ImpressServer, "ImpressServer" },
	{ (LONG64)vbox__DhcpOpt__ResourseLocationServer, "ResourseLocationServer" },
	{ (LONG64)vbox__DhcpOpt__HostName, "HostName" },
	{ (LONG64)vbox__DhcpOpt__BootFileSize, "BootFileSize" },
	{ (LONG64)vbox__DhcpOpt__MeritDumpFile, "MeritDumpFile" },
	{ (LONG64)vbox__DhcpOpt__DomainName, "DomainName" },
	{ (LONG64)vbox__DhcpOpt__SwapServer, "SwapServer" },
	{ (LONG64)vbox__DhcpOpt__RootPath, "RootPath" },
	{ (LONG64)vbox__DhcpOpt__ExtensionPath, "ExtensionPath" },
	{ (LONG64)vbox__DhcpOpt__IPForwardingEnableDisable, "IPForwardingEnableDisable" },
	{ (LONG64)vbox__DhcpOpt__NonLocalSourceRoutingEnableDisable, "NonLocalSourceRoutingEnableDisable" },
	{ (LONG64)vbox__DhcpOpt__PolicyFilter, "PolicyFilter" },
	{ (LONG64)vbox__DhcpOpt__MaximumDatagramReassemblySize, "MaximumDatagramReassemblySize" },
	{ (LONG64)vbox__DhcpOpt__DefaultIPTime2Live, "DefaultIPTime2Live" },
	{ (LONG64)vbox__DhcpOpt__PathMTUAgingTimeout, "PathMTUAgingTimeout" },
	{ (LONG64)vbox__DhcpOpt__IPLayerParametersPerInterface, "IPLayerParametersPerInterface" },
	{ (LONG64)vbox__DhcpOpt__InterfaceMTU, "InterfaceMTU" },
	{ (LONG64)vbox__DhcpOpt__AllSubnetsAreLocal, "AllSubnetsAreLocal" },
	{ (LONG64)vbox__DhcpOpt__BroadcastAddress, "BroadcastAddress" },
	{ (LONG64)vbox__DhcpOpt__PerformMaskDiscovery, "PerformMaskDiscovery" },
	{ (LONG64)vbox__DhcpOpt__MaskSupplier, "MaskSupplier" },
	{ (LONG64)vbox__DhcpOpt__PerformRouteDiscovery, "PerformRouteDiscovery" },
	{ (LONG64)vbox__DhcpOpt__RouterSolicitationAddress, "RouterSolicitationAddress" },
	{ (LONG64)vbox__DhcpOpt__StaticRoute, "StaticRoute" },
	{ (LONG64)vbox__DhcpOpt__TrailerEncapsulation, "TrailerEncapsulation" },
	{ (LONG64)vbox__DhcpOpt__ARPCacheTimeout, "ARPCacheTimeout" },
	{ (LONG64)vbox__DhcpOpt__EthernetEncapsulation, "EthernetEncapsulation" },
	{ (LONG64)vbox__DhcpOpt__TCPDefaultTTL, "TCPDefaultTTL" },
	{ (LONG64)vbox__DhcpOpt__TCPKeepAliveInterval, "TCPKeepAliveInterval" },
	{ (LONG64)vbox__DhcpOpt__TCPKeepAliveGarbage, "TCPKeepAliveGarbage" },
	{ (LONG64)vbox__DhcpOpt__NetworkInformationServiceDomain, "NetworkInformationServiceDomain" },
	{ (LONG64)vbox__DhcpOpt__NetworkInformationServiceServers, "NetworkInformationServiceServers" },
	{ (LONG64)vbox__DhcpOpt__NetworkTimeProtocolServers, "NetworkTimeProtocolServers" },
	{ (LONG64)vbox__DhcpOpt__VendorSpecificInformation, "VendorSpecificInformation" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE44, "Option_44" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE45, "Option_45" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE46, "Option_46" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE47, "Option_47" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE48, "Option_48" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE49, "Option_49" },
	{ (LONG64)vbox__DhcpOpt__IPAddressLeaseTime, "IPAddressLeaseTime" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE64, "Option_64" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE65, "Option_65" },
	{ (LONG64)vbox__DhcpOpt__TFTPServerName, "TFTPServerName" },
	{ (LONG64)vbox__DhcpOpt__BootfileName, "BootfileName" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE68, "Option_68" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE69, "Option_69" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE70, "Option_70" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE71, "Option_71" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE72, "Option_72" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE73, "Option_73" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE74, "Option_74" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE75, "Option_75" },
	{ (LONG64)vbox__DhcpOpt__Option_USCORE119, "Option_119" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DhcpOpt2s(struct soap *soap, enum vbox__DhcpOpt n)
{	const char *s = soap_code_str(soap_codes_vbox__DhcpOpt, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DhcpOpt(struct soap *soap, const char *tag, int id, const enum vbox__DhcpOpt *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DhcpOpt), type) || soap_send(soap, soap_vbox__DhcpOpt2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DhcpOpt(struct soap *soap, const char *s, enum vbox__DhcpOpt *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DhcpOpt, s);
	if (map)
		*a = (enum vbox__DhcpOpt)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 62)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DhcpOpt)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DhcpOpt * SOAP_FMAC4 soap_in_vbox__DhcpOpt(struct soap *soap, const char *tag, enum vbox__DhcpOpt *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DhcpOpt *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DhcpOpt, sizeof(enum vbox__DhcpOpt), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DhcpOpt(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DhcpOpt *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DhcpOpt, SOAP_TYPE_vbox__DhcpOpt, sizeof(enum vbox__DhcpOpt), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DhcpOpt(struct soap *soap, const enum vbox__DhcpOpt *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DhcpOpt(soap, tag?tag:"vbox:DhcpOpt", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DhcpOpt * SOAP_FMAC4 soap_get_vbox__DhcpOpt(struct soap *soap, enum vbox__DhcpOpt *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DhcpOpt(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BitmapFormat
	*a = SOAP_DEFAULT_vbox__BitmapFormat;
#else
	*a = (enum vbox__BitmapFormat)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__BitmapFormat[] =
{	{ (LONG64)vbox__BitmapFormat__Opaque, "Opaque" },
	{ (LONG64)vbox__BitmapFormat__BGR, "BGR" },
	{ (LONG64)vbox__BitmapFormat__BGR0, "BGR0" },
	{ (LONG64)vbox__BitmapFormat__BGRA, "BGRA" },
	{ (LONG64)vbox__BitmapFormat__RGBA, "RGBA" },
	{ (LONG64)vbox__BitmapFormat__PNG, "PNG" },
	{ (LONG64)vbox__BitmapFormat__JPEG, "JPEG" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__BitmapFormat2s(struct soap *soap, enum vbox__BitmapFormat n)
{	const char *s = soap_code_str(soap_codes_vbox__BitmapFormat, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__BitmapFormat(struct soap *soap, const char *tag, int id, const enum vbox__BitmapFormat *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__BitmapFormat), type) || soap_send(soap, soap_vbox__BitmapFormat2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__BitmapFormat(struct soap *soap, const char *s, enum vbox__BitmapFormat *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__BitmapFormat, s);
	if (map)
		*a = (enum vbox__BitmapFormat)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__BitmapFormat)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__BitmapFormat * SOAP_FMAC4 soap_in_vbox__BitmapFormat(struct soap *soap, const char *tag, enum vbox__BitmapFormat *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__BitmapFormat *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__BitmapFormat, sizeof(enum vbox__BitmapFormat), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__BitmapFormat(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__BitmapFormat *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__BitmapFormat, SOAP_TYPE_vbox__BitmapFormat, sizeof(enum vbox__BitmapFormat), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__BitmapFormat(struct soap *soap, const enum vbox__BitmapFormat *a, const char *tag, const char *type)
{
	if (soap_out_vbox__BitmapFormat(soap, tag?tag:"vbox:BitmapFormat", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__BitmapFormat * SOAP_FMAC4 soap_get_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__BitmapFormat(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__KeyboardHIDType
	*a = SOAP_DEFAULT_vbox__KeyboardHIDType;
#else
	*a = (enum vbox__KeyboardHIDType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__KeyboardHIDType[] =
{	{ (LONG64)vbox__KeyboardHIDType__None, "None" },
	{ (LONG64)vbox__KeyboardHIDType__PS2Keyboard, "PS2Keyboard" },
	{ (LONG64)vbox__KeyboardHIDType__USBKeyboard, "USBKeyboard" },
	{ (LONG64)vbox__KeyboardHIDType__ComboKeyboard, "ComboKeyboard" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__KeyboardHIDType2s(struct soap *soap, enum vbox__KeyboardHIDType n)
{	const char *s = soap_code_str(soap_codes_vbox__KeyboardHIDType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__KeyboardHIDType(struct soap *soap, const char *tag, int id, const enum vbox__KeyboardHIDType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__KeyboardHIDType), type) || soap_send(soap, soap_vbox__KeyboardHIDType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__KeyboardHIDType(struct soap *soap, const char *s, enum vbox__KeyboardHIDType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__KeyboardHIDType, s);
	if (map)
		*a = (enum vbox__KeyboardHIDType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__KeyboardHIDType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__KeyboardHIDType * SOAP_FMAC4 soap_in_vbox__KeyboardHIDType(struct soap *soap, const char *tag, enum vbox__KeyboardHIDType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__KeyboardHIDType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__KeyboardHIDType, sizeof(enum vbox__KeyboardHIDType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__KeyboardHIDType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__KeyboardHIDType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__KeyboardHIDType, SOAP_TYPE_vbox__KeyboardHIDType, sizeof(enum vbox__KeyboardHIDType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__KeyboardHIDType(struct soap *soap, const enum vbox__KeyboardHIDType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__KeyboardHIDType(soap, tag?tag:"vbox:KeyboardHIDType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__KeyboardHIDType * SOAP_FMAC4 soap_get_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__KeyboardHIDType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PointingHIDType
	*a = SOAP_DEFAULT_vbox__PointingHIDType;
#else
	*a = (enum vbox__PointingHIDType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__PointingHIDType[] =
{	{ (LONG64)vbox__PointingHIDType__None, "None" },
	{ (LONG64)vbox__PointingHIDType__PS2Mouse, "PS2Mouse" },
	{ (LONG64)vbox__PointingHIDType__USBMouse, "USBMouse" },
	{ (LONG64)vbox__PointingHIDType__USBTablet, "USBTablet" },
	{ (LONG64)vbox__PointingHIDType__ComboMouse, "ComboMouse" },
	{ (LONG64)vbox__PointingHIDType__USBMultiTouch, "USBMultiTouch" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__PointingHIDType2s(struct soap *soap, enum vbox__PointingHIDType n)
{	const char *s = soap_code_str(soap_codes_vbox__PointingHIDType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__PointingHIDType(struct soap *soap, const char *tag, int id, const enum vbox__PointingHIDType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__PointingHIDType), type) || soap_send(soap, soap_vbox__PointingHIDType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__PointingHIDType(struct soap *soap, const char *s, enum vbox__PointingHIDType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__PointingHIDType, s);
	if (map)
		*a = (enum vbox__PointingHIDType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__PointingHIDType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__PointingHIDType * SOAP_FMAC4 soap_in_vbox__PointingHIDType(struct soap *soap, const char *tag, enum vbox__PointingHIDType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__PointingHIDType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__PointingHIDType, sizeof(enum vbox__PointingHIDType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__PointingHIDType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__PointingHIDType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__PointingHIDType, SOAP_TYPE_vbox__PointingHIDType, sizeof(enum vbox__PointingHIDType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__PointingHIDType(struct soap *soap, const enum vbox__PointingHIDType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__PointingHIDType(soap, tag?tag:"vbox:PointingHIDType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__PointingHIDType * SOAP_FMAC4 soap_get_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__PointingHIDType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FirmwareType
	*a = SOAP_DEFAULT_vbox__FirmwareType;
#else
	*a = (enum vbox__FirmwareType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FirmwareType[] =
{	{ (LONG64)vbox__FirmwareType__BIOS, "BIOS" },
	{ (LONG64)vbox__FirmwareType__EFI, "EFI" },
	{ (LONG64)vbox__FirmwareType__EFI32, "EFI32" },
	{ (LONG64)vbox__FirmwareType__EFI64, "EFI64" },
	{ (LONG64)vbox__FirmwareType__EFIDUAL, "EFIDUAL" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FirmwareType2s(struct soap *soap, enum vbox__FirmwareType n)
{	const char *s = soap_code_str(soap_codes_vbox__FirmwareType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FirmwareType(struct soap *soap, const char *tag, int id, const enum vbox__FirmwareType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FirmwareType), type) || soap_send(soap, soap_vbox__FirmwareType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FirmwareType(struct soap *soap, const char *s, enum vbox__FirmwareType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FirmwareType, s);
	if (map)
		*a = (enum vbox__FirmwareType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FirmwareType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FirmwareType * SOAP_FMAC4 soap_in_vbox__FirmwareType(struct soap *soap, const char *tag, enum vbox__FirmwareType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FirmwareType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FirmwareType, sizeof(enum vbox__FirmwareType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FirmwareType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FirmwareType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FirmwareType, SOAP_TYPE_vbox__FirmwareType, sizeof(enum vbox__FirmwareType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FirmwareType(struct soap *soap, const enum vbox__FirmwareType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FirmwareType(soap, tag?tag:"vbox:FirmwareType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FirmwareType * SOAP_FMAC4 soap_get_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FirmwareType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessorFeature
	*a = SOAP_DEFAULT_vbox__ProcessorFeature;
#else
	*a = (enum vbox__ProcessorFeature)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ProcessorFeature[] =
{	{ (LONG64)vbox__ProcessorFeature__HWVirtEx, "HWVirtEx" },
	{ (LONG64)vbox__ProcessorFeature__PAE, "PAE" },
	{ (LONG64)vbox__ProcessorFeature__LongMode, "LongMode" },
	{ (LONG64)vbox__ProcessorFeature__NestedPaging, "NestedPaging" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ProcessorFeature2s(struct soap *soap, enum vbox__ProcessorFeature n)
{	const char *s = soap_code_str(soap_codes_vbox__ProcessorFeature, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ProcessorFeature(struct soap *soap, const char *tag, int id, const enum vbox__ProcessorFeature *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ProcessorFeature), type) || soap_send(soap, soap_vbox__ProcessorFeature2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ProcessorFeature(struct soap *soap, const char *s, enum vbox__ProcessorFeature *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ProcessorFeature, s);
	if (map)
		*a = (enum vbox__ProcessorFeature)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ProcessorFeature)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_in_vbox__ProcessorFeature(struct soap *soap, const char *tag, enum vbox__ProcessorFeature *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ProcessorFeature *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ProcessorFeature, sizeof(enum vbox__ProcessorFeature), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ProcessorFeature(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ProcessorFeature *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ProcessorFeature, SOAP_TYPE_vbox__ProcessorFeature, sizeof(enum vbox__ProcessorFeature), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ProcessorFeature(struct soap *soap, const enum vbox__ProcessorFeature *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ProcessorFeature(soap, tag?tag:"vbox:ProcessorFeature", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ProcessorFeature * SOAP_FMAC4 soap_get_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ProcessorFeature(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__APICMode(struct soap *soap, enum vbox__APICMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__APICMode
	*a = SOAP_DEFAULT_vbox__APICMode;
#else
	*a = (enum vbox__APICMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__APICMode[] =
{	{ (LONG64)vbox__APICMode__Disabled, "Disabled" },
	{ (LONG64)vbox__APICMode__APIC, "APIC" },
	{ (LONG64)vbox__APICMode__X2APIC, "X2APIC" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__APICMode2s(struct soap *soap, enum vbox__APICMode n)
{	const char *s = soap_code_str(soap_codes_vbox__APICMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__APICMode(struct soap *soap, const char *tag, int id, const enum vbox__APICMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__APICMode), type) || soap_send(soap, soap_vbox__APICMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__APICMode(struct soap *soap, const char *s, enum vbox__APICMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__APICMode, s);
	if (map)
		*a = (enum vbox__APICMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__APICMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__APICMode * SOAP_FMAC4 soap_in_vbox__APICMode(struct soap *soap, const char *tag, enum vbox__APICMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__APICMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__APICMode, sizeof(enum vbox__APICMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__APICMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__APICMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__APICMode, SOAP_TYPE_vbox__APICMode, sizeof(enum vbox__APICMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__APICMode(struct soap *soap, const enum vbox__APICMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__APICMode(soap, tag?tag:"vbox:APICMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__APICMode * SOAP_FMAC4 soap_get_vbox__APICMode(struct soap *soap, enum vbox__APICMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__APICMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BIOSBootMenuMode
	*a = SOAP_DEFAULT_vbox__BIOSBootMenuMode;
#else
	*a = (enum vbox__BIOSBootMenuMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__BIOSBootMenuMode[] =
{	{ (LONG64)vbox__BIOSBootMenuMode__Disabled, "Disabled" },
	{ (LONG64)vbox__BIOSBootMenuMode__MenuOnly, "MenuOnly" },
	{ (LONG64)vbox__BIOSBootMenuMode__MessageAndMenu, "MessageAndMenu" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__BIOSBootMenuMode2s(struct soap *soap, enum vbox__BIOSBootMenuMode n)
{	const char *s = soap_code_str(soap_codes_vbox__BIOSBootMenuMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, int id, const enum vbox__BIOSBootMenuMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__BIOSBootMenuMode), type) || soap_send(soap, soap_vbox__BIOSBootMenuMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__BIOSBootMenuMode(struct soap *soap, const char *s, enum vbox__BIOSBootMenuMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__BIOSBootMenuMode, s);
	if (map)
		*a = (enum vbox__BIOSBootMenuMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__BIOSBootMenuMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_in_vbox__BIOSBootMenuMode(struct soap *soap, const char *tag, enum vbox__BIOSBootMenuMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__BIOSBootMenuMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__BIOSBootMenuMode, sizeof(enum vbox__BIOSBootMenuMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__BIOSBootMenuMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__BIOSBootMenuMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__BIOSBootMenuMode, SOAP_TYPE_vbox__BIOSBootMenuMode, sizeof(enum vbox__BIOSBootMenuMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__BIOSBootMenuMode(struct soap *soap, const enum vbox__BIOSBootMenuMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__BIOSBootMenuMode(soap, tag?tag:"vbox:BIOSBootMenuMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__BIOSBootMenuMode * SOAP_FMAC4 soap_get_vbox__BIOSBootMenuMode(struct soap *soap, enum vbox__BIOSBootMenuMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__BIOSBootMenuMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__Scope(struct soap *soap, enum vbox__Scope *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Scope
	*a = SOAP_DEFAULT_vbox__Scope;
#else
	*a = (enum vbox__Scope)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__Scope[] =
{	{ (LONG64)vbox__Scope__Global, "Global" },
	{ (LONG64)vbox__Scope__Machine, "Machine" },
	{ (LONG64)vbox__Scope__Session, "Session" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__Scope2s(struct soap *soap, enum vbox__Scope n)
{	const char *s = soap_code_str(soap_codes_vbox__Scope, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__Scope(struct soap *soap, const char *tag, int id, const enum vbox__Scope *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__Scope), type) || soap_send(soap, soap_vbox__Scope2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__Scope(struct soap *soap, const char *s, enum vbox__Scope *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__Scope, s);
	if (map)
		*a = (enum vbox__Scope)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__Scope)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_in_vbox__Scope(struct soap *soap, const char *tag, enum vbox__Scope *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__Scope *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__Scope, sizeof(enum vbox__Scope), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__Scope(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__Scope *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__Scope, SOAP_TYPE_vbox__Scope, sizeof(enum vbox__Scope), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__Scope(struct soap *soap, const enum vbox__Scope *a, const char *tag, const char *type)
{
	if (soap_out_vbox__Scope(soap, tag?tag:"vbox:Scope", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__Scope * SOAP_FMAC4 soap_get_vbox__Scope(struct soap *soap, enum vbox__Scope *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__Scope(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DnDMode
	*a = SOAP_DEFAULT_vbox__DnDMode;
#else
	*a = (enum vbox__DnDMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DnDMode[] =
{	{ (LONG64)vbox__DnDMode__Disabled, "Disabled" },
	{ (LONG64)vbox__DnDMode__HostToGuest, "HostToGuest" },
	{ (LONG64)vbox__DnDMode__GuestToHost, "GuestToHost" },
	{ (LONG64)vbox__DnDMode__Bidirectional, "Bidirectional" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DnDMode2s(struct soap *soap, enum vbox__DnDMode n)
{	const char *s = soap_code_str(soap_codes_vbox__DnDMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DnDMode(struct soap *soap, const char *tag, int id, const enum vbox__DnDMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DnDMode), type) || soap_send(soap, soap_vbox__DnDMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DnDMode(struct soap *soap, const char *s, enum vbox__DnDMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DnDMode, s);
	if (map)
		*a = (enum vbox__DnDMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DnDMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DnDMode * SOAP_FMAC4 soap_in_vbox__DnDMode(struct soap *soap, const char *tag, enum vbox__DnDMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DnDMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DnDMode, sizeof(enum vbox__DnDMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DnDMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DnDMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DnDMode, SOAP_TYPE_vbox__DnDMode, sizeof(enum vbox__DnDMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DnDMode(struct soap *soap, const enum vbox__DnDMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DnDMode(soap, tag?tag:"vbox:DnDMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DnDMode * SOAP_FMAC4 soap_get_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DnDMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ClipboardMode
	*a = SOAP_DEFAULT_vbox__ClipboardMode;
#else
	*a = (enum vbox__ClipboardMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ClipboardMode[] =
{	{ (LONG64)vbox__ClipboardMode__Disabled, "Disabled" },
	{ (LONG64)vbox__ClipboardMode__HostToGuest, "HostToGuest" },
	{ (LONG64)vbox__ClipboardMode__GuestToHost, "GuestToHost" },
	{ (LONG64)vbox__ClipboardMode__Bidirectional, "Bidirectional" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ClipboardMode2s(struct soap *soap, enum vbox__ClipboardMode n)
{	const char *s = soap_code_str(soap_codes_vbox__ClipboardMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ClipboardMode(struct soap *soap, const char *tag, int id, const enum vbox__ClipboardMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ClipboardMode), type) || soap_send(soap, soap_vbox__ClipboardMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ClipboardMode(struct soap *soap, const char *s, enum vbox__ClipboardMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ClipboardMode, s);
	if (map)
		*a = (enum vbox__ClipboardMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ClipboardMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_in_vbox__ClipboardMode(struct soap *soap, const char *tag, enum vbox__ClipboardMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ClipboardMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ClipboardMode, sizeof(enum vbox__ClipboardMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ClipboardMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ClipboardMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ClipboardMode, SOAP_TYPE_vbox__ClipboardMode, sizeof(enum vbox__ClipboardMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ClipboardMode(struct soap *soap, const enum vbox__ClipboardMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ClipboardMode(soap, tag?tag:"vbox:ClipboardMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ClipboardMode * SOAP_FMAC4 soap_get_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ClipboardMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceActivity
	*a = SOAP_DEFAULT_vbox__DeviceActivity;
#else
	*a = (enum vbox__DeviceActivity)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DeviceActivity[] =
{	{ (LONG64)vbox__DeviceActivity__Null, "Null" },
	{ (LONG64)vbox__DeviceActivity__Idle, "Idle" },
	{ (LONG64)vbox__DeviceActivity__Reading, "Reading" },
	{ (LONG64)vbox__DeviceActivity__Writing, "Writing" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceActivity2s(struct soap *soap, enum vbox__DeviceActivity n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceActivity, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceActivity(struct soap *soap, const char *tag, int id, const enum vbox__DeviceActivity *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceActivity), type) || soap_send(soap, soap_vbox__DeviceActivity2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceActivity(struct soap *soap, const char *s, enum vbox__DeviceActivity *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DeviceActivity, s);
	if (map)
		*a = (enum vbox__DeviceActivity)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceActivity)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_in_vbox__DeviceActivity(struct soap *soap, const char *tag, enum vbox__DeviceActivity *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceActivity *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceActivity, sizeof(enum vbox__DeviceActivity), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DeviceActivity(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceActivity *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceActivity, SOAP_TYPE_vbox__DeviceActivity, sizeof(enum vbox__DeviceActivity), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceActivity(struct soap *soap, const enum vbox__DeviceActivity *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DeviceActivity(soap, tag?tag:"vbox:DeviceActivity", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DeviceActivity * SOAP_FMAC4 soap_get_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceActivity(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceType
	*a = SOAP_DEFAULT_vbox__DeviceType;
#else
	*a = (enum vbox__DeviceType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__DeviceType[] =
{	{ (LONG64)vbox__DeviceType__Null, "Null" },
	{ (LONG64)vbox__DeviceType__Floppy, "Floppy" },
	{ (LONG64)vbox__DeviceType__DVD, "DVD" },
	{ (LONG64)vbox__DeviceType__HardDisk, "HardDisk" },
	{ (LONG64)vbox__DeviceType__Network, "Network" },
	{ (LONG64)vbox__DeviceType__USB, "USB" },
	{ (LONG64)vbox__DeviceType__SharedFolder, "SharedFolder" },
	{ (LONG64)vbox__DeviceType__Graphics3D, "Graphics3D" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__DeviceType2s(struct soap *soap, enum vbox__DeviceType n)
{	const char *s = soap_code_str(soap_codes_vbox__DeviceType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__DeviceType(struct soap *soap, const char *tag, int id, const enum vbox__DeviceType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__DeviceType), type) || soap_send(soap, soap_vbox__DeviceType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__DeviceType(struct soap *soap, const char *s, enum vbox__DeviceType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__DeviceType, s);
	if (map)
		*a = (enum vbox__DeviceType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 7)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__DeviceType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_in_vbox__DeviceType(struct soap *soap, const char *tag, enum vbox__DeviceType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__DeviceType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__DeviceType, sizeof(enum vbox__DeviceType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__DeviceType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__DeviceType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__DeviceType, SOAP_TYPE_vbox__DeviceType, sizeof(enum vbox__DeviceType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__DeviceType(struct soap *soap, const enum vbox__DeviceType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__DeviceType(soap, tag?tag:"vbox:DeviceType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__DeviceType * SOAP_FMAC4 soap_get_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__DeviceType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionType(struct soap *soap, enum vbox__SessionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionType
	*a = SOAP_DEFAULT_vbox__SessionType;
#else
	*a = (enum vbox__SessionType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__SessionType[] =
{	{ (LONG64)vbox__SessionType__Null, "Null" },
	{ (LONG64)vbox__SessionType__WriteLock, "WriteLock" },
	{ (LONG64)vbox__SessionType__Remote, "Remote" },
	{ (LONG64)vbox__SessionType__Shared, "Shared" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionType2s(struct soap *soap, enum vbox__SessionType n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionType(struct soap *soap, const char *tag, int id, const enum vbox__SessionType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionType), type) || soap_send(soap, soap_vbox__SessionType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionType(struct soap *soap, const char *s, enum vbox__SessionType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SessionType, s);
	if (map)
		*a = (enum vbox__SessionType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_in_vbox__SessionType(struct soap *soap, const char *tag, enum vbox__SessionType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionType, sizeof(enum vbox__SessionType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__SessionType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionType, SOAP_TYPE_vbox__SessionType, sizeof(enum vbox__SessionType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionType(struct soap *soap, const enum vbox__SessionType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__SessionType(soap, tag?tag:"vbox:SessionType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__SessionType * SOAP_FMAC4 soap_get_vbox__SessionType(struct soap *soap, enum vbox__SessionType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__LockType(struct soap *soap, enum vbox__LockType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__LockType
	*a = SOAP_DEFAULT_vbox__LockType;
#else
	*a = (enum vbox__LockType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__LockType[] =
{	{ (LONG64)vbox__LockType__Null, "Null" },
	{ (LONG64)vbox__LockType__Shared, "Shared" },
	{ (LONG64)vbox__LockType__Write, "Write" },
	{ (LONG64)vbox__LockType__VM, "VM" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__LockType2s(struct soap *soap, enum vbox__LockType n)
{	const char *s = soap_code_str(soap_codes_vbox__LockType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__LockType(struct soap *soap, const char *tag, int id, const enum vbox__LockType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__LockType), type) || soap_send(soap, soap_vbox__LockType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__LockType(struct soap *soap, const char *s, enum vbox__LockType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__LockType, s);
	if (map)
		*a = (enum vbox__LockType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 3)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__LockType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__LockType * SOAP_FMAC4 soap_in_vbox__LockType(struct soap *soap, const char *tag, enum vbox__LockType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__LockType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__LockType, sizeof(enum vbox__LockType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__LockType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__LockType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__LockType, SOAP_TYPE_vbox__LockType, sizeof(enum vbox__LockType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__LockType(struct soap *soap, const enum vbox__LockType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__LockType(soap, tag?tag:"vbox:LockType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__LockType * SOAP_FMAC4 soap_get_vbox__LockType(struct soap *soap, enum vbox__LockType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__LockType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__FaultToleranceState(struct soap *soap, enum vbox__FaultToleranceState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FaultToleranceState
	*a = SOAP_DEFAULT_vbox__FaultToleranceState;
#else
	*a = (enum vbox__FaultToleranceState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__FaultToleranceState[] =
{	{ (LONG64)vbox__FaultToleranceState__Inactive, "Inactive" },
	{ (LONG64)vbox__FaultToleranceState__Master, "Master" },
	{ (LONG64)vbox__FaultToleranceState__Standby, "Standby" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__FaultToleranceState2s(struct soap *soap, enum vbox__FaultToleranceState n)
{	const char *s = soap_code_str(soap_codes_vbox__FaultToleranceState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__FaultToleranceState(struct soap *soap, const char *tag, int id, const enum vbox__FaultToleranceState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__FaultToleranceState), type) || soap_send(soap, soap_vbox__FaultToleranceState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__FaultToleranceState(struct soap *soap, const char *s, enum vbox__FaultToleranceState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__FaultToleranceState, s);
	if (map)
		*a = (enum vbox__FaultToleranceState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 2)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__FaultToleranceState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__FaultToleranceState * SOAP_FMAC4 soap_in_vbox__FaultToleranceState(struct soap *soap, const char *tag, enum vbox__FaultToleranceState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__FaultToleranceState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__FaultToleranceState, sizeof(enum vbox__FaultToleranceState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__FaultToleranceState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__FaultToleranceState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__FaultToleranceState, SOAP_TYPE_vbox__FaultToleranceState, sizeof(enum vbox__FaultToleranceState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__FaultToleranceState(struct soap *soap, const enum vbox__FaultToleranceState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__FaultToleranceState(soap, tag?tag:"vbox:FaultToleranceState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__FaultToleranceState * SOAP_FMAC4 soap_get_vbox__FaultToleranceState(struct soap *soap, enum vbox__FaultToleranceState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__FaultToleranceState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ParavirtProvider
	*a = SOAP_DEFAULT_vbox__ParavirtProvider;
#else
	*a = (enum vbox__ParavirtProvider)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__ParavirtProvider[] =
{	{ (LONG64)vbox__ParavirtProvider__None, "None" },
	{ (LONG64)vbox__ParavirtProvider__Default, "Default" },
	{ (LONG64)vbox__ParavirtProvider__Legacy, "Legacy" },
	{ (LONG64)vbox__ParavirtProvider__Minimal, "Minimal" },
	{ (LONG64)vbox__ParavirtProvider__HyperV, "HyperV" },
	{ (LONG64)vbox__ParavirtProvider__KVM, "KVM" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__ParavirtProvider2s(struct soap *soap, enum vbox__ParavirtProvider n)
{	const char *s = soap_code_str(soap_codes_vbox__ParavirtProvider, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__ParavirtProvider(struct soap *soap, const char *tag, int id, const enum vbox__ParavirtProvider *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__ParavirtProvider), type) || soap_send(soap, soap_vbox__ParavirtProvider2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__ParavirtProvider(struct soap *soap, const char *s, enum vbox__ParavirtProvider *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__ParavirtProvider, s);
	if (map)
		*a = (enum vbox__ParavirtProvider)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__ParavirtProvider)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__ParavirtProvider * SOAP_FMAC4 soap_in_vbox__ParavirtProvider(struct soap *soap, const char *tag, enum vbox__ParavirtProvider *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__ParavirtProvider *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__ParavirtProvider, sizeof(enum vbox__ParavirtProvider), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__ParavirtProvider(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__ParavirtProvider *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__ParavirtProvider, SOAP_TYPE_vbox__ParavirtProvider, sizeof(enum vbox__ParavirtProvider), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__ParavirtProvider(struct soap *soap, const enum vbox__ParavirtProvider *a, const char *tag, const char *type)
{
	if (soap_out_vbox__ParavirtProvider(soap, tag?tag:"vbox:ParavirtProvider", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__ParavirtProvider * SOAP_FMAC4 soap_get_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__ParavirtProvider(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HWVirtExPropertyType
	*a = SOAP_DEFAULT_vbox__HWVirtExPropertyType;
#else
	*a = (enum vbox__HWVirtExPropertyType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__HWVirtExPropertyType[] =
{	{ (LONG64)vbox__HWVirtExPropertyType__Null, "Null" },
	{ (LONG64)vbox__HWVirtExPropertyType__Enabled, "Enabled" },
	{ (LONG64)vbox__HWVirtExPropertyType__VPID, "VPID" },
	{ (LONG64)vbox__HWVirtExPropertyType__NestedPaging, "NestedPaging" },
	{ (LONG64)vbox__HWVirtExPropertyType__UnrestrictedExecution, "UnrestrictedExecution" },
	{ (LONG64)vbox__HWVirtExPropertyType__LargePages, "LargePages" },
	{ (LONG64)vbox__HWVirtExPropertyType__Force, "Force" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__HWVirtExPropertyType2s(struct soap *soap, enum vbox__HWVirtExPropertyType n)
{	const char *s = soap_code_str(soap_codes_vbox__HWVirtExPropertyType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__HWVirtExPropertyType(struct soap *soap, const char *tag, int id, const enum vbox__HWVirtExPropertyType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__HWVirtExPropertyType), type) || soap_send(soap, soap_vbox__HWVirtExPropertyType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__HWVirtExPropertyType(struct soap *soap, const char *s, enum vbox__HWVirtExPropertyType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__HWVirtExPropertyType, s);
	if (map)
		*a = (enum vbox__HWVirtExPropertyType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 6)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__HWVirtExPropertyType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__HWVirtExPropertyType * SOAP_FMAC4 soap_in_vbox__HWVirtExPropertyType(struct soap *soap, const char *tag, enum vbox__HWVirtExPropertyType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__HWVirtExPropertyType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__HWVirtExPropertyType, sizeof(enum vbox__HWVirtExPropertyType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__HWVirtExPropertyType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__HWVirtExPropertyType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__HWVirtExPropertyType, SOAP_TYPE_vbox__HWVirtExPropertyType, sizeof(enum vbox__HWVirtExPropertyType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__HWVirtExPropertyType(struct soap *soap, const enum vbox__HWVirtExPropertyType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__HWVirtExPropertyType(soap, tag?tag:"vbox:HWVirtExPropertyType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__HWVirtExPropertyType * SOAP_FMAC4 soap_get_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__HWVirtExPropertyType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__CPUPropertyType(struct soap *soap, enum vbox__CPUPropertyType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CPUPropertyType
	*a = SOAP_DEFAULT_vbox__CPUPropertyType;
#else
	*a = (enum vbox__CPUPropertyType)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__CPUPropertyType[] =
{	{ (LONG64)vbox__CPUPropertyType__Null, "Null" },
	{ (LONG64)vbox__CPUPropertyType__PAE, "PAE" },
	{ (LONG64)vbox__CPUPropertyType__LongMode, "LongMode" },
	{ (LONG64)vbox__CPUPropertyType__TripleFaultReset, "TripleFaultReset" },
	{ (LONG64)vbox__CPUPropertyType__APIC, "APIC" },
	{ (LONG64)vbox__CPUPropertyType__X2APIC, "X2APIC" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__CPUPropertyType2s(struct soap *soap, enum vbox__CPUPropertyType n)
{	const char *s = soap_code_str(soap_codes_vbox__CPUPropertyType, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__CPUPropertyType(struct soap *soap, const char *tag, int id, const enum vbox__CPUPropertyType *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__CPUPropertyType), type) || soap_send(soap, soap_vbox__CPUPropertyType2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__CPUPropertyType(struct soap *soap, const char *s, enum vbox__CPUPropertyType *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__CPUPropertyType, s);
	if (map)
		*a = (enum vbox__CPUPropertyType)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 5)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__CPUPropertyType)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__CPUPropertyType * SOAP_FMAC4 soap_in_vbox__CPUPropertyType(struct soap *soap, const char *tag, enum vbox__CPUPropertyType *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__CPUPropertyType *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__CPUPropertyType, sizeof(enum vbox__CPUPropertyType), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__CPUPropertyType(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__CPUPropertyType *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__CPUPropertyType, SOAP_TYPE_vbox__CPUPropertyType, sizeof(enum vbox__CPUPropertyType), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__CPUPropertyType(struct soap *soap, const enum vbox__CPUPropertyType *a, const char *tag, const char *type)
{
	if (soap_out_vbox__CPUPropertyType(soap, tag?tag:"vbox:CPUPropertyType", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__CPUPropertyType * SOAP_FMAC4 soap_get_vbox__CPUPropertyType(struct soap *soap, enum vbox__CPUPropertyType *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__CPUPropertyType(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SessionState(struct soap *soap, enum vbox__SessionState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionState
	*a = SOAP_DEFAULT_vbox__SessionState;
#else
	*a = (enum vbox__SessionState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__SessionState[] =
{	{ (LONG64)vbox__SessionState__Null, "Null" },
	{ (LONG64)vbox__SessionState__Unlocked, "Unlocked" },
	{ (LONG64)vbox__SessionState__Locked, "Locked" },
	{ (LONG64)vbox__SessionState__Spawning, "Spawning" },
	{ (LONG64)vbox__SessionState__Unlocking, "Unlocking" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SessionState2s(struct soap *soap, enum vbox__SessionState n)
{	const char *s = soap_code_str(soap_codes_vbox__SessionState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SessionState(struct soap *soap, const char *tag, int id, const enum vbox__SessionState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SessionState), type) || soap_send(soap, soap_vbox__SessionState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SessionState(struct soap *soap, const char *s, enum vbox__SessionState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SessionState, s);
	if (map)
		*a = (enum vbox__SessionState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 4)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SessionState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_in_vbox__SessionState(struct soap *soap, const char *tag, enum vbox__SessionState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SessionState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SessionState, sizeof(enum vbox__SessionState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__SessionState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SessionState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SessionState, SOAP_TYPE_vbox__SessionState, sizeof(enum vbox__SessionState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SessionState(struct soap *soap, const enum vbox__SessionState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__SessionState(soap, tag?tag:"vbox:SessionState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__SessionState * SOAP_FMAC4 soap_get_vbox__SessionState(struct soap *soap, enum vbox__SessionState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SessionState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__MachineState(struct soap *soap, enum vbox__MachineState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MachineState
	*a = SOAP_DEFAULT_vbox__MachineState;
#else
	*a = (enum vbox__MachineState)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__MachineState[] =
{	{ (LONG64)vbox__MachineState__Null, "Null" },
	{ (LONG64)vbox__MachineState__PoweredOff, "PoweredOff" },
	{ (LONG64)vbox__MachineState__Saved, "Saved" },
	{ (LONG64)vbox__MachineState__Teleported, "Teleported" },
	{ (LONG64)vbox__MachineState__Aborted, "Aborted" },
	{ (LONG64)vbox__MachineState__Running, "Running" },
	{ (LONG64)vbox__MachineState__Paused, "Paused" },
	{ (LONG64)vbox__MachineState__Stuck, "Stuck" },
	{ (LONG64)vbox__MachineState__Teleporting, "Teleporting" },
	{ (LONG64)vbox__MachineState__LiveSnapshotting, "LiveSnapshotting" },
	{ (LONG64)vbox__MachineState__Starting, "Starting" },
	{ (LONG64)vbox__MachineState__Stopping, "Stopping" },
	{ (LONG64)vbox__MachineState__Saving, "Saving" },
	{ (LONG64)vbox__MachineState__Restoring, "Restoring" },
	{ (LONG64)vbox__MachineState__TeleportingPausedVM, "TeleportingPausedVM" },
	{ (LONG64)vbox__MachineState__TeleportingIn, "TeleportingIn" },
	{ (LONG64)vbox__MachineState__FaultTolerantSyncing, "FaultTolerantSyncing" },
	{ (LONG64)vbox__MachineState__DeletingSnapshotOnline, "DeletingSnapshotOnline" },
	{ (LONG64)vbox__MachineState__DeletingSnapshotPaused, "DeletingSnapshotPaused" },
	{ (LONG64)vbox__MachineState__OnlineSnapshotting, "OnlineSnapshotting" },
	{ (LONG64)vbox__MachineState__RestoringSnapshot, "RestoringSnapshot" },
	{ (LONG64)vbox__MachineState__DeletingSnapshot, "DeletingSnapshot" },
	{ (LONG64)vbox__MachineState__SettingUp, "SettingUp" },
	{ (LONG64)vbox__MachineState__Snapshotting, "Snapshotting" },
	{ (LONG64)vbox__MachineState__FirstOnline, "FirstOnline" },
	{ (LONG64)vbox__MachineState__LastOnline, "LastOnline" },
	{ (LONG64)vbox__MachineState__FirstTransient, "FirstTransient" },
	{ (LONG64)vbox__MachineState__LastTransient, "LastTransient" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__MachineState2s(struct soap *soap, enum vbox__MachineState n)
{	const char *s = soap_code_str(soap_codes_vbox__MachineState, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__MachineState(struct soap *soap, const char *tag, int id, const enum vbox__MachineState *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__MachineState), type) || soap_send(soap, soap_vbox__MachineState2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__MachineState(struct soap *soap, const char *s, enum vbox__MachineState *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__MachineState, s);
	if (map)
		*a = (enum vbox__MachineState)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 27)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__MachineState)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_in_vbox__MachineState(struct soap *soap, const char *tag, enum vbox__MachineState *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__MachineState *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__MachineState, sizeof(enum vbox__MachineState), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__MachineState(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__MachineState *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__MachineState, SOAP_TYPE_vbox__MachineState, sizeof(enum vbox__MachineState), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__MachineState(struct soap *soap, const enum vbox__MachineState *a, const char *tag, const char *type)
{
	if (soap_out_vbox__MachineState(soap, tag?tag:"vbox:MachineState", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__MachineState * SOAP_FMAC4 soap_get_vbox__MachineState(struct soap *soap, enum vbox__MachineState *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__MachineState(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AccessMode
	*a = SOAP_DEFAULT_vbox__AccessMode;
#else
	*a = (enum vbox__AccessMode)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__AccessMode[] =
{	{ (LONG64)vbox__AccessMode__ReadOnly, "ReadOnly" },
	{ (LONG64)vbox__AccessMode__ReadWrite, "ReadWrite" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__AccessMode2s(struct soap *soap, enum vbox__AccessMode n)
{	const char *s = soap_code_str(soap_codes_vbox__AccessMode, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__AccessMode(struct soap *soap, const char *tag, int id, const enum vbox__AccessMode *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__AccessMode), type) || soap_send(soap, soap_vbox__AccessMode2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__AccessMode(struct soap *soap, const char *s, enum vbox__AccessMode *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__AccessMode, s);
	if (map)
		*a = (enum vbox__AccessMode)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 1)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__AccessMode)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_in_vbox__AccessMode(struct soap *soap, const char *tag, enum vbox__AccessMode *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__AccessMode *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__AccessMode, sizeof(enum vbox__AccessMode), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__AccessMode(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__AccessMode *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__AccessMode, SOAP_TYPE_vbox__AccessMode, sizeof(enum vbox__AccessMode), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__AccessMode(struct soap *soap, const enum vbox__AccessMode *a, const char *tag, const char *type)
{
	if (soap_out_vbox__AccessMode(soap, tag?tag:"vbox:AccessMode", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__AccessMode * SOAP_FMAC4 soap_get_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__AccessMode(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

SOAP_FMAC3 void SOAP_FMAC4 soap_default_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SettingsVersion
	*a = SOAP_DEFAULT_vbox__SettingsVersion;
#else
	*a = (enum vbox__SettingsVersion)0;
#endif
}

static const struct soap_code_map soap_codes_vbox__SettingsVersion[] =
{	{ (LONG64)vbox__SettingsVersion__Null, "Null" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE0, "v1_0" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE1, "v1_1" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE2, "v1_2" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE3pre, "v1_3pre" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE3, "v1_3" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE4, "v1_4" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE5, "v1_5" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE6, "v1_6" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE7, "v1_7" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE8, "v1_8" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE9, "v1_9" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE10, "v1_10" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE11, "v1_11" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE12, "v1_12" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE13, "v1_13" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE14, "v1_14" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE15, "v1_15" },
	{ (LONG64)vbox__SettingsVersion__v1_USCORE16, "v1_16" },
	{ (LONG64)vbox__SettingsVersion__Future, "Future" },
	{ 0, NULL }
};

SOAP_FMAC3S const char* SOAP_FMAC4S soap_vbox__SettingsVersion2s(struct soap *soap, enum vbox__SettingsVersion n)
{	const char *s = soap_code_str(soap_codes_vbox__SettingsVersion, (long)n);
	if (s)
		return s;
	return soap_long2s(soap, (long)n);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out_vbox__SettingsVersion(struct soap *soap, const char *tag, int id, const enum vbox__SettingsVersion *a, const char *type)
{	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE_vbox__SettingsVersion), type) || soap_send(soap, soap_vbox__SettingsVersion2s(soap, *a)))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

SOAP_FMAC3S int SOAP_FMAC4S soap_s2vbox__SettingsVersion(struct soap *soap, const char *s, enum vbox__SettingsVersion *a)
{
	const struct soap_code_map *map;
	if (!s)
		return soap->error;
	map = soap_code(soap_codes_vbox__SettingsVersion, s);
	if (map)
		*a = (enum vbox__SettingsVersion)map->code;
	else
	{	long n;
		if (soap_s2long(soap, s, &n) || ((soap->mode & SOAP_XML_STRICT) && (n < 0 || n > 19)))
			return soap->error = SOAP_TYPE;
		*a = (enum vbox__SettingsVersion)n;
	}
	return SOAP_OK;
}

SOAP_FMAC3 enum vbox__SettingsVersion * SOAP_FMAC4 soap_in_vbox__SettingsVersion(struct soap *soap, const char *tag, enum vbox__SettingsVersion *a, const char *type)
{
	if (soap_element_begin_in(soap, tag, 0, type))
		return NULL;
	a = (enum vbox__SettingsVersion *)soap_id_enter(soap, soap->id, a, SOAP_TYPE_vbox__SettingsVersion, sizeof(enum vbox__SettingsVersion), NULL, NULL, NULL, NULL);
	if (!a)
		return NULL;
	if (soap->body && !*soap->href)
	{	if (soap_s2vbox__SettingsVersion(soap, soap_value(soap), a) || soap_element_end_in(soap, tag))
			return NULL;
	}
	else
	{	a = (enum vbox__SettingsVersion *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE_vbox__SettingsVersion, SOAP_TYPE_vbox__SettingsVersion, sizeof(enum vbox__SettingsVersion), 0, NULL, NULL);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}

SOAP_FMAC3 int SOAP_FMAC4 soap_put_vbox__SettingsVersion(struct soap *soap, const enum vbox__SettingsVersion *a, const char *tag, const char *type)
{
	if (soap_out_vbox__SettingsVersion(soap, tag?tag:"vbox:SettingsVersion", -2, a, type))
		return soap->error;
	return soap_putindependent(soap);
}

SOAP_FMAC3 enum vbox__SettingsVersion * SOAP_FMAC4 soap_get_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *p, const char *tag, const char *type)
{
	if ((p = soap_in_vbox__SettingsVersion(soap, tag, p, type)))
		if (soap_getindependent(soap))
			return NULL;
	return p;
}

void _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::soap_default(struct soap *soap)
{
	this->soap = soap;
	soap_default_bool(soap, &this->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval);
	/* transient soap skipped */
}

void _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::soap_serialize(struct soap *soap) const
{
	(void)soap; /* appease -Wall -Werror */
#ifndef WITH_NOIDREF
#endif
}

int _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::soap_out(struct soap *soap, const char *tag, int id, const char *type) const
{
	return soap_out__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, tag, id, this, type);
}

SOAP_FMAC3 int SOAP_FMAC4 soap_out__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *tag, int id, const _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *a, const char *type)
{
	(void)soap; (void)tag; (void)id; (void)a; (void)type; /* appease -Wall -Werror */
	if (soap_element_begin_out(soap, tag, soap_embedded_id(soap, id, a, SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse), type))
		return soap->error;
	if (soap_out_bool(soap, "returnval", -1, &a->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval, ""))
		return soap->error;
	return soap_element_end_out(soap, tag);
}

void *_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::soap_in(struct soap *soap, const char *tag, const char *type)
{	return soap_in__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, tag, this, type);
}

SOAP_FMAC3 _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * SOAP_FMAC4 soap_in__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *tag, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *a, const char *type)
{
	(void)tag; (void)type; /* appease -Wall -Werror */
	if (soap_element_begin_in(soap, tag, 0, NULL))
		return NULL;
	a = (_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *)soap_id_enter(soap, soap->id, a, SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse, sizeof(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse), soap->type, soap->arrayType, soap_instantiate, soap_fbase);
	if (!a)
		return NULL;
	if (soap->alloced)
		a->soap_default(soap);
	size_t soap_flag_returnval1 = 1;
	if (soap->body && !*soap->href)
	{
		for (;;)
		{	soap->error = SOAP_TAG_MISMATCH;
			if (soap_flag_returnval1 && soap->error == SOAP_TAG_MISMATCH)
				if (soap_in_bool(soap, "returnval", &a->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval, "xsd:boolean"))
				{	soap_flag_returnval1--;
					continue;
				}
			if (soap->error == SOAP_TAG_MISMATCH)
				soap->error = soap_ignore_element(soap);
			if (soap->error == SOAP_NO_TAG)
				break;
			if (soap->error)
				return NULL;
		}
		if (soap_element_end_in(soap, tag))
			return NULL;
		if ((soap->mode & SOAP_XML_STRICT) && (soap_flag_returnval1 > 0))
		{	soap->error = SOAP_OCCURS;
			return NULL;
		}
	}
	else if ((soap->mode & SOAP_XML_STRICT) && !*soap->href)
	{	soap->error = SOAP_OCCURS;
		return NULL;
	}
	else
	{	a = (_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *)soap_id_forward(soap, soap->href, (void*)a, 0, SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse, SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse, sizeof(_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse), 0, soap_finsert, soap_fbase);
		if (soap->body && soap_element_end_in(soap, tag))
			return NULL;
	}
	return a;
}
